#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 13
#define STATE_COUNT 704
#define LARGE_STATE_COUNT 242
#define SYMBOL_COUNT 101
#define ALIAS_COUNT 0
#define TOKEN_COUNT 51
#define EXTERNAL_TOKEN_COUNT 2
#define FIELD_COUNT 14
#define MAX_ALIAS_SEQUENCE_LENGTH 7
#define PRODUCTION_ID_COUNT 33

enum {
  sym_symbol = 1,
  sym_line_comment = 2,
  anon_sym_LPAREN = 3,
  anon_sym_RPAREN = 4,
  anon_sym_LBRACK = 5,
  anon_sym_RBRACK = 6,
  anon_sym_AT_LPAREN = 7,
  anon_sym_AT_LBRACK = 8,
  anon_sym_LBRACE = 9,
  anon_sym_RBRACE = 10,
  anon_sym_AT_LBRACE = 11,
  anon_sym_set = 12,
  anon_sym_def = 13,
  anon_sym_var = 14,
  anon_sym_quote = 15,
  anon_sym_splice = 16,
  anon_sym_quasiquote = 17,
  anon_sym_unquote = 18,
  anon_sym_break = 19,
  anon_sym_if = 20,
  anon_sym_do = 21,
  anon_sym_while = 22,
  anon_sym_fn = 23,
  anon_sym_upscope = 24,
  sym_variadic_marker = 25,
  sym_optional_marker = 26,
  sym_keys_marker = 27,
  anon_sym_SQUOTE = 28,
  anon_sym_SEMI = 29,
  anon_sym_TILDE = 30,
  anon_sym_COMMA = 31,
  anon_sym_PIPE = 32,
  anon_sym_defn = 33,
  anon_sym_defn_DASH = 34,
  anon_sym_varfn = 35,
  anon_sym_varfn_DASH = 36,
  anon_sym_defmacro = 37,
  anon_sym_defmacro_DASH = 38,
  sym_str_literal = 39,
  sym_buffer_literal = 40,
  aux_sym_number_literal_token1 = 41,
  aux_sym_number_literal_token2 = 42,
  aux_sym_number_literal_token3 = 43,
  anon_sym_true = 44,
  anon_sym_false = 45,
  sym_nil_literal = 46,
  sym_escape_sequence = 47,
  sym_keyword = 48,
  sym__long_str = 49,
  sym__long_buffer = 50,
  sym_source_file = 51,
  sym__expr = 52,
  sym_tuple = 53,
  sym_sqr_tuple = 54,
  sym_array = 55,
  sym_sqr_array = 56,
  sym_struct = 57,
  sym_table = 58,
  sym__struct_tables_commom = 59,
  sym_peg_set = 60,
  sym__special_forms = 61,
  sym_def = 62,
  sym_var = 63,
  sym_quote = 64,
  sym_splice = 65,
  sym_quasiquote = 66,
  sym_unquote = 67,
  sym_break = 68,
  sym_set = 69,
  sym_if = 70,
  sym_do = 71,
  sym_while = 72,
  sym_fn = 73,
  sym_upscope = 74,
  sym__parameters = 75,
  sym_parameters = 76,
  sym_tuple_parameters = 77,
  sym__shorthand = 78,
  sym_short_quote = 79,
  sym_short_splice = 80,
  sym_short_quasiquote = 81,
  sym_short_unquote = 82,
  sym_short_fn = 83,
  sym__specials = 84,
  sym_extra_defs = 85,
  sym__literals = 86,
  sym_long_str_literal = 87,
  sym_long_buffer_literal = 88,
  sym_number_literal = 89,
  sym_bool_literal = 90,
  sym_metadata = 91,
  sym__name = 92,
  sym_body = 93,
  sym__identifier = 94,
  aux_sym_source_file_repeat1 = 95,
  aux_sym_tuple_repeat1 = 96,
  aux_sym_struct_repeat1 = 97,
  aux_sym_def_repeat1 = 98,
  aux_sym_while_repeat1 = 99,
  aux_sym_parameters_repeat1 = 100,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_symbol] = "symbol",
  [sym_line_comment] = "line_comment",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_AT_LPAREN] = "@(",
  [anon_sym_AT_LBRACK] = "@[",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_AT_LBRACE] = "@{",
  [anon_sym_set] = "set",
  [anon_sym_def] = "def",
  [anon_sym_var] = "var",
  [anon_sym_quote] = "quote",
  [anon_sym_splice] = "splice",
  [anon_sym_quasiquote] = "quasiquote",
  [anon_sym_unquote] = "unquote",
  [anon_sym_break] = "break",
  [anon_sym_if] = "if",
  [anon_sym_do] = "do",
  [anon_sym_while] = "while",
  [anon_sym_fn] = "fn",
  [anon_sym_upscope] = "upscope",
  [sym_variadic_marker] = "variadic_marker",
  [sym_optional_marker] = "optional_marker",
  [sym_keys_marker] = "keys_marker",
  [anon_sym_SQUOTE] = "'",
  [anon_sym_SEMI] = ";",
  [anon_sym_TILDE] = "~",
  [anon_sym_COMMA] = ",",
  [anon_sym_PIPE] = "|",
  [anon_sym_defn] = "defn",
  [anon_sym_defn_DASH] = "defn-",
  [anon_sym_varfn] = "varfn",
  [anon_sym_varfn_DASH] = "varfn-",
  [anon_sym_defmacro] = "defmacro",
  [anon_sym_defmacro_DASH] = "defmacro-",
  [sym_str_literal] = "str_literal",
  [sym_buffer_literal] = "buffer_literal",
  [aux_sym_number_literal_token1] = "number_literal_token1",
  [aux_sym_number_literal_token2] = "number_literal_token2",
  [aux_sym_number_literal_token3] = "number_literal_token3",
  [anon_sym_true] = "true",
  [anon_sym_false] = "false",
  [sym_nil_literal] = "nil_literal",
  [sym_escape_sequence] = "escape_sequence",
  [sym_keyword] = "keyword",
  [sym__long_str] = "_long_str",
  [sym__long_buffer] = "_long_buffer",
  [sym_source_file] = "source_file",
  [sym__expr] = "_expr",
  [sym_tuple] = "tuple",
  [sym_sqr_tuple] = "sqr_tuple",
  [sym_array] = "array",
  [sym_sqr_array] = "sqr_array",
  [sym_struct] = "struct",
  [sym_table] = "table",
  [sym__struct_tables_commom] = "_struct_tables_commom",
  [sym_peg_set] = "peg_set",
  [sym__special_forms] = "_special_forms",
  [sym_def] = "def",
  [sym_var] = "var",
  [sym_quote] = "quote",
  [sym_splice] = "splice",
  [sym_quasiquote] = "quasiquote",
  [sym_unquote] = "unquote",
  [sym_break] = "break",
  [sym_set] = "set",
  [sym_if] = "if",
  [sym_do] = "do",
  [sym_while] = "while",
  [sym_fn] = "fn",
  [sym_upscope] = "upscope",
  [sym__parameters] = "_parameters",
  [sym_parameters] = "parameters",
  [sym_tuple_parameters] = "tuple_parameters",
  [sym__shorthand] = "_shorthand",
  [sym_short_quote] = "short_quote",
  [sym_short_splice] = "short_splice",
  [sym_short_quasiquote] = "short_quasiquote",
  [sym_short_unquote] = "short_unquote",
  [sym_short_fn] = "short_fn",
  [sym__specials] = "_specials",
  [sym_extra_defs] = "extra_defs",
  [sym__literals] = "_literals",
  [sym_long_str_literal] = "long_str_literal",
  [sym_long_buffer_literal] = "long_buffer_literal",
  [sym_number_literal] = "number_literal",
  [sym_bool_literal] = "bool_literal",
  [sym_metadata] = "metadata",
  [sym__name] = "_name",
  [sym_body] = "body",
  [sym__identifier] = "_identifier",
  [aux_sym_source_file_repeat1] = "source_file_repeat1",
  [aux_sym_tuple_repeat1] = "tuple_repeat1",
  [aux_sym_struct_repeat1] = "struct_repeat1",
  [aux_sym_def_repeat1] = "def_repeat1",
  [aux_sym_while_repeat1] = "while_repeat1",
  [aux_sym_parameters_repeat1] = "parameters_repeat1",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_symbol] = sym_symbol,
  [sym_line_comment] = sym_line_comment,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_AT_LPAREN] = anon_sym_AT_LPAREN,
  [anon_sym_AT_LBRACK] = anon_sym_AT_LBRACK,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_AT_LBRACE] = anon_sym_AT_LBRACE,
  [anon_sym_set] = anon_sym_set,
  [anon_sym_def] = anon_sym_def,
  [anon_sym_var] = anon_sym_var,
  [anon_sym_quote] = anon_sym_quote,
  [anon_sym_splice] = anon_sym_splice,
  [anon_sym_quasiquote] = anon_sym_quasiquote,
  [anon_sym_unquote] = anon_sym_unquote,
  [anon_sym_break] = anon_sym_break,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_do] = anon_sym_do,
  [anon_sym_while] = anon_sym_while,
  [anon_sym_fn] = anon_sym_fn,
  [anon_sym_upscope] = anon_sym_upscope,
  [sym_variadic_marker] = sym_variadic_marker,
  [sym_optional_marker] = sym_optional_marker,
  [sym_keys_marker] = sym_keys_marker,
  [anon_sym_SQUOTE] = anon_sym_SQUOTE,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_defn] = anon_sym_defn,
  [anon_sym_defn_DASH] = anon_sym_defn_DASH,
  [anon_sym_varfn] = anon_sym_varfn,
  [anon_sym_varfn_DASH] = anon_sym_varfn_DASH,
  [anon_sym_defmacro] = anon_sym_defmacro,
  [anon_sym_defmacro_DASH] = anon_sym_defmacro_DASH,
  [sym_str_literal] = sym_str_literal,
  [sym_buffer_literal] = sym_buffer_literal,
  [aux_sym_number_literal_token1] = aux_sym_number_literal_token1,
  [aux_sym_number_literal_token2] = aux_sym_number_literal_token2,
  [aux_sym_number_literal_token3] = aux_sym_number_literal_token3,
  [anon_sym_true] = anon_sym_true,
  [anon_sym_false] = anon_sym_false,
  [sym_nil_literal] = sym_nil_literal,
  [sym_escape_sequence] = sym_escape_sequence,
  [sym_keyword] = sym_keyword,
  [sym__long_str] = sym__long_str,
  [sym__long_buffer] = sym__long_buffer,
  [sym_source_file] = sym_source_file,
  [sym__expr] = sym__expr,
  [sym_tuple] = sym_tuple,
  [sym_sqr_tuple] = sym_sqr_tuple,
  [sym_array] = sym_array,
  [sym_sqr_array] = sym_sqr_array,
  [sym_struct] = sym_struct,
  [sym_table] = sym_table,
  [sym__struct_tables_commom] = sym__struct_tables_commom,
  [sym_peg_set] = sym_peg_set,
  [sym__special_forms] = sym__special_forms,
  [sym_def] = sym_def,
  [sym_var] = sym_var,
  [sym_quote] = sym_quote,
  [sym_splice] = sym_splice,
  [sym_quasiquote] = sym_quasiquote,
  [sym_unquote] = sym_unquote,
  [sym_break] = sym_break,
  [sym_set] = sym_set,
  [sym_if] = sym_if,
  [sym_do] = sym_do,
  [sym_while] = sym_while,
  [sym_fn] = sym_fn,
  [sym_upscope] = sym_upscope,
  [sym__parameters] = sym__parameters,
  [sym_parameters] = sym_parameters,
  [sym_tuple_parameters] = sym_tuple_parameters,
  [sym__shorthand] = sym__shorthand,
  [sym_short_quote] = sym_short_quote,
  [sym_short_splice] = sym_short_splice,
  [sym_short_quasiquote] = sym_short_quasiquote,
  [sym_short_unquote] = sym_short_unquote,
  [sym_short_fn] = sym_short_fn,
  [sym__specials] = sym__specials,
  [sym_extra_defs] = sym_extra_defs,
  [sym__literals] = sym__literals,
  [sym_long_str_literal] = sym_long_str_literal,
  [sym_long_buffer_literal] = sym_long_buffer_literal,
  [sym_number_literal] = sym_number_literal,
  [sym_bool_literal] = sym_bool_literal,
  [sym_metadata] = sym_metadata,
  [sym__name] = sym__name,
  [sym_body] = sym_body,
  [sym__identifier] = sym__identifier,
  [aux_sym_source_file_repeat1] = aux_sym_source_file_repeat1,
  [aux_sym_tuple_repeat1] = aux_sym_tuple_repeat1,
  [aux_sym_struct_repeat1] = aux_sym_struct_repeat1,
  [aux_sym_def_repeat1] = aux_sym_def_repeat1,
  [aux_sym_while_repeat1] = aux_sym_while_repeat1,
  [aux_sym_parameters_repeat1] = aux_sym_parameters_repeat1,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_symbol] = {
    .visible = true,
    .named = true,
  },
  [sym_line_comment] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_set] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_def] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_var] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_quote] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_splice] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_quasiquote] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unquote] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_fn] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_upscope] = {
    .visible = true,
    .named = false,
  },
  [sym_variadic_marker] = {
    .visible = true,
    .named = true,
  },
  [sym_optional_marker] = {
    .visible = true,
    .named = true,
  },
  [sym_keys_marker] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_defn] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_defn_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_varfn] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_varfn_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_defmacro] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_defmacro_DASH] = {
    .visible = true,
    .named = false,
  },
  [sym_str_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_buffer_literal] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_number_literal_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_number_literal_token2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_number_literal_token3] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_true] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_false] = {
    .visible = true,
    .named = false,
  },
  [sym_nil_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword] = {
    .visible = true,
    .named = true,
  },
  [sym__long_str] = {
    .visible = false,
    .named = true,
  },
  [sym__long_buffer] = {
    .visible = false,
    .named = true,
  },
  [sym_source_file] = {
    .visible = true,
    .named = true,
  },
  [sym__expr] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_tuple] = {
    .visible = true,
    .named = true,
  },
  [sym_sqr_tuple] = {
    .visible = true,
    .named = true,
  },
  [sym_array] = {
    .visible = true,
    .named = true,
  },
  [sym_sqr_array] = {
    .visible = true,
    .named = true,
  },
  [sym_struct] = {
    .visible = true,
    .named = true,
  },
  [sym_table] = {
    .visible = true,
    .named = true,
  },
  [sym__struct_tables_commom] = {
    .visible = false,
    .named = true,
  },
  [sym_peg_set] = {
    .visible = true,
    .named = true,
  },
  [sym__special_forms] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_def] = {
    .visible = true,
    .named = true,
  },
  [sym_var] = {
    .visible = true,
    .named = true,
  },
  [sym_quote] = {
    .visible = true,
    .named = true,
  },
  [sym_splice] = {
    .visible = true,
    .named = true,
  },
  [sym_quasiquote] = {
    .visible = true,
    .named = true,
  },
  [sym_unquote] = {
    .visible = true,
    .named = true,
  },
  [sym_break] = {
    .visible = true,
    .named = true,
  },
  [sym_set] = {
    .visible = true,
    .named = true,
  },
  [sym_if] = {
    .visible = true,
    .named = true,
  },
  [sym_do] = {
    .visible = true,
    .named = true,
  },
  [sym_while] = {
    .visible = true,
    .named = true,
  },
  [sym_fn] = {
    .visible = true,
    .named = true,
  },
  [sym_upscope] = {
    .visible = true,
    .named = true,
  },
  [sym__parameters] = {
    .visible = false,
    .named = true,
  },
  [sym_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_tuple_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym__shorthand] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_short_quote] = {
    .visible = true,
    .named = true,
  },
  [sym_short_splice] = {
    .visible = true,
    .named = true,
  },
  [sym_short_quasiquote] = {
    .visible = true,
    .named = true,
  },
  [sym_short_unquote] = {
    .visible = true,
    .named = true,
  },
  [sym_short_fn] = {
    .visible = true,
    .named = true,
  },
  [sym__specials] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_extra_defs] = {
    .visible = true,
    .named = true,
  },
  [sym__literals] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_long_str_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_long_buffer_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_number_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_bool_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_metadata] = {
    .visible = true,
    .named = true,
  },
  [sym__name] = {
    .visible = false,
    .named = true,
  },
  [sym_body] = {
    .visible = true,
    .named = true,
  },
  [sym__identifier] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [aux_sym_source_file_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_tuple_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_struct_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_def_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_while_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
};

enum {
  field_body = 1,
  field_condition = 2,
  field_else = 3,
  field_form = 4,
  field_item = 5,
  field_key = 6,
  field_l_value = 7,
  field_metadata = 8,
  field_name = 9,
  field_parameter = 10,
  field_parameters = 11,
  field_r_value = 12,
  field_then = 13,
  field_value = 14,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_body] = "body",
  [field_condition] = "condition",
  [field_else] = "else",
  [field_form] = "form",
  [field_item] = "item",
  [field_key] = "key",
  [field_l_value] = "l_value",
  [field_metadata] = "metadata",
  [field_name] = "name",
  [field_parameter] = "parameter",
  [field_parameters] = "parameters",
  [field_r_value] = "r_value",
  [field_then] = "then",
  [field_value] = "value",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [1] = {.index = 0, .length = 1},
  [2] = {.index = 1, .length = 2},
  [3] = {.index = 3, .length = 1},
  [4] = {.index = 4, .length = 1},
  [5] = {.index = 5, .length = 1},
  [6] = {.index = 6, .length = 1},
  [7] = {.index = 7, .length = 2},
  [8] = {.index = 9, .length = 2},
  [9] = {.index = 11, .length = 2},
  [10] = {.index = 13, .length = 4},
  [11] = {.index = 17, .length = 1},
  [12] = {.index = 18, .length = 1},
  [13] = {.index = 19, .length = 2},
  [14] = {.index = 21, .length = 1},
  [15] = {.index = 22, .length = 1},
  [16] = {.index = 23, .length = 1},
  [17] = {.index = 24, .length = 2},
  [18] = {.index = 26, .length = 2},
  [19] = {.index = 28, .length = 2},
  [20] = {.index = 30, .length = 2},
  [21] = {.index = 32, .length = 2},
  [22] = {.index = 34, .length = 1},
  [23] = {.index = 35, .length = 2},
  [24] = {.index = 37, .length = 2},
  [25] = {.index = 39, .length = 2},
  [26] = {.index = 41, .length = 3},
  [27] = {.index = 44, .length = 3},
  [28] = {.index = 47, .length = 1},
  [29] = {.index = 48, .length = 3},
  [30] = {.index = 51, .length = 3},
  [31] = {.index = 54, .length = 2},
  [32] = {.index = 56, .length = 4},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_item, 0},
  [1] =
    {field_key, 0, .inherited = true},
    {field_value, 0, .inherited = true},
  [3] =
    {field_body, 1},
  [4] =
    {field_form, 0},
  [5] =
    {field_form, 0, .inherited = true},
  [6] =
    {field_item, 1, .inherited = true},
  [7] =
    {field_item, 0, .inherited = true},
    {field_item, 1, .inherited = true},
  [9] =
    {field_key, 0},
    {field_value, 1},
  [11] =
    {field_key, 1, .inherited = true},
    {field_value, 1, .inherited = true},
  [13] =
    {field_key, 0, .inherited = true},
    {field_key, 1, .inherited = true},
    {field_value, 0, .inherited = true},
    {field_value, 1, .inherited = true},
  [17] =
    {field_metadata, 0},
  [18] =
    {field_body, 2},
  [19] =
    {field_form, 0, .inherited = true},
    {field_form, 1, .inherited = true},
  [21] =
    {field_condition, 2},
  [22] =
    {field_parameter, 0},
  [23] =
    {field_parameters, 2},
  [24] =
    {field_l_value, 2},
    {field_r_value, 3},
  [26] =
    {field_name, 2},
    {field_value, 3},
  [28] =
    {field_metadata, 0, .inherited = true},
    {field_metadata, 1, .inherited = true},
  [30] =
    {field_condition, 2},
    {field_then, 3},
  [32] =
    {field_condition, 2},
    {field_form, 3, .inherited = true},
  [34] =
    {field_parameter, 1, .inherited = true},
  [35] =
    {field_parameter, 0, .inherited = true},
    {field_parameter, 1, .inherited = true},
  [37] =
    {field_body, 3},
    {field_parameters, 2},
  [39] =
    {field_name, 2},
    {field_parameters, 3},
  [41] =
    {field_metadata, 3, .inherited = true},
    {field_name, 2},
    {field_value, 4},
  [44] =
    {field_condition, 2},
    {field_else, 4},
    {field_then, 3},
  [47] =
    {field_parameter, 2, .inherited = true},
  [48] =
    {field_body, 4},
    {field_name, 2},
    {field_parameters, 3},
  [51] =
    {field_metadata, 3, .inherited = true},
    {field_name, 2},
    {field_parameters, 4},
  [54] =
    {field_parameter, 1, .inherited = true},
    {field_parameter, 3, .inherited = true},
  [56] =
    {field_body, 5},
    {field_metadata, 3, .inherited = true},
    {field_name, 2},
    {field_parameters, 4},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
};

static const uint16_t ts_non_terminal_alias_map[] = {
  0,
};

static inline bool sym_line_comment_character_set_1(int32_t c) {
  return (c < ','
    ? (c < ' '
      ? (c < '\r'
        ? c == '\t'
        : c <= '\r')
      : (c <= ' ' || (c < '\''
        ? c == '"'
        : c <= ')')))
    : (c <= ',' || (c < ']'
      ? (c < '['
        ? c == ';'
        : c <= '[')
      : (c <= ']' || (c < '{'
        ? c == '`'
        : c <= '~')))));
}

static inline bool sym_escape_sequence_character_set_1(int32_t c) {
  return (c < ','
    ? (c < ' '
      ? (c < '\r'
        ? (c >= '\t' && c <= '\n')
        : c <= '\r')
      : (c <= ' ' || (c < '\''
        ? c == '"'
        : c <= ')')))
    : (c <= ',' || (c < ']'
      ? (c < '['
        ? c == ';'
        : c <= '[')
      : (c <= ']' || (c < '{'
        ? c == '`'
        : c <= '~')))));
}

static inline bool sym_symbol_character_set_1(int32_t c) {
  return (c < ','
    ? (c < ' '
      ? (c < '\t'
        ? c == 0
        : (c <= '\n' || c == '\r'))
      : (c <= ' ' || (c < '\''
        ? c == '"'
        : c <= ')')))
    : (c <= ',' || (c < ']'
      ? (c < '['
        ? c == ';'
        : c <= '[')
      : (c <= ']' || (c < '{'
        ? c == '`'
        : c <= '~')))));
}

static inline bool sym_symbol_character_set_2(int32_t c) {
  return (c < '\''
    ? (c < '\r'
      ? (c < '\t'
        ? c == 0
        : c <= '\n')
      : (c <= '\r' || (c < '"'
        ? c == ' '
        : c <= '"')))
    : (c <= ')' || (c < '['
      ? (c < ';'
        ? c == ','
        : c <= ';')
      : (c <= '[' || (c < '`'
        ? c == ']'
        : c <= '~')))));
}

static inline bool sym_symbol_character_set_3(int32_t c) {
  return (c < ','
    ? (c < '\r'
      ? (c < '\t'
        ? c == 0
        : c <= '\n')
      : (c <= '\r' || (c < '\''
        ? c == ' '
        : c <= ')')))
    : (c <= ',' || (c < '`'
      ? (c < ']'
        ? c == ';'
        : c <= ']')
      : (c <= '`' || (c >= '|' && c <= '~')))));
}

static inline bool sym_symbol_character_set_4(int32_t c) {
  return (c < ','
    ? (c < ' '
      ? (c < '\t'
        ? c == 0
        : (c <= '\n' || c == '\r'))
      : (c <= ' ' || (c < '\''
        ? c == '"'
        : c <= ')')))
    : (c <= ',' || (c < ']'
      ? (c < '['
        ? c == ';'
        : c <= '[')
      : (c <= ']' || (c < '|'
        ? c == '`'
        : c <= '~')))));
}

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(23);
      if (lookahead == '"') ADVANCE(3);
      if (lookahead == '#') ADVANCE(24);
      if (lookahead == '&') ADVANCE(35);
      if (lookahead == '\'') ADVANCE(38);
      if (lookahead == '(') ADVANCE(26);
      if (lookahead == ')') ADVANCE(27);
      if (lookahead == ',') ADVANCE(41);
      if (lookahead == '.') ADVANCE(75);
      if (lookahead == '0') ADVANCE(45);
      if (lookahead == ':') ADVANCE(59);
      if (lookahead == ';') ADVANCE(39);
      if (lookahead == '@') ADVANCE(60);
      if (lookahead == '[') ADVANCE(28);
      if (lookahead == '\\') ADVANCE(68);
      if (lookahead == ']') ADVANCE(29);
      if (lookahead == '{') ADVANCE(32);
      if (lookahead == '|') ADVANCE(42);
      if (lookahead == '}') ADVANCE(33);
      if (lookahead == '~') ADVANCE(40);
      if (('+' <= lookahead && lookahead <= '-')) ADVANCE(61);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(21)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(46);
      if (lookahead != 0 &&
          lookahead != '`') ADVANCE(83);
      END_STATE();
    case 1:
      if (lookahead == '"') ADVANCE(3);
      if (lookahead == '#') ADVANCE(24);
      if (lookahead == '&') ADVANCE(35);
      if (lookahead == '\'') ADVANCE(38);
      if (lookahead == '(') ADVANCE(26);
      if (lookahead == ')') ADVANCE(27);
      if (lookahead == ',') ADVANCE(41);
      if (lookahead == '.') ADVANCE(75);
      if (lookahead == '0') ADVANCE(45);
      if (lookahead == ':') ADVANCE(59);
      if (lookahead == ';') ADVANCE(39);
      if (lookahead == '@') ADVANCE(60);
      if (lookahead == '[') ADVANCE(28);
      if (lookahead == ']') ADVANCE(29);
      if (lookahead == '{') ADVANCE(32);
      if (lookahead == '|') ADVANCE(42);
      if (lookahead == '~') ADVANCE(40);
      if (('+' <= lookahead && lookahead <= '-')) ADVANCE(61);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(1)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(46);
      if (lookahead != 0 &&
          lookahead != '`' &&
          lookahead != '}') ADVANCE(83);
      END_STATE();
    case 2:
      if (lookahead == '"') ADVANCE(3);
      if (lookahead == '#') ADVANCE(24);
      if (lookahead == '\'') ADVANCE(38);
      if (lookahead == '(') ADVANCE(26);
      if (lookahead == ',') ADVANCE(41);
      if (lookahead == ':') ADVANCE(59);
      if (lookahead == ';') ADVANCE(39);
      if (lookahead == '[') ADVANCE(28);
      if (lookahead == '~') ADVANCE(40);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(2)
      if (lookahead != 0 &&
          lookahead != ')' &&
          lookahead != ']' &&
          lookahead != '`' &&
          (lookahead < '{' || '}' < lookahead)) ADVANCE(83);
      END_STATE();
    case 3:
      if (lookahead == '"') ADVANCE(43);
      if (lookahead == '\\') ADVANCE(5);
      if (lookahead != 0) ADVANCE(3);
      END_STATE();
    case 4:
      if (lookahead == '"') ADVANCE(44);
      if (lookahead == '\\') ADVANCE(6);
      if (lookahead != 0) ADVANCE(4);
      END_STATE();
    case 5:
      if (lookahead == 'u') ADVANCE(7);
      if (lookahead == 'x') ADVANCE(18);
      if (lookahead != 0) ADVANCE(3);
      END_STATE();
    case 6:
      if (lookahead == 'u') ADVANCE(8);
      if (lookahead == 'x') ADVANCE(19);
      if (lookahead != 0) ADVANCE(4);
      END_STATE();
    case 7:
      if (lookahead == '{') ADVANCE(16);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(13);
      END_STATE();
    case 8:
      if (lookahead == '{') ADVANCE(17);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(20);
      END_STATE();
    case 9:
      if (lookahead == '}') ADVANCE(3);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(9);
      END_STATE();
    case 10:
      if (lookahead == '}') ADVANCE(57);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(10);
      END_STATE();
    case 11:
      if (lookahead == '}') ADVANCE(4);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(11);
      END_STATE();
    case 12:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(3);
      END_STATE();
    case 13:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(18);
      END_STATE();
    case 14:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(10);
      END_STATE();
    case 15:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(4);
      END_STATE();
    case 16:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(9);
      END_STATE();
    case 17:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(11);
      END_STATE();
    case 18:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(12);
      END_STATE();
    case 19:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(15);
      END_STATE();
    case 20:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(19);
      END_STATE();
    case 21:
      if (eof) ADVANCE(23);
      if (lookahead == '"') ADVANCE(3);
      if (lookahead == '#') ADVANCE(24);
      if (lookahead == '&') ADVANCE(35);
      if (lookahead == '\'') ADVANCE(38);
      if (lookahead == '(') ADVANCE(26);
      if (lookahead == ')') ADVANCE(27);
      if (lookahead == ',') ADVANCE(41);
      if (lookahead == '.') ADVANCE(75);
      if (lookahead == '0') ADVANCE(45);
      if (lookahead == ':') ADVANCE(59);
      if (lookahead == ';') ADVANCE(39);
      if (lookahead == '@') ADVANCE(60);
      if (lookahead == '[') ADVANCE(28);
      if (lookahead == ']') ADVANCE(29);
      if (lookahead == '{') ADVANCE(32);
      if (lookahead == '|') ADVANCE(42);
      if (lookahead == '}') ADVANCE(33);
      if (lookahead == '~') ADVANCE(40);
      if (('+' <= lookahead && lookahead <= '-')) ADVANCE(61);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(21)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(46);
      if (lookahead != 0 &&
          lookahead != '`') ADVANCE(83);
      END_STATE();
    case 22:
      if (eof) ADVANCE(23);
      if (lookahead == '"') ADVANCE(3);
      if (lookahead == '#') ADVANCE(24);
      if (lookahead == '\'') ADVANCE(38);
      if (lookahead == '(') ADVANCE(26);
      if (lookahead == ')') ADVANCE(27);
      if (lookahead == ',') ADVANCE(41);
      if (lookahead == '.') ADVANCE(75);
      if (lookahead == '0') ADVANCE(45);
      if (lookahead == ':') ADVANCE(59);
      if (lookahead == ';') ADVANCE(39);
      if (lookahead == '@') ADVANCE(60);
      if (lookahead == '[') ADVANCE(28);
      if (lookahead == ']') ADVANCE(29);
      if (lookahead == '{') ADVANCE(32);
      if (lookahead == '|') ADVANCE(42);
      if (lookahead == '}') ADVANCE(33);
      if (lookahead == '~') ADVANCE(40);
      if (('+' <= lookahead && lookahead <= '-')) ADVANCE(61);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(22)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(46);
      if (lookahead != 0 &&
          lookahead != '`') ADVANCE(83);
      END_STATE();
    case 23:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 24:
      ACCEPT_TOKEN(sym_line_comment);
      if (sym_line_comment_character_set_1(lookahead)) ADVANCE(25);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(24);
      END_STATE();
    case 25:
      ACCEPT_TOKEN(sym_line_comment);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(25);
      END_STATE();
    case 26:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 27:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 28:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 29:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 30:
      ACCEPT_TOKEN(anon_sym_AT_LPAREN);
      END_STATE();
    case 31:
      ACCEPT_TOKEN(anon_sym_AT_LBRACK);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 33:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 34:
      ACCEPT_TOKEN(anon_sym_AT_LBRACE);
      END_STATE();
    case 35:
      ACCEPT_TOKEN(sym_variadic_marker);
      if (lookahead == 'k') ADVANCE(64);
      if (lookahead == 'o') ADVANCE(65);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 36:
      ACCEPT_TOKEN(sym_optional_marker);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 37:
      ACCEPT_TOKEN(sym_keys_marker);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 38:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 39:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 40:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 41:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 42:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(sym_str_literal);
      END_STATE();
    case 44:
      ACCEPT_TOKEN(sym_buffer_literal);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(aux_sym_number_literal_token1);
      if (lookahead == '.') ADVANCE(49);
      if (lookahead == '_') ADVANCE(48);
      if (lookahead == 'r') ADVANCE(62);
      if (lookahead == 'x') ADVANCE(63);
      if (lookahead == '&' ||
          lookahead == 'E' ||
          lookahead == 'e') ADVANCE(71);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(47);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(aux_sym_number_literal_token1);
      if (lookahead == '.') ADVANCE(49);
      if (lookahead == '_') ADVANCE(48);
      if (lookahead == 'r') ADVANCE(62);
      if (lookahead == '&' ||
          lookahead == 'E' ||
          lookahead == 'e') ADVANCE(71);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(47);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 47:
      ACCEPT_TOKEN(aux_sym_number_literal_token1);
      if (lookahead == '.') ADVANCE(49);
      if (lookahead == 'r') ADVANCE(62);
      if (lookahead == '&' ||
          lookahead == 'E' ||
          lookahead == 'e') ADVANCE(71);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(48);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 48:
      ACCEPT_TOKEN(aux_sym_number_literal_token1);
      if (lookahead == '.') ADVANCE(49);
      if (lookahead == '&' ||
          lookahead == 'E' ||
          lookahead == 'e') ADVANCE(71);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(48);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 49:
      ACCEPT_TOKEN(aux_sym_number_literal_token1);
      if (lookahead == '&' ||
          lookahead == 'E' ||
          lookahead == 'e') ADVANCE(71);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(49);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 50:
      ACCEPT_TOKEN(aux_sym_number_literal_token1);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(50);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 51:
      ACCEPT_TOKEN(aux_sym_number_literal_token2);
      if (lookahead == '&') ADVANCE(73);
      if (lookahead == '.') ADVANCE(52);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(51);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 52:
      ACCEPT_TOKEN(aux_sym_number_literal_token2);
      if (lookahead == '&') ADVANCE(73);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(52);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(aux_sym_number_literal_token2);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(53);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 54:
      ACCEPT_TOKEN(aux_sym_number_literal_token3);
      if (lookahead == '&') ADVANCE(72);
      if (lookahead == '.') ADVANCE(55);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(54);
      if (!sym_symbol_character_set_2(lookahead)) ADVANCE(83);
      END_STATE();
    case 55:
      ACCEPT_TOKEN(aux_sym_number_literal_token3);
      if (lookahead == '&') ADVANCE(72);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(55);
      if (!sym_symbol_character_set_2(lookahead)) ADVANCE(83);
      END_STATE();
    case 56:
      ACCEPT_TOKEN(aux_sym_number_literal_token3);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(56);
      if (!sym_symbol_character_set_2(lookahead)) ADVANCE(83);
      END_STATE();
    case 57:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 58:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(sym_keyword);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(59);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(sym_symbol);
      if (lookahead == '"') ADVANCE(4);
      if (lookahead == '(') ADVANCE(30);
      if (lookahead == '[') ADVANCE(31);
      if (lookahead == '{') ADVANCE(34);
      if (!sym_symbol_character_set_3(lookahead)) ADVANCE(83);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(sym_symbol);
      if (lookahead == '.') ADVANCE(75);
      if (lookahead == '0') ADVANCE(45);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(46);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(sym_symbol);
      if (lookahead == '.') ADVANCE(81);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(54);
      if (!sym_symbol_character_set_2(lookahead)) ADVANCE(83);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(sym_symbol);
      if (lookahead == '.') ADVANCE(80);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(51);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 64:
      ACCEPT_TOKEN(sym_symbol);
      if (lookahead == 'e') ADVANCE(69);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(sym_symbol);
      if (lookahead == 'p') ADVANCE(67);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(sym_symbol);
      if (lookahead == 's') ADVANCE(37);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(sym_symbol);
      if (lookahead == 't') ADVANCE(36);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(sym_symbol);
      if (lookahead == 'u') ADVANCE(70);
      if (lookahead == 'x') ADVANCE(79);
      if (sym_escape_sequence_character_set_1(lookahead)) ADVANCE(57);
      if (lookahead != 0) ADVANCE(58);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(sym_symbol);
      if (lookahead == 'y') ADVANCE(66);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(sym_symbol);
      if (lookahead == '{') ADVANCE(14);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(76);
      if (!sym_symbol_character_set_4(lookahead)) ADVANCE(83);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(sym_symbol);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(74);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(50);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(sym_symbol);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(82);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(56);
      if (!sym_symbol_character_set_2(lookahead)) ADVANCE(83);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(sym_symbol);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(78);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(53);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(sym_symbol);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(50);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(sym_symbol);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(49);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(sym_symbol);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(79);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(sym_symbol);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(58);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(sym_symbol);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(53);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(sym_symbol);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(77);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(sym_symbol);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(52);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(sym_symbol);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(55);
      if (!sym_symbol_character_set_2(lookahead)) ADVANCE(83);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(sym_symbol);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(56);
      if (!sym_symbol_character_set_2(lookahead)) ADVANCE(83);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(sym_symbol);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (lookahead == 'b') ADVANCE(1);
      if (lookahead == 'd') ADVANCE(2);
      if (lookahead == 'f') ADVANCE(3);
      if (lookahead == 'i') ADVANCE(4);
      if (lookahead == 'n') ADVANCE(5);
      if (lookahead == 'q') ADVANCE(6);
      if (lookahead == 's') ADVANCE(7);
      if (lookahead == 't') ADVANCE(8);
      if (lookahead == 'u') ADVANCE(9);
      if (lookahead == 'v') ADVANCE(10);
      if (lookahead == 'w') ADVANCE(11);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(0)
      END_STATE();
    case 1:
      if (lookahead == 'r') ADVANCE(12);
      END_STATE();
    case 2:
      if (lookahead == 'e') ADVANCE(13);
      if (lookahead == 'o') ADVANCE(14);
      END_STATE();
    case 3:
      if (lookahead == 'a') ADVANCE(15);
      if (lookahead == 'n') ADVANCE(16);
      END_STATE();
    case 4:
      if (lookahead == 'f') ADVANCE(17);
      END_STATE();
    case 5:
      if (lookahead == 'i') ADVANCE(18);
      END_STATE();
    case 6:
      if (lookahead == 'u') ADVANCE(19);
      END_STATE();
    case 7:
      if (lookahead == 'e') ADVANCE(20);
      if (lookahead == 'p') ADVANCE(21);
      END_STATE();
    case 8:
      if (lookahead == 'r') ADVANCE(22);
      END_STATE();
    case 9:
      if (lookahead == 'n') ADVANCE(23);
      if (lookahead == 'p') ADVANCE(24);
      END_STATE();
    case 10:
      if (lookahead == 'a') ADVANCE(25);
      END_STATE();
    case 11:
      if (lookahead == 'h') ADVANCE(26);
      END_STATE();
    case 12:
      if (lookahead == 'e') ADVANCE(27);
      END_STATE();
    case 13:
      if (lookahead == 'f') ADVANCE(28);
      END_STATE();
    case 14:
      ACCEPT_TOKEN(anon_sym_do);
      END_STATE();
    case 15:
      if (lookahead == 'l') ADVANCE(29);
      END_STATE();
    case 16:
      ACCEPT_TOKEN(anon_sym_fn);
      END_STATE();
    case 17:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 18:
      if (lookahead == 'l') ADVANCE(30);
      END_STATE();
    case 19:
      if (lookahead == 'a') ADVANCE(31);
      if (lookahead == 'o') ADVANCE(32);
      END_STATE();
    case 20:
      if (lookahead == 't') ADVANCE(33);
      END_STATE();
    case 21:
      if (lookahead == 'l') ADVANCE(34);
      END_STATE();
    case 22:
      if (lookahead == 'u') ADVANCE(35);
      END_STATE();
    case 23:
      if (lookahead == 'q') ADVANCE(36);
      END_STATE();
    case 24:
      if (lookahead == 's') ADVANCE(37);
      END_STATE();
    case 25:
      if (lookahead == 'r') ADVANCE(38);
      END_STATE();
    case 26:
      if (lookahead == 'i') ADVANCE(39);
      END_STATE();
    case 27:
      if (lookahead == 'a') ADVANCE(40);
      END_STATE();
    case 28:
      ACCEPT_TOKEN(anon_sym_def);
      if (lookahead == 'm') ADVANCE(41);
      if (lookahead == 'n') ADVANCE(42);
      END_STATE();
    case 29:
      if (lookahead == 's') ADVANCE(43);
      END_STATE();
    case 30:
      ACCEPT_TOKEN(sym_nil_literal);
      END_STATE();
    case 31:
      if (lookahead == 's') ADVANCE(44);
      END_STATE();
    case 32:
      if (lookahead == 't') ADVANCE(45);
      END_STATE();
    case 33:
      ACCEPT_TOKEN(anon_sym_set);
      END_STATE();
    case 34:
      if (lookahead == 'i') ADVANCE(46);
      END_STATE();
    case 35:
      if (lookahead == 'e') ADVANCE(47);
      END_STATE();
    case 36:
      if (lookahead == 'u') ADVANCE(48);
      END_STATE();
    case 37:
      if (lookahead == 'c') ADVANCE(49);
      END_STATE();
    case 38:
      ACCEPT_TOKEN(anon_sym_var);
      if (lookahead == 'f') ADVANCE(50);
      END_STATE();
    case 39:
      if (lookahead == 'l') ADVANCE(51);
      END_STATE();
    case 40:
      if (lookahead == 'k') ADVANCE(52);
      END_STATE();
    case 41:
      if (lookahead == 'a') ADVANCE(53);
      END_STATE();
    case 42:
      ACCEPT_TOKEN(anon_sym_defn);
      if (lookahead == '-') ADVANCE(54);
      END_STATE();
    case 43:
      if (lookahead == 'e') ADVANCE(55);
      END_STATE();
    case 44:
      if (lookahead == 'i') ADVANCE(56);
      END_STATE();
    case 45:
      if (lookahead == 'e') ADVANCE(57);
      END_STATE();
    case 46:
      if (lookahead == 'c') ADVANCE(58);
      END_STATE();
    case 47:
      ACCEPT_TOKEN(anon_sym_true);
      END_STATE();
    case 48:
      if (lookahead == 'o') ADVANCE(59);
      END_STATE();
    case 49:
      if (lookahead == 'o') ADVANCE(60);
      END_STATE();
    case 50:
      if (lookahead == 'n') ADVANCE(61);
      END_STATE();
    case 51:
      if (lookahead == 'e') ADVANCE(62);
      END_STATE();
    case 52:
      ACCEPT_TOKEN(anon_sym_break);
      END_STATE();
    case 53:
      if (lookahead == 'c') ADVANCE(63);
      END_STATE();
    case 54:
      ACCEPT_TOKEN(anon_sym_defn_DASH);
      END_STATE();
    case 55:
      ACCEPT_TOKEN(anon_sym_false);
      END_STATE();
    case 56:
      if (lookahead == 'q') ADVANCE(64);
      END_STATE();
    case 57:
      ACCEPT_TOKEN(anon_sym_quote);
      END_STATE();
    case 58:
      if (lookahead == 'e') ADVANCE(65);
      END_STATE();
    case 59:
      if (lookahead == 't') ADVANCE(66);
      END_STATE();
    case 60:
      if (lookahead == 'p') ADVANCE(67);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(anon_sym_varfn);
      if (lookahead == '-') ADVANCE(68);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 63:
      if (lookahead == 'r') ADVANCE(69);
      END_STATE();
    case 64:
      if (lookahead == 'u') ADVANCE(70);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(anon_sym_splice);
      END_STATE();
    case 66:
      if (lookahead == 'e') ADVANCE(71);
      END_STATE();
    case 67:
      if (lookahead == 'e') ADVANCE(72);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(anon_sym_varfn_DASH);
      END_STATE();
    case 69:
      if (lookahead == 'o') ADVANCE(73);
      END_STATE();
    case 70:
      if (lookahead == 'o') ADVANCE(74);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(anon_sym_unquote);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(anon_sym_upscope);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(anon_sym_defmacro);
      if (lookahead == '-') ADVANCE(75);
      END_STATE();
    case 74:
      if (lookahead == 't') ADVANCE(76);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(anon_sym_defmacro_DASH);
      END_STATE();
    case 76:
      if (lookahead == 'e') ADVANCE(77);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(anon_sym_quasiquote);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 22, .external_lex_state = 1},
  [2] = {.lex_state = 22, .external_lex_state = 1},
  [3] = {.lex_state = 22, .external_lex_state = 1},
  [4] = {.lex_state = 22, .external_lex_state = 1},
  [5] = {.lex_state = 22, .external_lex_state = 1},
  [6] = {.lex_state = 22, .external_lex_state = 1},
  [7] = {.lex_state = 22, .external_lex_state = 1},
  [8] = {.lex_state = 1, .external_lex_state = 1},
  [9] = {.lex_state = 1, .external_lex_state = 1},
  [10] = {.lex_state = 1, .external_lex_state = 1},
  [11] = {.lex_state = 1, .external_lex_state = 1},
  [12] = {.lex_state = 1, .external_lex_state = 1},
  [13] = {.lex_state = 22, .external_lex_state = 1},
  [14] = {.lex_state = 22, .external_lex_state = 1},
  [15] = {.lex_state = 22, .external_lex_state = 1},
  [16] = {.lex_state = 22, .external_lex_state = 1},
  [17] = {.lex_state = 22, .external_lex_state = 1},
  [18] = {.lex_state = 22, .external_lex_state = 1},
  [19] = {.lex_state = 22, .external_lex_state = 1},
  [20] = {.lex_state = 22, .external_lex_state = 1},
  [21] = {.lex_state = 22, .external_lex_state = 1},
  [22] = {.lex_state = 22, .external_lex_state = 1},
  [23] = {.lex_state = 22, .external_lex_state = 1},
  [24] = {.lex_state = 22, .external_lex_state = 1},
  [25] = {.lex_state = 22, .external_lex_state = 1},
  [26] = {.lex_state = 22, .external_lex_state = 1},
  [27] = {.lex_state = 22, .external_lex_state = 1},
  [28] = {.lex_state = 22, .external_lex_state = 1},
  [29] = {.lex_state = 22, .external_lex_state = 1},
  [30] = {.lex_state = 22, .external_lex_state = 1},
  [31] = {.lex_state = 22, .external_lex_state = 1},
  [32] = {.lex_state = 22, .external_lex_state = 1},
  [33] = {.lex_state = 22, .external_lex_state = 1},
  [34] = {.lex_state = 22, .external_lex_state = 1},
  [35] = {.lex_state = 22, .external_lex_state = 1},
  [36] = {.lex_state = 22, .external_lex_state = 1},
  [37] = {.lex_state = 22, .external_lex_state = 1},
  [38] = {.lex_state = 22, .external_lex_state = 1},
  [39] = {.lex_state = 22, .external_lex_state = 1},
  [40] = {.lex_state = 22, .external_lex_state = 1},
  [41] = {.lex_state = 22, .external_lex_state = 1},
  [42] = {.lex_state = 22, .external_lex_state = 1},
  [43] = {.lex_state = 22, .external_lex_state = 1},
  [44] = {.lex_state = 22, .external_lex_state = 1},
  [45] = {.lex_state = 22, .external_lex_state = 1},
  [46] = {.lex_state = 22, .external_lex_state = 1},
  [47] = {.lex_state = 22, .external_lex_state = 1},
  [48] = {.lex_state = 22, .external_lex_state = 1},
  [49] = {.lex_state = 22, .external_lex_state = 1},
  [50] = {.lex_state = 22, .external_lex_state = 1},
  [51] = {.lex_state = 22, .external_lex_state = 1},
  [52] = {.lex_state = 22, .external_lex_state = 1},
  [53] = {.lex_state = 22, .external_lex_state = 1},
  [54] = {.lex_state = 22, .external_lex_state = 1},
  [55] = {.lex_state = 22, .external_lex_state = 1},
  [56] = {.lex_state = 22, .external_lex_state = 1},
  [57] = {.lex_state = 22, .external_lex_state = 1},
  [58] = {.lex_state = 22, .external_lex_state = 1},
  [59] = {.lex_state = 22, .external_lex_state = 1},
  [60] = {.lex_state = 22, .external_lex_state = 1},
  [61] = {.lex_state = 22, .external_lex_state = 1},
  [62] = {.lex_state = 22, .external_lex_state = 1},
  [63] = {.lex_state = 22, .external_lex_state = 1},
  [64] = {.lex_state = 22, .external_lex_state = 1},
  [65] = {.lex_state = 22, .external_lex_state = 1},
  [66] = {.lex_state = 22, .external_lex_state = 1},
  [67] = {.lex_state = 22, .external_lex_state = 1},
  [68] = {.lex_state = 22, .external_lex_state = 1},
  [69] = {.lex_state = 22, .external_lex_state = 1},
  [70] = {.lex_state = 22, .external_lex_state = 1},
  [71] = {.lex_state = 22, .external_lex_state = 1},
  [72] = {.lex_state = 22, .external_lex_state = 1},
  [73] = {.lex_state = 22, .external_lex_state = 1},
  [74] = {.lex_state = 22, .external_lex_state = 1},
  [75] = {.lex_state = 22, .external_lex_state = 1},
  [76] = {.lex_state = 22, .external_lex_state = 1},
  [77] = {.lex_state = 22, .external_lex_state = 1},
  [78] = {.lex_state = 22, .external_lex_state = 1},
  [79] = {.lex_state = 22, .external_lex_state = 1},
  [80] = {.lex_state = 22, .external_lex_state = 1},
  [81] = {.lex_state = 22, .external_lex_state = 1},
  [82] = {.lex_state = 22, .external_lex_state = 1},
  [83] = {.lex_state = 22, .external_lex_state = 1},
  [84] = {.lex_state = 22, .external_lex_state = 1},
  [85] = {.lex_state = 22, .external_lex_state = 1},
  [86] = {.lex_state = 22, .external_lex_state = 1},
  [87] = {.lex_state = 22, .external_lex_state = 1},
  [88] = {.lex_state = 22, .external_lex_state = 1},
  [89] = {.lex_state = 22, .external_lex_state = 1},
  [90] = {.lex_state = 22, .external_lex_state = 1},
  [91] = {.lex_state = 22, .external_lex_state = 1},
  [92] = {.lex_state = 22, .external_lex_state = 1},
  [93] = {.lex_state = 22, .external_lex_state = 1},
  [94] = {.lex_state = 22, .external_lex_state = 1},
  [95] = {.lex_state = 22, .external_lex_state = 1},
  [96] = {.lex_state = 22, .external_lex_state = 1},
  [97] = {.lex_state = 22, .external_lex_state = 1},
  [98] = {.lex_state = 22, .external_lex_state = 1},
  [99] = {.lex_state = 22, .external_lex_state = 1},
  [100] = {.lex_state = 22, .external_lex_state = 1},
  [101] = {.lex_state = 22, .external_lex_state = 1},
  [102] = {.lex_state = 22, .external_lex_state = 1},
  [103] = {.lex_state = 22, .external_lex_state = 1},
  [104] = {.lex_state = 22, .external_lex_state = 1},
  [105] = {.lex_state = 22, .external_lex_state = 1},
  [106] = {.lex_state = 22, .external_lex_state = 1},
  [107] = {.lex_state = 22, .external_lex_state = 1},
  [108] = {.lex_state = 22, .external_lex_state = 1},
  [109] = {.lex_state = 22, .external_lex_state = 1},
  [110] = {.lex_state = 22, .external_lex_state = 1},
  [111] = {.lex_state = 22, .external_lex_state = 1},
  [112] = {.lex_state = 22, .external_lex_state = 1},
  [113] = {.lex_state = 22, .external_lex_state = 1},
  [114] = {.lex_state = 22, .external_lex_state = 1},
  [115] = {.lex_state = 22, .external_lex_state = 1},
  [116] = {.lex_state = 22, .external_lex_state = 1},
  [117] = {.lex_state = 22, .external_lex_state = 1},
  [118] = {.lex_state = 22, .external_lex_state = 1},
  [119] = {.lex_state = 22, .external_lex_state = 1},
  [120] = {.lex_state = 22, .external_lex_state = 1},
  [121] = {.lex_state = 22, .external_lex_state = 1},
  [122] = {.lex_state = 22, .external_lex_state = 1},
  [123] = {.lex_state = 22, .external_lex_state = 1},
  [124] = {.lex_state = 22, .external_lex_state = 1},
  [125] = {.lex_state = 22, .external_lex_state = 1},
  [126] = {.lex_state = 22, .external_lex_state = 1},
  [127] = {.lex_state = 22, .external_lex_state = 1},
  [128] = {.lex_state = 22, .external_lex_state = 1},
  [129] = {.lex_state = 22, .external_lex_state = 1},
  [130] = {.lex_state = 22, .external_lex_state = 1},
  [131] = {.lex_state = 22, .external_lex_state = 1},
  [132] = {.lex_state = 22, .external_lex_state = 1},
  [133] = {.lex_state = 22, .external_lex_state = 1},
  [134] = {.lex_state = 22, .external_lex_state = 1},
  [135] = {.lex_state = 22, .external_lex_state = 1},
  [136] = {.lex_state = 22, .external_lex_state = 1},
  [137] = {.lex_state = 22, .external_lex_state = 1},
  [138] = {.lex_state = 22, .external_lex_state = 1},
  [139] = {.lex_state = 22, .external_lex_state = 1},
  [140] = {.lex_state = 22, .external_lex_state = 1},
  [141] = {.lex_state = 22, .external_lex_state = 1},
  [142] = {.lex_state = 22, .external_lex_state = 1},
  [143] = {.lex_state = 22, .external_lex_state = 1},
  [144] = {.lex_state = 22, .external_lex_state = 1},
  [145] = {.lex_state = 22, .external_lex_state = 1},
  [146] = {.lex_state = 22, .external_lex_state = 1},
  [147] = {.lex_state = 22, .external_lex_state = 1},
  [148] = {.lex_state = 22, .external_lex_state = 1},
  [149] = {.lex_state = 22, .external_lex_state = 1},
  [150] = {.lex_state = 22, .external_lex_state = 1},
  [151] = {.lex_state = 22, .external_lex_state = 1},
  [152] = {.lex_state = 22, .external_lex_state = 1},
  [153] = {.lex_state = 22, .external_lex_state = 1},
  [154] = {.lex_state = 22, .external_lex_state = 1},
  [155] = {.lex_state = 22, .external_lex_state = 1},
  [156] = {.lex_state = 22, .external_lex_state = 1},
  [157] = {.lex_state = 22, .external_lex_state = 1},
  [158] = {.lex_state = 22, .external_lex_state = 1},
  [159] = {.lex_state = 22, .external_lex_state = 1},
  [160] = {.lex_state = 22, .external_lex_state = 1},
  [161] = {.lex_state = 22, .external_lex_state = 1},
  [162] = {.lex_state = 22, .external_lex_state = 1},
  [163] = {.lex_state = 22, .external_lex_state = 1},
  [164] = {.lex_state = 22, .external_lex_state = 1},
  [165] = {.lex_state = 22, .external_lex_state = 1},
  [166] = {.lex_state = 22, .external_lex_state = 1},
  [167] = {.lex_state = 22, .external_lex_state = 1},
  [168] = {.lex_state = 22, .external_lex_state = 1},
  [169] = {.lex_state = 22, .external_lex_state = 1},
  [170] = {.lex_state = 22, .external_lex_state = 1},
  [171] = {.lex_state = 22, .external_lex_state = 1},
  [172] = {.lex_state = 22, .external_lex_state = 1},
  [173] = {.lex_state = 22, .external_lex_state = 1},
  [174] = {.lex_state = 22, .external_lex_state = 1},
  [175] = {.lex_state = 22, .external_lex_state = 1},
  [176] = {.lex_state = 22, .external_lex_state = 1},
  [177] = {.lex_state = 22, .external_lex_state = 1},
  [178] = {.lex_state = 22, .external_lex_state = 1},
  [179] = {.lex_state = 22, .external_lex_state = 1},
  [180] = {.lex_state = 22, .external_lex_state = 1},
  [181] = {.lex_state = 22, .external_lex_state = 1},
  [182] = {.lex_state = 22, .external_lex_state = 1},
  [183] = {.lex_state = 22, .external_lex_state = 1},
  [184] = {.lex_state = 22, .external_lex_state = 1},
  [185] = {.lex_state = 22, .external_lex_state = 1},
  [186] = {.lex_state = 22, .external_lex_state = 1},
  [187] = {.lex_state = 22, .external_lex_state = 1},
  [188] = {.lex_state = 22, .external_lex_state = 1},
  [189] = {.lex_state = 22, .external_lex_state = 1},
  [190] = {.lex_state = 22, .external_lex_state = 1},
  [191] = {.lex_state = 22, .external_lex_state = 1},
  [192] = {.lex_state = 22, .external_lex_state = 1},
  [193] = {.lex_state = 22, .external_lex_state = 1},
  [194] = {.lex_state = 22, .external_lex_state = 1},
  [195] = {.lex_state = 22, .external_lex_state = 1},
  [196] = {.lex_state = 22, .external_lex_state = 1},
  [197] = {.lex_state = 22, .external_lex_state = 1},
  [198] = {.lex_state = 22, .external_lex_state = 1},
  [199] = {.lex_state = 22, .external_lex_state = 1},
  [200] = {.lex_state = 22, .external_lex_state = 1},
  [201] = {.lex_state = 22, .external_lex_state = 1},
  [202] = {.lex_state = 22, .external_lex_state = 1},
  [203] = {.lex_state = 22, .external_lex_state = 1},
  [204] = {.lex_state = 22, .external_lex_state = 1},
  [205] = {.lex_state = 22, .external_lex_state = 1},
  [206] = {.lex_state = 22, .external_lex_state = 1},
  [207] = {.lex_state = 22, .external_lex_state = 1},
  [208] = {.lex_state = 22, .external_lex_state = 1},
  [209] = {.lex_state = 22, .external_lex_state = 1},
  [210] = {.lex_state = 22, .external_lex_state = 1},
  [211] = {.lex_state = 22, .external_lex_state = 1},
  [212] = {.lex_state = 22, .external_lex_state = 1},
  [213] = {.lex_state = 22, .external_lex_state = 1},
  [214] = {.lex_state = 22, .external_lex_state = 1},
  [215] = {.lex_state = 22, .external_lex_state = 1},
  [216] = {.lex_state = 22, .external_lex_state = 1},
  [217] = {.lex_state = 22, .external_lex_state = 1},
  [218] = {.lex_state = 22, .external_lex_state = 1},
  [219] = {.lex_state = 22, .external_lex_state = 1},
  [220] = {.lex_state = 22, .external_lex_state = 1},
  [221] = {.lex_state = 22, .external_lex_state = 1},
  [222] = {.lex_state = 22, .external_lex_state = 1},
  [223] = {.lex_state = 22, .external_lex_state = 1},
  [224] = {.lex_state = 22, .external_lex_state = 1},
  [225] = {.lex_state = 22, .external_lex_state = 1},
  [226] = {.lex_state = 22, .external_lex_state = 1},
  [227] = {.lex_state = 22, .external_lex_state = 1},
  [228] = {.lex_state = 22, .external_lex_state = 1},
  [229] = {.lex_state = 22, .external_lex_state = 1},
  [230] = {.lex_state = 22, .external_lex_state = 1},
  [231] = {.lex_state = 22, .external_lex_state = 1},
  [232] = {.lex_state = 22, .external_lex_state = 1},
  [233] = {.lex_state = 22, .external_lex_state = 1},
  [234] = {.lex_state = 22, .external_lex_state = 1},
  [235] = {.lex_state = 22, .external_lex_state = 1},
  [236] = {.lex_state = 22, .external_lex_state = 1},
  [237] = {.lex_state = 22, .external_lex_state = 1},
  [238] = {.lex_state = 22, .external_lex_state = 1},
  [239] = {.lex_state = 22, .external_lex_state = 1},
  [240] = {.lex_state = 22, .external_lex_state = 1},
  [241] = {.lex_state = 22, .external_lex_state = 1},
  [242] = {.lex_state = 22, .external_lex_state = 1},
  [243] = {.lex_state = 1, .external_lex_state = 1},
  [244] = {.lex_state = 1, .external_lex_state = 1},
  [245] = {.lex_state = 1, .external_lex_state = 1},
  [246] = {.lex_state = 1, .external_lex_state = 1},
  [247] = {.lex_state = 1, .external_lex_state = 1},
  [248] = {.lex_state = 1, .external_lex_state = 1},
  [249] = {.lex_state = 1, .external_lex_state = 1},
  [250] = {.lex_state = 1, .external_lex_state = 1},
  [251] = {.lex_state = 1, .external_lex_state = 1},
  [252] = {.lex_state = 1, .external_lex_state = 1},
  [253] = {.lex_state = 1, .external_lex_state = 1},
  [254] = {.lex_state = 1, .external_lex_state = 1},
  [255] = {.lex_state = 1, .external_lex_state = 1},
  [256] = {.lex_state = 1, .external_lex_state = 1},
  [257] = {.lex_state = 1, .external_lex_state = 1},
  [258] = {.lex_state = 1, .external_lex_state = 1},
  [259] = {.lex_state = 1, .external_lex_state = 1},
  [260] = {.lex_state = 1, .external_lex_state = 1},
  [261] = {.lex_state = 1, .external_lex_state = 1},
  [262] = {.lex_state = 1, .external_lex_state = 1},
  [263] = {.lex_state = 1, .external_lex_state = 1},
  [264] = {.lex_state = 1, .external_lex_state = 1},
  [265] = {.lex_state = 1, .external_lex_state = 1},
  [266] = {.lex_state = 1, .external_lex_state = 1},
  [267] = {.lex_state = 1, .external_lex_state = 1},
  [268] = {.lex_state = 1, .external_lex_state = 1},
  [269] = {.lex_state = 1, .external_lex_state = 1},
  [270] = {.lex_state = 1, .external_lex_state = 1},
  [271] = {.lex_state = 1, .external_lex_state = 1},
  [272] = {.lex_state = 1, .external_lex_state = 1},
  [273] = {.lex_state = 1, .external_lex_state = 1},
  [274] = {.lex_state = 1, .external_lex_state = 1},
  [275] = {.lex_state = 1, .external_lex_state = 1},
  [276] = {.lex_state = 1, .external_lex_state = 1},
  [277] = {.lex_state = 1, .external_lex_state = 1},
  [278] = {.lex_state = 1, .external_lex_state = 1},
  [279] = {.lex_state = 1, .external_lex_state = 1},
  [280] = {.lex_state = 1, .external_lex_state = 1},
  [281] = {.lex_state = 1, .external_lex_state = 1},
  [282] = {.lex_state = 1, .external_lex_state = 1},
  [283] = {.lex_state = 1, .external_lex_state = 1},
  [284] = {.lex_state = 1, .external_lex_state = 1},
  [285] = {.lex_state = 1, .external_lex_state = 1},
  [286] = {.lex_state = 1, .external_lex_state = 1},
  [287] = {.lex_state = 1, .external_lex_state = 1},
  [288] = {.lex_state = 1, .external_lex_state = 1},
  [289] = {.lex_state = 1, .external_lex_state = 1},
  [290] = {.lex_state = 1, .external_lex_state = 1},
  [291] = {.lex_state = 1, .external_lex_state = 1},
  [292] = {.lex_state = 1, .external_lex_state = 1},
  [293] = {.lex_state = 1, .external_lex_state = 1},
  [294] = {.lex_state = 1, .external_lex_state = 1},
  [295] = {.lex_state = 1, .external_lex_state = 1},
  [296] = {.lex_state = 1, .external_lex_state = 1},
  [297] = {.lex_state = 1, .external_lex_state = 1},
  [298] = {.lex_state = 1, .external_lex_state = 1},
  [299] = {.lex_state = 1, .external_lex_state = 1},
  [300] = {.lex_state = 1, .external_lex_state = 1},
  [301] = {.lex_state = 1, .external_lex_state = 1},
  [302] = {.lex_state = 1, .external_lex_state = 1},
  [303] = {.lex_state = 22, .external_lex_state = 1},
  [304] = {.lex_state = 22, .external_lex_state = 1},
  [305] = {.lex_state = 22, .external_lex_state = 1},
  [306] = {.lex_state = 22, .external_lex_state = 1},
  [307] = {.lex_state = 22, .external_lex_state = 1},
  [308] = {.lex_state = 22, .external_lex_state = 1},
  [309] = {.lex_state = 22, .external_lex_state = 1},
  [310] = {.lex_state = 22, .external_lex_state = 1},
  [311] = {.lex_state = 22, .external_lex_state = 1},
  [312] = {.lex_state = 22, .external_lex_state = 1},
  [313] = {.lex_state = 22, .external_lex_state = 1},
  [314] = {.lex_state = 22, .external_lex_state = 1},
  [315] = {.lex_state = 22, .external_lex_state = 1},
  [316] = {.lex_state = 22, .external_lex_state = 1},
  [317] = {.lex_state = 22, .external_lex_state = 1},
  [318] = {.lex_state = 22, .external_lex_state = 1},
  [319] = {.lex_state = 22, .external_lex_state = 1},
  [320] = {.lex_state = 22, .external_lex_state = 1},
  [321] = {.lex_state = 22, .external_lex_state = 1},
  [322] = {.lex_state = 22, .external_lex_state = 1},
  [323] = {.lex_state = 22, .external_lex_state = 1},
  [324] = {.lex_state = 22, .external_lex_state = 1},
  [325] = {.lex_state = 22, .external_lex_state = 1},
  [326] = {.lex_state = 22, .external_lex_state = 1},
  [327] = {.lex_state = 22, .external_lex_state = 1},
  [328] = {.lex_state = 22, .external_lex_state = 1},
  [329] = {.lex_state = 22, .external_lex_state = 1},
  [330] = {.lex_state = 22, .external_lex_state = 1},
  [331] = {.lex_state = 22, .external_lex_state = 1},
  [332] = {.lex_state = 22, .external_lex_state = 1},
  [333] = {.lex_state = 22, .external_lex_state = 1},
  [334] = {.lex_state = 22, .external_lex_state = 1},
  [335] = {.lex_state = 22, .external_lex_state = 1},
  [336] = {.lex_state = 22, .external_lex_state = 1},
  [337] = {.lex_state = 22, .external_lex_state = 1},
  [338] = {.lex_state = 22, .external_lex_state = 1},
  [339] = {.lex_state = 22, .external_lex_state = 1},
  [340] = {.lex_state = 22, .external_lex_state = 1},
  [341] = {.lex_state = 22, .external_lex_state = 1},
  [342] = {.lex_state = 22, .external_lex_state = 1},
  [343] = {.lex_state = 22, .external_lex_state = 1},
  [344] = {.lex_state = 22, .external_lex_state = 1},
  [345] = {.lex_state = 22, .external_lex_state = 1},
  [346] = {.lex_state = 22, .external_lex_state = 1},
  [347] = {.lex_state = 22, .external_lex_state = 1},
  [348] = {.lex_state = 22, .external_lex_state = 1},
  [349] = {.lex_state = 22, .external_lex_state = 1},
  [350] = {.lex_state = 22, .external_lex_state = 1},
  [351] = {.lex_state = 22, .external_lex_state = 1},
  [352] = {.lex_state = 22, .external_lex_state = 1},
  [353] = {.lex_state = 22, .external_lex_state = 1},
  [354] = {.lex_state = 22, .external_lex_state = 1},
  [355] = {.lex_state = 22, .external_lex_state = 1},
  [356] = {.lex_state = 22, .external_lex_state = 1},
  [357] = {.lex_state = 22, .external_lex_state = 1},
  [358] = {.lex_state = 22, .external_lex_state = 1},
  [359] = {.lex_state = 22, .external_lex_state = 1},
  [360] = {.lex_state = 22, .external_lex_state = 1},
  [361] = {.lex_state = 22, .external_lex_state = 1},
  [362] = {.lex_state = 22, .external_lex_state = 1},
  [363] = {.lex_state = 2, .external_lex_state = 2},
  [364] = {.lex_state = 2, .external_lex_state = 2},
  [365] = {.lex_state = 2, .external_lex_state = 2},
  [366] = {.lex_state = 2, .external_lex_state = 2},
  [367] = {.lex_state = 2, .external_lex_state = 2},
  [368] = {.lex_state = 22, .external_lex_state = 1},
  [369] = {.lex_state = 2, .external_lex_state = 2},
  [370] = {.lex_state = 2, .external_lex_state = 2},
  [371] = {.lex_state = 2, .external_lex_state = 2},
  [372] = {.lex_state = 2, .external_lex_state = 2},
  [373] = {.lex_state = 2, .external_lex_state = 2},
  [374] = {.lex_state = 22, .external_lex_state = 1},
  [375] = {.lex_state = 22, .external_lex_state = 1},
  [376] = {.lex_state = 22, .external_lex_state = 1},
  [377] = {.lex_state = 22, .external_lex_state = 1},
  [378] = {.lex_state = 22, .external_lex_state = 1},
  [379] = {.lex_state = 22, .external_lex_state = 1},
  [380] = {.lex_state = 22, .external_lex_state = 1},
  [381] = {.lex_state = 22, .external_lex_state = 1},
  [382] = {.lex_state = 22, .external_lex_state = 1},
  [383] = {.lex_state = 22, .external_lex_state = 1},
  [384] = {.lex_state = 22, .external_lex_state = 1},
  [385] = {.lex_state = 22, .external_lex_state = 1},
  [386] = {.lex_state = 22, .external_lex_state = 1},
  [387] = {.lex_state = 22, .external_lex_state = 1},
  [388] = {.lex_state = 22, .external_lex_state = 1},
  [389] = {.lex_state = 22, .external_lex_state = 1},
  [390] = {.lex_state = 22, .external_lex_state = 1},
  [391] = {.lex_state = 22, .external_lex_state = 1},
  [392] = {.lex_state = 22, .external_lex_state = 1},
  [393] = {.lex_state = 22, .external_lex_state = 1},
  [394] = {.lex_state = 22, .external_lex_state = 1},
  [395] = {.lex_state = 22, .external_lex_state = 1},
  [396] = {.lex_state = 22, .external_lex_state = 1},
  [397] = {.lex_state = 22, .external_lex_state = 1},
  [398] = {.lex_state = 22, .external_lex_state = 1},
  [399] = {.lex_state = 22, .external_lex_state = 1},
  [400] = {.lex_state = 22, .external_lex_state = 1},
  [401] = {.lex_state = 22, .external_lex_state = 1},
  [402] = {.lex_state = 22, .external_lex_state = 1},
  [403] = {.lex_state = 22, .external_lex_state = 1},
  [404] = {.lex_state = 22, .external_lex_state = 1},
  [405] = {.lex_state = 22, .external_lex_state = 1},
  [406] = {.lex_state = 22, .external_lex_state = 1},
  [407] = {.lex_state = 22, .external_lex_state = 1},
  [408] = {.lex_state = 22, .external_lex_state = 1},
  [409] = {.lex_state = 22, .external_lex_state = 1},
  [410] = {.lex_state = 22, .external_lex_state = 1},
  [411] = {.lex_state = 22, .external_lex_state = 1},
  [412] = {.lex_state = 22, .external_lex_state = 1},
  [413] = {.lex_state = 22, .external_lex_state = 1},
  [414] = {.lex_state = 22, .external_lex_state = 1},
  [415] = {.lex_state = 22, .external_lex_state = 1},
  [416] = {.lex_state = 22, .external_lex_state = 1},
  [417] = {.lex_state = 22, .external_lex_state = 1},
  [418] = {.lex_state = 22, .external_lex_state = 1},
  [419] = {.lex_state = 22, .external_lex_state = 1},
  [420] = {.lex_state = 22, .external_lex_state = 1},
  [421] = {.lex_state = 22, .external_lex_state = 1},
  [422] = {.lex_state = 22, .external_lex_state = 1},
  [423] = {.lex_state = 22, .external_lex_state = 1},
  [424] = {.lex_state = 22, .external_lex_state = 1},
  [425] = {.lex_state = 22, .external_lex_state = 1},
  [426] = {.lex_state = 22, .external_lex_state = 1},
  [427] = {.lex_state = 22, .external_lex_state = 1},
  [428] = {.lex_state = 22, .external_lex_state = 1},
  [429] = {.lex_state = 22, .external_lex_state = 1},
  [430] = {.lex_state = 22, .external_lex_state = 1},
  [431] = {.lex_state = 22, .external_lex_state = 1},
  [432] = {.lex_state = 22, .external_lex_state = 1},
  [433] = {.lex_state = 22, .external_lex_state = 1},
  [434] = {.lex_state = 22, .external_lex_state = 1},
  [435] = {.lex_state = 22, .external_lex_state = 1},
  [436] = {.lex_state = 22, .external_lex_state = 1},
  [437] = {.lex_state = 22, .external_lex_state = 1},
  [438] = {.lex_state = 22, .external_lex_state = 1},
  [439] = {.lex_state = 22, .external_lex_state = 1},
  [440] = {.lex_state = 22, .external_lex_state = 1},
  [441] = {.lex_state = 22, .external_lex_state = 1},
  [442] = {.lex_state = 22, .external_lex_state = 1},
  [443] = {.lex_state = 22, .external_lex_state = 1},
  [444] = {.lex_state = 22, .external_lex_state = 1},
  [445] = {.lex_state = 22, .external_lex_state = 1},
  [446] = {.lex_state = 22, .external_lex_state = 1},
  [447] = {.lex_state = 22, .external_lex_state = 1},
  [448] = {.lex_state = 22, .external_lex_state = 1},
  [449] = {.lex_state = 22, .external_lex_state = 1},
  [450] = {.lex_state = 22, .external_lex_state = 1},
  [451] = {.lex_state = 22, .external_lex_state = 1},
  [452] = {.lex_state = 22, .external_lex_state = 1},
  [453] = {.lex_state = 22, .external_lex_state = 1},
  [454] = {.lex_state = 22, .external_lex_state = 1},
  [455] = {.lex_state = 22, .external_lex_state = 1},
  [456] = {.lex_state = 22, .external_lex_state = 1},
  [457] = {.lex_state = 22, .external_lex_state = 1},
  [458] = {.lex_state = 22, .external_lex_state = 1},
  [459] = {.lex_state = 22, .external_lex_state = 1},
  [460] = {.lex_state = 22, .external_lex_state = 1},
  [461] = {.lex_state = 22, .external_lex_state = 1},
  [462] = {.lex_state = 22, .external_lex_state = 1},
  [463] = {.lex_state = 22, .external_lex_state = 1},
  [464] = {.lex_state = 22, .external_lex_state = 1},
  [465] = {.lex_state = 22, .external_lex_state = 1},
  [466] = {.lex_state = 22, .external_lex_state = 1},
  [467] = {.lex_state = 22, .external_lex_state = 1},
  [468] = {.lex_state = 22, .external_lex_state = 1},
  [469] = {.lex_state = 22, .external_lex_state = 1},
  [470] = {.lex_state = 22, .external_lex_state = 1},
  [471] = {.lex_state = 22, .external_lex_state = 1},
  [472] = {.lex_state = 22, .external_lex_state = 1},
  [473] = {.lex_state = 22, .external_lex_state = 1},
  [474] = {.lex_state = 22, .external_lex_state = 1},
  [475] = {.lex_state = 22, .external_lex_state = 1},
  [476] = {.lex_state = 22, .external_lex_state = 1},
  [477] = {.lex_state = 22, .external_lex_state = 1},
  [478] = {.lex_state = 22, .external_lex_state = 1},
  [479] = {.lex_state = 22, .external_lex_state = 1},
  [480] = {.lex_state = 2},
  [481] = {.lex_state = 2},
  [482] = {.lex_state = 2},
  [483] = {.lex_state = 2},
  [484] = {.lex_state = 2},
  [485] = {.lex_state = 2, .external_lex_state = 2},
  [486] = {.lex_state = 2},
  [487] = {.lex_state = 2},
  [488] = {.lex_state = 2},
  [489] = {.lex_state = 2},
  [490] = {.lex_state = 2},
  [491] = {.lex_state = 2},
  [492] = {.lex_state = 2},
  [493] = {.lex_state = 2},
  [494] = {.lex_state = 2},
  [495] = {.lex_state = 2},
  [496] = {.lex_state = 2, .external_lex_state = 2},
  [497] = {.lex_state = 2, .external_lex_state = 2},
  [498] = {.lex_state = 2, .external_lex_state = 2},
  [499] = {.lex_state = 2, .external_lex_state = 2},
  [500] = {.lex_state = 2, .external_lex_state = 2},
  [501] = {.lex_state = 2, .external_lex_state = 2},
  [502] = {.lex_state = 2, .external_lex_state = 2},
  [503] = {.lex_state = 2, .external_lex_state = 2},
  [504] = {.lex_state = 2, .external_lex_state = 2},
  [505] = {.lex_state = 2, .external_lex_state = 2},
  [506] = {.lex_state = 2, .external_lex_state = 2},
  [507] = {.lex_state = 2, .external_lex_state = 2},
  [508] = {.lex_state = 2, .external_lex_state = 2},
  [509] = {.lex_state = 2, .external_lex_state = 2},
  [510] = {.lex_state = 2, .external_lex_state = 2},
  [511] = {.lex_state = 2, .external_lex_state = 2},
  [512] = {.lex_state = 2, .external_lex_state = 2},
  [513] = {.lex_state = 2, .external_lex_state = 2},
  [514] = {.lex_state = 2, .external_lex_state = 2},
  [515] = {.lex_state = 2, .external_lex_state = 2},
  [516] = {.lex_state = 2, .external_lex_state = 2},
  [517] = {.lex_state = 2, .external_lex_state = 2},
  [518] = {.lex_state = 2, .external_lex_state = 2},
  [519] = {.lex_state = 2, .external_lex_state = 2},
  [520] = {.lex_state = 2, .external_lex_state = 2},
  [521] = {.lex_state = 2, .external_lex_state = 2},
  [522] = {.lex_state = 2, .external_lex_state = 2},
  [523] = {.lex_state = 2, .external_lex_state = 2},
  [524] = {.lex_state = 2, .external_lex_state = 2},
  [525] = {.lex_state = 2, .external_lex_state = 2},
  [526] = {.lex_state = 2, .external_lex_state = 2},
  [527] = {.lex_state = 2, .external_lex_state = 2},
  [528] = {.lex_state = 2, .external_lex_state = 2},
  [529] = {.lex_state = 2, .external_lex_state = 2},
  [530] = {.lex_state = 2, .external_lex_state = 2},
  [531] = {.lex_state = 2, .external_lex_state = 2},
  [532] = {.lex_state = 2, .external_lex_state = 2},
  [533] = {.lex_state = 2, .external_lex_state = 2},
  [534] = {.lex_state = 2, .external_lex_state = 2},
  [535] = {.lex_state = 2, .external_lex_state = 2},
  [536] = {.lex_state = 2, .external_lex_state = 2},
  [537] = {.lex_state = 2, .external_lex_state = 2},
  [538] = {.lex_state = 2, .external_lex_state = 2},
  [539] = {.lex_state = 2, .external_lex_state = 2},
  [540] = {.lex_state = 2, .external_lex_state = 2},
  [541] = {.lex_state = 2, .external_lex_state = 2},
  [542] = {.lex_state = 2, .external_lex_state = 2},
  [543] = {.lex_state = 2, .external_lex_state = 2},
  [544] = {.lex_state = 2, .external_lex_state = 2},
  [545] = {.lex_state = 2, .external_lex_state = 2},
  [546] = {.lex_state = 2, .external_lex_state = 2},
  [547] = {.lex_state = 2, .external_lex_state = 2},
  [548] = {.lex_state = 2, .external_lex_state = 2},
  [549] = {.lex_state = 2, .external_lex_state = 2},
  [550] = {.lex_state = 2, .external_lex_state = 2},
  [551] = {.lex_state = 2, .external_lex_state = 2},
  [552] = {.lex_state = 2, .external_lex_state = 2},
  [553] = {.lex_state = 2, .external_lex_state = 2},
  [554] = {.lex_state = 2, .external_lex_state = 2},
  [555] = {.lex_state = 2, .external_lex_state = 2},
  [556] = {.lex_state = 2, .external_lex_state = 2},
  [557] = {.lex_state = 2},
  [558] = {.lex_state = 2},
  [559] = {.lex_state = 0},
  [560] = {.lex_state = 0},
  [561] = {.lex_state = 0},
  [562] = {.lex_state = 0},
  [563] = {.lex_state = 0},
  [564] = {.lex_state = 0},
  [565] = {.lex_state = 0},
  [566] = {.lex_state = 0},
  [567] = {.lex_state = 0},
  [568] = {.lex_state = 0},
  [569] = {.lex_state = 0},
  [570] = {.lex_state = 0},
  [571] = {.lex_state = 0},
  [572] = {.lex_state = 0},
  [573] = {.lex_state = 0},
  [574] = {.lex_state = 0},
  [575] = {.lex_state = 0},
  [576] = {.lex_state = 0},
  [577] = {.lex_state = 0},
  [578] = {.lex_state = 0},
  [579] = {.lex_state = 0},
  [580] = {.lex_state = 0},
  [581] = {.lex_state = 0},
  [582] = {.lex_state = 0},
  [583] = {.lex_state = 0},
  [584] = {.lex_state = 0},
  [585] = {.lex_state = 0},
  [586] = {.lex_state = 0},
  [587] = {.lex_state = 0},
  [588] = {.lex_state = 0},
  [589] = {.lex_state = 0},
  [590] = {.lex_state = 0},
  [591] = {.lex_state = 0},
  [592] = {.lex_state = 0},
  [593] = {.lex_state = 0},
  [594] = {.lex_state = 0},
  [595] = {.lex_state = 0},
  [596] = {.lex_state = 0},
  [597] = {.lex_state = 0},
  [598] = {.lex_state = 0},
  [599] = {.lex_state = 0},
  [600] = {.lex_state = 0},
  [601] = {.lex_state = 0},
  [602] = {.lex_state = 0},
  [603] = {.lex_state = 0},
  [604] = {.lex_state = 0},
  [605] = {.lex_state = 0},
  [606] = {.lex_state = 0},
  [607] = {.lex_state = 0},
  [608] = {.lex_state = 0},
  [609] = {.lex_state = 0},
  [610] = {.lex_state = 0},
  [611] = {.lex_state = 0},
  [612] = {.lex_state = 0},
  [613] = {.lex_state = 0},
  [614] = {.lex_state = 0},
  [615] = {.lex_state = 0},
  [616] = {.lex_state = 0},
  [617] = {.lex_state = 0},
  [618] = {.lex_state = 0},
  [619] = {.lex_state = 0},
  [620] = {.lex_state = 0},
  [621] = {.lex_state = 0},
  [622] = {.lex_state = 0},
  [623] = {.lex_state = 0},
  [624] = {.lex_state = 0},
  [625] = {.lex_state = 0},
  [626] = {.lex_state = 0},
  [627] = {.lex_state = 0},
  [628] = {.lex_state = 0},
  [629] = {.lex_state = 0},
  [630] = {.lex_state = 0},
  [631] = {.lex_state = 0},
  [632] = {.lex_state = 0},
  [633] = {.lex_state = 0},
  [634] = {.lex_state = 0},
  [635] = {.lex_state = 0},
  [636] = {.lex_state = 0},
  [637] = {.lex_state = 0},
  [638] = {.lex_state = 0},
  [639] = {.lex_state = 0},
  [640] = {.lex_state = 0},
  [641] = {.lex_state = 0},
  [642] = {.lex_state = 0},
  [643] = {.lex_state = 0},
  [644] = {.lex_state = 0},
  [645] = {.lex_state = 0},
  [646] = {.lex_state = 0},
  [647] = {.lex_state = 0},
  [648] = {.lex_state = 0},
  [649] = {.lex_state = 0},
  [650] = {.lex_state = 0},
  [651] = {.lex_state = 0},
  [652] = {.lex_state = 0},
  [653] = {.lex_state = 0},
  [654] = {.lex_state = 0},
  [655] = {.lex_state = 0},
  [656] = {.lex_state = 0},
  [657] = {.lex_state = 0},
  [658] = {.lex_state = 0},
  [659] = {.lex_state = 0},
  [660] = {.lex_state = 0},
  [661] = {.lex_state = 0},
  [662] = {.lex_state = 0},
  [663] = {.lex_state = 0},
  [664] = {.lex_state = 0},
  [665] = {.lex_state = 0},
  [666] = {.lex_state = 0},
  [667] = {.lex_state = 0},
  [668] = {.lex_state = 0},
  [669] = {.lex_state = 0},
  [670] = {.lex_state = 0},
  [671] = {.lex_state = 0},
  [672] = {.lex_state = 0},
  [673] = {.lex_state = 0},
  [674] = {.lex_state = 0},
  [675] = {.lex_state = 0},
  [676] = {.lex_state = 0},
  [677] = {.lex_state = 0},
  [678] = {.lex_state = 0},
  [679] = {.lex_state = 0},
  [680] = {.lex_state = 0},
  [681] = {.lex_state = 0},
  [682] = {.lex_state = 0},
  [683] = {.lex_state = 0},
  [684] = {.lex_state = 0},
  [685] = {.lex_state = 0},
  [686] = {.lex_state = 0},
  [687] = {.lex_state = 0},
  [688] = {.lex_state = 0},
  [689] = {.lex_state = 0},
  [690] = {.lex_state = 0},
  [691] = {.lex_state = 0},
  [692] = {.lex_state = 0},
  [693] = {.lex_state = 0},
  [694] = {.lex_state = 0},
  [695] = {.lex_state = 0},
  [696] = {.lex_state = 0},
  [697] = {.lex_state = 0},
  [698] = {.lex_state = 0},
  [699] = {.lex_state = 0},
  [700] = {.lex_state = 0},
  [701] = {.lex_state = 0},
  [702] = {.lex_state = 0},
  [703] = {.lex_state = 0},
};

enum {
  ts_external_token__long_str = 0,
  ts_external_token__long_buffer = 1,
};

static const TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__long_str] = sym__long_str,
  [ts_external_token__long_buffer] = sym__long_buffer,
};

static const bool ts_external_scanner_states[3][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__long_str] = true,
    [ts_external_token__long_buffer] = true,
  },
  [2] = {
    [ts_external_token__long_str] = true,
  },
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_symbol] = ACTIONS(1),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_AT_LPAREN] = ACTIONS(1),
    [anon_sym_AT_LBRACK] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_AT_LBRACE] = ACTIONS(1),
    [anon_sym_set] = ACTIONS(1),
    [anon_sym_def] = ACTIONS(1),
    [anon_sym_var] = ACTIONS(1),
    [anon_sym_quote] = ACTIONS(1),
    [anon_sym_splice] = ACTIONS(1),
    [anon_sym_quasiquote] = ACTIONS(1),
    [anon_sym_unquote] = ACTIONS(1),
    [anon_sym_break] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_do] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_fn] = ACTIONS(1),
    [anon_sym_upscope] = ACTIONS(1),
    [sym_variadic_marker] = ACTIONS(1),
    [sym_optional_marker] = ACTIONS(1),
    [sym_keys_marker] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_defn] = ACTIONS(1),
    [anon_sym_defn_DASH] = ACTIONS(1),
    [anon_sym_varfn] = ACTIONS(1),
    [anon_sym_varfn_DASH] = ACTIONS(1),
    [anon_sym_defmacro] = ACTIONS(1),
    [anon_sym_defmacro_DASH] = ACTIONS(1),
    [sym_str_literal] = ACTIONS(1),
    [sym_buffer_literal] = ACTIONS(1),
    [aux_sym_number_literal_token1] = ACTIONS(1),
    [aux_sym_number_literal_token2] = ACTIONS(1),
    [aux_sym_number_literal_token3] = ACTIONS(1),
    [anon_sym_true] = ACTIONS(1),
    [anon_sym_false] = ACTIONS(1),
    [sym_nil_literal] = ACTIONS(1),
    [sym_escape_sequence] = ACTIONS(1),
    [sym_keyword] = ACTIONS(1),
    [sym__long_str] = ACTIONS(1),
    [sym__long_buffer] = ACTIONS(1),
  },
  [1] = {
    [sym_source_file] = STATE(696),
    [sym__expr] = STATE(103),
    [sym_tuple] = STATE(411),
    [sym_sqr_tuple] = STATE(411),
    [sym_array] = STATE(411),
    [sym_sqr_array] = STATE(411),
    [sym_struct] = STATE(411),
    [sym_table] = STATE(411),
    [sym_peg_set] = STATE(411),
    [sym__special_forms] = STATE(411),
    [sym_def] = STATE(412),
    [sym_var] = STATE(412),
    [sym_quote] = STATE(412),
    [sym_splice] = STATE(412),
    [sym_quasiquote] = STATE(412),
    [sym_unquote] = STATE(412),
    [sym_break] = STATE(412),
    [sym_set] = STATE(412),
    [sym_if] = STATE(412),
    [sym_do] = STATE(412),
    [sym_while] = STATE(412),
    [sym_fn] = STATE(412),
    [sym_upscope] = STATE(412),
    [sym__shorthand] = STATE(411),
    [sym_short_quote] = STATE(413),
    [sym_short_splice] = STATE(413),
    [sym_short_quasiquote] = STATE(413),
    [sym_short_unquote] = STATE(413),
    [sym_short_fn] = STATE(413),
    [sym__specials] = STATE(411),
    [sym_extra_defs] = STATE(416),
    [sym__literals] = STATE(411),
    [sym_long_str_literal] = STATE(392),
    [sym_long_buffer_literal] = STATE(392),
    [sym_number_literal] = STATE(392),
    [sym_bool_literal] = STATE(392),
    [sym__identifier] = STATE(411),
    [aux_sym_source_file_repeat1] = STATE(103),
    [ts_builtin_sym_end] = ACTIONS(5),
    [sym_symbol] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(9),
    [anon_sym_LBRACK] = ACTIONS(11),
    [anon_sym_AT_LPAREN] = ACTIONS(13),
    [anon_sym_AT_LBRACK] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_AT_LBRACE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(27),
    [anon_sym_PIPE] = ACTIONS(29),
    [sym_str_literal] = ACTIONS(31),
    [sym_buffer_literal] = ACTIONS(31),
    [aux_sym_number_literal_token1] = ACTIONS(33),
    [aux_sym_number_literal_token2] = ACTIONS(33),
    [aux_sym_number_literal_token3] = ACTIONS(33),
    [anon_sym_true] = ACTIONS(35),
    [anon_sym_false] = ACTIONS(35),
    [sym_nil_literal] = ACTIONS(37),
    [sym_keyword] = ACTIONS(39),
    [sym__long_str] = ACTIONS(41),
    [sym__long_buffer] = ACTIONS(43),
  },
  [2] = {
    [sym__expr] = STATE(368),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [aux_sym_tuple_repeat1] = STATE(78),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_set] = ACTIONS(61),
    [anon_sym_def] = ACTIONS(63),
    [anon_sym_var] = ACTIONS(65),
    [anon_sym_quote] = ACTIONS(67),
    [anon_sym_splice] = ACTIONS(69),
    [anon_sym_quasiquote] = ACTIONS(71),
    [anon_sym_unquote] = ACTIONS(73),
    [anon_sym_break] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_do] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_fn] = ACTIONS(83),
    [anon_sym_upscope] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [anon_sym_defn] = ACTIONS(97),
    [anon_sym_defn_DASH] = ACTIONS(97),
    [anon_sym_varfn] = ACTIONS(97),
    [anon_sym_varfn_DASH] = ACTIONS(97),
    [anon_sym_defmacro] = ACTIONS(97),
    [anon_sym_defmacro_DASH] = ACTIONS(97),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [3] = {
    [sym__expr] = STATE(368),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [aux_sym_tuple_repeat1] = STATE(145),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(113),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_set] = ACTIONS(115),
    [anon_sym_def] = ACTIONS(117),
    [anon_sym_var] = ACTIONS(119),
    [anon_sym_quote] = ACTIONS(121),
    [anon_sym_splice] = ACTIONS(123),
    [anon_sym_quasiquote] = ACTIONS(125),
    [anon_sym_unquote] = ACTIONS(127),
    [anon_sym_break] = ACTIONS(129),
    [anon_sym_if] = ACTIONS(131),
    [anon_sym_do] = ACTIONS(133),
    [anon_sym_while] = ACTIONS(135),
    [anon_sym_fn] = ACTIONS(137),
    [anon_sym_upscope] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [anon_sym_defn] = ACTIONS(141),
    [anon_sym_defn_DASH] = ACTIONS(141),
    [anon_sym_varfn] = ACTIONS(141),
    [anon_sym_varfn_DASH] = ACTIONS(141),
    [anon_sym_defmacro] = ACTIONS(141),
    [anon_sym_defmacro_DASH] = ACTIONS(141),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [4] = {
    [sym__expr] = STATE(368),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [aux_sym_tuple_repeat1] = STATE(118),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(143),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_set] = ACTIONS(145),
    [anon_sym_def] = ACTIONS(147),
    [anon_sym_var] = ACTIONS(149),
    [anon_sym_quote] = ACTIONS(151),
    [anon_sym_splice] = ACTIONS(153),
    [anon_sym_quasiquote] = ACTIONS(155),
    [anon_sym_unquote] = ACTIONS(157),
    [anon_sym_break] = ACTIONS(159),
    [anon_sym_if] = ACTIONS(161),
    [anon_sym_do] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_fn] = ACTIONS(167),
    [anon_sym_upscope] = ACTIONS(169),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [anon_sym_defn] = ACTIONS(171),
    [anon_sym_defn_DASH] = ACTIONS(171),
    [anon_sym_varfn] = ACTIONS(171),
    [anon_sym_varfn_DASH] = ACTIONS(171),
    [anon_sym_defmacro] = ACTIONS(171),
    [anon_sym_defmacro_DASH] = ACTIONS(171),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [5] = {
    [sym__expr] = STATE(368),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [aux_sym_tuple_repeat1] = STATE(126),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(173),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_set] = ACTIONS(175),
    [anon_sym_def] = ACTIONS(177),
    [anon_sym_var] = ACTIONS(179),
    [anon_sym_quote] = ACTIONS(181),
    [anon_sym_splice] = ACTIONS(183),
    [anon_sym_quasiquote] = ACTIONS(185),
    [anon_sym_unquote] = ACTIONS(187),
    [anon_sym_break] = ACTIONS(189),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_while] = ACTIONS(195),
    [anon_sym_fn] = ACTIONS(197),
    [anon_sym_upscope] = ACTIONS(199),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [anon_sym_defn] = ACTIONS(201),
    [anon_sym_defn_DASH] = ACTIONS(201),
    [anon_sym_varfn] = ACTIONS(201),
    [anon_sym_varfn_DASH] = ACTIONS(201),
    [anon_sym_defmacro] = ACTIONS(201),
    [anon_sym_defmacro_DASH] = ACTIONS(201),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [6] = {
    [sym__expr] = STATE(368),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [aux_sym_tuple_repeat1] = STATE(95),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_set] = ACTIONS(205),
    [anon_sym_def] = ACTIONS(207),
    [anon_sym_var] = ACTIONS(209),
    [anon_sym_quote] = ACTIONS(67),
    [anon_sym_splice] = ACTIONS(69),
    [anon_sym_quasiquote] = ACTIONS(71),
    [anon_sym_unquote] = ACTIONS(73),
    [anon_sym_break] = ACTIONS(211),
    [anon_sym_if] = ACTIONS(213),
    [anon_sym_do] = ACTIONS(215),
    [anon_sym_while] = ACTIONS(217),
    [anon_sym_fn] = ACTIONS(219),
    [anon_sym_upscope] = ACTIONS(221),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [anon_sym_defn] = ACTIONS(223),
    [anon_sym_defn_DASH] = ACTIONS(223),
    [anon_sym_varfn] = ACTIONS(223),
    [anon_sym_varfn_DASH] = ACTIONS(223),
    [anon_sym_defmacro] = ACTIONS(223),
    [anon_sym_defmacro_DASH] = ACTIONS(223),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [7] = {
    [sym__expr] = STATE(368),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [aux_sym_tuple_repeat1] = STATE(95),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_set] = ACTIONS(205),
    [anon_sym_def] = ACTIONS(207),
    [anon_sym_var] = ACTIONS(209),
    [anon_sym_quote] = ACTIONS(225),
    [anon_sym_splice] = ACTIONS(227),
    [anon_sym_quasiquote] = ACTIONS(229),
    [anon_sym_unquote] = ACTIONS(231),
    [anon_sym_break] = ACTIONS(211),
    [anon_sym_if] = ACTIONS(213),
    [anon_sym_do] = ACTIONS(215),
    [anon_sym_while] = ACTIONS(217),
    [anon_sym_fn] = ACTIONS(219),
    [anon_sym_upscope] = ACTIONS(221),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [anon_sym_defn] = ACTIONS(223),
    [anon_sym_defn_DASH] = ACTIONS(223),
    [anon_sym_varfn] = ACTIONS(223),
    [anon_sym_varfn_DASH] = ACTIONS(223),
    [anon_sym_defmacro] = ACTIONS(223),
    [anon_sym_defmacro_DASH] = ACTIONS(223),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [8] = {
    [sym__expr] = STATE(247),
    [sym_tuple] = STATE(281),
    [sym_sqr_tuple] = STATE(281),
    [sym_array] = STATE(281),
    [sym_sqr_array] = STATE(281),
    [sym_struct] = STATE(281),
    [sym_table] = STATE(281),
    [sym_peg_set] = STATE(281),
    [sym__special_forms] = STATE(281),
    [sym_def] = STATE(280),
    [sym_var] = STATE(280),
    [sym_quote] = STATE(280),
    [sym_splice] = STATE(280),
    [sym_quasiquote] = STATE(280),
    [sym_unquote] = STATE(280),
    [sym_break] = STATE(280),
    [sym_set] = STATE(280),
    [sym_if] = STATE(280),
    [sym_do] = STATE(280),
    [sym_while] = STATE(280),
    [sym_fn] = STATE(280),
    [sym_upscope] = STATE(280),
    [sym__shorthand] = STATE(281),
    [sym_short_quote] = STATE(279),
    [sym_short_splice] = STATE(279),
    [sym_short_quasiquote] = STATE(279),
    [sym_short_unquote] = STATE(279),
    [sym_short_fn] = STATE(279),
    [sym__specials] = STATE(281),
    [sym_extra_defs] = STATE(244),
    [sym__literals] = STATE(281),
    [sym_long_str_literal] = STATE(285),
    [sym_long_buffer_literal] = STATE(285),
    [sym_number_literal] = STATE(285),
    [sym_bool_literal] = STATE(285),
    [sym__identifier] = STATE(281),
    [aux_sym_parameters_repeat1] = STATE(11),
    [sym_symbol] = ACTIONS(233),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_RPAREN] = ACTIONS(237),
    [anon_sym_LBRACK] = ACTIONS(239),
    [anon_sym_AT_LPAREN] = ACTIONS(241),
    [anon_sym_AT_LBRACK] = ACTIONS(243),
    [anon_sym_LBRACE] = ACTIONS(245),
    [anon_sym_AT_LBRACE] = ACTIONS(247),
    [anon_sym_quote] = ACTIONS(67),
    [anon_sym_splice] = ACTIONS(69),
    [anon_sym_quasiquote] = ACTIONS(71),
    [anon_sym_unquote] = ACTIONS(73),
    [sym_variadic_marker] = ACTIONS(249),
    [sym_optional_marker] = ACTIONS(249),
    [sym_keys_marker] = ACTIONS(249),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SEMI] = ACTIONS(253),
    [anon_sym_TILDE] = ACTIONS(255),
    [anon_sym_COMMA] = ACTIONS(257),
    [anon_sym_PIPE] = ACTIONS(259),
    [sym_str_literal] = ACTIONS(261),
    [sym_buffer_literal] = ACTIONS(261),
    [aux_sym_number_literal_token1] = ACTIONS(263),
    [aux_sym_number_literal_token2] = ACTIONS(263),
    [aux_sym_number_literal_token3] = ACTIONS(263),
    [anon_sym_true] = ACTIONS(265),
    [anon_sym_false] = ACTIONS(265),
    [sym_nil_literal] = ACTIONS(267),
    [sym_keyword] = ACTIONS(269),
    [sym__long_str] = ACTIONS(271),
    [sym__long_buffer] = ACTIONS(273),
  },
  [9] = {
    [sym__expr] = STATE(247),
    [sym_tuple] = STATE(281),
    [sym_sqr_tuple] = STATE(281),
    [sym_array] = STATE(281),
    [sym_sqr_array] = STATE(281),
    [sym_struct] = STATE(281),
    [sym_table] = STATE(281),
    [sym_peg_set] = STATE(281),
    [sym__special_forms] = STATE(281),
    [sym_def] = STATE(280),
    [sym_var] = STATE(280),
    [sym_quote] = STATE(280),
    [sym_splice] = STATE(280),
    [sym_quasiquote] = STATE(280),
    [sym_unquote] = STATE(280),
    [sym_break] = STATE(280),
    [sym_set] = STATE(280),
    [sym_if] = STATE(280),
    [sym_do] = STATE(280),
    [sym_while] = STATE(280),
    [sym_fn] = STATE(280),
    [sym_upscope] = STATE(280),
    [sym__shorthand] = STATE(281),
    [sym_short_quote] = STATE(279),
    [sym_short_splice] = STATE(279),
    [sym_short_quasiquote] = STATE(279),
    [sym_short_unquote] = STATE(279),
    [sym_short_fn] = STATE(279),
    [sym__specials] = STATE(281),
    [sym_extra_defs] = STATE(244),
    [sym__literals] = STATE(281),
    [sym_long_str_literal] = STATE(285),
    [sym_long_buffer_literal] = STATE(285),
    [sym_number_literal] = STATE(285),
    [sym_bool_literal] = STATE(285),
    [sym__identifier] = STATE(281),
    [aux_sym_parameters_repeat1] = STATE(9),
    [sym_symbol] = ACTIONS(275),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(278),
    [anon_sym_RPAREN] = ACTIONS(281),
    [anon_sym_LBRACK] = ACTIONS(283),
    [anon_sym_RBRACK] = ACTIONS(281),
    [anon_sym_AT_LPAREN] = ACTIONS(286),
    [anon_sym_AT_LBRACK] = ACTIONS(289),
    [anon_sym_LBRACE] = ACTIONS(292),
    [anon_sym_AT_LBRACE] = ACTIONS(295),
    [sym_variadic_marker] = ACTIONS(298),
    [sym_optional_marker] = ACTIONS(298),
    [sym_keys_marker] = ACTIONS(298),
    [anon_sym_SQUOTE] = ACTIONS(300),
    [anon_sym_SEMI] = ACTIONS(303),
    [anon_sym_TILDE] = ACTIONS(306),
    [anon_sym_COMMA] = ACTIONS(309),
    [anon_sym_PIPE] = ACTIONS(312),
    [sym_str_literal] = ACTIONS(315),
    [sym_buffer_literal] = ACTIONS(315),
    [aux_sym_number_literal_token1] = ACTIONS(318),
    [aux_sym_number_literal_token2] = ACTIONS(318),
    [aux_sym_number_literal_token3] = ACTIONS(318),
    [anon_sym_true] = ACTIONS(321),
    [anon_sym_false] = ACTIONS(321),
    [sym_nil_literal] = ACTIONS(324),
    [sym_keyword] = ACTIONS(327),
    [sym__long_str] = ACTIONS(330),
    [sym__long_buffer] = ACTIONS(333),
  },
  [10] = {
    [sym__expr] = STATE(247),
    [sym_tuple] = STATE(281),
    [sym_sqr_tuple] = STATE(281),
    [sym_array] = STATE(281),
    [sym_sqr_array] = STATE(281),
    [sym_struct] = STATE(281),
    [sym_table] = STATE(281),
    [sym_peg_set] = STATE(281),
    [sym__special_forms] = STATE(281),
    [sym_def] = STATE(280),
    [sym_var] = STATE(280),
    [sym_quote] = STATE(280),
    [sym_splice] = STATE(280),
    [sym_quasiquote] = STATE(280),
    [sym_unquote] = STATE(280),
    [sym_break] = STATE(280),
    [sym_set] = STATE(280),
    [sym_if] = STATE(280),
    [sym_do] = STATE(280),
    [sym_while] = STATE(280),
    [sym_fn] = STATE(280),
    [sym_upscope] = STATE(280),
    [sym__shorthand] = STATE(281),
    [sym_short_quote] = STATE(279),
    [sym_short_splice] = STATE(279),
    [sym_short_quasiquote] = STATE(279),
    [sym_short_unquote] = STATE(279),
    [sym_short_fn] = STATE(279),
    [sym__specials] = STATE(281),
    [sym_extra_defs] = STATE(244),
    [sym__literals] = STATE(281),
    [sym_long_str_literal] = STATE(285),
    [sym_long_buffer_literal] = STATE(285),
    [sym_number_literal] = STATE(285),
    [sym_bool_literal] = STATE(285),
    [sym__identifier] = STATE(281),
    [aux_sym_parameters_repeat1] = STATE(9),
    [sym_symbol] = ACTIONS(233),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_LBRACK] = ACTIONS(239),
    [anon_sym_RBRACK] = ACTIONS(336),
    [anon_sym_AT_LPAREN] = ACTIONS(241),
    [anon_sym_AT_LBRACK] = ACTIONS(243),
    [anon_sym_LBRACE] = ACTIONS(245),
    [anon_sym_AT_LBRACE] = ACTIONS(247),
    [sym_variadic_marker] = ACTIONS(338),
    [sym_optional_marker] = ACTIONS(340),
    [sym_keys_marker] = ACTIONS(342),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SEMI] = ACTIONS(253),
    [anon_sym_TILDE] = ACTIONS(255),
    [anon_sym_COMMA] = ACTIONS(257),
    [anon_sym_PIPE] = ACTIONS(259),
    [sym_str_literal] = ACTIONS(261),
    [sym_buffer_literal] = ACTIONS(261),
    [aux_sym_number_literal_token1] = ACTIONS(263),
    [aux_sym_number_literal_token2] = ACTIONS(263),
    [aux_sym_number_literal_token3] = ACTIONS(263),
    [anon_sym_true] = ACTIONS(265),
    [anon_sym_false] = ACTIONS(265),
    [sym_nil_literal] = ACTIONS(267),
    [sym_keyword] = ACTIONS(269),
    [sym__long_str] = ACTIONS(271),
    [sym__long_buffer] = ACTIONS(273),
  },
  [11] = {
    [sym__expr] = STATE(247),
    [sym_tuple] = STATE(281),
    [sym_sqr_tuple] = STATE(281),
    [sym_array] = STATE(281),
    [sym_sqr_array] = STATE(281),
    [sym_struct] = STATE(281),
    [sym_table] = STATE(281),
    [sym_peg_set] = STATE(281),
    [sym__special_forms] = STATE(281),
    [sym_def] = STATE(280),
    [sym_var] = STATE(280),
    [sym_quote] = STATE(280),
    [sym_splice] = STATE(280),
    [sym_quasiquote] = STATE(280),
    [sym_unquote] = STATE(280),
    [sym_break] = STATE(280),
    [sym_set] = STATE(280),
    [sym_if] = STATE(280),
    [sym_do] = STATE(280),
    [sym_while] = STATE(280),
    [sym_fn] = STATE(280),
    [sym_upscope] = STATE(280),
    [sym__shorthand] = STATE(281),
    [sym_short_quote] = STATE(279),
    [sym_short_splice] = STATE(279),
    [sym_short_quasiquote] = STATE(279),
    [sym_short_unquote] = STATE(279),
    [sym_short_fn] = STATE(279),
    [sym__specials] = STATE(281),
    [sym_extra_defs] = STATE(244),
    [sym__literals] = STATE(281),
    [sym_long_str_literal] = STATE(285),
    [sym_long_buffer_literal] = STATE(285),
    [sym_number_literal] = STATE(285),
    [sym_bool_literal] = STATE(285),
    [sym__identifier] = STATE(281),
    [aux_sym_parameters_repeat1] = STATE(9),
    [sym_symbol] = ACTIONS(233),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_RPAREN] = ACTIONS(344),
    [anon_sym_LBRACK] = ACTIONS(239),
    [anon_sym_AT_LPAREN] = ACTIONS(241),
    [anon_sym_AT_LBRACK] = ACTIONS(243),
    [anon_sym_LBRACE] = ACTIONS(245),
    [anon_sym_AT_LBRACE] = ACTIONS(247),
    [sym_variadic_marker] = ACTIONS(346),
    [sym_optional_marker] = ACTIONS(348),
    [sym_keys_marker] = ACTIONS(350),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SEMI] = ACTIONS(253),
    [anon_sym_TILDE] = ACTIONS(255),
    [anon_sym_COMMA] = ACTIONS(257),
    [anon_sym_PIPE] = ACTIONS(259),
    [sym_str_literal] = ACTIONS(261),
    [sym_buffer_literal] = ACTIONS(261),
    [aux_sym_number_literal_token1] = ACTIONS(263),
    [aux_sym_number_literal_token2] = ACTIONS(263),
    [aux_sym_number_literal_token3] = ACTIONS(263),
    [anon_sym_true] = ACTIONS(265),
    [anon_sym_false] = ACTIONS(265),
    [sym_nil_literal] = ACTIONS(267),
    [sym_keyword] = ACTIONS(269),
    [sym__long_str] = ACTIONS(271),
    [sym__long_buffer] = ACTIONS(273),
  },
  [12] = {
    [sym__expr] = STATE(247),
    [sym_tuple] = STATE(281),
    [sym_sqr_tuple] = STATE(281),
    [sym_array] = STATE(281),
    [sym_sqr_array] = STATE(281),
    [sym_struct] = STATE(281),
    [sym_table] = STATE(281),
    [sym_peg_set] = STATE(281),
    [sym__special_forms] = STATE(281),
    [sym_def] = STATE(280),
    [sym_var] = STATE(280),
    [sym_quote] = STATE(280),
    [sym_splice] = STATE(280),
    [sym_quasiquote] = STATE(280),
    [sym_unquote] = STATE(280),
    [sym_break] = STATE(280),
    [sym_set] = STATE(280),
    [sym_if] = STATE(280),
    [sym_do] = STATE(280),
    [sym_while] = STATE(280),
    [sym_fn] = STATE(280),
    [sym_upscope] = STATE(280),
    [sym__shorthand] = STATE(281),
    [sym_short_quote] = STATE(279),
    [sym_short_splice] = STATE(279),
    [sym_short_quasiquote] = STATE(279),
    [sym_short_unquote] = STATE(279),
    [sym_short_fn] = STATE(279),
    [sym__specials] = STATE(281),
    [sym_extra_defs] = STATE(244),
    [sym__literals] = STATE(281),
    [sym_long_str_literal] = STATE(285),
    [sym_long_buffer_literal] = STATE(285),
    [sym_number_literal] = STATE(285),
    [sym_bool_literal] = STATE(285),
    [sym__identifier] = STATE(281),
    [aux_sym_parameters_repeat1] = STATE(10),
    [sym_symbol] = ACTIONS(233),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_LBRACK] = ACTIONS(239),
    [anon_sym_RBRACK] = ACTIONS(352),
    [anon_sym_AT_LPAREN] = ACTIONS(241),
    [anon_sym_AT_LBRACK] = ACTIONS(243),
    [anon_sym_LBRACE] = ACTIONS(245),
    [anon_sym_AT_LBRACE] = ACTIONS(247),
    [sym_variadic_marker] = ACTIONS(354),
    [sym_optional_marker] = ACTIONS(354),
    [sym_keys_marker] = ACTIONS(354),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SEMI] = ACTIONS(253),
    [anon_sym_TILDE] = ACTIONS(255),
    [anon_sym_COMMA] = ACTIONS(257),
    [anon_sym_PIPE] = ACTIONS(259),
    [sym_str_literal] = ACTIONS(261),
    [sym_buffer_literal] = ACTIONS(261),
    [aux_sym_number_literal_token1] = ACTIONS(263),
    [aux_sym_number_literal_token2] = ACTIONS(263),
    [aux_sym_number_literal_token3] = ACTIONS(263),
    [anon_sym_true] = ACTIONS(265),
    [anon_sym_false] = ACTIONS(265),
    [sym_nil_literal] = ACTIONS(267),
    [sym_keyword] = ACTIONS(269),
    [sym__long_str] = ACTIONS(271),
    [sym__long_buffer] = ACTIONS(273),
  },
  [13] = {
    [sym__expr] = STATE(470),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym_body] = STATE(575),
    [sym__identifier] = STATE(305),
    [aux_sym_while_repeat1] = STATE(96),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(356),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [14] = {
    [sym__expr] = STATE(470),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym_body] = STATE(582),
    [sym__identifier] = STATE(305),
    [aux_sym_while_repeat1] = STATE(96),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(358),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [15] = {
    [sym__expr] = STATE(210),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym__struct_tables_commom] = STATE(455),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [aux_sym_struct_repeat1] = STATE(50),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_RBRACE] = ACTIONS(360),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [16] = {
    [sym__expr] = STATE(470),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym_body] = STATE(644),
    [sym__identifier] = STATE(305),
    [aux_sym_while_repeat1] = STATE(96),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(362),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [17] = {
    [sym__expr] = STATE(470),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym_body] = STATE(638),
    [sym__identifier] = STATE(305),
    [aux_sym_while_repeat1] = STATE(96),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(364),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [18] = {
    [sym__expr] = STATE(470),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym_body] = STATE(630),
    [sym__identifier] = STATE(305),
    [aux_sym_while_repeat1] = STATE(96),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(366),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [19] = {
    [sym__expr] = STATE(470),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym_body] = STATE(626),
    [sym__identifier] = STATE(305),
    [aux_sym_while_repeat1] = STATE(96),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(368),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [20] = {
    [sym__expr] = STATE(210),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym__struct_tables_commom] = STATE(455),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [aux_sym_struct_repeat1] = STATE(25),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_RBRACE] = ACTIONS(370),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [21] = {
    [sym__expr] = STATE(210),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym__struct_tables_commom] = STATE(455),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [aux_sym_struct_repeat1] = STATE(26),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_RBRACE] = ACTIONS(372),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [22] = {
    [sym__expr] = STATE(470),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym_body] = STATE(595),
    [sym__identifier] = STATE(305),
    [aux_sym_while_repeat1] = STATE(96),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(374),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [23] = {
    [sym__expr] = STATE(470),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym_body] = STATE(594),
    [sym__identifier] = STATE(305),
    [aux_sym_while_repeat1] = STATE(96),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(376),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [24] = {
    [sym__expr] = STATE(362),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [aux_sym_parameters_repeat1] = STATE(24),
    [sym_symbol] = ACTIONS(378),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(381),
    [anon_sym_RPAREN] = ACTIONS(281),
    [anon_sym_LBRACK] = ACTIONS(384),
    [anon_sym_RBRACK] = ACTIONS(281),
    [anon_sym_AT_LPAREN] = ACTIONS(387),
    [anon_sym_AT_LBRACK] = ACTIONS(390),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_AT_LBRACE] = ACTIONS(396),
    [anon_sym_SQUOTE] = ACTIONS(399),
    [anon_sym_SEMI] = ACTIONS(402),
    [anon_sym_TILDE] = ACTIONS(405),
    [anon_sym_COMMA] = ACTIONS(408),
    [anon_sym_PIPE] = ACTIONS(411),
    [sym_str_literal] = ACTIONS(414),
    [sym_buffer_literal] = ACTIONS(414),
    [aux_sym_number_literal_token1] = ACTIONS(417),
    [aux_sym_number_literal_token2] = ACTIONS(417),
    [aux_sym_number_literal_token3] = ACTIONS(417),
    [anon_sym_true] = ACTIONS(420),
    [anon_sym_false] = ACTIONS(420),
    [sym_nil_literal] = ACTIONS(423),
    [sym_keyword] = ACTIONS(426),
    [sym__long_str] = ACTIONS(429),
    [sym__long_buffer] = ACTIONS(432),
  },
  [25] = {
    [sym__expr] = STATE(210),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym__struct_tables_commom] = STATE(455),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [aux_sym_struct_repeat1] = STATE(50),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_RBRACE] = ACTIONS(435),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [26] = {
    [sym__expr] = STATE(210),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym__struct_tables_commom] = STATE(455),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [aux_sym_struct_repeat1] = STATE(50),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_RBRACE] = ACTIONS(437),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [27] = {
    [sym__expr] = STATE(470),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym_body] = STATE(560),
    [sym__identifier] = STATE(305),
    [aux_sym_while_repeat1] = STATE(96),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(439),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [28] = {
    [sym__expr] = STATE(470),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym_body] = STATE(564),
    [sym__identifier] = STATE(305),
    [aux_sym_while_repeat1] = STATE(96),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(441),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [29] = {
    [sym__expr] = STATE(470),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym_body] = STATE(565),
    [sym__identifier] = STATE(305),
    [aux_sym_while_repeat1] = STATE(96),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(443),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [30] = {
    [sym__expr] = STATE(470),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym_body] = STATE(567),
    [sym__identifier] = STATE(305),
    [aux_sym_while_repeat1] = STATE(96),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [31] = {
    [sym__expr] = STATE(210),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym__struct_tables_commom] = STATE(455),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [aux_sym_struct_repeat1] = STATE(36),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_RBRACE] = ACTIONS(447),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [32] = {
    [sym__expr] = STATE(210),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym__struct_tables_commom] = STATE(455),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [aux_sym_struct_repeat1] = STATE(37),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_RBRACE] = ACTIONS(449),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [33] = {
    [sym__expr] = STATE(470),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym_body] = STATE(566),
    [sym__identifier] = STATE(305),
    [aux_sym_while_repeat1] = STATE(96),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(451),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [34] = {
    [sym__expr] = STATE(470),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym_body] = STATE(576),
    [sym__identifier] = STATE(305),
    [aux_sym_while_repeat1] = STATE(96),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(453),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [35] = {
    [sym__expr] = STATE(470),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym_body] = STATE(655),
    [sym__identifier] = STATE(305),
    [aux_sym_while_repeat1] = STATE(96),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [36] = {
    [sym__expr] = STATE(210),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym__struct_tables_commom] = STATE(455),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [aux_sym_struct_repeat1] = STATE(50),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_RBRACE] = ACTIONS(457),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [37] = {
    [sym__expr] = STATE(210),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym__struct_tables_commom] = STATE(455),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [aux_sym_struct_repeat1] = STATE(50),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_RBRACE] = ACTIONS(459),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [38] = {
    [sym__expr] = STATE(470),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym_body] = STATE(650),
    [sym__identifier] = STATE(305),
    [aux_sym_while_repeat1] = STATE(96),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(461),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [39] = {
    [sym__expr] = STATE(210),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym__struct_tables_commom] = STATE(455),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [aux_sym_struct_repeat1] = STATE(40),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_RBRACE] = ACTIONS(463),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [40] = {
    [sym__expr] = STATE(210),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym__struct_tables_commom] = STATE(455),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [aux_sym_struct_repeat1] = STATE(50),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_RBRACE] = ACTIONS(465),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [41] = {
    [sym__expr] = STATE(470),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym_body] = STATE(588),
    [sym__identifier] = STATE(305),
    [aux_sym_while_repeat1] = STATE(96),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(467),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [42] = {
    [sym__expr] = STATE(470),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym_body] = STATE(589),
    [sym__identifier] = STATE(305),
    [aux_sym_while_repeat1] = STATE(96),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [43] = {
    [sym__expr] = STATE(470),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym_body] = STATE(591),
    [sym__identifier] = STATE(305),
    [aux_sym_while_repeat1] = STATE(96),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(471),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [44] = {
    [sym__expr] = STATE(210),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym__struct_tables_commom] = STATE(455),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [aux_sym_struct_repeat1] = STATE(53),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_RBRACE] = ACTIONS(473),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [45] = {
    [sym__expr] = STATE(470),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym_body] = STATE(568),
    [sym__identifier] = STATE(305),
    [aux_sym_while_repeat1] = STATE(96),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(475),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [46] = {
    [sym__expr] = STATE(210),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym__struct_tables_commom] = STATE(455),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [aux_sym_struct_repeat1] = STATE(65),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_RBRACE] = ACTIONS(477),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [47] = {
    [sym__expr] = STATE(210),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym__struct_tables_commom] = STATE(455),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [aux_sym_struct_repeat1] = STATE(63),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_RBRACE] = ACTIONS(479),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [48] = {
    [sym__expr] = STATE(470),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym_body] = STATE(569),
    [sym__identifier] = STATE(305),
    [aux_sym_while_repeat1] = STATE(96),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(481),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [49] = {
    [sym__expr] = STATE(210),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym__struct_tables_commom] = STATE(455),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [aux_sym_struct_repeat1] = STATE(51),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_RBRACE] = ACTIONS(483),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [50] = {
    [sym__expr] = STATE(210),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym__struct_tables_commom] = STATE(455),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [aux_sym_struct_repeat1] = STATE(50),
    [sym_symbol] = ACTIONS(485),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(488),
    [anon_sym_LBRACK] = ACTIONS(491),
    [anon_sym_AT_LPAREN] = ACTIONS(494),
    [anon_sym_AT_LBRACK] = ACTIONS(497),
    [anon_sym_LBRACE] = ACTIONS(500),
    [anon_sym_RBRACE] = ACTIONS(503),
    [anon_sym_AT_LBRACE] = ACTIONS(505),
    [anon_sym_SQUOTE] = ACTIONS(508),
    [anon_sym_SEMI] = ACTIONS(511),
    [anon_sym_TILDE] = ACTIONS(514),
    [anon_sym_COMMA] = ACTIONS(517),
    [anon_sym_PIPE] = ACTIONS(520),
    [sym_str_literal] = ACTIONS(523),
    [sym_buffer_literal] = ACTIONS(523),
    [aux_sym_number_literal_token1] = ACTIONS(526),
    [aux_sym_number_literal_token2] = ACTIONS(526),
    [aux_sym_number_literal_token3] = ACTIONS(526),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_false] = ACTIONS(529),
    [sym_nil_literal] = ACTIONS(532),
    [sym_keyword] = ACTIONS(535),
    [sym__long_str] = ACTIONS(538),
    [sym__long_buffer] = ACTIONS(541),
  },
  [51] = {
    [sym__expr] = STATE(210),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym__struct_tables_commom] = STATE(455),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [aux_sym_struct_repeat1] = STATE(50),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_RBRACE] = ACTIONS(544),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [52] = {
    [sym__expr] = STATE(470),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym_body] = STATE(599),
    [sym__identifier] = STATE(305),
    [aux_sym_while_repeat1] = STATE(96),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(546),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [53] = {
    [sym__expr] = STATE(210),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym__struct_tables_commom] = STATE(455),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [aux_sym_struct_repeat1] = STATE(50),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_RBRACE] = ACTIONS(548),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [54] = {
    [sym__expr] = STATE(470),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym_body] = STATE(651),
    [sym__identifier] = STATE(305),
    [aux_sym_while_repeat1] = STATE(96),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(550),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [55] = {
    [sym__expr] = STATE(470),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym_body] = STATE(637),
    [sym__identifier] = STATE(305),
    [aux_sym_while_repeat1] = STATE(96),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(552),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [56] = {
    [sym__expr] = STATE(470),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym_body] = STATE(635),
    [sym__identifier] = STATE(305),
    [aux_sym_while_repeat1] = STATE(96),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(554),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [57] = {
    [sym__expr] = STATE(470),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym_body] = STATE(634),
    [sym__identifier] = STATE(305),
    [aux_sym_while_repeat1] = STATE(96),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(556),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [58] = {
    [sym__expr] = STATE(470),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym_body] = STATE(654),
    [sym__identifier] = STATE(305),
    [aux_sym_while_repeat1] = STATE(96),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [59] = {
    [sym__expr] = STATE(470),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym_body] = STATE(622),
    [sym__identifier] = STATE(305),
    [aux_sym_while_repeat1] = STATE(96),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(560),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [60] = {
    [sym__expr] = STATE(368),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [aux_sym_tuple_repeat1] = STATE(60),
    [sym_symbol] = ACTIONS(562),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(565),
    [anon_sym_RPAREN] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_RBRACK] = ACTIONS(568),
    [anon_sym_AT_LPAREN] = ACTIONS(573),
    [anon_sym_AT_LBRACK] = ACTIONS(576),
    [anon_sym_LBRACE] = ACTIONS(579),
    [anon_sym_AT_LBRACE] = ACTIONS(582),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [anon_sym_SEMI] = ACTIONS(588),
    [anon_sym_TILDE] = ACTIONS(591),
    [anon_sym_COMMA] = ACTIONS(594),
    [anon_sym_PIPE] = ACTIONS(597),
    [sym_str_literal] = ACTIONS(600),
    [sym_buffer_literal] = ACTIONS(600),
    [aux_sym_number_literal_token1] = ACTIONS(603),
    [aux_sym_number_literal_token2] = ACTIONS(603),
    [aux_sym_number_literal_token3] = ACTIONS(603),
    [anon_sym_true] = ACTIONS(606),
    [anon_sym_false] = ACTIONS(606),
    [sym_nil_literal] = ACTIONS(609),
    [sym_keyword] = ACTIONS(612),
    [sym__long_str] = ACTIONS(615),
    [sym__long_buffer] = ACTIONS(618),
  },
  [61] = {
    [sym__expr] = STATE(470),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym_body] = STATE(628),
    [sym__identifier] = STATE(305),
    [aux_sym_while_repeat1] = STATE(96),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(621),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [62] = {
    [sym__expr] = STATE(210),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym__struct_tables_commom] = STATE(455),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [aux_sym_struct_repeat1] = STATE(15),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_RBRACE] = ACTIONS(623),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [63] = {
    [sym__expr] = STATE(210),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym__struct_tables_commom] = STATE(455),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [aux_sym_struct_repeat1] = STATE(50),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_RBRACE] = ACTIONS(625),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [64] = {
    [sym__expr] = STATE(470),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym_body] = STATE(619),
    [sym__identifier] = STATE(305),
    [aux_sym_while_repeat1] = STATE(96),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(627),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [65] = {
    [sym__expr] = STATE(210),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym__struct_tables_commom] = STATE(455),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [aux_sym_struct_repeat1] = STATE(50),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_RBRACE] = ACTIONS(629),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [66] = {
    [sym__expr] = STATE(647),
    [sym_tuple] = STATE(607),
    [sym_sqr_tuple] = STATE(607),
    [sym_array] = STATE(607),
    [sym_sqr_array] = STATE(607),
    [sym_struct] = STATE(607),
    [sym_table] = STATE(607),
    [sym_peg_set] = STATE(607),
    [sym__special_forms] = STATE(607),
    [sym_def] = STATE(608),
    [sym_var] = STATE(608),
    [sym_quote] = STATE(444),
    [sym_splice] = STATE(444),
    [sym_quasiquote] = STATE(444),
    [sym_unquote] = STATE(444),
    [sym_break] = STATE(608),
    [sym_set] = STATE(608),
    [sym_if] = STATE(608),
    [sym_do] = STATE(608),
    [sym_while] = STATE(608),
    [sym_fn] = STATE(608),
    [sym_upscope] = STATE(608),
    [sym__shorthand] = STATE(607),
    [sym_short_quote] = STATE(443),
    [sym_short_splice] = STATE(443),
    [sym_short_quasiquote] = STATE(443),
    [sym_short_unquote] = STATE(443),
    [sym_short_fn] = STATE(609),
    [sym__specials] = STATE(607),
    [sym_extra_defs] = STATE(611),
    [sym__literals] = STATE(607),
    [sym_long_str_literal] = STATE(446),
    [sym_long_buffer_literal] = STATE(603),
    [sym_number_literal] = STATE(603),
    [sym_bool_literal] = STATE(603),
    [sym_metadata] = STATE(478),
    [sym__identifier] = STATE(607),
    [aux_sym_def_repeat1] = STATE(100),
    [sym_symbol] = ACTIONS(631),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_AT_LPAREN] = ACTIONS(637),
    [anon_sym_AT_LBRACK] = ACTIONS(639),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_AT_LBRACE] = ACTIONS(643),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(645),
    [sym_str_literal] = ACTIONS(647),
    [sym_buffer_literal] = ACTIONS(649),
    [aux_sym_number_literal_token1] = ACTIONS(651),
    [aux_sym_number_literal_token2] = ACTIONS(651),
    [aux_sym_number_literal_token3] = ACTIONS(651),
    [anon_sym_true] = ACTIONS(653),
    [anon_sym_false] = ACTIONS(653),
    [sym_nil_literal] = ACTIONS(655),
    [sym_keyword] = ACTIONS(657),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(659),
  },
  [67] = {
    [sym__expr] = STATE(368),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [aux_sym_tuple_repeat1] = STATE(123),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(661),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [68] = {
    [sym__expr] = STATE(624),
    [sym_tuple] = STATE(607),
    [sym_sqr_tuple] = STATE(607),
    [sym_array] = STATE(607),
    [sym_sqr_array] = STATE(607),
    [sym_struct] = STATE(607),
    [sym_table] = STATE(607),
    [sym_peg_set] = STATE(607),
    [sym__special_forms] = STATE(607),
    [sym_def] = STATE(608),
    [sym_var] = STATE(608),
    [sym_quote] = STATE(444),
    [sym_splice] = STATE(444),
    [sym_quasiquote] = STATE(444),
    [sym_unquote] = STATE(444),
    [sym_break] = STATE(608),
    [sym_set] = STATE(608),
    [sym_if] = STATE(608),
    [sym_do] = STATE(608),
    [sym_while] = STATE(608),
    [sym_fn] = STATE(608),
    [sym_upscope] = STATE(608),
    [sym__shorthand] = STATE(607),
    [sym_short_quote] = STATE(443),
    [sym_short_splice] = STATE(443),
    [sym_short_quasiquote] = STATE(443),
    [sym_short_unquote] = STATE(443),
    [sym_short_fn] = STATE(609),
    [sym__specials] = STATE(607),
    [sym_extra_defs] = STATE(611),
    [sym__literals] = STATE(607),
    [sym_long_str_literal] = STATE(446),
    [sym_long_buffer_literal] = STATE(603),
    [sym_number_literal] = STATE(603),
    [sym_bool_literal] = STATE(603),
    [sym_metadata] = STATE(478),
    [sym__identifier] = STATE(607),
    [aux_sym_def_repeat1] = STATE(142),
    [sym_symbol] = ACTIONS(631),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_AT_LPAREN] = ACTIONS(637),
    [anon_sym_AT_LBRACK] = ACTIONS(639),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_AT_LBRACE] = ACTIONS(643),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(645),
    [sym_str_literal] = ACTIONS(647),
    [sym_buffer_literal] = ACTIONS(649),
    [aux_sym_number_literal_token1] = ACTIONS(651),
    [aux_sym_number_literal_token2] = ACTIONS(651),
    [aux_sym_number_literal_token3] = ACTIONS(651),
    [anon_sym_true] = ACTIONS(653),
    [anon_sym_false] = ACTIONS(653),
    [sym_nil_literal] = ACTIONS(655),
    [sym_keyword] = ACTIONS(657),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(659),
  },
  [69] = {
    [sym__expr] = STATE(368),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [aux_sym_tuple_repeat1] = STATE(83),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_RBRACK] = ACTIONS(663),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [70] = {
    [sym__expr] = STATE(368),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [aux_sym_tuple_repeat1] = STATE(84),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(665),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [71] = {
    [sym__expr] = STATE(368),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [aux_sym_tuple_repeat1] = STATE(85),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_RBRACK] = ACTIONS(667),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [72] = {
    [sym__expr] = STATE(368),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [aux_sym_tuple_repeat1] = STATE(141),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_RBRACK] = ACTIONS(669),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [73] = {
    [sym__expr] = STATE(586),
    [sym_tuple] = STATE(607),
    [sym_sqr_tuple] = STATE(607),
    [sym_array] = STATE(607),
    [sym_sqr_array] = STATE(607),
    [sym_struct] = STATE(607),
    [sym_table] = STATE(607),
    [sym_peg_set] = STATE(607),
    [sym__special_forms] = STATE(607),
    [sym_def] = STATE(608),
    [sym_var] = STATE(608),
    [sym_quote] = STATE(444),
    [sym_splice] = STATE(444),
    [sym_quasiquote] = STATE(444),
    [sym_unquote] = STATE(444),
    [sym_break] = STATE(608),
    [sym_set] = STATE(608),
    [sym_if] = STATE(608),
    [sym_do] = STATE(608),
    [sym_while] = STATE(608),
    [sym_fn] = STATE(608),
    [sym_upscope] = STATE(608),
    [sym__shorthand] = STATE(607),
    [sym_short_quote] = STATE(443),
    [sym_short_splice] = STATE(443),
    [sym_short_quasiquote] = STATE(443),
    [sym_short_unquote] = STATE(443),
    [sym_short_fn] = STATE(609),
    [sym__specials] = STATE(607),
    [sym_extra_defs] = STATE(611),
    [sym__literals] = STATE(607),
    [sym_long_str_literal] = STATE(446),
    [sym_long_buffer_literal] = STATE(603),
    [sym_number_literal] = STATE(603),
    [sym_bool_literal] = STATE(603),
    [sym_metadata] = STATE(478),
    [sym__identifier] = STATE(607),
    [aux_sym_def_repeat1] = STATE(242),
    [sym_symbol] = ACTIONS(631),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_AT_LPAREN] = ACTIONS(637),
    [anon_sym_AT_LBRACK] = ACTIONS(639),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_AT_LBRACE] = ACTIONS(643),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(645),
    [sym_str_literal] = ACTIONS(647),
    [sym_buffer_literal] = ACTIONS(649),
    [aux_sym_number_literal_token1] = ACTIONS(651),
    [aux_sym_number_literal_token2] = ACTIONS(651),
    [aux_sym_number_literal_token3] = ACTIONS(651),
    [anon_sym_true] = ACTIONS(653),
    [anon_sym_false] = ACTIONS(653),
    [sym_nil_literal] = ACTIONS(655),
    [sym_keyword] = ACTIONS(657),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(659),
  },
  [74] = {
    [sym__expr] = STATE(585),
    [sym_tuple] = STATE(607),
    [sym_sqr_tuple] = STATE(607),
    [sym_array] = STATE(607),
    [sym_sqr_array] = STATE(607),
    [sym_struct] = STATE(607),
    [sym_table] = STATE(607),
    [sym_peg_set] = STATE(607),
    [sym__special_forms] = STATE(607),
    [sym_def] = STATE(608),
    [sym_var] = STATE(608),
    [sym_quote] = STATE(444),
    [sym_splice] = STATE(444),
    [sym_quasiquote] = STATE(444),
    [sym_unquote] = STATE(444),
    [sym_break] = STATE(608),
    [sym_set] = STATE(608),
    [sym_if] = STATE(608),
    [sym_do] = STATE(608),
    [sym_while] = STATE(608),
    [sym_fn] = STATE(608),
    [sym_upscope] = STATE(608),
    [sym__shorthand] = STATE(607),
    [sym_short_quote] = STATE(443),
    [sym_short_splice] = STATE(443),
    [sym_short_quasiquote] = STATE(443),
    [sym_short_unquote] = STATE(443),
    [sym_short_fn] = STATE(609),
    [sym__specials] = STATE(607),
    [sym_extra_defs] = STATE(611),
    [sym__literals] = STATE(607),
    [sym_long_str_literal] = STATE(446),
    [sym_long_buffer_literal] = STATE(603),
    [sym_number_literal] = STATE(603),
    [sym_bool_literal] = STATE(603),
    [sym_metadata] = STATE(478),
    [sym__identifier] = STATE(607),
    [aux_sym_def_repeat1] = STATE(242),
    [sym_symbol] = ACTIONS(631),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_AT_LPAREN] = ACTIONS(637),
    [anon_sym_AT_LBRACK] = ACTIONS(639),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_AT_LBRACE] = ACTIONS(643),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(645),
    [sym_str_literal] = ACTIONS(647),
    [sym_buffer_literal] = ACTIONS(649),
    [aux_sym_number_literal_token1] = ACTIONS(651),
    [aux_sym_number_literal_token2] = ACTIONS(651),
    [aux_sym_number_literal_token3] = ACTIONS(651),
    [anon_sym_true] = ACTIONS(653),
    [anon_sym_false] = ACTIONS(653),
    [sym_nil_literal] = ACTIONS(655),
    [sym_keyword] = ACTIONS(657),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(659),
  },
  [75] = {
    [sym__expr] = STATE(75),
    [sym_tuple] = STATE(411),
    [sym_sqr_tuple] = STATE(411),
    [sym_array] = STATE(411),
    [sym_sqr_array] = STATE(411),
    [sym_struct] = STATE(411),
    [sym_table] = STATE(411),
    [sym_peg_set] = STATE(411),
    [sym__special_forms] = STATE(411),
    [sym_def] = STATE(412),
    [sym_var] = STATE(412),
    [sym_quote] = STATE(412),
    [sym_splice] = STATE(412),
    [sym_quasiquote] = STATE(412),
    [sym_unquote] = STATE(412),
    [sym_break] = STATE(412),
    [sym_set] = STATE(412),
    [sym_if] = STATE(412),
    [sym_do] = STATE(412),
    [sym_while] = STATE(412),
    [sym_fn] = STATE(412),
    [sym_upscope] = STATE(412),
    [sym__shorthand] = STATE(411),
    [sym_short_quote] = STATE(413),
    [sym_short_splice] = STATE(413),
    [sym_short_quasiquote] = STATE(413),
    [sym_short_unquote] = STATE(413),
    [sym_short_fn] = STATE(413),
    [sym__specials] = STATE(411),
    [sym_extra_defs] = STATE(416),
    [sym__literals] = STATE(411),
    [sym_long_str_literal] = STATE(392),
    [sym_long_buffer_literal] = STATE(392),
    [sym_number_literal] = STATE(392),
    [sym_bool_literal] = STATE(392),
    [sym__identifier] = STATE(411),
    [aux_sym_source_file_repeat1] = STATE(75),
    [ts_builtin_sym_end] = ACTIONS(671),
    [sym_symbol] = ACTIONS(673),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(679),
    [anon_sym_AT_LPAREN] = ACTIONS(682),
    [anon_sym_AT_LBRACK] = ACTIONS(685),
    [anon_sym_LBRACE] = ACTIONS(688),
    [anon_sym_AT_LBRACE] = ACTIONS(691),
    [anon_sym_SQUOTE] = ACTIONS(694),
    [anon_sym_SEMI] = ACTIONS(697),
    [anon_sym_TILDE] = ACTIONS(700),
    [anon_sym_COMMA] = ACTIONS(703),
    [anon_sym_PIPE] = ACTIONS(706),
    [sym_str_literal] = ACTIONS(709),
    [sym_buffer_literal] = ACTIONS(709),
    [aux_sym_number_literal_token1] = ACTIONS(712),
    [aux_sym_number_literal_token2] = ACTIONS(712),
    [aux_sym_number_literal_token3] = ACTIONS(712),
    [anon_sym_true] = ACTIONS(715),
    [anon_sym_false] = ACTIONS(715),
    [sym_nil_literal] = ACTIONS(718),
    [sym_keyword] = ACTIONS(721),
    [sym__long_str] = ACTIONS(724),
    [sym__long_buffer] = ACTIONS(727),
  },
  [76] = {
    [sym__expr] = STATE(368),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [aux_sym_tuple_repeat1] = STATE(138),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [77] = {
    [sym__expr] = STATE(368),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [aux_sym_tuple_repeat1] = STATE(132),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_RBRACK] = ACTIONS(732),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [78] = {
    [sym__expr] = STATE(368),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [aux_sym_tuple_repeat1] = STATE(60),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(734),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [79] = {
    [sym__expr] = STATE(579),
    [sym_tuple] = STATE(607),
    [sym_sqr_tuple] = STATE(607),
    [sym_array] = STATE(607),
    [sym_sqr_array] = STATE(607),
    [sym_struct] = STATE(607),
    [sym_table] = STATE(607),
    [sym_peg_set] = STATE(607),
    [sym__special_forms] = STATE(607),
    [sym_def] = STATE(608),
    [sym_var] = STATE(608),
    [sym_quote] = STATE(444),
    [sym_splice] = STATE(444),
    [sym_quasiquote] = STATE(444),
    [sym_unquote] = STATE(444),
    [sym_break] = STATE(608),
    [sym_set] = STATE(608),
    [sym_if] = STATE(608),
    [sym_do] = STATE(608),
    [sym_while] = STATE(608),
    [sym_fn] = STATE(608),
    [sym_upscope] = STATE(608),
    [sym__shorthand] = STATE(607),
    [sym_short_quote] = STATE(443),
    [sym_short_splice] = STATE(443),
    [sym_short_quasiquote] = STATE(443),
    [sym_short_unquote] = STATE(443),
    [sym_short_fn] = STATE(609),
    [sym__specials] = STATE(607),
    [sym_extra_defs] = STATE(611),
    [sym__literals] = STATE(607),
    [sym_long_str_literal] = STATE(446),
    [sym_long_buffer_literal] = STATE(603),
    [sym_number_literal] = STATE(603),
    [sym_bool_literal] = STATE(603),
    [sym_metadata] = STATE(478),
    [sym__identifier] = STATE(607),
    [aux_sym_def_repeat1] = STATE(73),
    [sym_symbol] = ACTIONS(631),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_AT_LPAREN] = ACTIONS(637),
    [anon_sym_AT_LBRACK] = ACTIONS(639),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_AT_LBRACE] = ACTIONS(643),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(645),
    [sym_str_literal] = ACTIONS(647),
    [sym_buffer_literal] = ACTIONS(649),
    [aux_sym_number_literal_token1] = ACTIONS(651),
    [aux_sym_number_literal_token2] = ACTIONS(651),
    [aux_sym_number_literal_token3] = ACTIONS(651),
    [anon_sym_true] = ACTIONS(653),
    [anon_sym_false] = ACTIONS(653),
    [sym_nil_literal] = ACTIONS(655),
    [sym_keyword] = ACTIONS(657),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(659),
  },
  [80] = {
    [sym__expr] = STATE(627),
    [sym_tuple] = STATE(607),
    [sym_sqr_tuple] = STATE(607),
    [sym_array] = STATE(607),
    [sym_sqr_array] = STATE(607),
    [sym_struct] = STATE(607),
    [sym_table] = STATE(607),
    [sym_peg_set] = STATE(607),
    [sym__special_forms] = STATE(607),
    [sym_def] = STATE(608),
    [sym_var] = STATE(608),
    [sym_quote] = STATE(444),
    [sym_splice] = STATE(444),
    [sym_quasiquote] = STATE(444),
    [sym_unquote] = STATE(444),
    [sym_break] = STATE(608),
    [sym_set] = STATE(608),
    [sym_if] = STATE(608),
    [sym_do] = STATE(608),
    [sym_while] = STATE(608),
    [sym_fn] = STATE(608),
    [sym_upscope] = STATE(608),
    [sym__shorthand] = STATE(607),
    [sym_short_quote] = STATE(443),
    [sym_short_splice] = STATE(443),
    [sym_short_quasiquote] = STATE(443),
    [sym_short_unquote] = STATE(443),
    [sym_short_fn] = STATE(609),
    [sym__specials] = STATE(607),
    [sym_extra_defs] = STATE(611),
    [sym__literals] = STATE(607),
    [sym_long_str_literal] = STATE(446),
    [sym_long_buffer_literal] = STATE(603),
    [sym_number_literal] = STATE(603),
    [sym_bool_literal] = STATE(603),
    [sym_metadata] = STATE(478),
    [sym__identifier] = STATE(607),
    [aux_sym_def_repeat1] = STATE(113),
    [sym_symbol] = ACTIONS(631),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_AT_LPAREN] = ACTIONS(637),
    [anon_sym_AT_LBRACK] = ACTIONS(639),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_AT_LBRACE] = ACTIONS(643),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(645),
    [sym_str_literal] = ACTIONS(647),
    [sym_buffer_literal] = ACTIONS(649),
    [aux_sym_number_literal_token1] = ACTIONS(651),
    [aux_sym_number_literal_token2] = ACTIONS(651),
    [aux_sym_number_literal_token3] = ACTIONS(651),
    [anon_sym_true] = ACTIONS(653),
    [anon_sym_false] = ACTIONS(653),
    [sym_nil_literal] = ACTIONS(655),
    [sym_keyword] = ACTIONS(657),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(659),
  },
  [81] = {
    [sym__expr] = STATE(610),
    [sym_tuple] = STATE(607),
    [sym_sqr_tuple] = STATE(607),
    [sym_array] = STATE(607),
    [sym_sqr_array] = STATE(607),
    [sym_struct] = STATE(607),
    [sym_table] = STATE(607),
    [sym_peg_set] = STATE(607),
    [sym__special_forms] = STATE(607),
    [sym_def] = STATE(608),
    [sym_var] = STATE(608),
    [sym_quote] = STATE(444),
    [sym_splice] = STATE(444),
    [sym_quasiquote] = STATE(444),
    [sym_unquote] = STATE(444),
    [sym_break] = STATE(608),
    [sym_set] = STATE(608),
    [sym_if] = STATE(608),
    [sym_do] = STATE(608),
    [sym_while] = STATE(608),
    [sym_fn] = STATE(608),
    [sym_upscope] = STATE(608),
    [sym__shorthand] = STATE(607),
    [sym_short_quote] = STATE(443),
    [sym_short_splice] = STATE(443),
    [sym_short_quasiquote] = STATE(443),
    [sym_short_unquote] = STATE(443),
    [sym_short_fn] = STATE(609),
    [sym__specials] = STATE(607),
    [sym_extra_defs] = STATE(611),
    [sym__literals] = STATE(607),
    [sym_long_str_literal] = STATE(446),
    [sym_long_buffer_literal] = STATE(603),
    [sym_number_literal] = STATE(603),
    [sym_bool_literal] = STATE(603),
    [sym_metadata] = STATE(478),
    [sym__identifier] = STATE(607),
    [aux_sym_def_repeat1] = STATE(114),
    [sym_symbol] = ACTIONS(631),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_AT_LPAREN] = ACTIONS(637),
    [anon_sym_AT_LBRACK] = ACTIONS(639),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_AT_LBRACE] = ACTIONS(643),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(645),
    [sym_str_literal] = ACTIONS(647),
    [sym_buffer_literal] = ACTIONS(649),
    [aux_sym_number_literal_token1] = ACTIONS(651),
    [aux_sym_number_literal_token2] = ACTIONS(651),
    [aux_sym_number_literal_token3] = ACTIONS(651),
    [anon_sym_true] = ACTIONS(653),
    [anon_sym_false] = ACTIONS(653),
    [sym_nil_literal] = ACTIONS(655),
    [sym_keyword] = ACTIONS(657),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(659),
  },
  [82] = {
    [sym__expr] = STATE(578),
    [sym_tuple] = STATE(607),
    [sym_sqr_tuple] = STATE(607),
    [sym_array] = STATE(607),
    [sym_sqr_array] = STATE(607),
    [sym_struct] = STATE(607),
    [sym_table] = STATE(607),
    [sym_peg_set] = STATE(607),
    [sym__special_forms] = STATE(607),
    [sym_def] = STATE(608),
    [sym_var] = STATE(608),
    [sym_quote] = STATE(444),
    [sym_splice] = STATE(444),
    [sym_quasiquote] = STATE(444),
    [sym_unquote] = STATE(444),
    [sym_break] = STATE(608),
    [sym_set] = STATE(608),
    [sym_if] = STATE(608),
    [sym_do] = STATE(608),
    [sym_while] = STATE(608),
    [sym_fn] = STATE(608),
    [sym_upscope] = STATE(608),
    [sym__shorthand] = STATE(607),
    [sym_short_quote] = STATE(443),
    [sym_short_splice] = STATE(443),
    [sym_short_quasiquote] = STATE(443),
    [sym_short_unquote] = STATE(443),
    [sym_short_fn] = STATE(609),
    [sym__specials] = STATE(607),
    [sym_extra_defs] = STATE(611),
    [sym__literals] = STATE(607),
    [sym_long_str_literal] = STATE(446),
    [sym_long_buffer_literal] = STATE(603),
    [sym_number_literal] = STATE(603),
    [sym_bool_literal] = STATE(603),
    [sym_metadata] = STATE(478),
    [sym__identifier] = STATE(607),
    [aux_sym_def_repeat1] = STATE(74),
    [sym_symbol] = ACTIONS(631),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_AT_LPAREN] = ACTIONS(637),
    [anon_sym_AT_LBRACK] = ACTIONS(639),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_AT_LBRACE] = ACTIONS(643),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(645),
    [sym_str_literal] = ACTIONS(647),
    [sym_buffer_literal] = ACTIONS(649),
    [aux_sym_number_literal_token1] = ACTIONS(651),
    [aux_sym_number_literal_token2] = ACTIONS(651),
    [aux_sym_number_literal_token3] = ACTIONS(651),
    [anon_sym_true] = ACTIONS(653),
    [anon_sym_false] = ACTIONS(653),
    [sym_nil_literal] = ACTIONS(655),
    [sym_keyword] = ACTIONS(657),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(659),
  },
  [83] = {
    [sym__expr] = STATE(368),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [aux_sym_tuple_repeat1] = STATE(60),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_RBRACK] = ACTIONS(736),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [84] = {
    [sym__expr] = STATE(368),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [aux_sym_tuple_repeat1] = STATE(60),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(738),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [85] = {
    [sym__expr] = STATE(368),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [aux_sym_tuple_repeat1] = STATE(60),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_RBRACK] = ACTIONS(740),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [86] = {
    [sym__expr] = STATE(470),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [aux_sym_while_repeat1] = STATE(89),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(742),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [87] = {
    [sym__expr] = STATE(562),
    [sym_tuple] = STATE(607),
    [sym_sqr_tuple] = STATE(607),
    [sym_array] = STATE(607),
    [sym_sqr_array] = STATE(607),
    [sym_struct] = STATE(607),
    [sym_table] = STATE(607),
    [sym_peg_set] = STATE(607),
    [sym__special_forms] = STATE(607),
    [sym_def] = STATE(608),
    [sym_var] = STATE(608),
    [sym_quote] = STATE(444),
    [sym_splice] = STATE(444),
    [sym_quasiquote] = STATE(444),
    [sym_unquote] = STATE(444),
    [sym_break] = STATE(608),
    [sym_set] = STATE(608),
    [sym_if] = STATE(608),
    [sym_do] = STATE(608),
    [sym_while] = STATE(608),
    [sym_fn] = STATE(608),
    [sym_upscope] = STATE(608),
    [sym__shorthand] = STATE(607),
    [sym_short_quote] = STATE(443),
    [sym_short_splice] = STATE(443),
    [sym_short_quasiquote] = STATE(443),
    [sym_short_unquote] = STATE(443),
    [sym_short_fn] = STATE(609),
    [sym__specials] = STATE(607),
    [sym_extra_defs] = STATE(611),
    [sym__literals] = STATE(607),
    [sym_long_str_literal] = STATE(446),
    [sym_long_buffer_literal] = STATE(603),
    [sym_number_literal] = STATE(603),
    [sym_bool_literal] = STATE(603),
    [sym_metadata] = STATE(478),
    [sym__identifier] = STATE(607),
    [aux_sym_def_repeat1] = STATE(242),
    [sym_symbol] = ACTIONS(631),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_AT_LPAREN] = ACTIONS(637),
    [anon_sym_AT_LBRACK] = ACTIONS(639),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_AT_LBRACE] = ACTIONS(643),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(645),
    [sym_str_literal] = ACTIONS(647),
    [sym_buffer_literal] = ACTIONS(649),
    [aux_sym_number_literal_token1] = ACTIONS(651),
    [aux_sym_number_literal_token2] = ACTIONS(651),
    [aux_sym_number_literal_token3] = ACTIONS(651),
    [anon_sym_true] = ACTIONS(653),
    [anon_sym_false] = ACTIONS(653),
    [sym_nil_literal] = ACTIONS(655),
    [sym_keyword] = ACTIONS(657),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(659),
  },
  [88] = {
    [sym__expr] = STATE(561),
    [sym_tuple] = STATE(607),
    [sym_sqr_tuple] = STATE(607),
    [sym_array] = STATE(607),
    [sym_sqr_array] = STATE(607),
    [sym_struct] = STATE(607),
    [sym_table] = STATE(607),
    [sym_peg_set] = STATE(607),
    [sym__special_forms] = STATE(607),
    [sym_def] = STATE(608),
    [sym_var] = STATE(608),
    [sym_quote] = STATE(444),
    [sym_splice] = STATE(444),
    [sym_quasiquote] = STATE(444),
    [sym_unquote] = STATE(444),
    [sym_break] = STATE(608),
    [sym_set] = STATE(608),
    [sym_if] = STATE(608),
    [sym_do] = STATE(608),
    [sym_while] = STATE(608),
    [sym_fn] = STATE(608),
    [sym_upscope] = STATE(608),
    [sym__shorthand] = STATE(607),
    [sym_short_quote] = STATE(443),
    [sym_short_splice] = STATE(443),
    [sym_short_quasiquote] = STATE(443),
    [sym_short_unquote] = STATE(443),
    [sym_short_fn] = STATE(609),
    [sym__specials] = STATE(607),
    [sym_extra_defs] = STATE(611),
    [sym__literals] = STATE(607),
    [sym_long_str_literal] = STATE(446),
    [sym_long_buffer_literal] = STATE(603),
    [sym_number_literal] = STATE(603),
    [sym_bool_literal] = STATE(603),
    [sym_metadata] = STATE(478),
    [sym__identifier] = STATE(607),
    [aux_sym_def_repeat1] = STATE(242),
    [sym_symbol] = ACTIONS(631),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_AT_LPAREN] = ACTIONS(637),
    [anon_sym_AT_LBRACK] = ACTIONS(639),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_AT_LBRACE] = ACTIONS(643),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(645),
    [sym_str_literal] = ACTIONS(647),
    [sym_buffer_literal] = ACTIONS(649),
    [aux_sym_number_literal_token1] = ACTIONS(651),
    [aux_sym_number_literal_token2] = ACTIONS(651),
    [aux_sym_number_literal_token3] = ACTIONS(651),
    [anon_sym_true] = ACTIONS(653),
    [anon_sym_false] = ACTIONS(653),
    [sym_nil_literal] = ACTIONS(655),
    [sym_keyword] = ACTIONS(657),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(659),
  },
  [89] = {
    [sym__expr] = STATE(470),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [aux_sym_while_repeat1] = STATE(120),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(744),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [90] = {
    [sym__expr] = STATE(368),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [aux_sym_tuple_repeat1] = STATE(98),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_RBRACK] = ACTIONS(746),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [91] = {
    [sym__expr] = STATE(581),
    [sym_tuple] = STATE(607),
    [sym_sqr_tuple] = STATE(607),
    [sym_array] = STATE(607),
    [sym_sqr_array] = STATE(607),
    [sym_struct] = STATE(607),
    [sym_table] = STATE(607),
    [sym_peg_set] = STATE(607),
    [sym__special_forms] = STATE(607),
    [sym_def] = STATE(608),
    [sym_var] = STATE(608),
    [sym_quote] = STATE(444),
    [sym_splice] = STATE(444),
    [sym_quasiquote] = STATE(444),
    [sym_unquote] = STATE(444),
    [sym_break] = STATE(608),
    [sym_set] = STATE(608),
    [sym_if] = STATE(608),
    [sym_do] = STATE(608),
    [sym_while] = STATE(608),
    [sym_fn] = STATE(608),
    [sym_upscope] = STATE(608),
    [sym__shorthand] = STATE(607),
    [sym_short_quote] = STATE(443),
    [sym_short_splice] = STATE(443),
    [sym_short_quasiquote] = STATE(443),
    [sym_short_unquote] = STATE(443),
    [sym_short_fn] = STATE(609),
    [sym__specials] = STATE(607),
    [sym_extra_defs] = STATE(611),
    [sym__literals] = STATE(607),
    [sym_long_str_literal] = STATE(446),
    [sym_long_buffer_literal] = STATE(603),
    [sym_number_literal] = STATE(603),
    [sym_bool_literal] = STATE(603),
    [sym_metadata] = STATE(478),
    [sym__identifier] = STATE(607),
    [aux_sym_def_repeat1] = STATE(87),
    [sym_symbol] = ACTIONS(631),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_AT_LPAREN] = ACTIONS(637),
    [anon_sym_AT_LBRACK] = ACTIONS(639),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_AT_LBRACE] = ACTIONS(643),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(645),
    [sym_str_literal] = ACTIONS(647),
    [sym_buffer_literal] = ACTIONS(649),
    [aux_sym_number_literal_token1] = ACTIONS(651),
    [aux_sym_number_literal_token2] = ACTIONS(651),
    [aux_sym_number_literal_token3] = ACTIONS(651),
    [anon_sym_true] = ACTIONS(653),
    [anon_sym_false] = ACTIONS(653),
    [sym_nil_literal] = ACTIONS(655),
    [sym_keyword] = ACTIONS(657),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(659),
  },
  [92] = {
    [sym__expr] = STATE(368),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [aux_sym_tuple_repeat1] = STATE(99),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(748),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [93] = {
    [sym__expr] = STATE(584),
    [sym_tuple] = STATE(607),
    [sym_sqr_tuple] = STATE(607),
    [sym_array] = STATE(607),
    [sym_sqr_array] = STATE(607),
    [sym_struct] = STATE(607),
    [sym_table] = STATE(607),
    [sym_peg_set] = STATE(607),
    [sym__special_forms] = STATE(607),
    [sym_def] = STATE(608),
    [sym_var] = STATE(608),
    [sym_quote] = STATE(444),
    [sym_splice] = STATE(444),
    [sym_quasiquote] = STATE(444),
    [sym_unquote] = STATE(444),
    [sym_break] = STATE(608),
    [sym_set] = STATE(608),
    [sym_if] = STATE(608),
    [sym_do] = STATE(608),
    [sym_while] = STATE(608),
    [sym_fn] = STATE(608),
    [sym_upscope] = STATE(608),
    [sym__shorthand] = STATE(607),
    [sym_short_quote] = STATE(443),
    [sym_short_splice] = STATE(443),
    [sym_short_quasiquote] = STATE(443),
    [sym_short_unquote] = STATE(443),
    [sym_short_fn] = STATE(609),
    [sym__specials] = STATE(607),
    [sym_extra_defs] = STATE(611),
    [sym__literals] = STATE(607),
    [sym_long_str_literal] = STATE(446),
    [sym_long_buffer_literal] = STATE(603),
    [sym_number_literal] = STATE(603),
    [sym_bool_literal] = STATE(603),
    [sym_metadata] = STATE(478),
    [sym__identifier] = STATE(607),
    [aux_sym_def_repeat1] = STATE(88),
    [sym_symbol] = ACTIONS(631),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_AT_LPAREN] = ACTIONS(637),
    [anon_sym_AT_LBRACK] = ACTIONS(639),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_AT_LBRACE] = ACTIONS(643),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(645),
    [sym_str_literal] = ACTIONS(647),
    [sym_buffer_literal] = ACTIONS(649),
    [aux_sym_number_literal_token1] = ACTIONS(651),
    [aux_sym_number_literal_token2] = ACTIONS(651),
    [aux_sym_number_literal_token3] = ACTIONS(651),
    [anon_sym_true] = ACTIONS(653),
    [anon_sym_false] = ACTIONS(653),
    [sym_nil_literal] = ACTIONS(655),
    [sym_keyword] = ACTIONS(657),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(659),
  },
  [94] = {
    [sym__expr] = STATE(368),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [aux_sym_tuple_repeat1] = STATE(102),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_RBRACK] = ACTIONS(750),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [95] = {
    [sym__expr] = STATE(368),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [aux_sym_tuple_repeat1] = STATE(60),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(752),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [96] = {
    [sym__expr] = STATE(470),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [aux_sym_while_repeat1] = STATE(120),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(754),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [97] = {
    [sym__expr] = STATE(470),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [aux_sym_while_repeat1] = STATE(122),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(756),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [98] = {
    [sym__expr] = STATE(368),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [aux_sym_tuple_repeat1] = STATE(60),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_RBRACK] = ACTIONS(758),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [99] = {
    [sym__expr] = STATE(368),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [aux_sym_tuple_repeat1] = STATE(60),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(760),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [100] = {
    [sym__expr] = STATE(640),
    [sym_tuple] = STATE(607),
    [sym_sqr_tuple] = STATE(607),
    [sym_array] = STATE(607),
    [sym_sqr_array] = STATE(607),
    [sym_struct] = STATE(607),
    [sym_table] = STATE(607),
    [sym_peg_set] = STATE(607),
    [sym__special_forms] = STATE(607),
    [sym_def] = STATE(608),
    [sym_var] = STATE(608),
    [sym_quote] = STATE(444),
    [sym_splice] = STATE(444),
    [sym_quasiquote] = STATE(444),
    [sym_unquote] = STATE(444),
    [sym_break] = STATE(608),
    [sym_set] = STATE(608),
    [sym_if] = STATE(608),
    [sym_do] = STATE(608),
    [sym_while] = STATE(608),
    [sym_fn] = STATE(608),
    [sym_upscope] = STATE(608),
    [sym__shorthand] = STATE(607),
    [sym_short_quote] = STATE(443),
    [sym_short_splice] = STATE(443),
    [sym_short_quasiquote] = STATE(443),
    [sym_short_unquote] = STATE(443),
    [sym_short_fn] = STATE(609),
    [sym__specials] = STATE(607),
    [sym_extra_defs] = STATE(611),
    [sym__literals] = STATE(607),
    [sym_long_str_literal] = STATE(446),
    [sym_long_buffer_literal] = STATE(603),
    [sym_number_literal] = STATE(603),
    [sym_bool_literal] = STATE(603),
    [sym_metadata] = STATE(478),
    [sym__identifier] = STATE(607),
    [aux_sym_def_repeat1] = STATE(242),
    [sym_symbol] = ACTIONS(631),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_AT_LPAREN] = ACTIONS(637),
    [anon_sym_AT_LBRACK] = ACTIONS(639),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_AT_LBRACE] = ACTIONS(643),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(645),
    [sym_str_literal] = ACTIONS(647),
    [sym_buffer_literal] = ACTIONS(649),
    [aux_sym_number_literal_token1] = ACTIONS(651),
    [aux_sym_number_literal_token2] = ACTIONS(651),
    [aux_sym_number_literal_token3] = ACTIONS(651),
    [anon_sym_true] = ACTIONS(653),
    [anon_sym_false] = ACTIONS(653),
    [sym_nil_literal] = ACTIONS(655),
    [sym_keyword] = ACTIONS(657),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(659),
  },
  [101] = {
    [sym__expr] = STATE(641),
    [sym_tuple] = STATE(607),
    [sym_sqr_tuple] = STATE(607),
    [sym_array] = STATE(607),
    [sym_sqr_array] = STATE(607),
    [sym_struct] = STATE(607),
    [sym_table] = STATE(607),
    [sym_peg_set] = STATE(607),
    [sym__special_forms] = STATE(607),
    [sym_def] = STATE(608),
    [sym_var] = STATE(608),
    [sym_quote] = STATE(444),
    [sym_splice] = STATE(444),
    [sym_quasiquote] = STATE(444),
    [sym_unquote] = STATE(444),
    [sym_break] = STATE(608),
    [sym_set] = STATE(608),
    [sym_if] = STATE(608),
    [sym_do] = STATE(608),
    [sym_while] = STATE(608),
    [sym_fn] = STATE(608),
    [sym_upscope] = STATE(608),
    [sym__shorthand] = STATE(607),
    [sym_short_quote] = STATE(443),
    [sym_short_splice] = STATE(443),
    [sym_short_quasiquote] = STATE(443),
    [sym_short_unquote] = STATE(443),
    [sym_short_fn] = STATE(609),
    [sym__specials] = STATE(607),
    [sym_extra_defs] = STATE(611),
    [sym__literals] = STATE(607),
    [sym_long_str_literal] = STATE(446),
    [sym_long_buffer_literal] = STATE(603),
    [sym_number_literal] = STATE(603),
    [sym_bool_literal] = STATE(603),
    [sym_metadata] = STATE(478),
    [sym__identifier] = STATE(607),
    [aux_sym_def_repeat1] = STATE(242),
    [sym_symbol] = ACTIONS(631),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_AT_LPAREN] = ACTIONS(637),
    [anon_sym_AT_LBRACK] = ACTIONS(639),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_AT_LBRACE] = ACTIONS(643),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(645),
    [sym_str_literal] = ACTIONS(647),
    [sym_buffer_literal] = ACTIONS(649),
    [aux_sym_number_literal_token1] = ACTIONS(651),
    [aux_sym_number_literal_token2] = ACTIONS(651),
    [aux_sym_number_literal_token3] = ACTIONS(651),
    [anon_sym_true] = ACTIONS(653),
    [anon_sym_false] = ACTIONS(653),
    [sym_nil_literal] = ACTIONS(655),
    [sym_keyword] = ACTIONS(657),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(659),
  },
  [102] = {
    [sym__expr] = STATE(368),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [aux_sym_tuple_repeat1] = STATE(60),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_RBRACK] = ACTIONS(762),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [103] = {
    [sym__expr] = STATE(75),
    [sym_tuple] = STATE(411),
    [sym_sqr_tuple] = STATE(411),
    [sym_array] = STATE(411),
    [sym_sqr_array] = STATE(411),
    [sym_struct] = STATE(411),
    [sym_table] = STATE(411),
    [sym_peg_set] = STATE(411),
    [sym__special_forms] = STATE(411),
    [sym_def] = STATE(412),
    [sym_var] = STATE(412),
    [sym_quote] = STATE(412),
    [sym_splice] = STATE(412),
    [sym_quasiquote] = STATE(412),
    [sym_unquote] = STATE(412),
    [sym_break] = STATE(412),
    [sym_set] = STATE(412),
    [sym_if] = STATE(412),
    [sym_do] = STATE(412),
    [sym_while] = STATE(412),
    [sym_fn] = STATE(412),
    [sym_upscope] = STATE(412),
    [sym__shorthand] = STATE(411),
    [sym_short_quote] = STATE(413),
    [sym_short_splice] = STATE(413),
    [sym_short_quasiquote] = STATE(413),
    [sym_short_unquote] = STATE(413),
    [sym_short_fn] = STATE(413),
    [sym__specials] = STATE(411),
    [sym_extra_defs] = STATE(416),
    [sym__literals] = STATE(411),
    [sym_long_str_literal] = STATE(392),
    [sym_long_buffer_literal] = STATE(392),
    [sym_number_literal] = STATE(392),
    [sym_bool_literal] = STATE(392),
    [sym__identifier] = STATE(411),
    [aux_sym_source_file_repeat1] = STATE(75),
    [ts_builtin_sym_end] = ACTIONS(764),
    [sym_symbol] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(9),
    [anon_sym_LBRACK] = ACTIONS(11),
    [anon_sym_AT_LPAREN] = ACTIONS(13),
    [anon_sym_AT_LBRACK] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_AT_LBRACE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(27),
    [anon_sym_PIPE] = ACTIONS(29),
    [sym_str_literal] = ACTIONS(31),
    [sym_buffer_literal] = ACTIONS(31),
    [aux_sym_number_literal_token1] = ACTIONS(33),
    [aux_sym_number_literal_token2] = ACTIONS(33),
    [aux_sym_number_literal_token3] = ACTIONS(33),
    [anon_sym_true] = ACTIONS(35),
    [anon_sym_false] = ACTIONS(35),
    [sym_nil_literal] = ACTIONS(37),
    [sym_keyword] = ACTIONS(39),
    [sym__long_str] = ACTIONS(41),
    [sym__long_buffer] = ACTIONS(43),
  },
  [104] = {
    [sym__expr] = STATE(470),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [aux_sym_while_repeat1] = STATE(134),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [105] = {
    [sym__expr] = STATE(632),
    [sym_tuple] = STATE(607),
    [sym_sqr_tuple] = STATE(607),
    [sym_array] = STATE(607),
    [sym_sqr_array] = STATE(607),
    [sym_struct] = STATE(607),
    [sym_table] = STATE(607),
    [sym_peg_set] = STATE(607),
    [sym__special_forms] = STATE(607),
    [sym_def] = STATE(608),
    [sym_var] = STATE(608),
    [sym_quote] = STATE(444),
    [sym_splice] = STATE(444),
    [sym_quasiquote] = STATE(444),
    [sym_unquote] = STATE(444),
    [sym_break] = STATE(608),
    [sym_set] = STATE(608),
    [sym_if] = STATE(608),
    [sym_do] = STATE(608),
    [sym_while] = STATE(608),
    [sym_fn] = STATE(608),
    [sym_upscope] = STATE(608),
    [sym__shorthand] = STATE(607),
    [sym_short_quote] = STATE(443),
    [sym_short_splice] = STATE(443),
    [sym_short_quasiquote] = STATE(443),
    [sym_short_unquote] = STATE(443),
    [sym_short_fn] = STATE(609),
    [sym__specials] = STATE(607),
    [sym_extra_defs] = STATE(611),
    [sym__literals] = STATE(607),
    [sym_long_str_literal] = STATE(446),
    [sym_long_buffer_literal] = STATE(603),
    [sym_number_literal] = STATE(603),
    [sym_bool_literal] = STATE(603),
    [sym_metadata] = STATE(478),
    [sym__identifier] = STATE(607),
    [aux_sym_def_repeat1] = STATE(242),
    [sym_symbol] = ACTIONS(631),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_AT_LPAREN] = ACTIONS(637),
    [anon_sym_AT_LBRACK] = ACTIONS(639),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_AT_LBRACE] = ACTIONS(643),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(645),
    [sym_str_literal] = ACTIONS(647),
    [sym_buffer_literal] = ACTIONS(649),
    [aux_sym_number_literal_token1] = ACTIONS(651),
    [aux_sym_number_literal_token2] = ACTIONS(651),
    [aux_sym_number_literal_token3] = ACTIONS(651),
    [anon_sym_true] = ACTIONS(653),
    [anon_sym_false] = ACTIONS(653),
    [sym_nil_literal] = ACTIONS(655),
    [sym_keyword] = ACTIONS(657),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(659),
  },
  [106] = {
    [sym__expr] = STATE(648),
    [sym_tuple] = STATE(607),
    [sym_sqr_tuple] = STATE(607),
    [sym_array] = STATE(607),
    [sym_sqr_array] = STATE(607),
    [sym_struct] = STATE(607),
    [sym_table] = STATE(607),
    [sym_peg_set] = STATE(607),
    [sym__special_forms] = STATE(607),
    [sym_def] = STATE(608),
    [sym_var] = STATE(608),
    [sym_quote] = STATE(444),
    [sym_splice] = STATE(444),
    [sym_quasiquote] = STATE(444),
    [sym_unquote] = STATE(444),
    [sym_break] = STATE(608),
    [sym_set] = STATE(608),
    [sym_if] = STATE(608),
    [sym_do] = STATE(608),
    [sym_while] = STATE(608),
    [sym_fn] = STATE(608),
    [sym_upscope] = STATE(608),
    [sym__shorthand] = STATE(607),
    [sym_short_quote] = STATE(443),
    [sym_short_splice] = STATE(443),
    [sym_short_quasiquote] = STATE(443),
    [sym_short_unquote] = STATE(443),
    [sym_short_fn] = STATE(609),
    [sym__specials] = STATE(607),
    [sym_extra_defs] = STATE(611),
    [sym__literals] = STATE(607),
    [sym_long_str_literal] = STATE(446),
    [sym_long_buffer_literal] = STATE(603),
    [sym_number_literal] = STATE(603),
    [sym_bool_literal] = STATE(603),
    [sym_metadata] = STATE(478),
    [sym__identifier] = STATE(607),
    [aux_sym_def_repeat1] = STATE(101),
    [sym_symbol] = ACTIONS(631),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_AT_LPAREN] = ACTIONS(637),
    [anon_sym_AT_LBRACK] = ACTIONS(639),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_AT_LBRACE] = ACTIONS(643),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(645),
    [sym_str_literal] = ACTIONS(647),
    [sym_buffer_literal] = ACTIONS(649),
    [aux_sym_number_literal_token1] = ACTIONS(651),
    [aux_sym_number_literal_token2] = ACTIONS(651),
    [aux_sym_number_literal_token3] = ACTIONS(651),
    [anon_sym_true] = ACTIONS(653),
    [anon_sym_false] = ACTIONS(653),
    [sym_nil_literal] = ACTIONS(655),
    [sym_keyword] = ACTIONS(657),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(659),
  },
  [107] = {
    [sym__expr] = STATE(362),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [aux_sym_parameters_repeat1] = STATE(24),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_RBRACK] = ACTIONS(768),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [108] = {
    [sym__expr] = STATE(362),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [aux_sym_parameters_repeat1] = STATE(24),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(770),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [109] = {
    [sym__expr] = STATE(362),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [aux_sym_parameters_repeat1] = STATE(135),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_RBRACK] = ACTIONS(772),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [110] = {
    [sym__expr] = STATE(470),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [aux_sym_while_repeat1] = STATE(120),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(774),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [111] = {
    [sym__expr] = STATE(362),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [aux_sym_parameters_repeat1] = STATE(140),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_RBRACK] = ACTIONS(776),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [112] = {
    [sym__expr] = STATE(470),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [aux_sym_while_repeat1] = STATE(110),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(778),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [113] = {
    [sym__expr] = STATE(593),
    [sym_tuple] = STATE(607),
    [sym_sqr_tuple] = STATE(607),
    [sym_array] = STATE(607),
    [sym_sqr_array] = STATE(607),
    [sym_struct] = STATE(607),
    [sym_table] = STATE(607),
    [sym_peg_set] = STATE(607),
    [sym__special_forms] = STATE(607),
    [sym_def] = STATE(608),
    [sym_var] = STATE(608),
    [sym_quote] = STATE(444),
    [sym_splice] = STATE(444),
    [sym_quasiquote] = STATE(444),
    [sym_unquote] = STATE(444),
    [sym_break] = STATE(608),
    [sym_set] = STATE(608),
    [sym_if] = STATE(608),
    [sym_do] = STATE(608),
    [sym_while] = STATE(608),
    [sym_fn] = STATE(608),
    [sym_upscope] = STATE(608),
    [sym__shorthand] = STATE(607),
    [sym_short_quote] = STATE(443),
    [sym_short_splice] = STATE(443),
    [sym_short_quasiquote] = STATE(443),
    [sym_short_unquote] = STATE(443),
    [sym_short_fn] = STATE(609),
    [sym__specials] = STATE(607),
    [sym_extra_defs] = STATE(611),
    [sym__literals] = STATE(607),
    [sym_long_str_literal] = STATE(446),
    [sym_long_buffer_literal] = STATE(603),
    [sym_number_literal] = STATE(603),
    [sym_bool_literal] = STATE(603),
    [sym_metadata] = STATE(478),
    [sym__identifier] = STATE(607),
    [aux_sym_def_repeat1] = STATE(242),
    [sym_symbol] = ACTIONS(631),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_AT_LPAREN] = ACTIONS(637),
    [anon_sym_AT_LBRACK] = ACTIONS(639),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_AT_LBRACE] = ACTIONS(643),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(645),
    [sym_str_literal] = ACTIONS(647),
    [sym_buffer_literal] = ACTIONS(649),
    [aux_sym_number_literal_token1] = ACTIONS(651),
    [aux_sym_number_literal_token2] = ACTIONS(651),
    [aux_sym_number_literal_token3] = ACTIONS(651),
    [anon_sym_true] = ACTIONS(653),
    [anon_sym_false] = ACTIONS(653),
    [sym_nil_literal] = ACTIONS(655),
    [sym_keyword] = ACTIONS(657),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(659),
  },
  [114] = {
    [sym__expr] = STATE(590),
    [sym_tuple] = STATE(607),
    [sym_sqr_tuple] = STATE(607),
    [sym_array] = STATE(607),
    [sym_sqr_array] = STATE(607),
    [sym_struct] = STATE(607),
    [sym_table] = STATE(607),
    [sym_peg_set] = STATE(607),
    [sym__special_forms] = STATE(607),
    [sym_def] = STATE(608),
    [sym_var] = STATE(608),
    [sym_quote] = STATE(444),
    [sym_splice] = STATE(444),
    [sym_quasiquote] = STATE(444),
    [sym_unquote] = STATE(444),
    [sym_break] = STATE(608),
    [sym_set] = STATE(608),
    [sym_if] = STATE(608),
    [sym_do] = STATE(608),
    [sym_while] = STATE(608),
    [sym_fn] = STATE(608),
    [sym_upscope] = STATE(608),
    [sym__shorthand] = STATE(607),
    [sym_short_quote] = STATE(443),
    [sym_short_splice] = STATE(443),
    [sym_short_quasiquote] = STATE(443),
    [sym_short_unquote] = STATE(443),
    [sym_short_fn] = STATE(609),
    [sym__specials] = STATE(607),
    [sym_extra_defs] = STATE(611),
    [sym__literals] = STATE(607),
    [sym_long_str_literal] = STATE(446),
    [sym_long_buffer_literal] = STATE(603),
    [sym_number_literal] = STATE(603),
    [sym_bool_literal] = STATE(603),
    [sym_metadata] = STATE(478),
    [sym__identifier] = STATE(607),
    [aux_sym_def_repeat1] = STATE(242),
    [sym_symbol] = ACTIONS(631),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_AT_LPAREN] = ACTIONS(637),
    [anon_sym_AT_LBRACK] = ACTIONS(639),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_AT_LBRACE] = ACTIONS(643),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(645),
    [sym_str_literal] = ACTIONS(647),
    [sym_buffer_literal] = ACTIONS(649),
    [aux_sym_number_literal_token1] = ACTIONS(651),
    [aux_sym_number_literal_token2] = ACTIONS(651),
    [aux_sym_number_literal_token3] = ACTIONS(651),
    [anon_sym_true] = ACTIONS(653),
    [anon_sym_false] = ACTIONS(653),
    [sym_nil_literal] = ACTIONS(655),
    [sym_keyword] = ACTIONS(657),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(659),
  },
  [115] = {
    [sym__expr] = STATE(368),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [aux_sym_tuple_repeat1] = STATE(60),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_RBRACK] = ACTIONS(780),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [116] = {
    [sym__expr] = STATE(368),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [aux_sym_tuple_repeat1] = STATE(60),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(782),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [117] = {
    [sym__expr] = STATE(368),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [aux_sym_tuple_repeat1] = STATE(60),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_RBRACK] = ACTIONS(784),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [118] = {
    [sym__expr] = STATE(368),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [aux_sym_tuple_repeat1] = STATE(60),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(786),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [119] = {
    [sym__expr] = STATE(362),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [aux_sym_parameters_repeat1] = STATE(128),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_RBRACK] = ACTIONS(788),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [120] = {
    [sym__expr] = STATE(470),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [aux_sym_while_repeat1] = STATE(120),
    [sym_symbol] = ACTIONS(790),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(796),
    [anon_sym_LBRACK] = ACTIONS(798),
    [anon_sym_AT_LPAREN] = ACTIONS(801),
    [anon_sym_AT_LBRACK] = ACTIONS(804),
    [anon_sym_LBRACE] = ACTIONS(807),
    [anon_sym_AT_LBRACE] = ACTIONS(810),
    [anon_sym_SQUOTE] = ACTIONS(813),
    [anon_sym_SEMI] = ACTIONS(816),
    [anon_sym_TILDE] = ACTIONS(819),
    [anon_sym_COMMA] = ACTIONS(822),
    [anon_sym_PIPE] = ACTIONS(825),
    [sym_str_literal] = ACTIONS(828),
    [sym_buffer_literal] = ACTIONS(828),
    [aux_sym_number_literal_token1] = ACTIONS(831),
    [aux_sym_number_literal_token2] = ACTIONS(831),
    [aux_sym_number_literal_token3] = ACTIONS(831),
    [anon_sym_true] = ACTIONS(834),
    [anon_sym_false] = ACTIONS(834),
    [sym_nil_literal] = ACTIONS(837),
    [sym_keyword] = ACTIONS(840),
    [sym__long_str] = ACTIONS(843),
    [sym__long_buffer] = ACTIONS(846),
  },
  [121] = {
    [sym__expr] = STATE(368),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [aux_sym_tuple_repeat1] = STATE(60),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_RBRACK] = ACTIONS(849),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [122] = {
    [sym__expr] = STATE(470),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [aux_sym_while_repeat1] = STATE(120),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(851),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [123] = {
    [sym__expr] = STATE(368),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [aux_sym_tuple_repeat1] = STATE(60),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(853),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [124] = {
    [sym__expr] = STATE(362),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [aux_sym_parameters_repeat1] = STATE(146),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(855),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [125] = {
    [sym__expr] = STATE(368),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [aux_sym_tuple_repeat1] = STATE(60),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_RBRACK] = ACTIONS(857),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [126] = {
    [sym__expr] = STATE(368),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [aux_sym_tuple_repeat1] = STATE(60),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(859),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [127] = {
    [sym__expr] = STATE(362),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [aux_sym_parameters_repeat1] = STATE(107),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_RBRACK] = ACTIONS(861),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [128] = {
    [sym__expr] = STATE(362),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [aux_sym_parameters_repeat1] = STATE(24),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_RBRACK] = ACTIONS(863),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [129] = {
    [sym__expr] = STATE(362),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [aux_sym_parameters_repeat1] = STATE(24),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [130] = {
    [sym__expr] = STATE(368),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [aux_sym_tuple_repeat1] = STATE(125),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_RBRACK] = ACTIONS(867),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [131] = {
    [sym__expr] = STATE(625),
    [sym_tuple] = STATE(607),
    [sym_sqr_tuple] = STATE(607),
    [sym_array] = STATE(607),
    [sym_sqr_array] = STATE(607),
    [sym_struct] = STATE(607),
    [sym_table] = STATE(607),
    [sym_peg_set] = STATE(607),
    [sym__special_forms] = STATE(607),
    [sym_def] = STATE(608),
    [sym_var] = STATE(608),
    [sym_quote] = STATE(444),
    [sym_splice] = STATE(444),
    [sym_quasiquote] = STATE(444),
    [sym_unquote] = STATE(444),
    [sym_break] = STATE(608),
    [sym_set] = STATE(608),
    [sym_if] = STATE(608),
    [sym_do] = STATE(608),
    [sym_while] = STATE(608),
    [sym_fn] = STATE(608),
    [sym_upscope] = STATE(608),
    [sym__shorthand] = STATE(607),
    [sym_short_quote] = STATE(443),
    [sym_short_splice] = STATE(443),
    [sym_short_quasiquote] = STATE(443),
    [sym_short_unquote] = STATE(443),
    [sym_short_fn] = STATE(609),
    [sym__specials] = STATE(607),
    [sym_extra_defs] = STATE(611),
    [sym__literals] = STATE(607),
    [sym_long_str_literal] = STATE(446),
    [sym_long_buffer_literal] = STATE(603),
    [sym_number_literal] = STATE(603),
    [sym_bool_literal] = STATE(603),
    [sym_metadata] = STATE(478),
    [sym__identifier] = STATE(607),
    [aux_sym_def_repeat1] = STATE(105),
    [sym_symbol] = ACTIONS(631),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_AT_LPAREN] = ACTIONS(637),
    [anon_sym_AT_LBRACK] = ACTIONS(639),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_AT_LBRACE] = ACTIONS(643),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(645),
    [sym_str_literal] = ACTIONS(647),
    [sym_buffer_literal] = ACTIONS(649),
    [aux_sym_number_literal_token1] = ACTIONS(651),
    [aux_sym_number_literal_token2] = ACTIONS(651),
    [aux_sym_number_literal_token3] = ACTIONS(651),
    [anon_sym_true] = ACTIONS(653),
    [anon_sym_false] = ACTIONS(653),
    [sym_nil_literal] = ACTIONS(655),
    [sym_keyword] = ACTIONS(657),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(659),
  },
  [132] = {
    [sym__expr] = STATE(368),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [aux_sym_tuple_repeat1] = STATE(60),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_RBRACK] = ACTIONS(869),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [133] = {
    [sym__expr] = STATE(368),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [aux_sym_tuple_repeat1] = STATE(115),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_RBRACK] = ACTIONS(871),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [134] = {
    [sym__expr] = STATE(470),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [aux_sym_while_repeat1] = STATE(120),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(873),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [135] = {
    [sym__expr] = STATE(362),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [aux_sym_parameters_repeat1] = STATE(24),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_RBRACK] = ACTIONS(875),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [136] = {
    [sym__expr] = STATE(368),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [aux_sym_tuple_repeat1] = STATE(116),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(877),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [137] = {
    [sym__expr] = STATE(368),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [aux_sym_tuple_repeat1] = STATE(117),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_RBRACK] = ACTIONS(879),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [138] = {
    [sym__expr] = STATE(368),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [aux_sym_tuple_repeat1] = STATE(60),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(881),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [139] = {
    [sym__expr] = STATE(368),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [aux_sym_tuple_repeat1] = STATE(121),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_RBRACK] = ACTIONS(883),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [140] = {
    [sym__expr] = STATE(362),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [aux_sym_parameters_repeat1] = STATE(24),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_RBRACK] = ACTIONS(885),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [141] = {
    [sym__expr] = STATE(368),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [aux_sym_tuple_repeat1] = STATE(60),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_RBRACK] = ACTIONS(887),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [142] = {
    [sym__expr] = STATE(631),
    [sym_tuple] = STATE(607),
    [sym_sqr_tuple] = STATE(607),
    [sym_array] = STATE(607),
    [sym_sqr_array] = STATE(607),
    [sym_struct] = STATE(607),
    [sym_table] = STATE(607),
    [sym_peg_set] = STATE(607),
    [sym__special_forms] = STATE(607),
    [sym_def] = STATE(608),
    [sym_var] = STATE(608),
    [sym_quote] = STATE(444),
    [sym_splice] = STATE(444),
    [sym_quasiquote] = STATE(444),
    [sym_unquote] = STATE(444),
    [sym_break] = STATE(608),
    [sym_set] = STATE(608),
    [sym_if] = STATE(608),
    [sym_do] = STATE(608),
    [sym_while] = STATE(608),
    [sym_fn] = STATE(608),
    [sym_upscope] = STATE(608),
    [sym__shorthand] = STATE(607),
    [sym_short_quote] = STATE(443),
    [sym_short_splice] = STATE(443),
    [sym_short_quasiquote] = STATE(443),
    [sym_short_unquote] = STATE(443),
    [sym_short_fn] = STATE(609),
    [sym__specials] = STATE(607),
    [sym_extra_defs] = STATE(611),
    [sym__literals] = STATE(607),
    [sym_long_str_literal] = STATE(446),
    [sym_long_buffer_literal] = STATE(603),
    [sym_number_literal] = STATE(603),
    [sym_bool_literal] = STATE(603),
    [sym_metadata] = STATE(478),
    [sym__identifier] = STATE(607),
    [aux_sym_def_repeat1] = STATE(242),
    [sym_symbol] = ACTIONS(631),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_AT_LPAREN] = ACTIONS(637),
    [anon_sym_AT_LBRACK] = ACTIONS(639),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_AT_LBRACE] = ACTIONS(643),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(645),
    [sym_str_literal] = ACTIONS(647),
    [sym_buffer_literal] = ACTIONS(649),
    [aux_sym_number_literal_token1] = ACTIONS(651),
    [aux_sym_number_literal_token2] = ACTIONS(651),
    [aux_sym_number_literal_token3] = ACTIONS(651),
    [anon_sym_true] = ACTIONS(653),
    [anon_sym_false] = ACTIONS(653),
    [sym_nil_literal] = ACTIONS(655),
    [sym_keyword] = ACTIONS(657),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(659),
  },
  [143] = {
    [sym__expr] = STATE(470),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [aux_sym_while_repeat1] = STATE(120),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(889),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [144] = {
    [sym__expr] = STATE(362),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [aux_sym_parameters_repeat1] = STATE(24),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(891),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [145] = {
    [sym__expr] = STATE(368),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [aux_sym_tuple_repeat1] = STATE(60),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(893),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [146] = {
    [sym__expr] = STATE(362),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [aux_sym_parameters_repeat1] = STATE(24),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [147] = {
    [sym__expr] = STATE(470),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [aux_sym_while_repeat1] = STATE(143),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(897),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [148] = {
    [sym__expr] = STATE(362),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [aux_sym_parameters_repeat1] = STATE(144),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(899),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [149] = {
    [sym__expr] = STATE(362),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [aux_sym_parameters_repeat1] = STATE(108),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(901),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [150] = {
    [sym__expr] = STATE(362),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [aux_sym_parameters_repeat1] = STATE(129),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(903),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [151] = {
    [sym__expr] = STATE(656),
    [sym_tuple] = STATE(607),
    [sym_sqr_tuple] = STATE(607),
    [sym_array] = STATE(607),
    [sym_sqr_array] = STATE(607),
    [sym_struct] = STATE(607),
    [sym_table] = STATE(607),
    [sym_peg_set] = STATE(607),
    [sym__special_forms] = STATE(607),
    [sym_def] = STATE(608),
    [sym_var] = STATE(608),
    [sym_quote] = STATE(608),
    [sym_splice] = STATE(608),
    [sym_quasiquote] = STATE(608),
    [sym_unquote] = STATE(608),
    [sym_break] = STATE(608),
    [sym_set] = STATE(608),
    [sym_if] = STATE(608),
    [sym_do] = STATE(608),
    [sym_while] = STATE(608),
    [sym_fn] = STATE(608),
    [sym_upscope] = STATE(608),
    [sym__shorthand] = STATE(607),
    [sym_short_quote] = STATE(609),
    [sym_short_splice] = STATE(609),
    [sym_short_quasiquote] = STATE(609),
    [sym_short_unquote] = STATE(609),
    [sym_short_fn] = STATE(609),
    [sym__specials] = STATE(607),
    [sym_extra_defs] = STATE(611),
    [sym__literals] = STATE(607),
    [sym_long_str_literal] = STATE(603),
    [sym_long_buffer_literal] = STATE(603),
    [sym_number_literal] = STATE(603),
    [sym_bool_literal] = STATE(603),
    [sym__identifier] = STATE(607),
    [sym_symbol] = ACTIONS(631),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(907),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_AT_LPAREN] = ACTIONS(637),
    [anon_sym_AT_LBRACK] = ACTIONS(639),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_AT_LBRACE] = ACTIONS(643),
    [anon_sym_SQUOTE] = ACTIONS(909),
    [anon_sym_SEMI] = ACTIONS(911),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_COMMA] = ACTIONS(915),
    [anon_sym_PIPE] = ACTIONS(645),
    [sym_str_literal] = ACTIONS(649),
    [sym_buffer_literal] = ACTIONS(649),
    [aux_sym_number_literal_token1] = ACTIONS(651),
    [aux_sym_number_literal_token2] = ACTIONS(651),
    [aux_sym_number_literal_token3] = ACTIONS(651),
    [anon_sym_true] = ACTIONS(653),
    [anon_sym_false] = ACTIONS(653),
    [sym_nil_literal] = ACTIONS(655),
    [sym_keyword] = ACTIONS(917),
    [sym__long_str] = ACTIONS(919),
    [sym__long_buffer] = ACTIONS(659),
  },
  [152] = {
    [sym__expr] = STATE(663),
    [sym_tuple] = STATE(607),
    [sym_sqr_tuple] = STATE(607),
    [sym_array] = STATE(607),
    [sym_sqr_array] = STATE(607),
    [sym_struct] = STATE(607),
    [sym_table] = STATE(607),
    [sym_peg_set] = STATE(607),
    [sym__special_forms] = STATE(607),
    [sym_def] = STATE(608),
    [sym_var] = STATE(608),
    [sym_quote] = STATE(608),
    [sym_splice] = STATE(608),
    [sym_quasiquote] = STATE(608),
    [sym_unquote] = STATE(608),
    [sym_break] = STATE(608),
    [sym_set] = STATE(608),
    [sym_if] = STATE(608),
    [sym_do] = STATE(608),
    [sym_while] = STATE(608),
    [sym_fn] = STATE(608),
    [sym_upscope] = STATE(608),
    [sym__shorthand] = STATE(607),
    [sym_short_quote] = STATE(609),
    [sym_short_splice] = STATE(609),
    [sym_short_quasiquote] = STATE(609),
    [sym_short_unquote] = STATE(609),
    [sym_short_fn] = STATE(609),
    [sym__specials] = STATE(607),
    [sym_extra_defs] = STATE(611),
    [sym__literals] = STATE(607),
    [sym_long_str_literal] = STATE(603),
    [sym_long_buffer_literal] = STATE(603),
    [sym_number_literal] = STATE(603),
    [sym_bool_literal] = STATE(603),
    [sym__identifier] = STATE(607),
    [sym_symbol] = ACTIONS(631),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(921),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_AT_LPAREN] = ACTIONS(637),
    [anon_sym_AT_LBRACK] = ACTIONS(639),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_AT_LBRACE] = ACTIONS(643),
    [anon_sym_SQUOTE] = ACTIONS(909),
    [anon_sym_SEMI] = ACTIONS(911),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_COMMA] = ACTIONS(915),
    [anon_sym_PIPE] = ACTIONS(645),
    [sym_str_literal] = ACTIONS(649),
    [sym_buffer_literal] = ACTIONS(649),
    [aux_sym_number_literal_token1] = ACTIONS(651),
    [aux_sym_number_literal_token2] = ACTIONS(651),
    [aux_sym_number_literal_token3] = ACTIONS(651),
    [anon_sym_true] = ACTIONS(653),
    [anon_sym_false] = ACTIONS(653),
    [sym_nil_literal] = ACTIONS(655),
    [sym_keyword] = ACTIONS(917),
    [sym__long_str] = ACTIONS(919),
    [sym__long_buffer] = ACTIONS(659),
  },
  [153] = {
    [sym__expr] = STATE(596),
    [sym_tuple] = STATE(607),
    [sym_sqr_tuple] = STATE(607),
    [sym_array] = STATE(607),
    [sym_sqr_array] = STATE(607),
    [sym_struct] = STATE(607),
    [sym_table] = STATE(607),
    [sym_peg_set] = STATE(607),
    [sym__special_forms] = STATE(607),
    [sym_def] = STATE(608),
    [sym_var] = STATE(608),
    [sym_quote] = STATE(608),
    [sym_splice] = STATE(608),
    [sym_quasiquote] = STATE(608),
    [sym_unquote] = STATE(608),
    [sym_break] = STATE(608),
    [sym_set] = STATE(608),
    [sym_if] = STATE(608),
    [sym_do] = STATE(608),
    [sym_while] = STATE(608),
    [sym_fn] = STATE(608),
    [sym_upscope] = STATE(608),
    [sym__shorthand] = STATE(607),
    [sym_short_quote] = STATE(609),
    [sym_short_splice] = STATE(609),
    [sym_short_quasiquote] = STATE(609),
    [sym_short_unquote] = STATE(609),
    [sym_short_fn] = STATE(609),
    [sym__specials] = STATE(607),
    [sym_extra_defs] = STATE(611),
    [sym__literals] = STATE(607),
    [sym_long_str_literal] = STATE(603),
    [sym_long_buffer_literal] = STATE(603),
    [sym_number_literal] = STATE(603),
    [sym_bool_literal] = STATE(603),
    [sym__identifier] = STATE(607),
    [sym_symbol] = ACTIONS(631),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(923),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_AT_LPAREN] = ACTIONS(637),
    [anon_sym_AT_LBRACK] = ACTIONS(639),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_AT_LBRACE] = ACTIONS(643),
    [anon_sym_SQUOTE] = ACTIONS(909),
    [anon_sym_SEMI] = ACTIONS(911),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_COMMA] = ACTIONS(915),
    [anon_sym_PIPE] = ACTIONS(645),
    [sym_str_literal] = ACTIONS(649),
    [sym_buffer_literal] = ACTIONS(649),
    [aux_sym_number_literal_token1] = ACTIONS(651),
    [aux_sym_number_literal_token2] = ACTIONS(651),
    [aux_sym_number_literal_token3] = ACTIONS(651),
    [anon_sym_true] = ACTIONS(653),
    [anon_sym_false] = ACTIONS(653),
    [sym_nil_literal] = ACTIONS(655),
    [sym_keyword] = ACTIONS(917),
    [sym__long_str] = ACTIONS(919),
    [sym__long_buffer] = ACTIONS(659),
  },
  [154] = {
    [sym__expr] = STATE(597),
    [sym_tuple] = STATE(607),
    [sym_sqr_tuple] = STATE(607),
    [sym_array] = STATE(607),
    [sym_sqr_array] = STATE(607),
    [sym_struct] = STATE(607),
    [sym_table] = STATE(607),
    [sym_peg_set] = STATE(607),
    [sym__special_forms] = STATE(607),
    [sym_def] = STATE(608),
    [sym_var] = STATE(608),
    [sym_quote] = STATE(608),
    [sym_splice] = STATE(608),
    [sym_quasiquote] = STATE(608),
    [sym_unquote] = STATE(608),
    [sym_break] = STATE(608),
    [sym_set] = STATE(608),
    [sym_if] = STATE(608),
    [sym_do] = STATE(608),
    [sym_while] = STATE(608),
    [sym_fn] = STATE(608),
    [sym_upscope] = STATE(608),
    [sym__shorthand] = STATE(607),
    [sym_short_quote] = STATE(609),
    [sym_short_splice] = STATE(609),
    [sym_short_quasiquote] = STATE(609),
    [sym_short_unquote] = STATE(609),
    [sym_short_fn] = STATE(609),
    [sym__specials] = STATE(607),
    [sym_extra_defs] = STATE(611),
    [sym__literals] = STATE(607),
    [sym_long_str_literal] = STATE(603),
    [sym_long_buffer_literal] = STATE(603),
    [sym_number_literal] = STATE(603),
    [sym_bool_literal] = STATE(603),
    [sym__identifier] = STATE(607),
    [sym_symbol] = ACTIONS(631),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(925),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_AT_LPAREN] = ACTIONS(637),
    [anon_sym_AT_LBRACK] = ACTIONS(639),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_AT_LBRACE] = ACTIONS(643),
    [anon_sym_SQUOTE] = ACTIONS(909),
    [anon_sym_SEMI] = ACTIONS(911),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_COMMA] = ACTIONS(915),
    [anon_sym_PIPE] = ACTIONS(645),
    [sym_str_literal] = ACTIONS(649),
    [sym_buffer_literal] = ACTIONS(649),
    [aux_sym_number_literal_token1] = ACTIONS(651),
    [aux_sym_number_literal_token2] = ACTIONS(651),
    [aux_sym_number_literal_token3] = ACTIONS(651),
    [anon_sym_true] = ACTIONS(653),
    [anon_sym_false] = ACTIONS(653),
    [sym_nil_literal] = ACTIONS(655),
    [sym_keyword] = ACTIONS(917),
    [sym__long_str] = ACTIONS(919),
    [sym__long_buffer] = ACTIONS(659),
  },
  [155] = {
    [sym__expr] = STATE(598),
    [sym_tuple] = STATE(607),
    [sym_sqr_tuple] = STATE(607),
    [sym_array] = STATE(607),
    [sym_sqr_array] = STATE(607),
    [sym_struct] = STATE(607),
    [sym_table] = STATE(607),
    [sym_peg_set] = STATE(607),
    [sym__special_forms] = STATE(607),
    [sym_def] = STATE(608),
    [sym_var] = STATE(608),
    [sym_quote] = STATE(608),
    [sym_splice] = STATE(608),
    [sym_quasiquote] = STATE(608),
    [sym_unquote] = STATE(608),
    [sym_break] = STATE(608),
    [sym_set] = STATE(608),
    [sym_if] = STATE(608),
    [sym_do] = STATE(608),
    [sym_while] = STATE(608),
    [sym_fn] = STATE(608),
    [sym_upscope] = STATE(608),
    [sym__shorthand] = STATE(607),
    [sym_short_quote] = STATE(609),
    [sym_short_splice] = STATE(609),
    [sym_short_quasiquote] = STATE(609),
    [sym_short_unquote] = STATE(609),
    [sym_short_fn] = STATE(609),
    [sym__specials] = STATE(607),
    [sym_extra_defs] = STATE(611),
    [sym__literals] = STATE(607),
    [sym_long_str_literal] = STATE(603),
    [sym_long_buffer_literal] = STATE(603),
    [sym_number_literal] = STATE(603),
    [sym_bool_literal] = STATE(603),
    [sym__identifier] = STATE(607),
    [sym_symbol] = ACTIONS(631),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(927),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_AT_LPAREN] = ACTIONS(637),
    [anon_sym_AT_LBRACK] = ACTIONS(639),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_AT_LBRACE] = ACTIONS(643),
    [anon_sym_SQUOTE] = ACTIONS(909),
    [anon_sym_SEMI] = ACTIONS(911),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_COMMA] = ACTIONS(915),
    [anon_sym_PIPE] = ACTIONS(645),
    [sym_str_literal] = ACTIONS(649),
    [sym_buffer_literal] = ACTIONS(649),
    [aux_sym_number_literal_token1] = ACTIONS(651),
    [aux_sym_number_literal_token2] = ACTIONS(651),
    [aux_sym_number_literal_token3] = ACTIONS(651),
    [anon_sym_true] = ACTIONS(653),
    [anon_sym_false] = ACTIONS(653),
    [sym_nil_literal] = ACTIONS(655),
    [sym_keyword] = ACTIONS(917),
    [sym__long_str] = ACTIONS(919),
    [sym__long_buffer] = ACTIONS(659),
  },
  [156] = {
    [sym__expr] = STATE(633),
    [sym_tuple] = STATE(607),
    [sym_sqr_tuple] = STATE(607),
    [sym_array] = STATE(607),
    [sym_sqr_array] = STATE(607),
    [sym_struct] = STATE(607),
    [sym_table] = STATE(607),
    [sym_peg_set] = STATE(607),
    [sym__special_forms] = STATE(607),
    [sym_def] = STATE(608),
    [sym_var] = STATE(608),
    [sym_quote] = STATE(608),
    [sym_splice] = STATE(608),
    [sym_quasiquote] = STATE(608),
    [sym_unquote] = STATE(608),
    [sym_break] = STATE(608),
    [sym_set] = STATE(608),
    [sym_if] = STATE(608),
    [sym_do] = STATE(608),
    [sym_while] = STATE(608),
    [sym_fn] = STATE(608),
    [sym_upscope] = STATE(608),
    [sym__shorthand] = STATE(607),
    [sym_short_quote] = STATE(609),
    [sym_short_splice] = STATE(609),
    [sym_short_quasiquote] = STATE(609),
    [sym_short_unquote] = STATE(609),
    [sym_short_fn] = STATE(609),
    [sym__specials] = STATE(607),
    [sym_extra_defs] = STATE(611),
    [sym__literals] = STATE(607),
    [sym_long_str_literal] = STATE(603),
    [sym_long_buffer_literal] = STATE(603),
    [sym_number_literal] = STATE(603),
    [sym_bool_literal] = STATE(603),
    [sym__identifier] = STATE(607),
    [sym_symbol] = ACTIONS(631),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(929),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_AT_LPAREN] = ACTIONS(637),
    [anon_sym_AT_LBRACK] = ACTIONS(639),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_AT_LBRACE] = ACTIONS(643),
    [anon_sym_SQUOTE] = ACTIONS(909),
    [anon_sym_SEMI] = ACTIONS(911),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_COMMA] = ACTIONS(915),
    [anon_sym_PIPE] = ACTIONS(645),
    [sym_str_literal] = ACTIONS(649),
    [sym_buffer_literal] = ACTIONS(649),
    [aux_sym_number_literal_token1] = ACTIONS(651),
    [aux_sym_number_literal_token2] = ACTIONS(651),
    [aux_sym_number_literal_token3] = ACTIONS(651),
    [anon_sym_true] = ACTIONS(653),
    [anon_sym_false] = ACTIONS(653),
    [sym_nil_literal] = ACTIONS(655),
    [sym_keyword] = ACTIONS(917),
    [sym__long_str] = ACTIONS(919),
    [sym__long_buffer] = ACTIONS(659),
  },
  [157] = {
    [sym__expr] = STATE(583),
    [sym_tuple] = STATE(607),
    [sym_sqr_tuple] = STATE(607),
    [sym_array] = STATE(607),
    [sym_sqr_array] = STATE(607),
    [sym_struct] = STATE(607),
    [sym_table] = STATE(607),
    [sym_peg_set] = STATE(607),
    [sym__special_forms] = STATE(607),
    [sym_def] = STATE(608),
    [sym_var] = STATE(608),
    [sym_quote] = STATE(608),
    [sym_splice] = STATE(608),
    [sym_quasiquote] = STATE(608),
    [sym_unquote] = STATE(608),
    [sym_break] = STATE(608),
    [sym_set] = STATE(608),
    [sym_if] = STATE(608),
    [sym_do] = STATE(608),
    [sym_while] = STATE(608),
    [sym_fn] = STATE(608),
    [sym_upscope] = STATE(608),
    [sym__shorthand] = STATE(607),
    [sym_short_quote] = STATE(609),
    [sym_short_splice] = STATE(609),
    [sym_short_quasiquote] = STATE(609),
    [sym_short_unquote] = STATE(609),
    [sym_short_fn] = STATE(609),
    [sym__specials] = STATE(607),
    [sym_extra_defs] = STATE(611),
    [sym__literals] = STATE(607),
    [sym_long_str_literal] = STATE(603),
    [sym_long_buffer_literal] = STATE(603),
    [sym_number_literal] = STATE(603),
    [sym_bool_literal] = STATE(603),
    [sym__identifier] = STATE(607),
    [sym_symbol] = ACTIONS(631),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_AT_LPAREN] = ACTIONS(637),
    [anon_sym_AT_LBRACK] = ACTIONS(639),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_AT_LBRACE] = ACTIONS(643),
    [anon_sym_SQUOTE] = ACTIONS(909),
    [anon_sym_SEMI] = ACTIONS(911),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_COMMA] = ACTIONS(915),
    [anon_sym_PIPE] = ACTIONS(645),
    [sym_str_literal] = ACTIONS(649),
    [sym_buffer_literal] = ACTIONS(649),
    [aux_sym_number_literal_token1] = ACTIONS(651),
    [aux_sym_number_literal_token2] = ACTIONS(651),
    [aux_sym_number_literal_token3] = ACTIONS(651),
    [anon_sym_true] = ACTIONS(653),
    [anon_sym_false] = ACTIONS(653),
    [sym_nil_literal] = ACTIONS(655),
    [sym_keyword] = ACTIONS(917),
    [sym__long_str] = ACTIONS(919),
    [sym__long_buffer] = ACTIONS(659),
  },
  [158] = {
    [sym__expr] = STATE(618),
    [sym_tuple] = STATE(607),
    [sym_sqr_tuple] = STATE(607),
    [sym_array] = STATE(607),
    [sym_sqr_array] = STATE(607),
    [sym_struct] = STATE(607),
    [sym_table] = STATE(607),
    [sym_peg_set] = STATE(607),
    [sym__special_forms] = STATE(607),
    [sym_def] = STATE(608),
    [sym_var] = STATE(608),
    [sym_quote] = STATE(608),
    [sym_splice] = STATE(608),
    [sym_quasiquote] = STATE(608),
    [sym_unquote] = STATE(608),
    [sym_break] = STATE(608),
    [sym_set] = STATE(608),
    [sym_if] = STATE(608),
    [sym_do] = STATE(608),
    [sym_while] = STATE(608),
    [sym_fn] = STATE(608),
    [sym_upscope] = STATE(608),
    [sym__shorthand] = STATE(607),
    [sym_short_quote] = STATE(609),
    [sym_short_splice] = STATE(609),
    [sym_short_quasiquote] = STATE(609),
    [sym_short_unquote] = STATE(609),
    [sym_short_fn] = STATE(609),
    [sym__specials] = STATE(607),
    [sym_extra_defs] = STATE(611),
    [sym__literals] = STATE(607),
    [sym_long_str_literal] = STATE(603),
    [sym_long_buffer_literal] = STATE(603),
    [sym_number_literal] = STATE(603),
    [sym_bool_literal] = STATE(603),
    [sym__identifier] = STATE(607),
    [sym_symbol] = ACTIONS(631),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(933),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_AT_LPAREN] = ACTIONS(637),
    [anon_sym_AT_LBRACK] = ACTIONS(639),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_AT_LBRACE] = ACTIONS(643),
    [anon_sym_SQUOTE] = ACTIONS(909),
    [anon_sym_SEMI] = ACTIONS(911),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_COMMA] = ACTIONS(915),
    [anon_sym_PIPE] = ACTIONS(645),
    [sym_str_literal] = ACTIONS(649),
    [sym_buffer_literal] = ACTIONS(649),
    [aux_sym_number_literal_token1] = ACTIONS(651),
    [aux_sym_number_literal_token2] = ACTIONS(651),
    [aux_sym_number_literal_token3] = ACTIONS(651),
    [anon_sym_true] = ACTIONS(653),
    [anon_sym_false] = ACTIONS(653),
    [sym_nil_literal] = ACTIONS(655),
    [sym_keyword] = ACTIONS(917),
    [sym__long_str] = ACTIONS(919),
    [sym__long_buffer] = ACTIONS(659),
  },
  [159] = {
    [sym__expr] = STATE(617),
    [sym_tuple] = STATE(607),
    [sym_sqr_tuple] = STATE(607),
    [sym_array] = STATE(607),
    [sym_sqr_array] = STATE(607),
    [sym_struct] = STATE(607),
    [sym_table] = STATE(607),
    [sym_peg_set] = STATE(607),
    [sym__special_forms] = STATE(607),
    [sym_def] = STATE(608),
    [sym_var] = STATE(608),
    [sym_quote] = STATE(608),
    [sym_splice] = STATE(608),
    [sym_quasiquote] = STATE(608),
    [sym_unquote] = STATE(608),
    [sym_break] = STATE(608),
    [sym_set] = STATE(608),
    [sym_if] = STATE(608),
    [sym_do] = STATE(608),
    [sym_while] = STATE(608),
    [sym_fn] = STATE(608),
    [sym_upscope] = STATE(608),
    [sym__shorthand] = STATE(607),
    [sym_short_quote] = STATE(609),
    [sym_short_splice] = STATE(609),
    [sym_short_quasiquote] = STATE(609),
    [sym_short_unquote] = STATE(609),
    [sym_short_fn] = STATE(609),
    [sym__specials] = STATE(607),
    [sym_extra_defs] = STATE(611),
    [sym__literals] = STATE(607),
    [sym_long_str_literal] = STATE(603),
    [sym_long_buffer_literal] = STATE(603),
    [sym_number_literal] = STATE(603),
    [sym_bool_literal] = STATE(603),
    [sym__identifier] = STATE(607),
    [sym_symbol] = ACTIONS(631),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_AT_LPAREN] = ACTIONS(637),
    [anon_sym_AT_LBRACK] = ACTIONS(639),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_AT_LBRACE] = ACTIONS(643),
    [anon_sym_SQUOTE] = ACTIONS(909),
    [anon_sym_SEMI] = ACTIONS(911),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_COMMA] = ACTIONS(915),
    [anon_sym_PIPE] = ACTIONS(645),
    [sym_str_literal] = ACTIONS(649),
    [sym_buffer_literal] = ACTIONS(649),
    [aux_sym_number_literal_token1] = ACTIONS(651),
    [aux_sym_number_literal_token2] = ACTIONS(651),
    [aux_sym_number_literal_token3] = ACTIONS(651),
    [anon_sym_true] = ACTIONS(653),
    [anon_sym_false] = ACTIONS(653),
    [sym_nil_literal] = ACTIONS(655),
    [sym_keyword] = ACTIONS(917),
    [sym__long_str] = ACTIONS(919),
    [sym__long_buffer] = ACTIONS(659),
  },
  [160] = {
    [sym__expr] = STATE(600),
    [sym_tuple] = STATE(607),
    [sym_sqr_tuple] = STATE(607),
    [sym_array] = STATE(607),
    [sym_sqr_array] = STATE(607),
    [sym_struct] = STATE(607),
    [sym_table] = STATE(607),
    [sym_peg_set] = STATE(607),
    [sym__special_forms] = STATE(607),
    [sym_def] = STATE(608),
    [sym_var] = STATE(608),
    [sym_quote] = STATE(608),
    [sym_splice] = STATE(608),
    [sym_quasiquote] = STATE(608),
    [sym_unquote] = STATE(608),
    [sym_break] = STATE(608),
    [sym_set] = STATE(608),
    [sym_if] = STATE(608),
    [sym_do] = STATE(608),
    [sym_while] = STATE(608),
    [sym_fn] = STATE(608),
    [sym_upscope] = STATE(608),
    [sym__shorthand] = STATE(607),
    [sym_short_quote] = STATE(609),
    [sym_short_splice] = STATE(609),
    [sym_short_quasiquote] = STATE(609),
    [sym_short_unquote] = STATE(609),
    [sym_short_fn] = STATE(609),
    [sym__specials] = STATE(607),
    [sym_extra_defs] = STATE(611),
    [sym__literals] = STATE(607),
    [sym_long_str_literal] = STATE(603),
    [sym_long_buffer_literal] = STATE(603),
    [sym_number_literal] = STATE(603),
    [sym_bool_literal] = STATE(603),
    [sym__identifier] = STATE(607),
    [sym_symbol] = ACTIONS(631),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(937),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_AT_LPAREN] = ACTIONS(637),
    [anon_sym_AT_LBRACK] = ACTIONS(639),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_AT_LBRACE] = ACTIONS(643),
    [anon_sym_SQUOTE] = ACTIONS(909),
    [anon_sym_SEMI] = ACTIONS(911),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_COMMA] = ACTIONS(915),
    [anon_sym_PIPE] = ACTIONS(645),
    [sym_str_literal] = ACTIONS(649),
    [sym_buffer_literal] = ACTIONS(649),
    [aux_sym_number_literal_token1] = ACTIONS(651),
    [aux_sym_number_literal_token2] = ACTIONS(651),
    [aux_sym_number_literal_token3] = ACTIONS(651),
    [anon_sym_true] = ACTIONS(653),
    [anon_sym_false] = ACTIONS(653),
    [sym_nil_literal] = ACTIONS(655),
    [sym_keyword] = ACTIONS(917),
    [sym__long_str] = ACTIONS(919),
    [sym__long_buffer] = ACTIONS(659),
  },
  [161] = {
    [sym__expr] = STATE(616),
    [sym_tuple] = STATE(607),
    [sym_sqr_tuple] = STATE(607),
    [sym_array] = STATE(607),
    [sym_sqr_array] = STATE(607),
    [sym_struct] = STATE(607),
    [sym_table] = STATE(607),
    [sym_peg_set] = STATE(607),
    [sym__special_forms] = STATE(607),
    [sym_def] = STATE(608),
    [sym_var] = STATE(608),
    [sym_quote] = STATE(608),
    [sym_splice] = STATE(608),
    [sym_quasiquote] = STATE(608),
    [sym_unquote] = STATE(608),
    [sym_break] = STATE(608),
    [sym_set] = STATE(608),
    [sym_if] = STATE(608),
    [sym_do] = STATE(608),
    [sym_while] = STATE(608),
    [sym_fn] = STATE(608),
    [sym_upscope] = STATE(608),
    [sym__shorthand] = STATE(607),
    [sym_short_quote] = STATE(609),
    [sym_short_splice] = STATE(609),
    [sym_short_quasiquote] = STATE(609),
    [sym_short_unquote] = STATE(609),
    [sym_short_fn] = STATE(609),
    [sym__specials] = STATE(607),
    [sym_extra_defs] = STATE(611),
    [sym__literals] = STATE(607),
    [sym_long_str_literal] = STATE(603),
    [sym_long_buffer_literal] = STATE(603),
    [sym_number_literal] = STATE(603),
    [sym_bool_literal] = STATE(603),
    [sym__identifier] = STATE(607),
    [sym_symbol] = ACTIONS(631),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(939),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_AT_LPAREN] = ACTIONS(637),
    [anon_sym_AT_LBRACK] = ACTIONS(639),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_AT_LBRACE] = ACTIONS(643),
    [anon_sym_SQUOTE] = ACTIONS(909),
    [anon_sym_SEMI] = ACTIONS(911),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_COMMA] = ACTIONS(915),
    [anon_sym_PIPE] = ACTIONS(645),
    [sym_str_literal] = ACTIONS(649),
    [sym_buffer_literal] = ACTIONS(649),
    [aux_sym_number_literal_token1] = ACTIONS(651),
    [aux_sym_number_literal_token2] = ACTIONS(651),
    [aux_sym_number_literal_token3] = ACTIONS(651),
    [anon_sym_true] = ACTIONS(653),
    [anon_sym_false] = ACTIONS(653),
    [sym_nil_literal] = ACTIONS(655),
    [sym_keyword] = ACTIONS(917),
    [sym__long_str] = ACTIONS(919),
    [sym__long_buffer] = ACTIONS(659),
  },
  [162] = {
    [sym__expr] = STATE(615),
    [sym_tuple] = STATE(607),
    [sym_sqr_tuple] = STATE(607),
    [sym_array] = STATE(607),
    [sym_sqr_array] = STATE(607),
    [sym_struct] = STATE(607),
    [sym_table] = STATE(607),
    [sym_peg_set] = STATE(607),
    [sym__special_forms] = STATE(607),
    [sym_def] = STATE(608),
    [sym_var] = STATE(608),
    [sym_quote] = STATE(608),
    [sym_splice] = STATE(608),
    [sym_quasiquote] = STATE(608),
    [sym_unquote] = STATE(608),
    [sym_break] = STATE(608),
    [sym_set] = STATE(608),
    [sym_if] = STATE(608),
    [sym_do] = STATE(608),
    [sym_while] = STATE(608),
    [sym_fn] = STATE(608),
    [sym_upscope] = STATE(608),
    [sym__shorthand] = STATE(607),
    [sym_short_quote] = STATE(609),
    [sym_short_splice] = STATE(609),
    [sym_short_quasiquote] = STATE(609),
    [sym_short_unquote] = STATE(609),
    [sym_short_fn] = STATE(609),
    [sym__specials] = STATE(607),
    [sym_extra_defs] = STATE(611),
    [sym__literals] = STATE(607),
    [sym_long_str_literal] = STATE(603),
    [sym_long_buffer_literal] = STATE(603),
    [sym_number_literal] = STATE(603),
    [sym_bool_literal] = STATE(603),
    [sym__identifier] = STATE(607),
    [sym_symbol] = ACTIONS(631),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(941),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_AT_LPAREN] = ACTIONS(637),
    [anon_sym_AT_LBRACK] = ACTIONS(639),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_AT_LBRACE] = ACTIONS(643),
    [anon_sym_SQUOTE] = ACTIONS(909),
    [anon_sym_SEMI] = ACTIONS(911),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_COMMA] = ACTIONS(915),
    [anon_sym_PIPE] = ACTIONS(645),
    [sym_str_literal] = ACTIONS(649),
    [sym_buffer_literal] = ACTIONS(649),
    [aux_sym_number_literal_token1] = ACTIONS(651),
    [aux_sym_number_literal_token2] = ACTIONS(651),
    [aux_sym_number_literal_token3] = ACTIONS(651),
    [anon_sym_true] = ACTIONS(653),
    [anon_sym_false] = ACTIONS(653),
    [sym_nil_literal] = ACTIONS(655),
    [sym_keyword] = ACTIONS(917),
    [sym__long_str] = ACTIONS(919),
    [sym__long_buffer] = ACTIONS(659),
  },
  [163] = {
    [sym__expr] = STATE(614),
    [sym_tuple] = STATE(607),
    [sym_sqr_tuple] = STATE(607),
    [sym_array] = STATE(607),
    [sym_sqr_array] = STATE(607),
    [sym_struct] = STATE(607),
    [sym_table] = STATE(607),
    [sym_peg_set] = STATE(607),
    [sym__special_forms] = STATE(607),
    [sym_def] = STATE(608),
    [sym_var] = STATE(608),
    [sym_quote] = STATE(608),
    [sym_splice] = STATE(608),
    [sym_quasiquote] = STATE(608),
    [sym_unquote] = STATE(608),
    [sym_break] = STATE(608),
    [sym_set] = STATE(608),
    [sym_if] = STATE(608),
    [sym_do] = STATE(608),
    [sym_while] = STATE(608),
    [sym_fn] = STATE(608),
    [sym_upscope] = STATE(608),
    [sym__shorthand] = STATE(607),
    [sym_short_quote] = STATE(609),
    [sym_short_splice] = STATE(609),
    [sym_short_quasiquote] = STATE(609),
    [sym_short_unquote] = STATE(609),
    [sym_short_fn] = STATE(609),
    [sym__specials] = STATE(607),
    [sym_extra_defs] = STATE(611),
    [sym__literals] = STATE(607),
    [sym_long_str_literal] = STATE(603),
    [sym_long_buffer_literal] = STATE(603),
    [sym_number_literal] = STATE(603),
    [sym_bool_literal] = STATE(603),
    [sym__identifier] = STATE(607),
    [sym_symbol] = ACTIONS(631),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(943),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_AT_LPAREN] = ACTIONS(637),
    [anon_sym_AT_LBRACK] = ACTIONS(639),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_AT_LBRACE] = ACTIONS(643),
    [anon_sym_SQUOTE] = ACTIONS(909),
    [anon_sym_SEMI] = ACTIONS(911),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_COMMA] = ACTIONS(915),
    [anon_sym_PIPE] = ACTIONS(645),
    [sym_str_literal] = ACTIONS(649),
    [sym_buffer_literal] = ACTIONS(649),
    [aux_sym_number_literal_token1] = ACTIONS(651),
    [aux_sym_number_literal_token2] = ACTIONS(651),
    [aux_sym_number_literal_token3] = ACTIONS(651),
    [anon_sym_true] = ACTIONS(653),
    [anon_sym_false] = ACTIONS(653),
    [sym_nil_literal] = ACTIONS(655),
    [sym_keyword] = ACTIONS(917),
    [sym__long_str] = ACTIONS(919),
    [sym__long_buffer] = ACTIONS(659),
  },
  [164] = {
    [sym__expr] = STATE(668),
    [sym_tuple] = STATE(607),
    [sym_sqr_tuple] = STATE(607),
    [sym_array] = STATE(607),
    [sym_sqr_array] = STATE(607),
    [sym_struct] = STATE(607),
    [sym_table] = STATE(607),
    [sym_peg_set] = STATE(607),
    [sym__special_forms] = STATE(607),
    [sym_def] = STATE(608),
    [sym_var] = STATE(608),
    [sym_quote] = STATE(608),
    [sym_splice] = STATE(608),
    [sym_quasiquote] = STATE(608),
    [sym_unquote] = STATE(608),
    [sym_break] = STATE(608),
    [sym_set] = STATE(608),
    [sym_if] = STATE(608),
    [sym_do] = STATE(608),
    [sym_while] = STATE(608),
    [sym_fn] = STATE(608),
    [sym_upscope] = STATE(608),
    [sym__shorthand] = STATE(607),
    [sym_short_quote] = STATE(609),
    [sym_short_splice] = STATE(609),
    [sym_short_quasiquote] = STATE(609),
    [sym_short_unquote] = STATE(609),
    [sym_short_fn] = STATE(609),
    [sym__specials] = STATE(607),
    [sym_extra_defs] = STATE(611),
    [sym__literals] = STATE(607),
    [sym_long_str_literal] = STATE(603),
    [sym_long_buffer_literal] = STATE(603),
    [sym_number_literal] = STATE(603),
    [sym_bool_literal] = STATE(603),
    [sym__identifier] = STATE(607),
    [sym_symbol] = ACTIONS(631),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(945),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_AT_LPAREN] = ACTIONS(637),
    [anon_sym_AT_LBRACK] = ACTIONS(639),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_AT_LBRACE] = ACTIONS(643),
    [anon_sym_SQUOTE] = ACTIONS(909),
    [anon_sym_SEMI] = ACTIONS(911),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_COMMA] = ACTIONS(915),
    [anon_sym_PIPE] = ACTIONS(645),
    [sym_str_literal] = ACTIONS(649),
    [sym_buffer_literal] = ACTIONS(649),
    [aux_sym_number_literal_token1] = ACTIONS(651),
    [aux_sym_number_literal_token2] = ACTIONS(651),
    [aux_sym_number_literal_token3] = ACTIONS(651),
    [anon_sym_true] = ACTIONS(653),
    [anon_sym_false] = ACTIONS(653),
    [sym_nil_literal] = ACTIONS(655),
    [sym_keyword] = ACTIONS(917),
    [sym__long_str] = ACTIONS(919),
    [sym__long_buffer] = ACTIONS(659),
  },
  [165] = {
    [sym__expr] = STATE(580),
    [sym_tuple] = STATE(607),
    [sym_sqr_tuple] = STATE(607),
    [sym_array] = STATE(607),
    [sym_sqr_array] = STATE(607),
    [sym_struct] = STATE(607),
    [sym_table] = STATE(607),
    [sym_peg_set] = STATE(607),
    [sym__special_forms] = STATE(607),
    [sym_def] = STATE(608),
    [sym_var] = STATE(608),
    [sym_quote] = STATE(608),
    [sym_splice] = STATE(608),
    [sym_quasiquote] = STATE(608),
    [sym_unquote] = STATE(608),
    [sym_break] = STATE(608),
    [sym_set] = STATE(608),
    [sym_if] = STATE(608),
    [sym_do] = STATE(608),
    [sym_while] = STATE(608),
    [sym_fn] = STATE(608),
    [sym_upscope] = STATE(608),
    [sym__shorthand] = STATE(607),
    [sym_short_quote] = STATE(609),
    [sym_short_splice] = STATE(609),
    [sym_short_quasiquote] = STATE(609),
    [sym_short_unquote] = STATE(609),
    [sym_short_fn] = STATE(609),
    [sym__specials] = STATE(607),
    [sym_extra_defs] = STATE(611),
    [sym__literals] = STATE(607),
    [sym_long_str_literal] = STATE(603),
    [sym_long_buffer_literal] = STATE(603),
    [sym_number_literal] = STATE(603),
    [sym_bool_literal] = STATE(603),
    [sym__identifier] = STATE(607),
    [sym_symbol] = ACTIONS(631),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(947),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_AT_LPAREN] = ACTIONS(637),
    [anon_sym_AT_LBRACK] = ACTIONS(639),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_AT_LBRACE] = ACTIONS(643),
    [anon_sym_SQUOTE] = ACTIONS(909),
    [anon_sym_SEMI] = ACTIONS(911),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_COMMA] = ACTIONS(915),
    [anon_sym_PIPE] = ACTIONS(645),
    [sym_str_literal] = ACTIONS(649),
    [sym_buffer_literal] = ACTIONS(649),
    [aux_sym_number_literal_token1] = ACTIONS(651),
    [aux_sym_number_literal_token2] = ACTIONS(651),
    [aux_sym_number_literal_token3] = ACTIONS(651),
    [anon_sym_true] = ACTIONS(653),
    [anon_sym_false] = ACTIONS(653),
    [sym_nil_literal] = ACTIONS(655),
    [sym_keyword] = ACTIONS(917),
    [sym__long_str] = ACTIONS(919),
    [sym__long_buffer] = ACTIONS(659),
  },
  [166] = {
    [sym__expr] = STATE(639),
    [sym_tuple] = STATE(607),
    [sym_sqr_tuple] = STATE(607),
    [sym_array] = STATE(607),
    [sym_sqr_array] = STATE(607),
    [sym_struct] = STATE(607),
    [sym_table] = STATE(607),
    [sym_peg_set] = STATE(607),
    [sym__special_forms] = STATE(607),
    [sym_def] = STATE(608),
    [sym_var] = STATE(608),
    [sym_quote] = STATE(608),
    [sym_splice] = STATE(608),
    [sym_quasiquote] = STATE(608),
    [sym_unquote] = STATE(608),
    [sym_break] = STATE(608),
    [sym_set] = STATE(608),
    [sym_if] = STATE(608),
    [sym_do] = STATE(608),
    [sym_while] = STATE(608),
    [sym_fn] = STATE(608),
    [sym_upscope] = STATE(608),
    [sym__shorthand] = STATE(607),
    [sym_short_quote] = STATE(609),
    [sym_short_splice] = STATE(609),
    [sym_short_quasiquote] = STATE(609),
    [sym_short_unquote] = STATE(609),
    [sym_short_fn] = STATE(609),
    [sym__specials] = STATE(607),
    [sym_extra_defs] = STATE(611),
    [sym__literals] = STATE(607),
    [sym_long_str_literal] = STATE(603),
    [sym_long_buffer_literal] = STATE(603),
    [sym_number_literal] = STATE(603),
    [sym_bool_literal] = STATE(603),
    [sym__identifier] = STATE(607),
    [sym_symbol] = ACTIONS(631),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(949),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_AT_LPAREN] = ACTIONS(637),
    [anon_sym_AT_LBRACK] = ACTIONS(639),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_AT_LBRACE] = ACTIONS(643),
    [anon_sym_SQUOTE] = ACTIONS(909),
    [anon_sym_SEMI] = ACTIONS(911),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_COMMA] = ACTIONS(915),
    [anon_sym_PIPE] = ACTIONS(645),
    [sym_str_literal] = ACTIONS(649),
    [sym_buffer_literal] = ACTIONS(649),
    [aux_sym_number_literal_token1] = ACTIONS(651),
    [aux_sym_number_literal_token2] = ACTIONS(651),
    [aux_sym_number_literal_token3] = ACTIONS(651),
    [anon_sym_true] = ACTIONS(653),
    [anon_sym_false] = ACTIONS(653),
    [sym_nil_literal] = ACTIONS(655),
    [sym_keyword] = ACTIONS(917),
    [sym__long_str] = ACTIONS(919),
    [sym__long_buffer] = ACTIONS(659),
  },
  [167] = {
    [sym__expr] = STATE(657),
    [sym_tuple] = STATE(607),
    [sym_sqr_tuple] = STATE(607),
    [sym_array] = STATE(607),
    [sym_sqr_array] = STATE(607),
    [sym_struct] = STATE(607),
    [sym_table] = STATE(607),
    [sym_peg_set] = STATE(607),
    [sym__special_forms] = STATE(607),
    [sym_def] = STATE(608),
    [sym_var] = STATE(608),
    [sym_quote] = STATE(608),
    [sym_splice] = STATE(608),
    [sym_quasiquote] = STATE(608),
    [sym_unquote] = STATE(608),
    [sym_break] = STATE(608),
    [sym_set] = STATE(608),
    [sym_if] = STATE(608),
    [sym_do] = STATE(608),
    [sym_while] = STATE(608),
    [sym_fn] = STATE(608),
    [sym_upscope] = STATE(608),
    [sym__shorthand] = STATE(607),
    [sym_short_quote] = STATE(609),
    [sym_short_splice] = STATE(609),
    [sym_short_quasiquote] = STATE(609),
    [sym_short_unquote] = STATE(609),
    [sym_short_fn] = STATE(609),
    [sym__specials] = STATE(607),
    [sym_extra_defs] = STATE(611),
    [sym__literals] = STATE(607),
    [sym_long_str_literal] = STATE(603),
    [sym_long_buffer_literal] = STATE(603),
    [sym_number_literal] = STATE(603),
    [sym_bool_literal] = STATE(603),
    [sym__identifier] = STATE(607),
    [sym_symbol] = ACTIONS(631),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(951),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_AT_LPAREN] = ACTIONS(637),
    [anon_sym_AT_LBRACK] = ACTIONS(639),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_AT_LBRACE] = ACTIONS(643),
    [anon_sym_SQUOTE] = ACTIONS(909),
    [anon_sym_SEMI] = ACTIONS(911),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_COMMA] = ACTIONS(915),
    [anon_sym_PIPE] = ACTIONS(645),
    [sym_str_literal] = ACTIONS(649),
    [sym_buffer_literal] = ACTIONS(649),
    [aux_sym_number_literal_token1] = ACTIONS(651),
    [aux_sym_number_literal_token2] = ACTIONS(651),
    [aux_sym_number_literal_token3] = ACTIONS(651),
    [anon_sym_true] = ACTIONS(653),
    [anon_sym_false] = ACTIONS(653),
    [sym_nil_literal] = ACTIONS(655),
    [sym_keyword] = ACTIONS(917),
    [sym__long_str] = ACTIONS(919),
    [sym__long_buffer] = ACTIONS(659),
  },
  [168] = {
    [sym__expr] = STATE(659),
    [sym_tuple] = STATE(607),
    [sym_sqr_tuple] = STATE(607),
    [sym_array] = STATE(607),
    [sym_sqr_array] = STATE(607),
    [sym_struct] = STATE(607),
    [sym_table] = STATE(607),
    [sym_peg_set] = STATE(607),
    [sym__special_forms] = STATE(607),
    [sym_def] = STATE(608),
    [sym_var] = STATE(608),
    [sym_quote] = STATE(608),
    [sym_splice] = STATE(608),
    [sym_quasiquote] = STATE(608),
    [sym_unquote] = STATE(608),
    [sym_break] = STATE(608),
    [sym_set] = STATE(608),
    [sym_if] = STATE(608),
    [sym_do] = STATE(608),
    [sym_while] = STATE(608),
    [sym_fn] = STATE(608),
    [sym_upscope] = STATE(608),
    [sym__shorthand] = STATE(607),
    [sym_short_quote] = STATE(609),
    [sym_short_splice] = STATE(609),
    [sym_short_quasiquote] = STATE(609),
    [sym_short_unquote] = STATE(609),
    [sym_short_fn] = STATE(609),
    [sym__specials] = STATE(607),
    [sym_extra_defs] = STATE(611),
    [sym__literals] = STATE(607),
    [sym_long_str_literal] = STATE(603),
    [sym_long_buffer_literal] = STATE(603),
    [sym_number_literal] = STATE(603),
    [sym_bool_literal] = STATE(603),
    [sym__identifier] = STATE(607),
    [sym_symbol] = ACTIONS(631),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_AT_LPAREN] = ACTIONS(637),
    [anon_sym_AT_LBRACK] = ACTIONS(639),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_AT_LBRACE] = ACTIONS(643),
    [anon_sym_SQUOTE] = ACTIONS(909),
    [anon_sym_SEMI] = ACTIONS(911),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_COMMA] = ACTIONS(915),
    [anon_sym_PIPE] = ACTIONS(645),
    [sym_str_literal] = ACTIONS(649),
    [sym_buffer_literal] = ACTIONS(649),
    [aux_sym_number_literal_token1] = ACTIONS(651),
    [aux_sym_number_literal_token2] = ACTIONS(651),
    [aux_sym_number_literal_token3] = ACTIONS(651),
    [anon_sym_true] = ACTIONS(653),
    [anon_sym_false] = ACTIONS(653),
    [sym_nil_literal] = ACTIONS(655),
    [sym_keyword] = ACTIONS(917),
    [sym__long_str] = ACTIONS(919),
    [sym__long_buffer] = ACTIONS(659),
  },
  [169] = {
    [sym__expr] = STATE(587),
    [sym_tuple] = STATE(607),
    [sym_sqr_tuple] = STATE(607),
    [sym_array] = STATE(607),
    [sym_sqr_array] = STATE(607),
    [sym_struct] = STATE(607),
    [sym_table] = STATE(607),
    [sym_peg_set] = STATE(607),
    [sym__special_forms] = STATE(607),
    [sym_def] = STATE(608),
    [sym_var] = STATE(608),
    [sym_quote] = STATE(608),
    [sym_splice] = STATE(608),
    [sym_quasiquote] = STATE(608),
    [sym_unquote] = STATE(608),
    [sym_break] = STATE(608),
    [sym_set] = STATE(608),
    [sym_if] = STATE(608),
    [sym_do] = STATE(608),
    [sym_while] = STATE(608),
    [sym_fn] = STATE(608),
    [sym_upscope] = STATE(608),
    [sym__shorthand] = STATE(607),
    [sym_short_quote] = STATE(609),
    [sym_short_splice] = STATE(609),
    [sym_short_quasiquote] = STATE(609),
    [sym_short_unquote] = STATE(609),
    [sym_short_fn] = STATE(609),
    [sym__specials] = STATE(607),
    [sym_extra_defs] = STATE(611),
    [sym__literals] = STATE(607),
    [sym_long_str_literal] = STATE(603),
    [sym_long_buffer_literal] = STATE(603),
    [sym_number_literal] = STATE(603),
    [sym_bool_literal] = STATE(603),
    [sym__identifier] = STATE(607),
    [sym_symbol] = ACTIONS(631),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(955),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_AT_LPAREN] = ACTIONS(637),
    [anon_sym_AT_LBRACK] = ACTIONS(639),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_AT_LBRACE] = ACTIONS(643),
    [anon_sym_SQUOTE] = ACTIONS(909),
    [anon_sym_SEMI] = ACTIONS(911),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_COMMA] = ACTIONS(915),
    [anon_sym_PIPE] = ACTIONS(645),
    [sym_str_literal] = ACTIONS(649),
    [sym_buffer_literal] = ACTIONS(649),
    [aux_sym_number_literal_token1] = ACTIONS(651),
    [aux_sym_number_literal_token2] = ACTIONS(651),
    [aux_sym_number_literal_token3] = ACTIONS(651),
    [anon_sym_true] = ACTIONS(653),
    [anon_sym_false] = ACTIONS(653),
    [sym_nil_literal] = ACTIONS(655),
    [sym_keyword] = ACTIONS(917),
    [sym__long_str] = ACTIONS(919),
    [sym__long_buffer] = ACTIONS(659),
  },
  [170] = {
    [sym__expr] = STATE(660),
    [sym_tuple] = STATE(607),
    [sym_sqr_tuple] = STATE(607),
    [sym_array] = STATE(607),
    [sym_sqr_array] = STATE(607),
    [sym_struct] = STATE(607),
    [sym_table] = STATE(607),
    [sym_peg_set] = STATE(607),
    [sym__special_forms] = STATE(607),
    [sym_def] = STATE(608),
    [sym_var] = STATE(608),
    [sym_quote] = STATE(608),
    [sym_splice] = STATE(608),
    [sym_quasiquote] = STATE(608),
    [sym_unquote] = STATE(608),
    [sym_break] = STATE(608),
    [sym_set] = STATE(608),
    [sym_if] = STATE(608),
    [sym_do] = STATE(608),
    [sym_while] = STATE(608),
    [sym_fn] = STATE(608),
    [sym_upscope] = STATE(608),
    [sym__shorthand] = STATE(607),
    [sym_short_quote] = STATE(609),
    [sym_short_splice] = STATE(609),
    [sym_short_quasiquote] = STATE(609),
    [sym_short_unquote] = STATE(609),
    [sym_short_fn] = STATE(609),
    [sym__specials] = STATE(607),
    [sym_extra_defs] = STATE(611),
    [sym__literals] = STATE(607),
    [sym_long_str_literal] = STATE(603),
    [sym_long_buffer_literal] = STATE(603),
    [sym_number_literal] = STATE(603),
    [sym_bool_literal] = STATE(603),
    [sym__identifier] = STATE(607),
    [sym_symbol] = ACTIONS(631),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(957),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_AT_LPAREN] = ACTIONS(637),
    [anon_sym_AT_LBRACK] = ACTIONS(639),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_AT_LBRACE] = ACTIONS(643),
    [anon_sym_SQUOTE] = ACTIONS(909),
    [anon_sym_SEMI] = ACTIONS(911),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_COMMA] = ACTIONS(915),
    [anon_sym_PIPE] = ACTIONS(645),
    [sym_str_literal] = ACTIONS(649),
    [sym_buffer_literal] = ACTIONS(649),
    [aux_sym_number_literal_token1] = ACTIONS(651),
    [aux_sym_number_literal_token2] = ACTIONS(651),
    [aux_sym_number_literal_token3] = ACTIONS(651),
    [anon_sym_true] = ACTIONS(653),
    [anon_sym_false] = ACTIONS(653),
    [sym_nil_literal] = ACTIONS(655),
    [sym_keyword] = ACTIONS(917),
    [sym__long_str] = ACTIONS(919),
    [sym__long_buffer] = ACTIONS(659),
  },
  [171] = {
    [sym__expr] = STATE(662),
    [sym_tuple] = STATE(607),
    [sym_sqr_tuple] = STATE(607),
    [sym_array] = STATE(607),
    [sym_sqr_array] = STATE(607),
    [sym_struct] = STATE(607),
    [sym_table] = STATE(607),
    [sym_peg_set] = STATE(607),
    [sym__special_forms] = STATE(607),
    [sym_def] = STATE(608),
    [sym_var] = STATE(608),
    [sym_quote] = STATE(608),
    [sym_splice] = STATE(608),
    [sym_quasiquote] = STATE(608),
    [sym_unquote] = STATE(608),
    [sym_break] = STATE(608),
    [sym_set] = STATE(608),
    [sym_if] = STATE(608),
    [sym_do] = STATE(608),
    [sym_while] = STATE(608),
    [sym_fn] = STATE(608),
    [sym_upscope] = STATE(608),
    [sym__shorthand] = STATE(607),
    [sym_short_quote] = STATE(609),
    [sym_short_splice] = STATE(609),
    [sym_short_quasiquote] = STATE(609),
    [sym_short_unquote] = STATE(609),
    [sym_short_fn] = STATE(609),
    [sym__specials] = STATE(607),
    [sym_extra_defs] = STATE(611),
    [sym__literals] = STATE(607),
    [sym_long_str_literal] = STATE(603),
    [sym_long_buffer_literal] = STATE(603),
    [sym_number_literal] = STATE(603),
    [sym_bool_literal] = STATE(603),
    [sym__identifier] = STATE(607),
    [sym_symbol] = ACTIONS(631),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(959),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_AT_LPAREN] = ACTIONS(637),
    [anon_sym_AT_LBRACK] = ACTIONS(639),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_AT_LBRACE] = ACTIONS(643),
    [anon_sym_SQUOTE] = ACTIONS(909),
    [anon_sym_SEMI] = ACTIONS(911),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_COMMA] = ACTIONS(915),
    [anon_sym_PIPE] = ACTIONS(645),
    [sym_str_literal] = ACTIONS(649),
    [sym_buffer_literal] = ACTIONS(649),
    [aux_sym_number_literal_token1] = ACTIONS(651),
    [aux_sym_number_literal_token2] = ACTIONS(651),
    [aux_sym_number_literal_token3] = ACTIONS(651),
    [anon_sym_true] = ACTIONS(653),
    [anon_sym_false] = ACTIONS(653),
    [sym_nil_literal] = ACTIONS(655),
    [sym_keyword] = ACTIONS(917),
    [sym__long_str] = ACTIONS(919),
    [sym__long_buffer] = ACTIONS(659),
  },
  [172] = {
    [sym__expr] = STATE(665),
    [sym_tuple] = STATE(607),
    [sym_sqr_tuple] = STATE(607),
    [sym_array] = STATE(607),
    [sym_sqr_array] = STATE(607),
    [sym_struct] = STATE(607),
    [sym_table] = STATE(607),
    [sym_peg_set] = STATE(607),
    [sym__special_forms] = STATE(607),
    [sym_def] = STATE(608),
    [sym_var] = STATE(608),
    [sym_quote] = STATE(608),
    [sym_splice] = STATE(608),
    [sym_quasiquote] = STATE(608),
    [sym_unquote] = STATE(608),
    [sym_break] = STATE(608),
    [sym_set] = STATE(608),
    [sym_if] = STATE(608),
    [sym_do] = STATE(608),
    [sym_while] = STATE(608),
    [sym_fn] = STATE(608),
    [sym_upscope] = STATE(608),
    [sym__shorthand] = STATE(607),
    [sym_short_quote] = STATE(609),
    [sym_short_splice] = STATE(609),
    [sym_short_quasiquote] = STATE(609),
    [sym_short_unquote] = STATE(609),
    [sym_short_fn] = STATE(609),
    [sym__specials] = STATE(607),
    [sym_extra_defs] = STATE(611),
    [sym__literals] = STATE(607),
    [sym_long_str_literal] = STATE(603),
    [sym_long_buffer_literal] = STATE(603),
    [sym_number_literal] = STATE(603),
    [sym_bool_literal] = STATE(603),
    [sym__identifier] = STATE(607),
    [sym_symbol] = ACTIONS(631),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(961),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_AT_LPAREN] = ACTIONS(637),
    [anon_sym_AT_LBRACK] = ACTIONS(639),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_AT_LBRACE] = ACTIONS(643),
    [anon_sym_SQUOTE] = ACTIONS(909),
    [anon_sym_SEMI] = ACTIONS(911),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_COMMA] = ACTIONS(915),
    [anon_sym_PIPE] = ACTIONS(645),
    [sym_str_literal] = ACTIONS(649),
    [sym_buffer_literal] = ACTIONS(649),
    [aux_sym_number_literal_token1] = ACTIONS(651),
    [aux_sym_number_literal_token2] = ACTIONS(651),
    [aux_sym_number_literal_token3] = ACTIONS(651),
    [anon_sym_true] = ACTIONS(653),
    [anon_sym_false] = ACTIONS(653),
    [sym_nil_literal] = ACTIONS(655),
    [sym_keyword] = ACTIONS(917),
    [sym__long_str] = ACTIONS(919),
    [sym__long_buffer] = ACTIONS(659),
  },
  [173] = {
    [sym__expr] = STATE(563),
    [sym_tuple] = STATE(607),
    [sym_sqr_tuple] = STATE(607),
    [sym_array] = STATE(607),
    [sym_sqr_array] = STATE(607),
    [sym_struct] = STATE(607),
    [sym_table] = STATE(607),
    [sym_peg_set] = STATE(607),
    [sym__special_forms] = STATE(607),
    [sym_def] = STATE(608),
    [sym_var] = STATE(608),
    [sym_quote] = STATE(608),
    [sym_splice] = STATE(608),
    [sym_quasiquote] = STATE(608),
    [sym_unquote] = STATE(608),
    [sym_break] = STATE(608),
    [sym_set] = STATE(608),
    [sym_if] = STATE(608),
    [sym_do] = STATE(608),
    [sym_while] = STATE(608),
    [sym_fn] = STATE(608),
    [sym_upscope] = STATE(608),
    [sym__shorthand] = STATE(607),
    [sym_short_quote] = STATE(609),
    [sym_short_splice] = STATE(609),
    [sym_short_quasiquote] = STATE(609),
    [sym_short_unquote] = STATE(609),
    [sym_short_fn] = STATE(609),
    [sym__specials] = STATE(607),
    [sym_extra_defs] = STATE(611),
    [sym__literals] = STATE(607),
    [sym_long_str_literal] = STATE(603),
    [sym_long_buffer_literal] = STATE(603),
    [sym_number_literal] = STATE(603),
    [sym_bool_literal] = STATE(603),
    [sym__identifier] = STATE(607),
    [sym_symbol] = ACTIONS(631),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(963),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_AT_LPAREN] = ACTIONS(637),
    [anon_sym_AT_LBRACK] = ACTIONS(639),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_AT_LBRACE] = ACTIONS(643),
    [anon_sym_SQUOTE] = ACTIONS(909),
    [anon_sym_SEMI] = ACTIONS(911),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_COMMA] = ACTIONS(915),
    [anon_sym_PIPE] = ACTIONS(645),
    [sym_str_literal] = ACTIONS(649),
    [sym_buffer_literal] = ACTIONS(649),
    [aux_sym_number_literal_token1] = ACTIONS(651),
    [aux_sym_number_literal_token2] = ACTIONS(651),
    [aux_sym_number_literal_token3] = ACTIONS(651),
    [anon_sym_true] = ACTIONS(653),
    [anon_sym_false] = ACTIONS(653),
    [sym_nil_literal] = ACTIONS(655),
    [sym_keyword] = ACTIONS(917),
    [sym__long_str] = ACTIONS(919),
    [sym__long_buffer] = ACTIONS(659),
  },
  [174] = {
    [sym__expr] = STATE(658),
    [sym_tuple] = STATE(607),
    [sym_sqr_tuple] = STATE(607),
    [sym_array] = STATE(607),
    [sym_sqr_array] = STATE(607),
    [sym_struct] = STATE(607),
    [sym_table] = STATE(607),
    [sym_peg_set] = STATE(607),
    [sym__special_forms] = STATE(607),
    [sym_def] = STATE(608),
    [sym_var] = STATE(608),
    [sym_quote] = STATE(608),
    [sym_splice] = STATE(608),
    [sym_quasiquote] = STATE(608),
    [sym_unquote] = STATE(608),
    [sym_break] = STATE(608),
    [sym_set] = STATE(608),
    [sym_if] = STATE(608),
    [sym_do] = STATE(608),
    [sym_while] = STATE(608),
    [sym_fn] = STATE(608),
    [sym_upscope] = STATE(608),
    [sym__shorthand] = STATE(607),
    [sym_short_quote] = STATE(609),
    [sym_short_splice] = STATE(609),
    [sym_short_quasiquote] = STATE(609),
    [sym_short_unquote] = STATE(609),
    [sym_short_fn] = STATE(609),
    [sym__specials] = STATE(607),
    [sym_extra_defs] = STATE(611),
    [sym__literals] = STATE(607),
    [sym_long_str_literal] = STATE(603),
    [sym_long_buffer_literal] = STATE(603),
    [sym_number_literal] = STATE(603),
    [sym_bool_literal] = STATE(603),
    [sym__identifier] = STATE(607),
    [sym_symbol] = ACTIONS(631),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(965),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_AT_LPAREN] = ACTIONS(637),
    [anon_sym_AT_LBRACK] = ACTIONS(639),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_AT_LBRACE] = ACTIONS(643),
    [anon_sym_SQUOTE] = ACTIONS(909),
    [anon_sym_SEMI] = ACTIONS(911),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_COMMA] = ACTIONS(915),
    [anon_sym_PIPE] = ACTIONS(645),
    [sym_str_literal] = ACTIONS(649),
    [sym_buffer_literal] = ACTIONS(649),
    [aux_sym_number_literal_token1] = ACTIONS(651),
    [aux_sym_number_literal_token2] = ACTIONS(651),
    [aux_sym_number_literal_token3] = ACTIONS(651),
    [anon_sym_true] = ACTIONS(653),
    [anon_sym_false] = ACTIONS(653),
    [sym_nil_literal] = ACTIONS(655),
    [sym_keyword] = ACTIONS(917),
    [sym__long_str] = ACTIONS(919),
    [sym__long_buffer] = ACTIONS(659),
  },
  [175] = {
    [sym__expr] = STATE(574),
    [sym_tuple] = STATE(607),
    [sym_sqr_tuple] = STATE(607),
    [sym_array] = STATE(607),
    [sym_sqr_array] = STATE(607),
    [sym_struct] = STATE(607),
    [sym_table] = STATE(607),
    [sym_peg_set] = STATE(607),
    [sym__special_forms] = STATE(607),
    [sym_def] = STATE(608),
    [sym_var] = STATE(608),
    [sym_quote] = STATE(608),
    [sym_splice] = STATE(608),
    [sym_quasiquote] = STATE(608),
    [sym_unquote] = STATE(608),
    [sym_break] = STATE(608),
    [sym_set] = STATE(608),
    [sym_if] = STATE(608),
    [sym_do] = STATE(608),
    [sym_while] = STATE(608),
    [sym_fn] = STATE(608),
    [sym_upscope] = STATE(608),
    [sym__shorthand] = STATE(607),
    [sym_short_quote] = STATE(609),
    [sym_short_splice] = STATE(609),
    [sym_short_quasiquote] = STATE(609),
    [sym_short_unquote] = STATE(609),
    [sym_short_fn] = STATE(609),
    [sym__specials] = STATE(607),
    [sym_extra_defs] = STATE(611),
    [sym__literals] = STATE(607),
    [sym_long_str_literal] = STATE(603),
    [sym_long_buffer_literal] = STATE(603),
    [sym_number_literal] = STATE(603),
    [sym_bool_literal] = STATE(603),
    [sym__identifier] = STATE(607),
    [sym_symbol] = ACTIONS(631),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(967),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_AT_LPAREN] = ACTIONS(637),
    [anon_sym_AT_LBRACK] = ACTIONS(639),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_AT_LBRACE] = ACTIONS(643),
    [anon_sym_SQUOTE] = ACTIONS(909),
    [anon_sym_SEMI] = ACTIONS(911),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_COMMA] = ACTIONS(915),
    [anon_sym_PIPE] = ACTIONS(645),
    [sym_str_literal] = ACTIONS(649),
    [sym_buffer_literal] = ACTIONS(649),
    [aux_sym_number_literal_token1] = ACTIONS(651),
    [aux_sym_number_literal_token2] = ACTIONS(651),
    [aux_sym_number_literal_token3] = ACTIONS(651),
    [anon_sym_true] = ACTIONS(653),
    [anon_sym_false] = ACTIONS(653),
    [sym_nil_literal] = ACTIONS(655),
    [sym_keyword] = ACTIONS(917),
    [sym__long_str] = ACTIONS(919),
    [sym__long_buffer] = ACTIONS(659),
  },
  [176] = {
    [sym__expr] = STATE(573),
    [sym_tuple] = STATE(607),
    [sym_sqr_tuple] = STATE(607),
    [sym_array] = STATE(607),
    [sym_sqr_array] = STATE(607),
    [sym_struct] = STATE(607),
    [sym_table] = STATE(607),
    [sym_peg_set] = STATE(607),
    [sym__special_forms] = STATE(607),
    [sym_def] = STATE(608),
    [sym_var] = STATE(608),
    [sym_quote] = STATE(608),
    [sym_splice] = STATE(608),
    [sym_quasiquote] = STATE(608),
    [sym_unquote] = STATE(608),
    [sym_break] = STATE(608),
    [sym_set] = STATE(608),
    [sym_if] = STATE(608),
    [sym_do] = STATE(608),
    [sym_while] = STATE(608),
    [sym_fn] = STATE(608),
    [sym_upscope] = STATE(608),
    [sym__shorthand] = STATE(607),
    [sym_short_quote] = STATE(609),
    [sym_short_splice] = STATE(609),
    [sym_short_quasiquote] = STATE(609),
    [sym_short_unquote] = STATE(609),
    [sym_short_fn] = STATE(609),
    [sym__specials] = STATE(607),
    [sym_extra_defs] = STATE(611),
    [sym__literals] = STATE(607),
    [sym_long_str_literal] = STATE(603),
    [sym_long_buffer_literal] = STATE(603),
    [sym_number_literal] = STATE(603),
    [sym_bool_literal] = STATE(603),
    [sym__identifier] = STATE(607),
    [sym_symbol] = ACTIONS(631),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_AT_LPAREN] = ACTIONS(637),
    [anon_sym_AT_LBRACK] = ACTIONS(639),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_AT_LBRACE] = ACTIONS(643),
    [anon_sym_SQUOTE] = ACTIONS(909),
    [anon_sym_SEMI] = ACTIONS(911),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_COMMA] = ACTIONS(915),
    [anon_sym_PIPE] = ACTIONS(645),
    [sym_str_literal] = ACTIONS(649),
    [sym_buffer_literal] = ACTIONS(649),
    [aux_sym_number_literal_token1] = ACTIONS(651),
    [aux_sym_number_literal_token2] = ACTIONS(651),
    [aux_sym_number_literal_token3] = ACTIONS(651),
    [anon_sym_true] = ACTIONS(653),
    [anon_sym_false] = ACTIONS(653),
    [sym_nil_literal] = ACTIONS(655),
    [sym_keyword] = ACTIONS(917),
    [sym__long_str] = ACTIONS(919),
    [sym__long_buffer] = ACTIONS(659),
  },
  [177] = {
    [sym__expr] = STATE(572),
    [sym_tuple] = STATE(607),
    [sym_sqr_tuple] = STATE(607),
    [sym_array] = STATE(607),
    [sym_sqr_array] = STATE(607),
    [sym_struct] = STATE(607),
    [sym_table] = STATE(607),
    [sym_peg_set] = STATE(607),
    [sym__special_forms] = STATE(607),
    [sym_def] = STATE(608),
    [sym_var] = STATE(608),
    [sym_quote] = STATE(608),
    [sym_splice] = STATE(608),
    [sym_quasiquote] = STATE(608),
    [sym_unquote] = STATE(608),
    [sym_break] = STATE(608),
    [sym_set] = STATE(608),
    [sym_if] = STATE(608),
    [sym_do] = STATE(608),
    [sym_while] = STATE(608),
    [sym_fn] = STATE(608),
    [sym_upscope] = STATE(608),
    [sym__shorthand] = STATE(607),
    [sym_short_quote] = STATE(609),
    [sym_short_splice] = STATE(609),
    [sym_short_quasiquote] = STATE(609),
    [sym_short_unquote] = STATE(609),
    [sym_short_fn] = STATE(609),
    [sym__specials] = STATE(607),
    [sym_extra_defs] = STATE(611),
    [sym__literals] = STATE(607),
    [sym_long_str_literal] = STATE(603),
    [sym_long_buffer_literal] = STATE(603),
    [sym_number_literal] = STATE(603),
    [sym_bool_literal] = STATE(603),
    [sym__identifier] = STATE(607),
    [sym_symbol] = ACTIONS(631),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(971),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_AT_LPAREN] = ACTIONS(637),
    [anon_sym_AT_LBRACK] = ACTIONS(639),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_AT_LBRACE] = ACTIONS(643),
    [anon_sym_SQUOTE] = ACTIONS(909),
    [anon_sym_SEMI] = ACTIONS(911),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_COMMA] = ACTIONS(915),
    [anon_sym_PIPE] = ACTIONS(645),
    [sym_str_literal] = ACTIONS(649),
    [sym_buffer_literal] = ACTIONS(649),
    [aux_sym_number_literal_token1] = ACTIONS(651),
    [aux_sym_number_literal_token2] = ACTIONS(651),
    [aux_sym_number_literal_token3] = ACTIONS(651),
    [anon_sym_true] = ACTIONS(653),
    [anon_sym_false] = ACTIONS(653),
    [sym_nil_literal] = ACTIONS(655),
    [sym_keyword] = ACTIONS(917),
    [sym__long_str] = ACTIONS(919),
    [sym__long_buffer] = ACTIONS(659),
  },
  [178] = {
    [sym__expr] = STATE(571),
    [sym_tuple] = STATE(607),
    [sym_sqr_tuple] = STATE(607),
    [sym_array] = STATE(607),
    [sym_sqr_array] = STATE(607),
    [sym_struct] = STATE(607),
    [sym_table] = STATE(607),
    [sym_peg_set] = STATE(607),
    [sym__special_forms] = STATE(607),
    [sym_def] = STATE(608),
    [sym_var] = STATE(608),
    [sym_quote] = STATE(608),
    [sym_splice] = STATE(608),
    [sym_quasiquote] = STATE(608),
    [sym_unquote] = STATE(608),
    [sym_break] = STATE(608),
    [sym_set] = STATE(608),
    [sym_if] = STATE(608),
    [sym_do] = STATE(608),
    [sym_while] = STATE(608),
    [sym_fn] = STATE(608),
    [sym_upscope] = STATE(608),
    [sym__shorthand] = STATE(607),
    [sym_short_quote] = STATE(609),
    [sym_short_splice] = STATE(609),
    [sym_short_quasiquote] = STATE(609),
    [sym_short_unquote] = STATE(609),
    [sym_short_fn] = STATE(609),
    [sym__specials] = STATE(607),
    [sym_extra_defs] = STATE(611),
    [sym__literals] = STATE(607),
    [sym_long_str_literal] = STATE(603),
    [sym_long_buffer_literal] = STATE(603),
    [sym_number_literal] = STATE(603),
    [sym_bool_literal] = STATE(603),
    [sym__identifier] = STATE(607),
    [sym_symbol] = ACTIONS(631),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(973),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_AT_LPAREN] = ACTIONS(637),
    [anon_sym_AT_LBRACK] = ACTIONS(639),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_AT_LBRACE] = ACTIONS(643),
    [anon_sym_SQUOTE] = ACTIONS(909),
    [anon_sym_SEMI] = ACTIONS(911),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_COMMA] = ACTIONS(915),
    [anon_sym_PIPE] = ACTIONS(645),
    [sym_str_literal] = ACTIONS(649),
    [sym_buffer_literal] = ACTIONS(649),
    [aux_sym_number_literal_token1] = ACTIONS(651),
    [aux_sym_number_literal_token2] = ACTIONS(651),
    [aux_sym_number_literal_token3] = ACTIONS(651),
    [anon_sym_true] = ACTIONS(653),
    [anon_sym_false] = ACTIONS(653),
    [sym_nil_literal] = ACTIONS(655),
    [sym_keyword] = ACTIONS(917),
    [sym__long_str] = ACTIONS(919),
    [sym__long_buffer] = ACTIONS(659),
  },
  [179] = {
    [sym__expr] = STATE(570),
    [sym_tuple] = STATE(607),
    [sym_sqr_tuple] = STATE(607),
    [sym_array] = STATE(607),
    [sym_sqr_array] = STATE(607),
    [sym_struct] = STATE(607),
    [sym_table] = STATE(607),
    [sym_peg_set] = STATE(607),
    [sym__special_forms] = STATE(607),
    [sym_def] = STATE(608),
    [sym_var] = STATE(608),
    [sym_quote] = STATE(608),
    [sym_splice] = STATE(608),
    [sym_quasiquote] = STATE(608),
    [sym_unquote] = STATE(608),
    [sym_break] = STATE(608),
    [sym_set] = STATE(608),
    [sym_if] = STATE(608),
    [sym_do] = STATE(608),
    [sym_while] = STATE(608),
    [sym_fn] = STATE(608),
    [sym_upscope] = STATE(608),
    [sym__shorthand] = STATE(607),
    [sym_short_quote] = STATE(609),
    [sym_short_splice] = STATE(609),
    [sym_short_quasiquote] = STATE(609),
    [sym_short_unquote] = STATE(609),
    [sym_short_fn] = STATE(609),
    [sym__specials] = STATE(607),
    [sym_extra_defs] = STATE(611),
    [sym__literals] = STATE(607),
    [sym_long_str_literal] = STATE(603),
    [sym_long_buffer_literal] = STATE(603),
    [sym_number_literal] = STATE(603),
    [sym_bool_literal] = STATE(603),
    [sym__identifier] = STATE(607),
    [sym_symbol] = ACTIONS(631),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(975),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_AT_LPAREN] = ACTIONS(637),
    [anon_sym_AT_LBRACK] = ACTIONS(639),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_AT_LBRACE] = ACTIONS(643),
    [anon_sym_SQUOTE] = ACTIONS(909),
    [anon_sym_SEMI] = ACTIONS(911),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_COMMA] = ACTIONS(915),
    [anon_sym_PIPE] = ACTIONS(645),
    [sym_str_literal] = ACTIONS(649),
    [sym_buffer_literal] = ACTIONS(649),
    [aux_sym_number_literal_token1] = ACTIONS(651),
    [aux_sym_number_literal_token2] = ACTIONS(651),
    [aux_sym_number_literal_token3] = ACTIONS(651),
    [anon_sym_true] = ACTIONS(653),
    [anon_sym_false] = ACTIONS(653),
    [sym_nil_literal] = ACTIONS(655),
    [sym_keyword] = ACTIONS(917),
    [sym__long_str] = ACTIONS(919),
    [sym__long_buffer] = ACTIONS(659),
  },
  [180] = {
    [sym__expr] = STATE(661),
    [sym_tuple] = STATE(607),
    [sym_sqr_tuple] = STATE(607),
    [sym_array] = STATE(607),
    [sym_sqr_array] = STATE(607),
    [sym_struct] = STATE(607),
    [sym_table] = STATE(607),
    [sym_peg_set] = STATE(607),
    [sym__special_forms] = STATE(607),
    [sym_def] = STATE(608),
    [sym_var] = STATE(608),
    [sym_quote] = STATE(608),
    [sym_splice] = STATE(608),
    [sym_quasiquote] = STATE(608),
    [sym_unquote] = STATE(608),
    [sym_break] = STATE(608),
    [sym_set] = STATE(608),
    [sym_if] = STATE(608),
    [sym_do] = STATE(608),
    [sym_while] = STATE(608),
    [sym_fn] = STATE(608),
    [sym_upscope] = STATE(608),
    [sym__shorthand] = STATE(607),
    [sym_short_quote] = STATE(609),
    [sym_short_splice] = STATE(609),
    [sym_short_quasiquote] = STATE(609),
    [sym_short_unquote] = STATE(609),
    [sym_short_fn] = STATE(609),
    [sym__specials] = STATE(607),
    [sym_extra_defs] = STATE(611),
    [sym__literals] = STATE(607),
    [sym_long_str_literal] = STATE(603),
    [sym_long_buffer_literal] = STATE(603),
    [sym_number_literal] = STATE(603),
    [sym_bool_literal] = STATE(603),
    [sym__identifier] = STATE(607),
    [sym_symbol] = ACTIONS(631),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(977),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_AT_LPAREN] = ACTIONS(637),
    [anon_sym_AT_LBRACK] = ACTIONS(639),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_AT_LBRACE] = ACTIONS(643),
    [anon_sym_SQUOTE] = ACTIONS(909),
    [anon_sym_SEMI] = ACTIONS(911),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_COMMA] = ACTIONS(915),
    [anon_sym_PIPE] = ACTIONS(645),
    [sym_str_literal] = ACTIONS(649),
    [sym_buffer_literal] = ACTIONS(649),
    [aux_sym_number_literal_token1] = ACTIONS(651),
    [aux_sym_number_literal_token2] = ACTIONS(651),
    [aux_sym_number_literal_token3] = ACTIONS(651),
    [anon_sym_true] = ACTIONS(653),
    [anon_sym_false] = ACTIONS(653),
    [sym_nil_literal] = ACTIONS(655),
    [sym_keyword] = ACTIONS(917),
    [sym__long_str] = ACTIONS(919),
    [sym__long_buffer] = ACTIONS(659),
  },
  [181] = {
    [sym__expr] = STATE(317),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [182] = {
    [sym__expr] = STATE(458),
    [sym_tuple] = STATE(411),
    [sym_sqr_tuple] = STATE(411),
    [sym_array] = STATE(411),
    [sym_sqr_array] = STATE(411),
    [sym_struct] = STATE(411),
    [sym_table] = STATE(411),
    [sym_peg_set] = STATE(411),
    [sym__special_forms] = STATE(411),
    [sym_def] = STATE(412),
    [sym_var] = STATE(412),
    [sym_quote] = STATE(412),
    [sym_splice] = STATE(412),
    [sym_quasiquote] = STATE(412),
    [sym_unquote] = STATE(412),
    [sym_break] = STATE(412),
    [sym_set] = STATE(412),
    [sym_if] = STATE(412),
    [sym_do] = STATE(412),
    [sym_while] = STATE(412),
    [sym_fn] = STATE(412),
    [sym_upscope] = STATE(412),
    [sym__shorthand] = STATE(411),
    [sym_short_quote] = STATE(413),
    [sym_short_splice] = STATE(413),
    [sym_short_quasiquote] = STATE(413),
    [sym_short_unquote] = STATE(413),
    [sym_short_fn] = STATE(413),
    [sym__specials] = STATE(411),
    [sym_extra_defs] = STATE(416),
    [sym__literals] = STATE(411),
    [sym_long_str_literal] = STATE(392),
    [sym_long_buffer_literal] = STATE(392),
    [sym_number_literal] = STATE(392),
    [sym_bool_literal] = STATE(392),
    [sym__identifier] = STATE(411),
    [sym_symbol] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(9),
    [anon_sym_LBRACK] = ACTIONS(11),
    [anon_sym_AT_LPAREN] = ACTIONS(13),
    [anon_sym_AT_LBRACK] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_AT_LBRACE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(27),
    [anon_sym_PIPE] = ACTIONS(29),
    [sym_str_literal] = ACTIONS(31),
    [sym_buffer_literal] = ACTIONS(31),
    [aux_sym_number_literal_token1] = ACTIONS(33),
    [aux_sym_number_literal_token2] = ACTIONS(33),
    [aux_sym_number_literal_token3] = ACTIONS(33),
    [anon_sym_true] = ACTIONS(35),
    [anon_sym_false] = ACTIONS(35),
    [sym_nil_literal] = ACTIONS(37),
    [sym_keyword] = ACTIONS(39),
    [sym__long_str] = ACTIONS(41),
    [sym__long_buffer] = ACTIONS(43),
  },
  [183] = {
    [sym__expr] = STATE(225),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [184] = {
    [sym__expr] = STATE(231),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [185] = {
    [sym__expr] = STATE(81),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [186] = {
    [sym__expr] = STATE(80),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [187] = {
    [sym__expr] = STATE(205),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(465),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(467),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(464),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(979),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [188] = {
    [sym__expr] = STATE(106),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [189] = {
    [sym__expr] = STATE(623),
    [sym_tuple] = STATE(607),
    [sym_sqr_tuple] = STATE(607),
    [sym_array] = STATE(607),
    [sym_sqr_array] = STATE(607),
    [sym_struct] = STATE(607),
    [sym_table] = STATE(607),
    [sym_peg_set] = STATE(607),
    [sym__special_forms] = STATE(607),
    [sym_def] = STATE(608),
    [sym_var] = STATE(608),
    [sym_quote] = STATE(608),
    [sym_splice] = STATE(608),
    [sym_quasiquote] = STATE(608),
    [sym_unquote] = STATE(608),
    [sym_break] = STATE(608),
    [sym_set] = STATE(608),
    [sym_if] = STATE(608),
    [sym_do] = STATE(608),
    [sym_while] = STATE(608),
    [sym_fn] = STATE(608),
    [sym_upscope] = STATE(608),
    [sym__shorthand] = STATE(607),
    [sym_short_quote] = STATE(609),
    [sym_short_splice] = STATE(609),
    [sym_short_quasiquote] = STATE(609),
    [sym_short_unquote] = STATE(609),
    [sym_short_fn] = STATE(609),
    [sym__specials] = STATE(607),
    [sym_extra_defs] = STATE(611),
    [sym__literals] = STATE(607),
    [sym_long_str_literal] = STATE(603),
    [sym_long_buffer_literal] = STATE(603),
    [sym_number_literal] = STATE(603),
    [sym_bool_literal] = STATE(603),
    [sym__identifier] = STATE(607),
    [sym_symbol] = ACTIONS(631),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_AT_LPAREN] = ACTIONS(637),
    [anon_sym_AT_LBRACK] = ACTIONS(639),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_AT_LBRACE] = ACTIONS(643),
    [anon_sym_SQUOTE] = ACTIONS(909),
    [anon_sym_SEMI] = ACTIONS(911),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_COMMA] = ACTIONS(915),
    [anon_sym_PIPE] = ACTIONS(645),
    [sym_str_literal] = ACTIONS(649),
    [sym_buffer_literal] = ACTIONS(649),
    [aux_sym_number_literal_token1] = ACTIONS(651),
    [aux_sym_number_literal_token2] = ACTIONS(651),
    [aux_sym_number_literal_token3] = ACTIONS(651),
    [anon_sym_true] = ACTIONS(653),
    [anon_sym_false] = ACTIONS(653),
    [sym_nil_literal] = ACTIONS(655),
    [sym_keyword] = ACTIONS(917),
    [sym__long_str] = ACTIONS(919),
    [sym__long_buffer] = ACTIONS(659),
  },
  [190] = {
    [sym__expr] = STATE(166),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [191] = {
    [sym__expr] = STATE(66),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [192] = {
    [sym__expr] = STATE(243),
    [sym_tuple] = STATE(281),
    [sym_sqr_tuple] = STATE(281),
    [sym_array] = STATE(281),
    [sym_sqr_array] = STATE(281),
    [sym_struct] = STATE(281),
    [sym_table] = STATE(281),
    [sym_peg_set] = STATE(281),
    [sym__special_forms] = STATE(281),
    [sym_def] = STATE(280),
    [sym_var] = STATE(280),
    [sym_quote] = STATE(280),
    [sym_splice] = STATE(280),
    [sym_quasiquote] = STATE(280),
    [sym_unquote] = STATE(280),
    [sym_break] = STATE(280),
    [sym_set] = STATE(280),
    [sym_if] = STATE(280),
    [sym_do] = STATE(280),
    [sym_while] = STATE(280),
    [sym_fn] = STATE(280),
    [sym_upscope] = STATE(280),
    [sym__shorthand] = STATE(281),
    [sym_short_quote] = STATE(279),
    [sym_short_splice] = STATE(279),
    [sym_short_quasiquote] = STATE(279),
    [sym_short_unquote] = STATE(279),
    [sym_short_fn] = STATE(279),
    [sym__specials] = STATE(281),
    [sym_extra_defs] = STATE(244),
    [sym__literals] = STATE(281),
    [sym_long_str_literal] = STATE(285),
    [sym_long_buffer_literal] = STATE(285),
    [sym_number_literal] = STATE(285),
    [sym_bool_literal] = STATE(285),
    [sym__identifier] = STATE(281),
    [sym_symbol] = ACTIONS(233),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_LBRACK] = ACTIONS(239),
    [anon_sym_AT_LPAREN] = ACTIONS(241),
    [anon_sym_AT_LBRACK] = ACTIONS(243),
    [anon_sym_LBRACE] = ACTIONS(245),
    [anon_sym_AT_LBRACE] = ACTIONS(247),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SEMI] = ACTIONS(253),
    [anon_sym_TILDE] = ACTIONS(255),
    [anon_sym_COMMA] = ACTIONS(257),
    [anon_sym_PIPE] = ACTIONS(259),
    [sym_str_literal] = ACTIONS(261),
    [sym_buffer_literal] = ACTIONS(261),
    [aux_sym_number_literal_token1] = ACTIONS(263),
    [aux_sym_number_literal_token2] = ACTIONS(263),
    [aux_sym_number_literal_token3] = ACTIONS(263),
    [anon_sym_true] = ACTIONS(265),
    [anon_sym_false] = ACTIONS(265),
    [sym_nil_literal] = ACTIONS(267),
    [sym_keyword] = ACTIONS(269),
    [sym__long_str] = ACTIONS(271),
    [sym__long_buffer] = ACTIONS(273),
  },
  [193] = {
    [sym__expr] = STATE(292),
    [sym_tuple] = STATE(281),
    [sym_sqr_tuple] = STATE(281),
    [sym_array] = STATE(281),
    [sym_sqr_array] = STATE(281),
    [sym_struct] = STATE(281),
    [sym_table] = STATE(281),
    [sym_peg_set] = STATE(281),
    [sym__special_forms] = STATE(281),
    [sym_def] = STATE(280),
    [sym_var] = STATE(280),
    [sym_quote] = STATE(280),
    [sym_splice] = STATE(280),
    [sym_quasiquote] = STATE(280),
    [sym_unquote] = STATE(280),
    [sym_break] = STATE(280),
    [sym_set] = STATE(280),
    [sym_if] = STATE(280),
    [sym_do] = STATE(280),
    [sym_while] = STATE(280),
    [sym_fn] = STATE(280),
    [sym_upscope] = STATE(280),
    [sym__shorthand] = STATE(281),
    [sym_short_quote] = STATE(279),
    [sym_short_splice] = STATE(279),
    [sym_short_quasiquote] = STATE(279),
    [sym_short_unquote] = STATE(279),
    [sym_short_fn] = STATE(279),
    [sym__specials] = STATE(281),
    [sym_extra_defs] = STATE(244),
    [sym__literals] = STATE(281),
    [sym_long_str_literal] = STATE(285),
    [sym_long_buffer_literal] = STATE(285),
    [sym_number_literal] = STATE(285),
    [sym_bool_literal] = STATE(285),
    [sym__identifier] = STATE(281),
    [sym_symbol] = ACTIONS(233),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_LBRACK] = ACTIONS(239),
    [anon_sym_AT_LPAREN] = ACTIONS(241),
    [anon_sym_AT_LBRACK] = ACTIONS(243),
    [anon_sym_LBRACE] = ACTIONS(245),
    [anon_sym_AT_LBRACE] = ACTIONS(247),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SEMI] = ACTIONS(253),
    [anon_sym_TILDE] = ACTIONS(255),
    [anon_sym_COMMA] = ACTIONS(257),
    [anon_sym_PIPE] = ACTIONS(259),
    [sym_str_literal] = ACTIONS(261),
    [sym_buffer_literal] = ACTIONS(261),
    [aux_sym_number_literal_token1] = ACTIONS(263),
    [aux_sym_number_literal_token2] = ACTIONS(263),
    [aux_sym_number_literal_token3] = ACTIONS(263),
    [anon_sym_true] = ACTIONS(265),
    [anon_sym_false] = ACTIONS(265),
    [sym_nil_literal] = ACTIONS(267),
    [sym_keyword] = ACTIONS(269),
    [sym__long_str] = ACTIONS(271),
    [sym__long_buffer] = ACTIONS(273),
  },
  [194] = {
    [sym__expr] = STATE(315),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [195] = {
    [sym__expr] = STATE(316),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [196] = {
    [sym__expr] = STATE(226),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(423),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(422),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(424),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(981),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [197] = {
    [sym__expr] = STATE(318),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [198] = {
    [sym__expr] = STATE(325),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [199] = {
    [sym__expr] = STATE(293),
    [sym_tuple] = STATE(281),
    [sym_sqr_tuple] = STATE(281),
    [sym_array] = STATE(281),
    [sym_sqr_array] = STATE(281),
    [sym_struct] = STATE(281),
    [sym_table] = STATE(281),
    [sym_peg_set] = STATE(281),
    [sym__special_forms] = STATE(281),
    [sym_def] = STATE(280),
    [sym_var] = STATE(280),
    [sym_quote] = STATE(280),
    [sym_splice] = STATE(280),
    [sym_quasiquote] = STATE(280),
    [sym_unquote] = STATE(280),
    [sym_break] = STATE(280),
    [sym_set] = STATE(280),
    [sym_if] = STATE(280),
    [sym_do] = STATE(280),
    [sym_while] = STATE(280),
    [sym_fn] = STATE(280),
    [sym_upscope] = STATE(280),
    [sym__shorthand] = STATE(281),
    [sym_short_quote] = STATE(279),
    [sym_short_splice] = STATE(279),
    [sym_short_quasiquote] = STATE(279),
    [sym_short_unquote] = STATE(279),
    [sym_short_fn] = STATE(279),
    [sym__specials] = STATE(281),
    [sym_extra_defs] = STATE(244),
    [sym__literals] = STATE(281),
    [sym_long_str_literal] = STATE(285),
    [sym_long_buffer_literal] = STATE(285),
    [sym_number_literal] = STATE(285),
    [sym_bool_literal] = STATE(285),
    [sym__identifier] = STATE(281),
    [sym_symbol] = ACTIONS(233),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_LBRACK] = ACTIONS(239),
    [anon_sym_AT_LPAREN] = ACTIONS(241),
    [anon_sym_AT_LBRACK] = ACTIONS(243),
    [anon_sym_LBRACE] = ACTIONS(245),
    [anon_sym_AT_LBRACE] = ACTIONS(247),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SEMI] = ACTIONS(253),
    [anon_sym_TILDE] = ACTIONS(255),
    [anon_sym_COMMA] = ACTIONS(257),
    [anon_sym_PIPE] = ACTIONS(259),
    [sym_str_literal] = ACTIONS(261),
    [sym_buffer_literal] = ACTIONS(261),
    [aux_sym_number_literal_token1] = ACTIONS(263),
    [aux_sym_number_literal_token2] = ACTIONS(263),
    [aux_sym_number_literal_token3] = ACTIONS(263),
    [anon_sym_true] = ACTIONS(265),
    [anon_sym_false] = ACTIONS(265),
    [sym_nil_literal] = ACTIONS(267),
    [sym_keyword] = ACTIONS(269),
    [sym__long_str] = ACTIONS(271),
    [sym__long_buffer] = ACTIONS(273),
  },
  [200] = {
    [sym__expr] = STATE(294),
    [sym_tuple] = STATE(281),
    [sym_sqr_tuple] = STATE(281),
    [sym_array] = STATE(281),
    [sym_sqr_array] = STATE(281),
    [sym_struct] = STATE(281),
    [sym_table] = STATE(281),
    [sym_peg_set] = STATE(281),
    [sym__special_forms] = STATE(281),
    [sym_def] = STATE(280),
    [sym_var] = STATE(280),
    [sym_quote] = STATE(280),
    [sym_splice] = STATE(280),
    [sym_quasiquote] = STATE(280),
    [sym_unquote] = STATE(280),
    [sym_break] = STATE(280),
    [sym_set] = STATE(280),
    [sym_if] = STATE(280),
    [sym_do] = STATE(280),
    [sym_while] = STATE(280),
    [sym_fn] = STATE(280),
    [sym_upscope] = STATE(280),
    [sym__shorthand] = STATE(281),
    [sym_short_quote] = STATE(279),
    [sym_short_splice] = STATE(279),
    [sym_short_quasiquote] = STATE(279),
    [sym_short_unquote] = STATE(279),
    [sym_short_fn] = STATE(279),
    [sym__specials] = STATE(281),
    [sym_extra_defs] = STATE(244),
    [sym__literals] = STATE(281),
    [sym_long_str_literal] = STATE(285),
    [sym_long_buffer_literal] = STATE(285),
    [sym_number_literal] = STATE(285),
    [sym_bool_literal] = STATE(285),
    [sym__identifier] = STATE(281),
    [sym_symbol] = ACTIONS(233),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_LBRACK] = ACTIONS(239),
    [anon_sym_AT_LPAREN] = ACTIONS(241),
    [anon_sym_AT_LBRACK] = ACTIONS(243),
    [anon_sym_LBRACE] = ACTIONS(245),
    [anon_sym_AT_LBRACE] = ACTIONS(247),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SEMI] = ACTIONS(253),
    [anon_sym_TILDE] = ACTIONS(255),
    [anon_sym_COMMA] = ACTIONS(257),
    [anon_sym_PIPE] = ACTIONS(259),
    [sym_str_literal] = ACTIONS(261),
    [sym_buffer_literal] = ACTIONS(261),
    [aux_sym_number_literal_token1] = ACTIONS(263),
    [aux_sym_number_literal_token2] = ACTIONS(263),
    [aux_sym_number_literal_token3] = ACTIONS(263),
    [anon_sym_true] = ACTIONS(265),
    [anon_sym_false] = ACTIONS(265),
    [sym_nil_literal] = ACTIONS(267),
    [sym_keyword] = ACTIONS(269),
    [sym__long_str] = ACTIONS(271),
    [sym__long_buffer] = ACTIONS(273),
  },
  [201] = {
    [sym__expr] = STATE(497),
    [sym_tuple] = STATE(538),
    [sym_sqr_tuple] = STATE(538),
    [sym_array] = STATE(538),
    [sym_sqr_array] = STATE(538),
    [sym_struct] = STATE(538),
    [sym_table] = STATE(538),
    [sym_peg_set] = STATE(538),
    [sym__special_forms] = STATE(538),
    [sym_def] = STATE(537),
    [sym_var] = STATE(537),
    [sym_quote] = STATE(537),
    [sym_splice] = STATE(537),
    [sym_quasiquote] = STATE(537),
    [sym_unquote] = STATE(537),
    [sym_break] = STATE(537),
    [sym_set] = STATE(537),
    [sym_if] = STATE(537),
    [sym_do] = STATE(537),
    [sym_while] = STATE(537),
    [sym_fn] = STATE(537),
    [sym_upscope] = STATE(537),
    [sym__shorthand] = STATE(538),
    [sym_short_quote] = STATE(536),
    [sym_short_splice] = STATE(536),
    [sym_short_quasiquote] = STATE(536),
    [sym_short_unquote] = STATE(536),
    [sym_short_fn] = STATE(536),
    [sym__specials] = STATE(538),
    [sym_extra_defs] = STATE(535),
    [sym__literals] = STATE(538),
    [sym_long_str_literal] = STATE(542),
    [sym_long_buffer_literal] = STATE(542),
    [sym_number_literal] = STATE(542),
    [sym_bool_literal] = STATE(542),
    [sym__identifier] = STATE(538),
    [sym_symbol] = ACTIONS(983),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(985),
    [anon_sym_LBRACK] = ACTIONS(987),
    [anon_sym_AT_LPAREN] = ACTIONS(989),
    [anon_sym_AT_LBRACK] = ACTIONS(991),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_AT_LBRACE] = ACTIONS(995),
    [anon_sym_SQUOTE] = ACTIONS(997),
    [anon_sym_SEMI] = ACTIONS(999),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_COMMA] = ACTIONS(1003),
    [anon_sym_PIPE] = ACTIONS(1005),
    [sym_str_literal] = ACTIONS(1007),
    [sym_buffer_literal] = ACTIONS(1007),
    [aux_sym_number_literal_token1] = ACTIONS(1009),
    [aux_sym_number_literal_token2] = ACTIONS(1009),
    [aux_sym_number_literal_token3] = ACTIONS(1009),
    [anon_sym_true] = ACTIONS(1011),
    [anon_sym_false] = ACTIONS(1011),
    [sym_nil_literal] = ACTIONS(1013),
    [sym_keyword] = ACTIONS(1015),
    [sym__long_str] = ACTIONS(1017),
    [sym__long_buffer] = ACTIONS(1019),
  },
  [202] = {
    [sym__expr] = STATE(131),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [203] = {
    [sym__expr] = STATE(112),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [204] = {
    [sym__expr] = STATE(189),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(441),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(442),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(440),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(1021),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [205] = {
    [sym__expr] = STATE(636),
    [sym_tuple] = STATE(607),
    [sym_sqr_tuple] = STATE(607),
    [sym_array] = STATE(607),
    [sym_sqr_array] = STATE(607),
    [sym_struct] = STATE(607),
    [sym_table] = STATE(607),
    [sym_peg_set] = STATE(607),
    [sym__special_forms] = STATE(607),
    [sym_def] = STATE(608),
    [sym_var] = STATE(608),
    [sym_quote] = STATE(608),
    [sym_splice] = STATE(608),
    [sym_quasiquote] = STATE(608),
    [sym_unquote] = STATE(608),
    [sym_break] = STATE(608),
    [sym_set] = STATE(608),
    [sym_if] = STATE(608),
    [sym_do] = STATE(608),
    [sym_while] = STATE(608),
    [sym_fn] = STATE(608),
    [sym_upscope] = STATE(608),
    [sym__shorthand] = STATE(607),
    [sym_short_quote] = STATE(609),
    [sym_short_splice] = STATE(609),
    [sym_short_quasiquote] = STATE(609),
    [sym_short_unquote] = STATE(609),
    [sym_short_fn] = STATE(609),
    [sym__specials] = STATE(607),
    [sym_extra_defs] = STATE(611),
    [sym__literals] = STATE(607),
    [sym_long_str_literal] = STATE(603),
    [sym_long_buffer_literal] = STATE(603),
    [sym_number_literal] = STATE(603),
    [sym_bool_literal] = STATE(603),
    [sym__identifier] = STATE(607),
    [sym_symbol] = ACTIONS(631),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_AT_LPAREN] = ACTIONS(637),
    [anon_sym_AT_LBRACK] = ACTIONS(639),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_AT_LBRACE] = ACTIONS(643),
    [anon_sym_SQUOTE] = ACTIONS(909),
    [anon_sym_SEMI] = ACTIONS(911),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_COMMA] = ACTIONS(915),
    [anon_sym_PIPE] = ACTIONS(645),
    [sym_str_literal] = ACTIONS(649),
    [sym_buffer_literal] = ACTIONS(649),
    [aux_sym_number_literal_token1] = ACTIONS(651),
    [aux_sym_number_literal_token2] = ACTIONS(651),
    [aux_sym_number_literal_token3] = ACTIONS(651),
    [anon_sym_true] = ACTIONS(653),
    [anon_sym_false] = ACTIONS(653),
    [sym_nil_literal] = ACTIONS(655),
    [sym_keyword] = ACTIONS(917),
    [sym__long_str] = ACTIONS(919),
    [sym__long_buffer] = ACTIONS(659),
  },
  [206] = {
    [sym__expr] = STATE(649),
    [sym_tuple] = STATE(607),
    [sym_sqr_tuple] = STATE(607),
    [sym_array] = STATE(607),
    [sym_sqr_array] = STATE(607),
    [sym_struct] = STATE(607),
    [sym_table] = STATE(607),
    [sym_peg_set] = STATE(607),
    [sym__special_forms] = STATE(607),
    [sym_def] = STATE(608),
    [sym_var] = STATE(608),
    [sym_quote] = STATE(608),
    [sym_splice] = STATE(608),
    [sym_quasiquote] = STATE(608),
    [sym_unquote] = STATE(608),
    [sym_break] = STATE(608),
    [sym_set] = STATE(608),
    [sym_if] = STATE(608),
    [sym_do] = STATE(608),
    [sym_while] = STATE(608),
    [sym_fn] = STATE(608),
    [sym_upscope] = STATE(608),
    [sym__shorthand] = STATE(607),
    [sym_short_quote] = STATE(609),
    [sym_short_splice] = STATE(609),
    [sym_short_quasiquote] = STATE(609),
    [sym_short_unquote] = STATE(609),
    [sym_short_fn] = STATE(609),
    [sym__specials] = STATE(607),
    [sym_extra_defs] = STATE(611),
    [sym__literals] = STATE(607),
    [sym_long_str_literal] = STATE(603),
    [sym_long_buffer_literal] = STATE(603),
    [sym_number_literal] = STATE(603),
    [sym_bool_literal] = STATE(603),
    [sym__identifier] = STATE(607),
    [sym_symbol] = ACTIONS(631),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_AT_LPAREN] = ACTIONS(637),
    [anon_sym_AT_LBRACK] = ACTIONS(639),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_AT_LBRACE] = ACTIONS(643),
    [anon_sym_SQUOTE] = ACTIONS(909),
    [anon_sym_SEMI] = ACTIONS(911),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_COMMA] = ACTIONS(915),
    [anon_sym_PIPE] = ACTIONS(645),
    [sym_str_literal] = ACTIONS(649),
    [sym_buffer_literal] = ACTIONS(649),
    [aux_sym_number_literal_token1] = ACTIONS(651),
    [aux_sym_number_literal_token2] = ACTIONS(651),
    [aux_sym_number_literal_token3] = ACTIONS(651),
    [anon_sym_true] = ACTIONS(653),
    [anon_sym_false] = ACTIONS(653),
    [sym_nil_literal] = ACTIONS(655),
    [sym_keyword] = ACTIONS(917),
    [sym__long_str] = ACTIONS(919),
    [sym__long_buffer] = ACTIONS(659),
  },
  [207] = {
    [sym__expr] = STATE(547),
    [sym_tuple] = STATE(538),
    [sym_sqr_tuple] = STATE(538),
    [sym_array] = STATE(538),
    [sym_sqr_array] = STATE(538),
    [sym_struct] = STATE(538),
    [sym_table] = STATE(538),
    [sym_peg_set] = STATE(538),
    [sym__special_forms] = STATE(538),
    [sym_def] = STATE(537),
    [sym_var] = STATE(537),
    [sym_quote] = STATE(537),
    [sym_splice] = STATE(537),
    [sym_quasiquote] = STATE(537),
    [sym_unquote] = STATE(537),
    [sym_break] = STATE(537),
    [sym_set] = STATE(537),
    [sym_if] = STATE(537),
    [sym_do] = STATE(537),
    [sym_while] = STATE(537),
    [sym_fn] = STATE(537),
    [sym_upscope] = STATE(537),
    [sym__shorthand] = STATE(538),
    [sym_short_quote] = STATE(536),
    [sym_short_splice] = STATE(536),
    [sym_short_quasiquote] = STATE(536),
    [sym_short_unquote] = STATE(536),
    [sym_short_fn] = STATE(536),
    [sym__specials] = STATE(538),
    [sym_extra_defs] = STATE(535),
    [sym__literals] = STATE(538),
    [sym_long_str_literal] = STATE(542),
    [sym_long_buffer_literal] = STATE(542),
    [sym_number_literal] = STATE(542),
    [sym_bool_literal] = STATE(542),
    [sym__identifier] = STATE(538),
    [sym_symbol] = ACTIONS(983),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(985),
    [anon_sym_LBRACK] = ACTIONS(987),
    [anon_sym_AT_LPAREN] = ACTIONS(989),
    [anon_sym_AT_LBRACK] = ACTIONS(991),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_AT_LBRACE] = ACTIONS(995),
    [anon_sym_SQUOTE] = ACTIONS(997),
    [anon_sym_SEMI] = ACTIONS(999),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_COMMA] = ACTIONS(1003),
    [anon_sym_PIPE] = ACTIONS(1005),
    [sym_str_literal] = ACTIONS(1007),
    [sym_buffer_literal] = ACTIONS(1007),
    [aux_sym_number_literal_token1] = ACTIONS(1009),
    [aux_sym_number_literal_token2] = ACTIONS(1009),
    [aux_sym_number_literal_token3] = ACTIONS(1009),
    [anon_sym_true] = ACTIONS(1011),
    [anon_sym_false] = ACTIONS(1011),
    [sym_nil_literal] = ACTIONS(1013),
    [sym_keyword] = ACTIONS(1015),
    [sym__long_str] = ACTIONS(1017),
    [sym__long_buffer] = ACTIONS(1019),
  },
  [208] = {
    [sym__expr] = STATE(548),
    [sym_tuple] = STATE(538),
    [sym_sqr_tuple] = STATE(538),
    [sym_array] = STATE(538),
    [sym_sqr_array] = STATE(538),
    [sym_struct] = STATE(538),
    [sym_table] = STATE(538),
    [sym_peg_set] = STATE(538),
    [sym__special_forms] = STATE(538),
    [sym_def] = STATE(537),
    [sym_var] = STATE(537),
    [sym_quote] = STATE(537),
    [sym_splice] = STATE(537),
    [sym_quasiquote] = STATE(537),
    [sym_unquote] = STATE(537),
    [sym_break] = STATE(537),
    [sym_set] = STATE(537),
    [sym_if] = STATE(537),
    [sym_do] = STATE(537),
    [sym_while] = STATE(537),
    [sym_fn] = STATE(537),
    [sym_upscope] = STATE(537),
    [sym__shorthand] = STATE(538),
    [sym_short_quote] = STATE(536),
    [sym_short_splice] = STATE(536),
    [sym_short_quasiquote] = STATE(536),
    [sym_short_unquote] = STATE(536),
    [sym_short_fn] = STATE(536),
    [sym__specials] = STATE(538),
    [sym_extra_defs] = STATE(535),
    [sym__literals] = STATE(538),
    [sym_long_str_literal] = STATE(542),
    [sym_long_buffer_literal] = STATE(542),
    [sym_number_literal] = STATE(542),
    [sym_bool_literal] = STATE(542),
    [sym__identifier] = STATE(538),
    [sym_symbol] = ACTIONS(983),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(985),
    [anon_sym_LBRACK] = ACTIONS(987),
    [anon_sym_AT_LPAREN] = ACTIONS(989),
    [anon_sym_AT_LBRACK] = ACTIONS(991),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_AT_LBRACE] = ACTIONS(995),
    [anon_sym_SQUOTE] = ACTIONS(997),
    [anon_sym_SEMI] = ACTIONS(999),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_COMMA] = ACTIONS(1003),
    [anon_sym_PIPE] = ACTIONS(1005),
    [sym_str_literal] = ACTIONS(1007),
    [sym_buffer_literal] = ACTIONS(1007),
    [aux_sym_number_literal_token1] = ACTIONS(1009),
    [aux_sym_number_literal_token2] = ACTIONS(1009),
    [aux_sym_number_literal_token3] = ACTIONS(1009),
    [anon_sym_true] = ACTIONS(1011),
    [anon_sym_false] = ACTIONS(1011),
    [sym_nil_literal] = ACTIONS(1013),
    [sym_keyword] = ACTIONS(1015),
    [sym__long_str] = ACTIONS(1017),
    [sym__long_buffer] = ACTIONS(1019),
  },
  [209] = {
    [sym__expr] = STATE(518),
    [sym_tuple] = STATE(538),
    [sym_sqr_tuple] = STATE(538),
    [sym_array] = STATE(538),
    [sym_sqr_array] = STATE(538),
    [sym_struct] = STATE(538),
    [sym_table] = STATE(538),
    [sym_peg_set] = STATE(538),
    [sym__special_forms] = STATE(538),
    [sym_def] = STATE(537),
    [sym_var] = STATE(537),
    [sym_quote] = STATE(537),
    [sym_splice] = STATE(537),
    [sym_quasiquote] = STATE(537),
    [sym_unquote] = STATE(537),
    [sym_break] = STATE(537),
    [sym_set] = STATE(537),
    [sym_if] = STATE(537),
    [sym_do] = STATE(537),
    [sym_while] = STATE(537),
    [sym_fn] = STATE(537),
    [sym_upscope] = STATE(537),
    [sym__shorthand] = STATE(538),
    [sym_short_quote] = STATE(536),
    [sym_short_splice] = STATE(536),
    [sym_short_quasiquote] = STATE(536),
    [sym_short_unquote] = STATE(536),
    [sym_short_fn] = STATE(536),
    [sym__specials] = STATE(538),
    [sym_extra_defs] = STATE(535),
    [sym__literals] = STATE(538),
    [sym_long_str_literal] = STATE(542),
    [sym_long_buffer_literal] = STATE(542),
    [sym_number_literal] = STATE(542),
    [sym_bool_literal] = STATE(542),
    [sym__identifier] = STATE(538),
    [sym_symbol] = ACTIONS(983),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(985),
    [anon_sym_LBRACK] = ACTIONS(987),
    [anon_sym_AT_LPAREN] = ACTIONS(989),
    [anon_sym_AT_LBRACK] = ACTIONS(991),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_AT_LBRACE] = ACTIONS(995),
    [anon_sym_SQUOTE] = ACTIONS(997),
    [anon_sym_SEMI] = ACTIONS(999),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_COMMA] = ACTIONS(1003),
    [anon_sym_PIPE] = ACTIONS(1005),
    [sym_str_literal] = ACTIONS(1007),
    [sym_buffer_literal] = ACTIONS(1007),
    [aux_sym_number_literal_token1] = ACTIONS(1009),
    [aux_sym_number_literal_token2] = ACTIONS(1009),
    [aux_sym_number_literal_token3] = ACTIONS(1009),
    [anon_sym_true] = ACTIONS(1011),
    [anon_sym_false] = ACTIONS(1011),
    [sym_nil_literal] = ACTIONS(1013),
    [sym_keyword] = ACTIONS(1015),
    [sym__long_str] = ACTIONS(1017),
    [sym__long_buffer] = ACTIONS(1019),
  },
  [210] = {
    [sym__expr] = STATE(450),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [211] = {
    [sym__expr] = STATE(169),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [212] = {
    [sym__expr] = STATE(97),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [213] = {
    [sym__expr] = STATE(577),
    [sym_tuple] = STATE(607),
    [sym_sqr_tuple] = STATE(607),
    [sym_array] = STATE(607),
    [sym_sqr_array] = STATE(607),
    [sym_struct] = STATE(607),
    [sym_table] = STATE(607),
    [sym_peg_set] = STATE(607),
    [sym__special_forms] = STATE(607),
    [sym_def] = STATE(608),
    [sym_var] = STATE(608),
    [sym_quote] = STATE(608),
    [sym_splice] = STATE(608),
    [sym_quasiquote] = STATE(608),
    [sym_unquote] = STATE(608),
    [sym_break] = STATE(608),
    [sym_set] = STATE(608),
    [sym_if] = STATE(608),
    [sym_do] = STATE(608),
    [sym_while] = STATE(608),
    [sym_fn] = STATE(608),
    [sym_upscope] = STATE(608),
    [sym__shorthand] = STATE(607),
    [sym_short_quote] = STATE(609),
    [sym_short_splice] = STATE(609),
    [sym_short_quasiquote] = STATE(609),
    [sym_short_unquote] = STATE(609),
    [sym_short_fn] = STATE(609),
    [sym__specials] = STATE(607),
    [sym_extra_defs] = STATE(611),
    [sym__literals] = STATE(607),
    [sym_long_str_literal] = STATE(603),
    [sym_long_buffer_literal] = STATE(603),
    [sym_number_literal] = STATE(603),
    [sym_bool_literal] = STATE(603),
    [sym__identifier] = STATE(607),
    [sym_symbol] = ACTIONS(631),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_AT_LPAREN] = ACTIONS(637),
    [anon_sym_AT_LBRACK] = ACTIONS(639),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_AT_LBRACE] = ACTIONS(643),
    [anon_sym_SQUOTE] = ACTIONS(909),
    [anon_sym_SEMI] = ACTIONS(911),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_COMMA] = ACTIONS(915),
    [anon_sym_PIPE] = ACTIONS(645),
    [sym_str_literal] = ACTIONS(649),
    [sym_buffer_literal] = ACTIONS(649),
    [aux_sym_number_literal_token1] = ACTIONS(651),
    [aux_sym_number_literal_token2] = ACTIONS(651),
    [aux_sym_number_literal_token3] = ACTIONS(651),
    [anon_sym_true] = ACTIONS(653),
    [anon_sym_false] = ACTIONS(653),
    [sym_nil_literal] = ACTIONS(655),
    [sym_keyword] = ACTIONS(917),
    [sym__long_str] = ACTIONS(919),
    [sym__long_buffer] = ACTIONS(659),
  },
  [214] = {
    [sym__expr] = STATE(147),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [215] = {
    [sym__expr] = STATE(213),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(391),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(390),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(394),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(1023),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [216] = {
    [sym__expr] = STATE(460),
    [sym_tuple] = STATE(411),
    [sym_sqr_tuple] = STATE(411),
    [sym_array] = STATE(411),
    [sym_sqr_array] = STATE(411),
    [sym_struct] = STATE(411),
    [sym_table] = STATE(411),
    [sym_peg_set] = STATE(411),
    [sym__special_forms] = STATE(411),
    [sym_def] = STATE(412),
    [sym_var] = STATE(412),
    [sym_quote] = STATE(412),
    [sym_splice] = STATE(412),
    [sym_quasiquote] = STATE(412),
    [sym_unquote] = STATE(412),
    [sym_break] = STATE(412),
    [sym_set] = STATE(412),
    [sym_if] = STATE(412),
    [sym_do] = STATE(412),
    [sym_while] = STATE(412),
    [sym_fn] = STATE(412),
    [sym_upscope] = STATE(412),
    [sym__shorthand] = STATE(411),
    [sym_short_quote] = STATE(413),
    [sym_short_splice] = STATE(413),
    [sym_short_quasiquote] = STATE(413),
    [sym_short_unquote] = STATE(413),
    [sym_short_fn] = STATE(413),
    [sym__specials] = STATE(411),
    [sym_extra_defs] = STATE(416),
    [sym__literals] = STATE(411),
    [sym_long_str_literal] = STATE(392),
    [sym_long_buffer_literal] = STATE(392),
    [sym_number_literal] = STATE(392),
    [sym_bool_literal] = STATE(392),
    [sym__identifier] = STATE(411),
    [sym_symbol] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(9),
    [anon_sym_LBRACK] = ACTIONS(11),
    [anon_sym_AT_LPAREN] = ACTIONS(13),
    [anon_sym_AT_LBRACK] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_AT_LBRACE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(27),
    [anon_sym_PIPE] = ACTIONS(29),
    [sym_str_literal] = ACTIONS(31),
    [sym_buffer_literal] = ACTIONS(31),
    [aux_sym_number_literal_token1] = ACTIONS(33),
    [aux_sym_number_literal_token2] = ACTIONS(33),
    [aux_sym_number_literal_token3] = ACTIONS(33),
    [anon_sym_true] = ACTIONS(35),
    [anon_sym_false] = ACTIONS(35),
    [sym_nil_literal] = ACTIONS(37),
    [sym_keyword] = ACTIONS(39),
    [sym__long_str] = ACTIONS(41),
    [sym__long_buffer] = ACTIONS(43),
  },
  [217] = {
    [sym__expr] = STATE(461),
    [sym_tuple] = STATE(411),
    [sym_sqr_tuple] = STATE(411),
    [sym_array] = STATE(411),
    [sym_sqr_array] = STATE(411),
    [sym_struct] = STATE(411),
    [sym_table] = STATE(411),
    [sym_peg_set] = STATE(411),
    [sym__special_forms] = STATE(411),
    [sym_def] = STATE(412),
    [sym_var] = STATE(412),
    [sym_quote] = STATE(412),
    [sym_splice] = STATE(412),
    [sym_quasiquote] = STATE(412),
    [sym_unquote] = STATE(412),
    [sym_break] = STATE(412),
    [sym_set] = STATE(412),
    [sym_if] = STATE(412),
    [sym_do] = STATE(412),
    [sym_while] = STATE(412),
    [sym_fn] = STATE(412),
    [sym_upscope] = STATE(412),
    [sym__shorthand] = STATE(411),
    [sym_short_quote] = STATE(413),
    [sym_short_splice] = STATE(413),
    [sym_short_quasiquote] = STATE(413),
    [sym_short_unquote] = STATE(413),
    [sym_short_fn] = STATE(413),
    [sym__specials] = STATE(411),
    [sym_extra_defs] = STATE(416),
    [sym__literals] = STATE(411),
    [sym_long_str_literal] = STATE(392),
    [sym_long_buffer_literal] = STATE(392),
    [sym_number_literal] = STATE(392),
    [sym_bool_literal] = STATE(392),
    [sym__identifier] = STATE(411),
    [sym_symbol] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(9),
    [anon_sym_LBRACK] = ACTIONS(11),
    [anon_sym_AT_LPAREN] = ACTIONS(13),
    [anon_sym_AT_LBRACK] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_AT_LBRACE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(27),
    [anon_sym_PIPE] = ACTIONS(29),
    [sym_str_literal] = ACTIONS(31),
    [sym_buffer_literal] = ACTIONS(31),
    [aux_sym_number_literal_token1] = ACTIONS(33),
    [aux_sym_number_literal_token2] = ACTIONS(33),
    [aux_sym_number_literal_token3] = ACTIONS(33),
    [anon_sym_true] = ACTIONS(35),
    [anon_sym_false] = ACTIONS(35),
    [sym_nil_literal] = ACTIONS(37),
    [sym_keyword] = ACTIONS(39),
    [sym__long_str] = ACTIONS(41),
    [sym__long_buffer] = ACTIONS(43),
  },
  [218] = {
    [sym__expr] = STATE(462),
    [sym_tuple] = STATE(411),
    [sym_sqr_tuple] = STATE(411),
    [sym_array] = STATE(411),
    [sym_sqr_array] = STATE(411),
    [sym_struct] = STATE(411),
    [sym_table] = STATE(411),
    [sym_peg_set] = STATE(411),
    [sym__special_forms] = STATE(411),
    [sym_def] = STATE(412),
    [sym_var] = STATE(412),
    [sym_quote] = STATE(412),
    [sym_splice] = STATE(412),
    [sym_quasiquote] = STATE(412),
    [sym_unquote] = STATE(412),
    [sym_break] = STATE(412),
    [sym_set] = STATE(412),
    [sym_if] = STATE(412),
    [sym_do] = STATE(412),
    [sym_while] = STATE(412),
    [sym_fn] = STATE(412),
    [sym_upscope] = STATE(412),
    [sym__shorthand] = STATE(411),
    [sym_short_quote] = STATE(413),
    [sym_short_splice] = STATE(413),
    [sym_short_quasiquote] = STATE(413),
    [sym_short_unquote] = STATE(413),
    [sym_short_fn] = STATE(413),
    [sym__specials] = STATE(411),
    [sym_extra_defs] = STATE(416),
    [sym__literals] = STATE(411),
    [sym_long_str_literal] = STATE(392),
    [sym_long_buffer_literal] = STATE(392),
    [sym_number_literal] = STATE(392),
    [sym_bool_literal] = STATE(392),
    [sym__identifier] = STATE(411),
    [sym_symbol] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(9),
    [anon_sym_LBRACK] = ACTIONS(11),
    [anon_sym_AT_LPAREN] = ACTIONS(13),
    [anon_sym_AT_LBRACK] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_AT_LBRACE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(27),
    [anon_sym_PIPE] = ACTIONS(29),
    [sym_str_literal] = ACTIONS(31),
    [sym_buffer_literal] = ACTIONS(31),
    [aux_sym_number_literal_token1] = ACTIONS(33),
    [aux_sym_number_literal_token2] = ACTIONS(33),
    [aux_sym_number_literal_token3] = ACTIONS(33),
    [anon_sym_true] = ACTIONS(35),
    [anon_sym_false] = ACTIONS(35),
    [sym_nil_literal] = ACTIONS(37),
    [sym_keyword] = ACTIONS(39),
    [sym__long_str] = ACTIONS(41),
    [sym__long_buffer] = ACTIONS(43),
  },
  [219] = {
    [sym__expr] = STATE(190),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [220] = {
    [sym__expr] = STATE(173),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [221] = {
    [sym__expr] = STATE(463),
    [sym_tuple] = STATE(411),
    [sym_sqr_tuple] = STATE(411),
    [sym_array] = STATE(411),
    [sym_sqr_array] = STATE(411),
    [sym_struct] = STATE(411),
    [sym_table] = STATE(411),
    [sym_peg_set] = STATE(411),
    [sym__special_forms] = STATE(411),
    [sym_def] = STATE(412),
    [sym_var] = STATE(412),
    [sym_quote] = STATE(412),
    [sym_splice] = STATE(412),
    [sym_quasiquote] = STATE(412),
    [sym_unquote] = STATE(412),
    [sym_break] = STATE(412),
    [sym_set] = STATE(412),
    [sym_if] = STATE(412),
    [sym_do] = STATE(412),
    [sym_while] = STATE(412),
    [sym_fn] = STATE(412),
    [sym_upscope] = STATE(412),
    [sym__shorthand] = STATE(411),
    [sym_short_quote] = STATE(413),
    [sym_short_splice] = STATE(413),
    [sym_short_quasiquote] = STATE(413),
    [sym_short_unquote] = STATE(413),
    [sym_short_fn] = STATE(413),
    [sym__specials] = STATE(411),
    [sym_extra_defs] = STATE(416),
    [sym__literals] = STATE(411),
    [sym_long_str_literal] = STATE(392),
    [sym_long_buffer_literal] = STATE(392),
    [sym_number_literal] = STATE(392),
    [sym_bool_literal] = STATE(392),
    [sym__identifier] = STATE(411),
    [sym_symbol] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(9),
    [anon_sym_LBRACK] = ACTIONS(11),
    [anon_sym_AT_LPAREN] = ACTIONS(13),
    [anon_sym_AT_LBRACK] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_AT_LBRACE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(27),
    [anon_sym_PIPE] = ACTIONS(29),
    [sym_str_literal] = ACTIONS(31),
    [sym_buffer_literal] = ACTIONS(31),
    [aux_sym_number_literal_token1] = ACTIONS(33),
    [aux_sym_number_literal_token2] = ACTIONS(33),
    [aux_sym_number_literal_token3] = ACTIONS(33),
    [anon_sym_true] = ACTIONS(35),
    [anon_sym_false] = ACTIONS(35),
    [sym_nil_literal] = ACTIONS(37),
    [sym_keyword] = ACTIONS(39),
    [sym__long_str] = ACTIONS(41),
    [sym__long_buffer] = ACTIONS(43),
  },
  [222] = {
    [sym__expr] = STATE(68),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [223] = {
    [sym__expr] = STATE(211),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [224] = {
    [sym__expr] = STATE(79),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [225] = {
    [sym__expr] = STATE(157),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [226] = {
    [sym__expr] = STATE(592),
    [sym_tuple] = STATE(607),
    [sym_sqr_tuple] = STATE(607),
    [sym_array] = STATE(607),
    [sym_sqr_array] = STATE(607),
    [sym_struct] = STATE(607),
    [sym_table] = STATE(607),
    [sym_peg_set] = STATE(607),
    [sym__special_forms] = STATE(607),
    [sym_def] = STATE(608),
    [sym_var] = STATE(608),
    [sym_quote] = STATE(608),
    [sym_splice] = STATE(608),
    [sym_quasiquote] = STATE(608),
    [sym_unquote] = STATE(608),
    [sym_break] = STATE(608),
    [sym_set] = STATE(608),
    [sym_if] = STATE(608),
    [sym_do] = STATE(608),
    [sym_while] = STATE(608),
    [sym_fn] = STATE(608),
    [sym_upscope] = STATE(608),
    [sym__shorthand] = STATE(607),
    [sym_short_quote] = STATE(609),
    [sym_short_splice] = STATE(609),
    [sym_short_quasiquote] = STATE(609),
    [sym_short_unquote] = STATE(609),
    [sym_short_fn] = STATE(609),
    [sym__specials] = STATE(607),
    [sym_extra_defs] = STATE(611),
    [sym__literals] = STATE(607),
    [sym_long_str_literal] = STATE(603),
    [sym_long_buffer_literal] = STATE(603),
    [sym_number_literal] = STATE(603),
    [sym_bool_literal] = STATE(603),
    [sym__identifier] = STATE(607),
    [sym_symbol] = ACTIONS(631),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_AT_LPAREN] = ACTIONS(637),
    [anon_sym_AT_LBRACK] = ACTIONS(639),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_AT_LBRACE] = ACTIONS(643),
    [anon_sym_SQUOTE] = ACTIONS(909),
    [anon_sym_SEMI] = ACTIONS(911),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_COMMA] = ACTIONS(915),
    [anon_sym_PIPE] = ACTIONS(645),
    [sym_str_literal] = ACTIONS(649),
    [sym_buffer_literal] = ACTIONS(649),
    [aux_sym_number_literal_token1] = ACTIONS(651),
    [aux_sym_number_literal_token2] = ACTIONS(651),
    [aux_sym_number_literal_token3] = ACTIONS(651),
    [anon_sym_true] = ACTIONS(653),
    [anon_sym_false] = ACTIONS(653),
    [sym_nil_literal] = ACTIONS(655),
    [sym_keyword] = ACTIONS(917),
    [sym__long_str] = ACTIONS(919),
    [sym__long_buffer] = ACTIONS(659),
  },
  [227] = {
    [sym__expr] = STATE(104),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [228] = {
    [sym__expr] = STATE(82),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [229] = {
    [sym__expr] = STATE(220),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [230] = {
    [sym__expr] = STATE(543),
    [sym_tuple] = STATE(538),
    [sym_sqr_tuple] = STATE(538),
    [sym_array] = STATE(538),
    [sym_sqr_array] = STATE(538),
    [sym_struct] = STATE(538),
    [sym_table] = STATE(538),
    [sym_peg_set] = STATE(538),
    [sym__special_forms] = STATE(538),
    [sym_def] = STATE(537),
    [sym_var] = STATE(537),
    [sym_quote] = STATE(537),
    [sym_splice] = STATE(537),
    [sym_quasiquote] = STATE(537),
    [sym_unquote] = STATE(537),
    [sym_break] = STATE(537),
    [sym_set] = STATE(537),
    [sym_if] = STATE(537),
    [sym_do] = STATE(537),
    [sym_while] = STATE(537),
    [sym_fn] = STATE(537),
    [sym_upscope] = STATE(537),
    [sym__shorthand] = STATE(538),
    [sym_short_quote] = STATE(536),
    [sym_short_splice] = STATE(536),
    [sym_short_quasiquote] = STATE(536),
    [sym_short_unquote] = STATE(536),
    [sym_short_fn] = STATE(536),
    [sym__specials] = STATE(538),
    [sym_extra_defs] = STATE(535),
    [sym__literals] = STATE(538),
    [sym_long_str_literal] = STATE(542),
    [sym_long_buffer_literal] = STATE(542),
    [sym_number_literal] = STATE(542),
    [sym_bool_literal] = STATE(542),
    [sym__identifier] = STATE(538),
    [sym_symbol] = ACTIONS(983),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(985),
    [anon_sym_LBRACK] = ACTIONS(987),
    [anon_sym_AT_LPAREN] = ACTIONS(989),
    [anon_sym_AT_LBRACK] = ACTIONS(991),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_AT_LBRACE] = ACTIONS(995),
    [anon_sym_SQUOTE] = ACTIONS(997),
    [anon_sym_SEMI] = ACTIONS(999),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_COMMA] = ACTIONS(1003),
    [anon_sym_PIPE] = ACTIONS(1005),
    [sym_str_literal] = ACTIONS(1007),
    [sym_buffer_literal] = ACTIONS(1007),
    [aux_sym_number_literal_token1] = ACTIONS(1009),
    [aux_sym_number_literal_token2] = ACTIONS(1009),
    [aux_sym_number_literal_token3] = ACTIONS(1009),
    [anon_sym_true] = ACTIONS(1011),
    [anon_sym_false] = ACTIONS(1011),
    [sym_nil_literal] = ACTIONS(1013),
    [sym_keyword] = ACTIONS(1015),
    [sym__long_str] = ACTIONS(1017),
    [sym__long_buffer] = ACTIONS(1019),
  },
  [231] = {
    [sym__expr] = STATE(156),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [232] = {
    [sym__expr] = STATE(268),
    [sym_tuple] = STATE(281),
    [sym_sqr_tuple] = STATE(281),
    [sym_array] = STATE(281),
    [sym_sqr_array] = STATE(281),
    [sym_struct] = STATE(281),
    [sym_table] = STATE(281),
    [sym_peg_set] = STATE(281),
    [sym__special_forms] = STATE(281),
    [sym_def] = STATE(280),
    [sym_var] = STATE(280),
    [sym_quote] = STATE(280),
    [sym_splice] = STATE(280),
    [sym_quasiquote] = STATE(280),
    [sym_unquote] = STATE(280),
    [sym_break] = STATE(280),
    [sym_set] = STATE(280),
    [sym_if] = STATE(280),
    [sym_do] = STATE(280),
    [sym_while] = STATE(280),
    [sym_fn] = STATE(280),
    [sym_upscope] = STATE(280),
    [sym__shorthand] = STATE(281),
    [sym_short_quote] = STATE(279),
    [sym_short_splice] = STATE(279),
    [sym_short_quasiquote] = STATE(279),
    [sym_short_unquote] = STATE(279),
    [sym_short_fn] = STATE(279),
    [sym__specials] = STATE(281),
    [sym_extra_defs] = STATE(244),
    [sym__literals] = STATE(281),
    [sym_long_str_literal] = STATE(285),
    [sym_long_buffer_literal] = STATE(285),
    [sym_number_literal] = STATE(285),
    [sym_bool_literal] = STATE(285),
    [sym__identifier] = STATE(281),
    [sym_symbol] = ACTIONS(233),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_LBRACK] = ACTIONS(239),
    [anon_sym_AT_LPAREN] = ACTIONS(241),
    [anon_sym_AT_LBRACK] = ACTIONS(243),
    [anon_sym_LBRACE] = ACTIONS(245),
    [anon_sym_AT_LBRACE] = ACTIONS(247),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SEMI] = ACTIONS(253),
    [anon_sym_TILDE] = ACTIONS(255),
    [anon_sym_COMMA] = ACTIONS(257),
    [anon_sym_PIPE] = ACTIONS(259),
    [sym_str_literal] = ACTIONS(261),
    [sym_buffer_literal] = ACTIONS(261),
    [aux_sym_number_literal_token1] = ACTIONS(263),
    [aux_sym_number_literal_token2] = ACTIONS(263),
    [aux_sym_number_literal_token3] = ACTIONS(263),
    [anon_sym_true] = ACTIONS(265),
    [anon_sym_false] = ACTIONS(265),
    [sym_nil_literal] = ACTIONS(267),
    [sym_keyword] = ACTIONS(269),
    [sym__long_str] = ACTIONS(271),
    [sym__long_buffer] = ACTIONS(273),
  },
  [233] = {
    [sym__expr] = STATE(206),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(474),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(475),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(473),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(1025),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [234] = {
    [sym__expr] = STATE(86),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [235] = {
    [sym__expr] = STATE(653),
    [sym_tuple] = STATE(607),
    [sym_sqr_tuple] = STATE(607),
    [sym_array] = STATE(607),
    [sym_sqr_array] = STATE(607),
    [sym_struct] = STATE(607),
    [sym_table] = STATE(607),
    [sym_peg_set] = STATE(607),
    [sym__special_forms] = STATE(607),
    [sym_def] = STATE(608),
    [sym_var] = STATE(608),
    [sym_quote] = STATE(608),
    [sym_splice] = STATE(608),
    [sym_quasiquote] = STATE(608),
    [sym_unquote] = STATE(608),
    [sym_break] = STATE(608),
    [sym_set] = STATE(608),
    [sym_if] = STATE(608),
    [sym_do] = STATE(608),
    [sym_while] = STATE(608),
    [sym_fn] = STATE(608),
    [sym_upscope] = STATE(608),
    [sym__shorthand] = STATE(607),
    [sym_short_quote] = STATE(609),
    [sym_short_splice] = STATE(609),
    [sym_short_quasiquote] = STATE(609),
    [sym_short_unquote] = STATE(609),
    [sym_short_fn] = STATE(609),
    [sym__specials] = STATE(607),
    [sym_extra_defs] = STATE(611),
    [sym__literals] = STATE(607),
    [sym_long_str_literal] = STATE(603),
    [sym_long_buffer_literal] = STATE(603),
    [sym_number_literal] = STATE(603),
    [sym_bool_literal] = STATE(603),
    [sym__identifier] = STATE(607),
    [sym_symbol] = ACTIONS(631),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_AT_LPAREN] = ACTIONS(637),
    [anon_sym_AT_LBRACK] = ACTIONS(639),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_AT_LBRACE] = ACTIONS(643),
    [anon_sym_SQUOTE] = ACTIONS(909),
    [anon_sym_SEMI] = ACTIONS(911),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_COMMA] = ACTIONS(915),
    [anon_sym_PIPE] = ACTIONS(645),
    [sym_str_literal] = ACTIONS(649),
    [sym_buffer_literal] = ACTIONS(649),
    [aux_sym_number_literal_token1] = ACTIONS(651),
    [aux_sym_number_literal_token2] = ACTIONS(651),
    [aux_sym_number_literal_token3] = ACTIONS(651),
    [anon_sym_true] = ACTIONS(653),
    [anon_sym_false] = ACTIONS(653),
    [sym_nil_literal] = ACTIONS(655),
    [sym_keyword] = ACTIONS(917),
    [sym__long_str] = ACTIONS(919),
    [sym__long_buffer] = ACTIONS(659),
  },
  [236] = {
    [sym__expr] = STATE(652),
    [sym_tuple] = STATE(607),
    [sym_sqr_tuple] = STATE(607),
    [sym_array] = STATE(607),
    [sym_sqr_array] = STATE(607),
    [sym_struct] = STATE(607),
    [sym_table] = STATE(607),
    [sym_peg_set] = STATE(607),
    [sym__special_forms] = STATE(607),
    [sym_def] = STATE(608),
    [sym_var] = STATE(608),
    [sym_quote] = STATE(608),
    [sym_splice] = STATE(608),
    [sym_quasiquote] = STATE(608),
    [sym_unquote] = STATE(608),
    [sym_break] = STATE(608),
    [sym_set] = STATE(608),
    [sym_if] = STATE(608),
    [sym_do] = STATE(608),
    [sym_while] = STATE(608),
    [sym_fn] = STATE(608),
    [sym_upscope] = STATE(608),
    [sym__shorthand] = STATE(607),
    [sym_short_quote] = STATE(609),
    [sym_short_splice] = STATE(609),
    [sym_short_quasiquote] = STATE(609),
    [sym_short_unquote] = STATE(609),
    [sym_short_fn] = STATE(609),
    [sym__specials] = STATE(607),
    [sym_extra_defs] = STATE(611),
    [sym__literals] = STATE(607),
    [sym_long_str_literal] = STATE(603),
    [sym_long_buffer_literal] = STATE(603),
    [sym_number_literal] = STATE(603),
    [sym_bool_literal] = STATE(603),
    [sym__identifier] = STATE(607),
    [sym_symbol] = ACTIONS(631),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_AT_LPAREN] = ACTIONS(637),
    [anon_sym_AT_LBRACK] = ACTIONS(639),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_AT_LBRACE] = ACTIONS(643),
    [anon_sym_SQUOTE] = ACTIONS(909),
    [anon_sym_SEMI] = ACTIONS(911),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_COMMA] = ACTIONS(915),
    [anon_sym_PIPE] = ACTIONS(645),
    [sym_str_literal] = ACTIONS(649),
    [sym_buffer_literal] = ACTIONS(649),
    [aux_sym_number_literal_token1] = ACTIONS(651),
    [aux_sym_number_literal_token2] = ACTIONS(651),
    [aux_sym_number_literal_token3] = ACTIONS(651),
    [anon_sym_true] = ACTIONS(653),
    [anon_sym_false] = ACTIONS(653),
    [sym_nil_literal] = ACTIONS(655),
    [sym_keyword] = ACTIONS(917),
    [sym__long_str] = ACTIONS(919),
    [sym__long_buffer] = ACTIONS(659),
  },
  [237] = {
    [sym__expr] = STATE(646),
    [sym_tuple] = STATE(607),
    [sym_sqr_tuple] = STATE(607),
    [sym_array] = STATE(607),
    [sym_sqr_array] = STATE(607),
    [sym_struct] = STATE(607),
    [sym_table] = STATE(607),
    [sym_peg_set] = STATE(607),
    [sym__special_forms] = STATE(607),
    [sym_def] = STATE(608),
    [sym_var] = STATE(608),
    [sym_quote] = STATE(608),
    [sym_splice] = STATE(608),
    [sym_quasiquote] = STATE(608),
    [sym_unquote] = STATE(608),
    [sym_break] = STATE(608),
    [sym_set] = STATE(608),
    [sym_if] = STATE(608),
    [sym_do] = STATE(608),
    [sym_while] = STATE(608),
    [sym_fn] = STATE(608),
    [sym_upscope] = STATE(608),
    [sym__shorthand] = STATE(607),
    [sym_short_quote] = STATE(609),
    [sym_short_splice] = STATE(609),
    [sym_short_quasiquote] = STATE(609),
    [sym_short_unquote] = STATE(609),
    [sym_short_fn] = STATE(609),
    [sym__specials] = STATE(607),
    [sym_extra_defs] = STATE(611),
    [sym__literals] = STATE(607),
    [sym_long_str_literal] = STATE(603),
    [sym_long_buffer_literal] = STATE(603),
    [sym_number_literal] = STATE(603),
    [sym_bool_literal] = STATE(603),
    [sym__identifier] = STATE(607),
    [sym_symbol] = ACTIONS(631),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_AT_LPAREN] = ACTIONS(637),
    [anon_sym_AT_LBRACK] = ACTIONS(639),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_AT_LBRACE] = ACTIONS(643),
    [anon_sym_SQUOTE] = ACTIONS(909),
    [anon_sym_SEMI] = ACTIONS(911),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_COMMA] = ACTIONS(915),
    [anon_sym_PIPE] = ACTIONS(645),
    [sym_str_literal] = ACTIONS(649),
    [sym_buffer_literal] = ACTIONS(649),
    [aux_sym_number_literal_token1] = ACTIONS(651),
    [aux_sym_number_literal_token2] = ACTIONS(651),
    [aux_sym_number_literal_token3] = ACTIONS(651),
    [anon_sym_true] = ACTIONS(653),
    [anon_sym_false] = ACTIONS(653),
    [sym_nil_literal] = ACTIONS(655),
    [sym_keyword] = ACTIONS(917),
    [sym__long_str] = ACTIONS(919),
    [sym__long_buffer] = ACTIONS(659),
  },
  [238] = {
    [sym__expr] = STATE(645),
    [sym_tuple] = STATE(607),
    [sym_sqr_tuple] = STATE(607),
    [sym_array] = STATE(607),
    [sym_sqr_array] = STATE(607),
    [sym_struct] = STATE(607),
    [sym_table] = STATE(607),
    [sym_peg_set] = STATE(607),
    [sym__special_forms] = STATE(607),
    [sym_def] = STATE(608),
    [sym_var] = STATE(608),
    [sym_quote] = STATE(608),
    [sym_splice] = STATE(608),
    [sym_quasiquote] = STATE(608),
    [sym_unquote] = STATE(608),
    [sym_break] = STATE(608),
    [sym_set] = STATE(608),
    [sym_if] = STATE(608),
    [sym_do] = STATE(608),
    [sym_while] = STATE(608),
    [sym_fn] = STATE(608),
    [sym_upscope] = STATE(608),
    [sym__shorthand] = STATE(607),
    [sym_short_quote] = STATE(609),
    [sym_short_splice] = STATE(609),
    [sym_short_quasiquote] = STATE(609),
    [sym_short_unquote] = STATE(609),
    [sym_short_fn] = STATE(609),
    [sym__specials] = STATE(607),
    [sym_extra_defs] = STATE(611),
    [sym__literals] = STATE(607),
    [sym_long_str_literal] = STATE(603),
    [sym_long_buffer_literal] = STATE(603),
    [sym_number_literal] = STATE(603),
    [sym_bool_literal] = STATE(603),
    [sym__identifier] = STATE(607),
    [sym_symbol] = ACTIONS(631),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_AT_LPAREN] = ACTIONS(637),
    [anon_sym_AT_LBRACK] = ACTIONS(639),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_AT_LBRACE] = ACTIONS(643),
    [anon_sym_SQUOTE] = ACTIONS(909),
    [anon_sym_SEMI] = ACTIONS(911),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_COMMA] = ACTIONS(915),
    [anon_sym_PIPE] = ACTIONS(645),
    [sym_str_literal] = ACTIONS(649),
    [sym_buffer_literal] = ACTIONS(649),
    [aux_sym_number_literal_token1] = ACTIONS(651),
    [aux_sym_number_literal_token2] = ACTIONS(651),
    [aux_sym_number_literal_token3] = ACTIONS(651),
    [anon_sym_true] = ACTIONS(653),
    [anon_sym_false] = ACTIONS(653),
    [sym_nil_literal] = ACTIONS(655),
    [sym_keyword] = ACTIONS(917),
    [sym__long_str] = ACTIONS(919),
    [sym__long_buffer] = ACTIONS(659),
  },
  [239] = {
    [sym__expr] = STATE(643),
    [sym_tuple] = STATE(607),
    [sym_sqr_tuple] = STATE(607),
    [sym_array] = STATE(607),
    [sym_sqr_array] = STATE(607),
    [sym_struct] = STATE(607),
    [sym_table] = STATE(607),
    [sym_peg_set] = STATE(607),
    [sym__special_forms] = STATE(607),
    [sym_def] = STATE(608),
    [sym_var] = STATE(608),
    [sym_quote] = STATE(608),
    [sym_splice] = STATE(608),
    [sym_quasiquote] = STATE(608),
    [sym_unquote] = STATE(608),
    [sym_break] = STATE(608),
    [sym_set] = STATE(608),
    [sym_if] = STATE(608),
    [sym_do] = STATE(608),
    [sym_while] = STATE(608),
    [sym_fn] = STATE(608),
    [sym_upscope] = STATE(608),
    [sym__shorthand] = STATE(607),
    [sym_short_quote] = STATE(609),
    [sym_short_splice] = STATE(609),
    [sym_short_quasiquote] = STATE(609),
    [sym_short_unquote] = STATE(609),
    [sym_short_fn] = STATE(609),
    [sym__specials] = STATE(607),
    [sym_extra_defs] = STATE(611),
    [sym__literals] = STATE(607),
    [sym_long_str_literal] = STATE(603),
    [sym_long_buffer_literal] = STATE(603),
    [sym_number_literal] = STATE(603),
    [sym_bool_literal] = STATE(603),
    [sym__identifier] = STATE(607),
    [sym_symbol] = ACTIONS(631),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_AT_LPAREN] = ACTIONS(637),
    [anon_sym_AT_LBRACK] = ACTIONS(639),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_AT_LBRACE] = ACTIONS(643),
    [anon_sym_SQUOTE] = ACTIONS(909),
    [anon_sym_SEMI] = ACTIONS(911),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_COMMA] = ACTIONS(915),
    [anon_sym_PIPE] = ACTIONS(645),
    [sym_str_literal] = ACTIONS(649),
    [sym_buffer_literal] = ACTIONS(649),
    [aux_sym_number_literal_token1] = ACTIONS(651),
    [aux_sym_number_literal_token2] = ACTIONS(651),
    [aux_sym_number_literal_token3] = ACTIONS(651),
    [anon_sym_true] = ACTIONS(653),
    [anon_sym_false] = ACTIONS(653),
    [sym_nil_literal] = ACTIONS(655),
    [sym_keyword] = ACTIONS(917),
    [sym__long_str] = ACTIONS(919),
    [sym__long_buffer] = ACTIONS(659),
  },
  [240] = {
    [sym__expr] = STATE(91),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [241] = {
    [sym__expr] = STATE(93),
    [sym_tuple] = STATE(305),
    [sym_sqr_tuple] = STATE(305),
    [sym_array] = STATE(305),
    [sym_sqr_array] = STATE(305),
    [sym_struct] = STATE(305),
    [sym_table] = STATE(305),
    [sym_peg_set] = STATE(305),
    [sym__special_forms] = STATE(305),
    [sym_def] = STATE(339),
    [sym_var] = STATE(339),
    [sym_quote] = STATE(339),
    [sym_splice] = STATE(339),
    [sym_quasiquote] = STATE(339),
    [sym_unquote] = STATE(339),
    [sym_break] = STATE(339),
    [sym_set] = STATE(339),
    [sym_if] = STATE(339),
    [sym_do] = STATE(339),
    [sym_while] = STATE(339),
    [sym_fn] = STATE(339),
    [sym_upscope] = STATE(339),
    [sym__shorthand] = STATE(305),
    [sym_short_quote] = STATE(308),
    [sym_short_splice] = STATE(308),
    [sym_short_quasiquote] = STATE(308),
    [sym_short_unquote] = STATE(308),
    [sym_short_fn] = STATE(308),
    [sym__specials] = STATE(305),
    [sym_extra_defs] = STATE(337),
    [sym__literals] = STATE(305),
    [sym_long_str_literal] = STATE(322),
    [sym_long_buffer_literal] = STATE(322),
    [sym_number_literal] = STATE(322),
    [sym_bool_literal] = STATE(322),
    [sym__identifier] = STATE(305),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 13,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1029), 1,
      anon_sym_LPAREN,
    ACTIONS(1034), 1,
      anon_sym_SQUOTE,
    ACTIONS(1037), 1,
      anon_sym_SEMI,
    ACTIONS(1040), 1,
      anon_sym_TILDE,
    ACTIONS(1043), 1,
      anon_sym_COMMA,
    ACTIONS(1049), 1,
      sym__long_str,
    STATE(242), 1,
      aux_sym_def_repeat1,
    STATE(478), 1,
      sym_metadata,
    ACTIONS(1046), 2,
      sym_str_literal,
      sym_keyword,
    ACTIONS(1027), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1032), 8,
      sym__long_buffer,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_PIPE,
      sym_buffer_literal,
    STATE(479), 9,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
      sym_long_str_literal,
  [62] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1052), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1054), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [98] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1056), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1058), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [134] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1060), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1062), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [170] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1064), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1066), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [206] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1068), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1070), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [242] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1072), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1074), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [278] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1076), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1078), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [314] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1080), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1082), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [350] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1084), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1086), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [386] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1088), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1090), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [422] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1092), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1094), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [458] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1096), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1098), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [494] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1100), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1102), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [530] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1104), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1106), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [566] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1108), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1110), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [602] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1112), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1114), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [638] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1116), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1118), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [674] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1120), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1122), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [710] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1124), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1126), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [746] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1128), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1130), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [782] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1132), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1134), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [818] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1136), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1138), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [854] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1140), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1142), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [890] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1144), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1146), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [926] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1148), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1150), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [962] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1152), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1154), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [998] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1156), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1158), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1034] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1160), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1162), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1070] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1164), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1166), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1106] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1168), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1170), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1142] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1172), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1174), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1178] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1176), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1178), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1214] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1180), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1182), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1250] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1184), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1186), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1286] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1188), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1190), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1322] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1192), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1194), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1358] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1196), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1198), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1394] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1200), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1202), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1430] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1204), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1206), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1466] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1208), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1210), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1502] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1212), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1214), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1538] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1216), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1218), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1574] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1220), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1222), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1610] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1224), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1226), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1646] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1228), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1230), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1682] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1232), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1234), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1718] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1236), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1238), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1754] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1240), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1242), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1790] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1244), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1246), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1826] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1248), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1250), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1862] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1252), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1254), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1898] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1256), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1258), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1934] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1260), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1262), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1970] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1264), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1266), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [2006] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1268), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1270), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [2042] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1272), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1274), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [2078] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1276), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1278), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [2114] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1280), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1282), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [2150] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1284), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1286), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [2186] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1288), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1290), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [2222] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1128), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1130), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [2256] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1156), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1158), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [2290] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1204), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1206), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [2324] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1164), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1166), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [2358] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1160), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1162), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [2392] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1196), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1198), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [2426] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1192), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1194), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [2460] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1188), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1190), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [2494] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1184), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1186), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [2528] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1180), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1182), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [2562] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1176), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1178), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [2596] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1172), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1174), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [2630] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1052), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1054), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [2664] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1248), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1250), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [2698] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1252), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1254), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [2732] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1256), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1258), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [2766] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1240), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1242), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [2800] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1212), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1214), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [2834] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1216), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1218), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [2868] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1220), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1222), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [2902] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1224), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1226), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [2936] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1124), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1126), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [2970] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1152), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1154), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3004] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1260), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1262), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3038] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1148), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1150), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3072] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1228), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1230), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3106] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1144), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1146), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3140] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1244), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1246), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3174] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1140), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1142), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3208] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1136), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1138), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3242] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1264), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1266), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3276] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1268), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1270), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3310] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1272), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1274), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3344] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1132), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1134), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3378] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1056), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1058), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3412] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1120), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1122), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3446] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1200), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1202), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3480] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1092), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1094), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3514] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1116), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1118), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3548] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1112), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1114), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3582] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1108), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1110), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3616] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1104), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1106), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3650] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1100), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1102), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3684] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1096), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1098), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3718] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1088), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1090), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3752] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1084), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1086), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3786] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1276), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1278), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3820] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1280), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1282), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3854] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1284), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1286), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3888] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1288), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1290), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3922] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1076), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1078), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3956] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1072), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1074), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3990] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1064), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1066), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [4024] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1080), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1082), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [4058] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1060), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1062), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [4092] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1236), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1238), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [4126] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1232), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1234), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [4160] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1208), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1210), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [4194] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1168), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1170), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [4228] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1068), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1070), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [4261] = 16,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(45), 1,
      sym_symbol,
    ACTIONS(87), 1,
      anon_sym_SQUOTE,
    ACTIONS(89), 1,
      anon_sym_SEMI,
    ACTIONS(91), 1,
      anon_sym_TILDE,
    ACTIONS(93), 1,
      anon_sym_COMMA,
    ACTIONS(1017), 1,
      sym__long_str,
    ACTIONS(1292), 1,
      anon_sym_LPAREN,
    ACTIONS(1294), 1,
      anon_sym_LBRACK,
    ACTIONS(1296), 1,
      sym_str_literal,
    ACTIONS(1298), 1,
      sym_keyword,
    STATE(365), 1,
      aux_sym_def_repeat1,
    STATE(516), 1,
      sym_metadata,
    STATE(524), 1,
      sym_long_str_literal,
    STATE(18), 4,
      sym__parameters,
      sym_parameters,
      sym_tuple_parameters,
      sym__identifier,
    STATE(419), 8,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
  [4320] = 16,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(45), 1,
      sym_symbol,
    ACTIONS(87), 1,
      anon_sym_SQUOTE,
    ACTIONS(89), 1,
      anon_sym_SEMI,
    ACTIONS(91), 1,
      anon_sym_TILDE,
    ACTIONS(93), 1,
      anon_sym_COMMA,
    ACTIONS(1017), 1,
      sym__long_str,
    ACTIONS(1292), 1,
      anon_sym_LPAREN,
    ACTIONS(1294), 1,
      anon_sym_LBRACK,
    ACTIONS(1296), 1,
      sym_str_literal,
    ACTIONS(1298), 1,
      sym_keyword,
    STATE(366), 1,
      aux_sym_def_repeat1,
    STATE(516), 1,
      sym_metadata,
    STATE(524), 1,
      sym_long_str_literal,
    STATE(45), 4,
      sym__parameters,
      sym_parameters,
      sym_tuple_parameters,
      sym__identifier,
    STATE(419), 8,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
  [4379] = 16,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(45), 1,
      sym_symbol,
    ACTIONS(87), 1,
      anon_sym_SQUOTE,
    ACTIONS(89), 1,
      anon_sym_SEMI,
    ACTIONS(91), 1,
      anon_sym_TILDE,
    ACTIONS(93), 1,
      anon_sym_COMMA,
    ACTIONS(1017), 1,
      sym__long_str,
    ACTIONS(1292), 1,
      anon_sym_LPAREN,
    ACTIONS(1294), 1,
      anon_sym_LBRACK,
    ACTIONS(1296), 1,
      sym_str_literal,
    ACTIONS(1298), 1,
      sym_keyword,
    STATE(485), 1,
      aux_sym_def_repeat1,
    STATE(516), 1,
      sym_metadata,
    STATE(524), 1,
      sym_long_str_literal,
    STATE(19), 4,
      sym__parameters,
      sym_parameters,
      sym_tuple_parameters,
      sym__identifier,
    STATE(419), 8,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
  [4438] = 16,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(45), 1,
      sym_symbol,
    ACTIONS(87), 1,
      anon_sym_SQUOTE,
    ACTIONS(89), 1,
      anon_sym_SEMI,
    ACTIONS(91), 1,
      anon_sym_TILDE,
    ACTIONS(93), 1,
      anon_sym_COMMA,
    ACTIONS(1017), 1,
      sym__long_str,
    ACTIONS(1292), 1,
      anon_sym_LPAREN,
    ACTIONS(1294), 1,
      anon_sym_LBRACK,
    ACTIONS(1296), 1,
      sym_str_literal,
    ACTIONS(1298), 1,
      sym_keyword,
    STATE(485), 1,
      aux_sym_def_repeat1,
    STATE(516), 1,
      sym_metadata,
    STATE(524), 1,
      sym_long_str_literal,
    STATE(33), 4,
      sym__parameters,
      sym_parameters,
      sym_tuple_parameters,
      sym__identifier,
    STATE(419), 8,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
  [4497] = 16,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(45), 1,
      sym_symbol,
    ACTIONS(87), 1,
      anon_sym_SQUOTE,
    ACTIONS(89), 1,
      anon_sym_SEMI,
    ACTIONS(91), 1,
      anon_sym_TILDE,
    ACTIONS(93), 1,
      anon_sym_COMMA,
    ACTIONS(1017), 1,
      sym__long_str,
    ACTIONS(1292), 1,
      anon_sym_LPAREN,
    ACTIONS(1294), 1,
      anon_sym_LBRACK,
    ACTIONS(1296), 1,
      sym_str_literal,
    ACTIONS(1298), 1,
      sym_keyword,
    STATE(369), 1,
      aux_sym_def_repeat1,
    STATE(516), 1,
      sym_metadata,
    STATE(524), 1,
      sym_long_str_literal,
    STATE(56), 4,
      sym__parameters,
      sym_parameters,
      sym_tuple_parameters,
      sym__identifier,
    STATE(419), 8,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
  [4556] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1300), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1302), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [4589] = 16,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(45), 1,
      sym_symbol,
    ACTIONS(87), 1,
      anon_sym_SQUOTE,
    ACTIONS(89), 1,
      anon_sym_SEMI,
    ACTIONS(91), 1,
      anon_sym_TILDE,
    ACTIONS(93), 1,
      anon_sym_COMMA,
    ACTIONS(1017), 1,
      sym__long_str,
    ACTIONS(1292), 1,
      anon_sym_LPAREN,
    ACTIONS(1294), 1,
      anon_sym_LBRACK,
    ACTIONS(1296), 1,
      sym_str_literal,
    ACTIONS(1298), 1,
      sym_keyword,
    STATE(485), 1,
      aux_sym_def_repeat1,
    STATE(516), 1,
      sym_metadata,
    STATE(524), 1,
      sym_long_str_literal,
    STATE(55), 4,
      sym__parameters,
      sym_parameters,
      sym_tuple_parameters,
      sym__identifier,
    STATE(419), 8,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
  [4648] = 16,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(45), 1,
      sym_symbol,
    ACTIONS(87), 1,
      anon_sym_SQUOTE,
    ACTIONS(89), 1,
      anon_sym_SEMI,
    ACTIONS(91), 1,
      anon_sym_TILDE,
    ACTIONS(93), 1,
      anon_sym_COMMA,
    ACTIONS(1017), 1,
      sym__long_str,
    ACTIONS(1292), 1,
      anon_sym_LPAREN,
    ACTIONS(1294), 1,
      anon_sym_LBRACK,
    ACTIONS(1296), 1,
      sym_str_literal,
    ACTIONS(1298), 1,
      sym_keyword,
    STATE(371), 1,
      aux_sym_def_repeat1,
    STATE(516), 1,
      sym_metadata,
    STATE(524), 1,
      sym_long_str_literal,
    STATE(29), 4,
      sym__parameters,
      sym_parameters,
      sym_tuple_parameters,
      sym__identifier,
    STATE(419), 8,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
  [4707] = 16,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(45), 1,
      sym_symbol,
    ACTIONS(87), 1,
      anon_sym_SQUOTE,
    ACTIONS(89), 1,
      anon_sym_SEMI,
    ACTIONS(91), 1,
      anon_sym_TILDE,
    ACTIONS(93), 1,
      anon_sym_COMMA,
    ACTIONS(1017), 1,
      sym__long_str,
    ACTIONS(1292), 1,
      anon_sym_LPAREN,
    ACTIONS(1294), 1,
      anon_sym_LBRACK,
    ACTIONS(1296), 1,
      sym_str_literal,
    ACTIONS(1298), 1,
      sym_keyword,
    STATE(485), 1,
      aux_sym_def_repeat1,
    STATE(516), 1,
      sym_metadata,
    STATE(524), 1,
      sym_long_str_literal,
    STATE(30), 4,
      sym__parameters,
      sym_parameters,
      sym_tuple_parameters,
      sym__identifier,
    STATE(419), 8,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
  [4766] = 16,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(45), 1,
      sym_symbol,
    ACTIONS(87), 1,
      anon_sym_SQUOTE,
    ACTIONS(89), 1,
      anon_sym_SEMI,
    ACTIONS(91), 1,
      anon_sym_TILDE,
    ACTIONS(93), 1,
      anon_sym_COMMA,
    ACTIONS(1017), 1,
      sym__long_str,
    ACTIONS(1292), 1,
      anon_sym_LPAREN,
    ACTIONS(1294), 1,
      anon_sym_LBRACK,
    ACTIONS(1296), 1,
      sym_str_literal,
    ACTIONS(1298), 1,
      sym_keyword,
    STATE(373), 1,
      aux_sym_def_repeat1,
    STATE(516), 1,
      sym_metadata,
    STATE(524), 1,
      sym_long_str_literal,
    STATE(42), 4,
      sym__parameters,
      sym_parameters,
      sym_tuple_parameters,
      sym__identifier,
    STATE(419), 8,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
  [4825] = 16,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(45), 1,
      sym_symbol,
    ACTIONS(87), 1,
      anon_sym_SQUOTE,
    ACTIONS(89), 1,
      anon_sym_SEMI,
    ACTIONS(91), 1,
      anon_sym_TILDE,
    ACTIONS(93), 1,
      anon_sym_COMMA,
    ACTIONS(1017), 1,
      sym__long_str,
    ACTIONS(1292), 1,
      anon_sym_LPAREN,
    ACTIONS(1294), 1,
      anon_sym_LBRACK,
    ACTIONS(1296), 1,
      sym_str_literal,
    ACTIONS(1298), 1,
      sym_keyword,
    STATE(485), 1,
      aux_sym_def_repeat1,
    STATE(516), 1,
      sym_metadata,
    STATE(524), 1,
      sym_long_str_literal,
    STATE(43), 4,
      sym__parameters,
      sym_parameters,
      sym_tuple_parameters,
      sym__identifier,
    STATE(419), 8,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
  [4884] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1304), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1306), 17,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [4916] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1308), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1310), 17,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [4948] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1088), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1090), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [4980] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1084), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1086), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5012] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1080), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1082), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5044] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1312), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1314), 17,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5076] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1316), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1318), 17,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5108] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1316), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1318), 17,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5140] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1316), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1318), 17,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5172] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1320), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1322), 17,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5204] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1304), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1306), 17,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5236] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1304), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1306), 17,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5268] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1168), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1170), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5300] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1208), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1210), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5332] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1232), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1234), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5364] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1224), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1226), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5396] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1324), 1,
      anon_sym_RPAREN,
    ACTIONS(1196), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1198), 16,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5430] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1324), 1,
      anon_sym_RPAREN,
    ACTIONS(1200), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1202), 16,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5464] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1220), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1222), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5496] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1216), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1218), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5528] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1324), 1,
      anon_sym_RPAREN,
    ACTIONS(1220), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1222), 16,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5562] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1212), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1214), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5594] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1240), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1242), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5626] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1326), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1328), 17,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5658] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1140), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1142), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5690] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1136), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1138), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5722] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1244), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1246), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5754] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1330), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1332), 17,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5786] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1330), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1332), 17,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5818] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1092), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1094), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5850] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1330), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1332), 17,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5882] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1334), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1336), 17,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5914] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1338), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1340), 17,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5946] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1144), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1146), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5978] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1148), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1150), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6010] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1156), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1158), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6042] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1334), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1336), 17,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6074] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1204), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1206), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6106] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1200), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1202), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6138] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1196), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1198), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6170] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1334), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1336), 17,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6202] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1160), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1162), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6234] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1056), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1058), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6266] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1192), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1194), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6298] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1164), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1166), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6330] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1342), 1,
      sym_symbol,
    ACTIONS(1348), 6,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
    ACTIONS(1346), 8,
      sym__long_buffer,
      anon_sym_RPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_PIPE,
      sym_buffer_literal,
    ACTIONS(1344), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [6366] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1228), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1230), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6398] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1060), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1062), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6430] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1350), 1,
      anon_sym_RPAREN,
    ACTIONS(1196), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1198), 16,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6464] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1350), 1,
      anon_sym_RPAREN,
    ACTIONS(1200), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1202), 16,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6498] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1350), 1,
      anon_sym_RPAREN,
    ACTIONS(1220), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1222), 16,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6532] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1236), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1238), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6564] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1342), 1,
      sym_symbol,
    ACTIONS(1240), 6,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
    ACTIONS(1242), 8,
      sym__long_buffer,
      anon_sym_RPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_PIPE,
      sym_buffer_literal,
    ACTIONS(1344), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [6600] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1352), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1354), 17,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6632] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1356), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1358), 17,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6664] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1360), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1362), 17,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6696] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1188), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1190), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6728] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1184), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1186), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6760] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1180), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1182), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6792] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1064), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1066), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6824] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1072), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1074), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6856] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1076), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1078), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6888] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1288), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1290), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6920] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1284), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1286), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6952] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1280), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1282), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6984] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1276), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1278), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7016] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1364), 1,
      anon_sym_RPAREN,
    ACTIONS(1220), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1222), 16,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7050] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1364), 1,
      anon_sym_RPAREN,
    ACTIONS(1200), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1202), 16,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7084] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1364), 1,
      anon_sym_RPAREN,
    ACTIONS(1196), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1198), 16,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7118] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1198), 1,
      anon_sym_RPAREN,
    ACTIONS(1342), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1344), 16,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7152] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1202), 1,
      anon_sym_RPAREN,
    ACTIONS(1342), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1344), 16,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7186] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1242), 1,
      anon_sym_RPAREN,
    ACTIONS(1342), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1344), 16,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7220] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1222), 1,
      anon_sym_RPAREN,
    ACTIONS(1342), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1344), 16,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7254] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1096), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1098), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7286] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1100), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1102), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7318] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1104), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1106), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7350] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1366), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1368), 17,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7382] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1108), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1110), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7414] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1112), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1114), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7446] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1116), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1118), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7478] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1176), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1178), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7510] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1370), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1372), 17,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7542] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1172), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1174), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7574] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1120), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1122), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7606] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1052), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1054), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7638] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1124), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1126), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7670] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1248), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1250), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7702] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1252), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1254), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7734] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1256), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1258), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7766] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1152), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1154), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7798] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1374), 1,
      anon_sym_RPAREN,
    ACTIONS(1220), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1222), 16,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7832] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1374), 1,
      anon_sym_RPAREN,
    ACTIONS(1200), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1202), 16,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7866] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1376), 1,
      sym_symbol,
    ACTIONS(1348), 6,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
    ACTIONS(1378), 7,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_keyword,
    ACTIONS(1346), 10,
      sym__long_str,
      sym__long_buffer,
      anon_sym_RPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
  [7902] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1374), 1,
      anon_sym_RPAREN,
    ACTIONS(1196), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1198), 16,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7936] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1260), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1262), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7968] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1264), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1266), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [8000] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1380), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1382), 17,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [8032] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1268), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1270), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [8064] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1272), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1274), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [8096] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1384), 1,
      anon_sym_RPAREN,
    ACTIONS(1220), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1222), 16,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [8130] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1384), 1,
      anon_sym_RPAREN,
    ACTIONS(1200), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1202), 16,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [8164] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1384), 1,
      anon_sym_RPAREN,
    ACTIONS(1196), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1198), 16,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [8198] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1132), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1134), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [8230] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1128), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1130), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [8262] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1386), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1388), 16,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [8293] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1342), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1344), 16,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [8324] = 12,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(45), 1,
      sym_symbol,
    ACTIONS(87), 1,
      anon_sym_SQUOTE,
    ACTIONS(89), 1,
      anon_sym_SEMI,
    ACTIONS(91), 1,
      anon_sym_TILDE,
    ACTIONS(93), 1,
      anon_sym_COMMA,
    ACTIONS(107), 1,
      sym_keyword,
    ACTIONS(1292), 1,
      anon_sym_LPAREN,
    ACTIONS(1294), 1,
      anon_sym_LBRACK,
    STATE(486), 1,
      sym__name,
    STATE(14), 3,
      sym__parameters,
      sym_parameters,
      sym_tuple_parameters,
    STATE(466), 9,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
      sym__identifier,
  [8371] = 12,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(45), 1,
      sym_symbol,
    ACTIONS(87), 1,
      anon_sym_SQUOTE,
    ACTIONS(89), 1,
      anon_sym_SEMI,
    ACTIONS(91), 1,
      anon_sym_TILDE,
    ACTIONS(93), 1,
      anon_sym_COMMA,
    ACTIONS(107), 1,
      sym_keyword,
    ACTIONS(1292), 1,
      anon_sym_LPAREN,
    ACTIONS(1294), 1,
      anon_sym_LBRACK,
    STATE(489), 1,
      sym__name,
    STATE(27), 3,
      sym__parameters,
      sym_parameters,
      sym_tuple_parameters,
    STATE(466), 9,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
      sym__identifier,
  [8418] = 12,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(45), 1,
      sym_symbol,
    ACTIONS(87), 1,
      anon_sym_SQUOTE,
    ACTIONS(89), 1,
      anon_sym_SEMI,
    ACTIONS(91), 1,
      anon_sym_TILDE,
    ACTIONS(93), 1,
      anon_sym_COMMA,
    ACTIONS(107), 1,
      sym_keyword,
    ACTIONS(1292), 1,
      anon_sym_LPAREN,
    ACTIONS(1294), 1,
      anon_sym_LBRACK,
    STATE(490), 1,
      sym__name,
    STATE(61), 3,
      sym__parameters,
      sym_parameters,
      sym_tuple_parameters,
    STATE(466), 9,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
      sym__identifier,
  [8465] = 12,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(45), 1,
      sym_symbol,
    ACTIONS(87), 1,
      anon_sym_SQUOTE,
    ACTIONS(89), 1,
      anon_sym_SEMI,
    ACTIONS(91), 1,
      anon_sym_TILDE,
    ACTIONS(93), 1,
      anon_sym_COMMA,
    ACTIONS(107), 1,
      sym_keyword,
    ACTIONS(1292), 1,
      anon_sym_LPAREN,
    ACTIONS(1294), 1,
      anon_sym_LBRACK,
    STATE(487), 1,
      sym__name,
    STATE(52), 3,
      sym__parameters,
      sym_parameters,
      sym_tuple_parameters,
    STATE(466), 9,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
      sym__identifier,
  [8512] = 12,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(45), 1,
      sym_symbol,
    ACTIONS(87), 1,
      anon_sym_SQUOTE,
    ACTIONS(89), 1,
      anon_sym_SEMI,
    ACTIONS(91), 1,
      anon_sym_TILDE,
    ACTIONS(93), 1,
      anon_sym_COMMA,
    ACTIONS(107), 1,
      sym_keyword,
    ACTIONS(1292), 1,
      anon_sym_LPAREN,
    ACTIONS(1294), 1,
      anon_sym_LBRACK,
    STATE(488), 1,
      sym__name,
    STATE(16), 3,
      sym__parameters,
      sym_parameters,
      sym_tuple_parameters,
    STATE(466), 9,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
      sym__identifier,
  [8559] = 13,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1027), 1,
      sym_symbol,
    ACTIONS(1032), 1,
      anon_sym_LBRACK,
    ACTIONS(1390), 1,
      anon_sym_LPAREN,
    ACTIONS(1393), 1,
      anon_sym_SQUOTE,
    ACTIONS(1396), 1,
      anon_sym_SEMI,
    ACTIONS(1399), 1,
      anon_sym_TILDE,
    ACTIONS(1402), 1,
      anon_sym_COMMA,
    ACTIONS(1408), 1,
      sym__long_str,
    STATE(485), 1,
      aux_sym_def_repeat1,
    STATE(516), 1,
      sym_metadata,
    ACTIONS(1405), 2,
      sym_str_literal,
      sym_keyword,
    STATE(524), 9,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
      sym_long_str_literal,
  [8608] = 10,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(45), 1,
      sym_symbol,
    ACTIONS(87), 1,
      anon_sym_SQUOTE,
    ACTIONS(89), 1,
      anon_sym_SEMI,
    ACTIONS(91), 1,
      anon_sym_TILDE,
    ACTIONS(93), 1,
      anon_sym_COMMA,
    ACTIONS(107), 1,
      sym_keyword,
    ACTIONS(1292), 1,
      anon_sym_LPAREN,
    ACTIONS(1294), 1,
      anon_sym_LBRACK,
    STATE(41), 12,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym__parameters,
      sym_parameters,
      sym_tuple_parameters,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
      sym__identifier,
  [8650] = 10,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(45), 1,
      sym_symbol,
    ACTIONS(87), 1,
      anon_sym_SQUOTE,
    ACTIONS(89), 1,
      anon_sym_SEMI,
    ACTIONS(91), 1,
      anon_sym_TILDE,
    ACTIONS(93), 1,
      anon_sym_COMMA,
    ACTIONS(107), 1,
      sym_keyword,
    ACTIONS(1292), 1,
      anon_sym_LPAREN,
    ACTIONS(1294), 1,
      anon_sym_LBRACK,
    STATE(48), 12,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym__parameters,
      sym_parameters,
      sym_tuple_parameters,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
      sym__identifier,
  [8692] = 10,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(45), 1,
      sym_symbol,
    ACTIONS(87), 1,
      anon_sym_SQUOTE,
    ACTIONS(89), 1,
      anon_sym_SEMI,
    ACTIONS(91), 1,
      anon_sym_TILDE,
    ACTIONS(93), 1,
      anon_sym_COMMA,
    ACTIONS(107), 1,
      sym_keyword,
    ACTIONS(1292), 1,
      anon_sym_LPAREN,
    ACTIONS(1294), 1,
      anon_sym_LBRACK,
    STATE(17), 12,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym__parameters,
      sym_parameters,
      sym_tuple_parameters,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
      sym__identifier,
  [8734] = 10,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(45), 1,
      sym_symbol,
    ACTIONS(87), 1,
      anon_sym_SQUOTE,
    ACTIONS(89), 1,
      anon_sym_SEMI,
    ACTIONS(91), 1,
      anon_sym_TILDE,
    ACTIONS(93), 1,
      anon_sym_COMMA,
    ACTIONS(107), 1,
      sym_keyword,
    ACTIONS(1292), 1,
      anon_sym_LPAREN,
    ACTIONS(1294), 1,
      anon_sym_LBRACK,
    STATE(28), 12,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym__parameters,
      sym_parameters,
      sym_tuple_parameters,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
      sym__identifier,
  [8776] = 10,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(45), 1,
      sym_symbol,
    ACTIONS(87), 1,
      anon_sym_SQUOTE,
    ACTIONS(89), 1,
      anon_sym_SEMI,
    ACTIONS(91), 1,
      anon_sym_TILDE,
    ACTIONS(93), 1,
      anon_sym_COMMA,
    ACTIONS(107), 1,
      sym_keyword,
    ACTIONS(1292), 1,
      anon_sym_LPAREN,
    ACTIONS(1294), 1,
      anon_sym_LBRACK,
    STATE(57), 12,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym__parameters,
      sym_parameters,
      sym_tuple_parameters,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
      sym__identifier,
  [8818] = 9,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(983), 1,
      sym_symbol,
    ACTIONS(997), 1,
      anon_sym_SQUOTE,
    ACTIONS(999), 1,
      anon_sym_SEMI,
    ACTIONS(1001), 1,
      anon_sym_TILDE,
    ACTIONS(1003), 1,
      anon_sym_COMMA,
    ACTIONS(1015), 1,
      sym_keyword,
    ACTIONS(1411), 1,
      anon_sym_LPAREN,
    STATE(367), 10,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
      sym__name,
      sym__identifier,
  [8855] = 9,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(983), 1,
      sym_symbol,
    ACTIONS(997), 1,
      anon_sym_SQUOTE,
    ACTIONS(999), 1,
      anon_sym_SEMI,
    ACTIONS(1001), 1,
      anon_sym_TILDE,
    ACTIONS(1003), 1,
      anon_sym_COMMA,
    ACTIONS(1015), 1,
      sym_keyword,
    ACTIONS(1411), 1,
      anon_sym_LPAREN,
    STATE(372), 10,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
      sym__name,
      sym__identifier,
  [8892] = 9,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(983), 1,
      sym_symbol,
    ACTIONS(997), 1,
      anon_sym_SQUOTE,
    ACTIONS(999), 1,
      anon_sym_SEMI,
    ACTIONS(1001), 1,
      anon_sym_TILDE,
    ACTIONS(1003), 1,
      anon_sym_COMMA,
    ACTIONS(1015), 1,
      sym_keyword,
    ACTIONS(1411), 1,
      anon_sym_LPAREN,
    STATE(370), 10,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
      sym__name,
      sym__identifier,
  [8929] = 9,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(983), 1,
      sym_symbol,
    ACTIONS(997), 1,
      anon_sym_SQUOTE,
    ACTIONS(999), 1,
      anon_sym_SEMI,
    ACTIONS(1001), 1,
      anon_sym_TILDE,
    ACTIONS(1003), 1,
      anon_sym_COMMA,
    ACTIONS(1015), 1,
      sym_keyword,
    ACTIONS(1411), 1,
      anon_sym_LPAREN,
    STATE(363), 10,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
      sym__name,
      sym__identifier,
  [8966] = 9,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(983), 1,
      sym_symbol,
    ACTIONS(997), 1,
      anon_sym_SQUOTE,
    ACTIONS(999), 1,
      anon_sym_SEMI,
    ACTIONS(1001), 1,
      anon_sym_TILDE,
    ACTIONS(1003), 1,
      anon_sym_COMMA,
    ACTIONS(1015), 1,
      sym_keyword,
    ACTIONS(1411), 1,
      anon_sym_LPAREN,
    STATE(364), 10,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
      sym__name,
      sym__identifier,
  [9003] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1112), 1,
      sym_symbol,
    ACTIONS(1114), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9021] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1152), 1,
      sym_symbol,
    ACTIONS(1154), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9039] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1084), 1,
      sym_symbol,
    ACTIONS(1086), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9057] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1088), 1,
      sym_symbol,
    ACTIONS(1090), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9075] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1092), 1,
      sym_symbol,
    ACTIONS(1094), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9093] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1136), 1,
      sym_symbol,
    ACTIONS(1138), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9111] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1140), 1,
      sym_symbol,
    ACTIONS(1142), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9129] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1144), 1,
      sym_symbol,
    ACTIONS(1146), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9147] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1148), 1,
      sym_symbol,
    ACTIONS(1150), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9165] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1156), 1,
      sym_symbol,
    ACTIONS(1158), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9183] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1160), 1,
      sym_symbol,
    ACTIONS(1162), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9201] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1164), 1,
      sym_symbol,
    ACTIONS(1166), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9219] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1244), 1,
      sym_symbol,
    ACTIONS(1246), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9237] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1060), 1,
      sym_symbol,
    ACTIONS(1062), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9255] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1064), 1,
      sym_symbol,
    ACTIONS(1066), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9273] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1072), 1,
      sym_symbol,
    ACTIONS(1074), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9291] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1076), 1,
      sym_symbol,
    ACTIONS(1078), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9309] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1096), 1,
      sym_symbol,
    ACTIONS(1098), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9327] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1100), 1,
      sym_symbol,
    ACTIONS(1102), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9345] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1104), 1,
      sym_symbol,
    ACTIONS(1106), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9363] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1386), 1,
      sym_symbol,
    ACTIONS(1388), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9381] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1108), 1,
      sym_symbol,
    ACTIONS(1110), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9399] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1252), 1,
      sym_symbol,
    ACTIONS(1254), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9417] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1116), 1,
      sym_symbol,
    ACTIONS(1118), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9435] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1120), 1,
      sym_symbol,
    ACTIONS(1122), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9453] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1124), 1,
      sym_symbol,
    ACTIONS(1126), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9471] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1128), 1,
      sym_symbol,
    ACTIONS(1130), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9489] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1132), 1,
      sym_symbol,
    ACTIONS(1134), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9507] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1342), 1,
      sym_symbol,
    ACTIONS(1344), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9525] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1168), 1,
      sym_symbol,
    ACTIONS(1170), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9543] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1208), 1,
      sym_symbol,
    ACTIONS(1210), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9561] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1080), 1,
      sym_symbol,
    ACTIONS(1082), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9579] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1232), 1,
      sym_symbol,
    ACTIONS(1234), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9597] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1172), 1,
      sym_symbol,
    ACTIONS(1174), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9615] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1176), 1,
      sym_symbol,
    ACTIONS(1178), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9633] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1180), 1,
      sym_symbol,
    ACTIONS(1182), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9651] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1184), 1,
      sym_symbol,
    ACTIONS(1186), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9669] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1188), 1,
      sym_symbol,
    ACTIONS(1190), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9687] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1192), 1,
      sym_symbol,
    ACTIONS(1194), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9705] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1056), 1,
      sym_symbol,
    ACTIONS(1058), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9723] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1196), 1,
      sym_symbol,
    ACTIONS(1198), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9741] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1200), 1,
      sym_symbol,
    ACTIONS(1202), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9759] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1204), 1,
      sym_symbol,
    ACTIONS(1206), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9777] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1236), 1,
      sym_symbol,
    ACTIONS(1238), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9795] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1212), 1,
      sym_symbol,
    ACTIONS(1214), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9813] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1216), 1,
      sym_symbol,
    ACTIONS(1218), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9831] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1220), 1,
      sym_symbol,
    ACTIONS(1222), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9849] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1256), 1,
      sym_symbol,
    ACTIONS(1258), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9867] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1224), 1,
      sym_symbol,
    ACTIONS(1226), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9885] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1228), 1,
      sym_symbol,
    ACTIONS(1230), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9903] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1240), 1,
      sym_symbol,
    ACTIONS(1242), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9921] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1052), 1,
      sym_symbol,
    ACTIONS(1054), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9939] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1248), 1,
      sym_symbol,
    ACTIONS(1250), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9957] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1288), 1,
      sym_symbol,
    ACTIONS(1290), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9975] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1284), 1,
      sym_symbol,
    ACTIONS(1286), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9993] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1280), 1,
      sym_symbol,
    ACTIONS(1282), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [10011] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1276), 1,
      sym_symbol,
    ACTIONS(1278), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [10029] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1272), 1,
      sym_symbol,
    ACTIONS(1274), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [10047] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1268), 1,
      sym_symbol,
    ACTIONS(1270), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [10065] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1264), 1,
      sym_symbol,
    ACTIONS(1266), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [10083] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1260), 1,
      sym_symbol,
    ACTIONS(1262), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [10101] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1413), 1,
      anon_sym_quote,
    ACTIONS(1415), 1,
      anon_sym_splice,
    ACTIONS(1417), 1,
      anon_sym_quasiquote,
    ACTIONS(1419), 1,
      anon_sym_unquote,
  [10117] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1421), 1,
      anon_sym_quote,
    ACTIONS(1423), 1,
      anon_sym_splice,
    ACTIONS(1425), 1,
      anon_sym_quasiquote,
    ACTIONS(1427), 1,
      anon_sym_unquote,
  [10133] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1282), 1,
      anon_sym_RPAREN,
  [10140] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1429), 1,
      anon_sym_RPAREN,
  [10147] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1431), 1,
      anon_sym_RPAREN,
  [10154] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1433), 1,
      anon_sym_RPAREN,
  [10161] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1435), 1,
      anon_sym_RPAREN,
  [10168] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1437), 1,
      anon_sym_RPAREN,
  [10175] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1439), 1,
      anon_sym_RPAREN,
  [10182] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1441), 1,
      anon_sym_RPAREN,
  [10189] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1443), 1,
      anon_sym_RPAREN,
  [10196] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1445), 1,
      anon_sym_RPAREN,
  [10203] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1447), 1,
      anon_sym_RPAREN,
  [10210] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1449), 1,
      anon_sym_RPAREN,
  [10217] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1451), 1,
      anon_sym_RPAREN,
  [10224] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1453), 1,
      anon_sym_RPAREN,
  [10231] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1455), 1,
      anon_sym_RPAREN,
  [10238] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1457), 1,
      anon_sym_RPAREN,
  [10245] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1459), 1,
      anon_sym_RPAREN,
  [10252] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1461), 1,
      anon_sym_RPAREN,
  [10259] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1463), 1,
      anon_sym_RPAREN,
  [10266] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1465), 1,
      anon_sym_RPAREN,
  [10273] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1467), 1,
      anon_sym_RPAREN,
  [10280] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1469), 1,
      anon_sym_RPAREN,
  [10287] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1471), 1,
      anon_sym_RPAREN,
  [10294] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1473), 1,
      anon_sym_RPAREN,
  [10301] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1475), 1,
      anon_sym_RPAREN,
  [10308] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1477), 1,
      anon_sym_RPAREN,
  [10315] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1479), 1,
      anon_sym_RPAREN,
  [10322] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1481), 1,
      anon_sym_RPAREN,
  [10329] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1483), 1,
      anon_sym_RPAREN,
  [10336] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1485), 1,
      anon_sym_RPAREN,
  [10343] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1487), 1,
      anon_sym_RPAREN,
  [10350] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1489), 1,
      anon_sym_RPAREN,
  [10357] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1491), 1,
      anon_sym_RPAREN,
  [10364] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1493), 1,
      anon_sym_RPAREN,
  [10371] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1495), 1,
      anon_sym_RPAREN,
  [10378] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1497), 1,
      anon_sym_RPAREN,
  [10385] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1499), 1,
      anon_sym_RPAREN,
  [10392] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1501), 1,
      anon_sym_RPAREN,
  [10399] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1503), 1,
      anon_sym_RPAREN,
  [10406] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1505), 1,
      anon_sym_RPAREN,
  [10413] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1507), 1,
      anon_sym_RPAREN,
  [10420] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1509), 1,
      anon_sym_RPAREN,
  [10427] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1078), 1,
      anon_sym_RPAREN,
  [10434] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1226), 1,
      anon_sym_RPAREN,
  [10441] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1222), 1,
      anon_sym_RPAREN,
  [10448] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1218), 1,
      anon_sym_RPAREN,
  [10455] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1214), 1,
      anon_sym_RPAREN,
  [10462] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1242), 1,
      anon_sym_RPAREN,
  [10469] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1206), 1,
      anon_sym_RPAREN,
  [10476] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1202), 1,
      anon_sym_RPAREN,
  [10483] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1198), 1,
      anon_sym_RPAREN,
  [10490] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1511), 1,
      anon_sym_RPAREN,
  [10497] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1058), 1,
      anon_sym_RPAREN,
  [10504] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1194), 1,
      anon_sym_RPAREN,
  [10511] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1190), 1,
      anon_sym_RPAREN,
  [10518] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1513), 1,
      anon_sym_RPAREN,
  [10525] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1515), 1,
      anon_sym_RPAREN,
  [10532] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1517), 1,
      anon_sym_RPAREN,
  [10539] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1519), 1,
      anon_sym_RPAREN,
  [10546] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1521), 1,
      anon_sym_RPAREN,
  [10553] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1523), 1,
      anon_sym_RPAREN,
  [10560] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1186), 1,
      anon_sym_RPAREN,
  [10567] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1182), 1,
      anon_sym_RPAREN,
  [10574] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1525), 1,
      anon_sym_RPAREN,
  [10581] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1527), 1,
      anon_sym_RPAREN,
  [10588] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1529), 1,
      anon_sym_RPAREN,
  [10595] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1531), 1,
      anon_sym_RPAREN,
  [10602] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1533), 1,
      anon_sym_RPAREN,
  [10609] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1535), 1,
      anon_sym_RPAREN,
  [10616] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1537), 1,
      anon_sym_RPAREN,
  [10623] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1178), 1,
      anon_sym_RPAREN,
  [10630] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1539), 1,
      anon_sym_RPAREN,
  [10637] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1541), 1,
      anon_sym_RPAREN,
  [10644] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1543), 1,
      anon_sym_RPAREN,
  [10651] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1545), 1,
      anon_sym_RPAREN,
  [10658] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1547), 1,
      anon_sym_RPAREN,
  [10665] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1549), 1,
      anon_sym_RPAREN,
  [10672] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1551), 1,
      anon_sym_RPAREN,
  [10679] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1553), 1,
      anon_sym_RPAREN,
  [10686] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1555), 1,
      anon_sym_RPAREN,
  [10693] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1557), 1,
      anon_sym_RPAREN,
  [10700] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1559), 1,
      anon_sym_RPAREN,
  [10707] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1561), 1,
      anon_sym_RPAREN,
  [10714] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1174), 1,
      anon_sym_RPAREN,
  [10721] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1054), 1,
      anon_sym_RPAREN,
  [10728] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1563), 1,
      anon_sym_RPAREN,
  [10735] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1250), 1,
      anon_sym_RPAREN,
  [10742] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1254), 1,
      anon_sym_RPAREN,
  [10749] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1565), 1,
      anon_sym_RPAREN,
  [10756] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1567), 1,
      anon_sym_RPAREN,
  [10763] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1569), 1,
      anon_sym_RPAREN,
  [10770] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1571), 1,
      anon_sym_RPAREN,
  [10777] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1573), 1,
      anon_sym_RPAREN,
  [10784] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1258), 1,
      anon_sym_RPAREN,
  [10791] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1154), 1,
      anon_sym_RPAREN,
  [10798] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1575), 1,
      anon_sym_RPAREN,
  [10805] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1577), 1,
      anon_sym_RPAREN,
  [10812] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1579), 1,
      anon_sym_RPAREN,
  [10819] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1581), 1,
      anon_sym_RPAREN,
  [10826] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1583), 1,
      anon_sym_RPAREN,
  [10833] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1585), 1,
      anon_sym_RPAREN,
  [10840] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1587), 1,
      anon_sym_RPAREN,
  [10847] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1589), 1,
      anon_sym_RPAREN,
  [10854] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1591), 1,
      anon_sym_RPAREN,
  [10861] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1593), 1,
      anon_sym_RPAREN,
  [10868] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1262), 1,
      anon_sym_RPAREN,
  [10875] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1595), 1,
      anon_sym_RPAREN,
  [10882] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1266), 1,
      anon_sym_RPAREN,
  [10889] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1270), 1,
      anon_sym_RPAREN,
  [10896] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1597), 1,
      anon_sym_RPAREN,
  [10903] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1274), 1,
      anon_sym_RPAREN,
  [10910] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1134), 1,
      anon_sym_RPAREN,
  [10917] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1130), 1,
      anon_sym_RPAREN,
  [10924] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1126), 1,
      anon_sym_RPAREN,
  [10931] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1122), 1,
      anon_sym_RPAREN,
  [10938] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1118), 1,
      anon_sym_RPAREN,
  [10945] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1114), 1,
      anon_sym_RPAREN,
  [10952] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1110), 1,
      anon_sym_RPAREN,
  [10959] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1106), 1,
      anon_sym_RPAREN,
  [10966] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1102), 1,
      anon_sym_RPAREN,
  [10973] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1098), 1,
      anon_sym_RPAREN,
  [10980] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1278), 1,
      anon_sym_RPAREN,
  [10987] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1286), 1,
      anon_sym_RPAREN,
  [10994] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1290), 1,
      anon_sym_RPAREN,
  [11001] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1230), 1,
      anon_sym_RPAREN,
  [11008] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1074), 1,
      anon_sym_RPAREN,
  [11015] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1066), 1,
      anon_sym_RPAREN,
  [11022] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1062), 1,
      anon_sym_RPAREN,
  [11029] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1246), 1,
      anon_sym_RPAREN,
  [11036] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1166), 1,
      anon_sym_RPAREN,
  [11043] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1162), 1,
      anon_sym_RPAREN,
  [11050] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1158), 1,
      anon_sym_RPAREN,
  [11057] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1150), 1,
      anon_sym_RPAREN,
  [11064] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1146), 1,
      anon_sym_RPAREN,
  [11071] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1142), 1,
      anon_sym_RPAREN,
  [11078] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1138), 1,
      anon_sym_RPAREN,
  [11085] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1094), 1,
      anon_sym_RPAREN,
  [11092] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1599), 1,
      ts_builtin_sym_end,
  [11099] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1090), 1,
      anon_sym_RPAREN,
  [11106] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1086), 1,
      anon_sym_RPAREN,
  [11113] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1082), 1,
      anon_sym_RPAREN,
  [11120] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1170), 1,
      anon_sym_RPAREN,
  [11127] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1210), 1,
      anon_sym_RPAREN,
  [11134] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1234), 1,
      anon_sym_RPAREN,
  [11141] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1238), 1,
      anon_sym_RPAREN,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(242)] = 0,
  [SMALL_STATE(243)] = 62,
  [SMALL_STATE(244)] = 98,
  [SMALL_STATE(245)] = 134,
  [SMALL_STATE(246)] = 170,
  [SMALL_STATE(247)] = 206,
  [SMALL_STATE(248)] = 242,
  [SMALL_STATE(249)] = 278,
  [SMALL_STATE(250)] = 314,
  [SMALL_STATE(251)] = 350,
  [SMALL_STATE(252)] = 386,
  [SMALL_STATE(253)] = 422,
  [SMALL_STATE(254)] = 458,
  [SMALL_STATE(255)] = 494,
  [SMALL_STATE(256)] = 530,
  [SMALL_STATE(257)] = 566,
  [SMALL_STATE(258)] = 602,
  [SMALL_STATE(259)] = 638,
  [SMALL_STATE(260)] = 674,
  [SMALL_STATE(261)] = 710,
  [SMALL_STATE(262)] = 746,
  [SMALL_STATE(263)] = 782,
  [SMALL_STATE(264)] = 818,
  [SMALL_STATE(265)] = 854,
  [SMALL_STATE(266)] = 890,
  [SMALL_STATE(267)] = 926,
  [SMALL_STATE(268)] = 962,
  [SMALL_STATE(269)] = 998,
  [SMALL_STATE(270)] = 1034,
  [SMALL_STATE(271)] = 1070,
  [SMALL_STATE(272)] = 1106,
  [SMALL_STATE(273)] = 1142,
  [SMALL_STATE(274)] = 1178,
  [SMALL_STATE(275)] = 1214,
  [SMALL_STATE(276)] = 1250,
  [SMALL_STATE(277)] = 1286,
  [SMALL_STATE(278)] = 1322,
  [SMALL_STATE(279)] = 1358,
  [SMALL_STATE(280)] = 1394,
  [SMALL_STATE(281)] = 1430,
  [SMALL_STATE(282)] = 1466,
  [SMALL_STATE(283)] = 1502,
  [SMALL_STATE(284)] = 1538,
  [SMALL_STATE(285)] = 1574,
  [SMALL_STATE(286)] = 1610,
  [SMALL_STATE(287)] = 1646,
  [SMALL_STATE(288)] = 1682,
  [SMALL_STATE(289)] = 1718,
  [SMALL_STATE(290)] = 1754,
  [SMALL_STATE(291)] = 1790,
  [SMALL_STATE(292)] = 1826,
  [SMALL_STATE(293)] = 1862,
  [SMALL_STATE(294)] = 1898,
  [SMALL_STATE(295)] = 1934,
  [SMALL_STATE(296)] = 1970,
  [SMALL_STATE(297)] = 2006,
  [SMALL_STATE(298)] = 2042,
  [SMALL_STATE(299)] = 2078,
  [SMALL_STATE(300)] = 2114,
  [SMALL_STATE(301)] = 2150,
  [SMALL_STATE(302)] = 2186,
  [SMALL_STATE(303)] = 2222,
  [SMALL_STATE(304)] = 2256,
  [SMALL_STATE(305)] = 2290,
  [SMALL_STATE(306)] = 2324,
  [SMALL_STATE(307)] = 2358,
  [SMALL_STATE(308)] = 2392,
  [SMALL_STATE(309)] = 2426,
  [SMALL_STATE(310)] = 2460,
  [SMALL_STATE(311)] = 2494,
  [SMALL_STATE(312)] = 2528,
  [SMALL_STATE(313)] = 2562,
  [SMALL_STATE(314)] = 2596,
  [SMALL_STATE(315)] = 2630,
  [SMALL_STATE(316)] = 2664,
  [SMALL_STATE(317)] = 2698,
  [SMALL_STATE(318)] = 2732,
  [SMALL_STATE(319)] = 2766,
  [SMALL_STATE(320)] = 2800,
  [SMALL_STATE(321)] = 2834,
  [SMALL_STATE(322)] = 2868,
  [SMALL_STATE(323)] = 2902,
  [SMALL_STATE(324)] = 2936,
  [SMALL_STATE(325)] = 2970,
  [SMALL_STATE(326)] = 3004,
  [SMALL_STATE(327)] = 3038,
  [SMALL_STATE(328)] = 3072,
  [SMALL_STATE(329)] = 3106,
  [SMALL_STATE(330)] = 3140,
  [SMALL_STATE(331)] = 3174,
  [SMALL_STATE(332)] = 3208,
  [SMALL_STATE(333)] = 3242,
  [SMALL_STATE(334)] = 3276,
  [SMALL_STATE(335)] = 3310,
  [SMALL_STATE(336)] = 3344,
  [SMALL_STATE(337)] = 3378,
  [SMALL_STATE(338)] = 3412,
  [SMALL_STATE(339)] = 3446,
  [SMALL_STATE(340)] = 3480,
  [SMALL_STATE(341)] = 3514,
  [SMALL_STATE(342)] = 3548,
  [SMALL_STATE(343)] = 3582,
  [SMALL_STATE(344)] = 3616,
  [SMALL_STATE(345)] = 3650,
  [SMALL_STATE(346)] = 3684,
  [SMALL_STATE(347)] = 3718,
  [SMALL_STATE(348)] = 3752,
  [SMALL_STATE(349)] = 3786,
  [SMALL_STATE(350)] = 3820,
  [SMALL_STATE(351)] = 3854,
  [SMALL_STATE(352)] = 3888,
  [SMALL_STATE(353)] = 3922,
  [SMALL_STATE(354)] = 3956,
  [SMALL_STATE(355)] = 3990,
  [SMALL_STATE(356)] = 4024,
  [SMALL_STATE(357)] = 4058,
  [SMALL_STATE(358)] = 4092,
  [SMALL_STATE(359)] = 4126,
  [SMALL_STATE(360)] = 4160,
  [SMALL_STATE(361)] = 4194,
  [SMALL_STATE(362)] = 4228,
  [SMALL_STATE(363)] = 4261,
  [SMALL_STATE(364)] = 4320,
  [SMALL_STATE(365)] = 4379,
  [SMALL_STATE(366)] = 4438,
  [SMALL_STATE(367)] = 4497,
  [SMALL_STATE(368)] = 4556,
  [SMALL_STATE(369)] = 4589,
  [SMALL_STATE(370)] = 4648,
  [SMALL_STATE(371)] = 4707,
  [SMALL_STATE(372)] = 4766,
  [SMALL_STATE(373)] = 4825,
  [SMALL_STATE(374)] = 4884,
  [SMALL_STATE(375)] = 4916,
  [SMALL_STATE(376)] = 4948,
  [SMALL_STATE(377)] = 4980,
  [SMALL_STATE(378)] = 5012,
  [SMALL_STATE(379)] = 5044,
  [SMALL_STATE(380)] = 5076,
  [SMALL_STATE(381)] = 5108,
  [SMALL_STATE(382)] = 5140,
  [SMALL_STATE(383)] = 5172,
  [SMALL_STATE(384)] = 5204,
  [SMALL_STATE(385)] = 5236,
  [SMALL_STATE(386)] = 5268,
  [SMALL_STATE(387)] = 5300,
  [SMALL_STATE(388)] = 5332,
  [SMALL_STATE(389)] = 5364,
  [SMALL_STATE(390)] = 5396,
  [SMALL_STATE(391)] = 5430,
  [SMALL_STATE(392)] = 5464,
  [SMALL_STATE(393)] = 5496,
  [SMALL_STATE(394)] = 5528,
  [SMALL_STATE(395)] = 5562,
  [SMALL_STATE(396)] = 5594,
  [SMALL_STATE(397)] = 5626,
  [SMALL_STATE(398)] = 5658,
  [SMALL_STATE(399)] = 5690,
  [SMALL_STATE(400)] = 5722,
  [SMALL_STATE(401)] = 5754,
  [SMALL_STATE(402)] = 5786,
  [SMALL_STATE(403)] = 5818,
  [SMALL_STATE(404)] = 5850,
  [SMALL_STATE(405)] = 5882,
  [SMALL_STATE(406)] = 5914,
  [SMALL_STATE(407)] = 5946,
  [SMALL_STATE(408)] = 5978,
  [SMALL_STATE(409)] = 6010,
  [SMALL_STATE(410)] = 6042,
  [SMALL_STATE(411)] = 6074,
  [SMALL_STATE(412)] = 6106,
  [SMALL_STATE(413)] = 6138,
  [SMALL_STATE(414)] = 6170,
  [SMALL_STATE(415)] = 6202,
  [SMALL_STATE(416)] = 6234,
  [SMALL_STATE(417)] = 6266,
  [SMALL_STATE(418)] = 6298,
  [SMALL_STATE(419)] = 6330,
  [SMALL_STATE(420)] = 6366,
  [SMALL_STATE(421)] = 6398,
  [SMALL_STATE(422)] = 6430,
  [SMALL_STATE(423)] = 6464,
  [SMALL_STATE(424)] = 6498,
  [SMALL_STATE(425)] = 6532,
  [SMALL_STATE(426)] = 6564,
  [SMALL_STATE(427)] = 6600,
  [SMALL_STATE(428)] = 6632,
  [SMALL_STATE(429)] = 6664,
  [SMALL_STATE(430)] = 6696,
  [SMALL_STATE(431)] = 6728,
  [SMALL_STATE(432)] = 6760,
  [SMALL_STATE(433)] = 6792,
  [SMALL_STATE(434)] = 6824,
  [SMALL_STATE(435)] = 6856,
  [SMALL_STATE(436)] = 6888,
  [SMALL_STATE(437)] = 6920,
  [SMALL_STATE(438)] = 6952,
  [SMALL_STATE(439)] = 6984,
  [SMALL_STATE(440)] = 7016,
  [SMALL_STATE(441)] = 7050,
  [SMALL_STATE(442)] = 7084,
  [SMALL_STATE(443)] = 7118,
  [SMALL_STATE(444)] = 7152,
  [SMALL_STATE(445)] = 7186,
  [SMALL_STATE(446)] = 7220,
  [SMALL_STATE(447)] = 7254,
  [SMALL_STATE(448)] = 7286,
  [SMALL_STATE(449)] = 7318,
  [SMALL_STATE(450)] = 7350,
  [SMALL_STATE(451)] = 7382,
  [SMALL_STATE(452)] = 7414,
  [SMALL_STATE(453)] = 7446,
  [SMALL_STATE(454)] = 7478,
  [SMALL_STATE(455)] = 7510,
  [SMALL_STATE(456)] = 7542,
  [SMALL_STATE(457)] = 7574,
  [SMALL_STATE(458)] = 7606,
  [SMALL_STATE(459)] = 7638,
  [SMALL_STATE(460)] = 7670,
  [SMALL_STATE(461)] = 7702,
  [SMALL_STATE(462)] = 7734,
  [SMALL_STATE(463)] = 7766,
  [SMALL_STATE(464)] = 7798,
  [SMALL_STATE(465)] = 7832,
  [SMALL_STATE(466)] = 7866,
  [SMALL_STATE(467)] = 7902,
  [SMALL_STATE(468)] = 7936,
  [SMALL_STATE(469)] = 7968,
  [SMALL_STATE(470)] = 8000,
  [SMALL_STATE(471)] = 8032,
  [SMALL_STATE(472)] = 8064,
  [SMALL_STATE(473)] = 8096,
  [SMALL_STATE(474)] = 8130,
  [SMALL_STATE(475)] = 8164,
  [SMALL_STATE(476)] = 8198,
  [SMALL_STATE(477)] = 8230,
  [SMALL_STATE(478)] = 8262,
  [SMALL_STATE(479)] = 8293,
  [SMALL_STATE(480)] = 8324,
  [SMALL_STATE(481)] = 8371,
  [SMALL_STATE(482)] = 8418,
  [SMALL_STATE(483)] = 8465,
  [SMALL_STATE(484)] = 8512,
  [SMALL_STATE(485)] = 8559,
  [SMALL_STATE(486)] = 8608,
  [SMALL_STATE(487)] = 8650,
  [SMALL_STATE(488)] = 8692,
  [SMALL_STATE(489)] = 8734,
  [SMALL_STATE(490)] = 8776,
  [SMALL_STATE(491)] = 8818,
  [SMALL_STATE(492)] = 8855,
  [SMALL_STATE(493)] = 8892,
  [SMALL_STATE(494)] = 8929,
  [SMALL_STATE(495)] = 8966,
  [SMALL_STATE(496)] = 9003,
  [SMALL_STATE(497)] = 9021,
  [SMALL_STATE(498)] = 9039,
  [SMALL_STATE(499)] = 9057,
  [SMALL_STATE(500)] = 9075,
  [SMALL_STATE(501)] = 9093,
  [SMALL_STATE(502)] = 9111,
  [SMALL_STATE(503)] = 9129,
  [SMALL_STATE(504)] = 9147,
  [SMALL_STATE(505)] = 9165,
  [SMALL_STATE(506)] = 9183,
  [SMALL_STATE(507)] = 9201,
  [SMALL_STATE(508)] = 9219,
  [SMALL_STATE(509)] = 9237,
  [SMALL_STATE(510)] = 9255,
  [SMALL_STATE(511)] = 9273,
  [SMALL_STATE(512)] = 9291,
  [SMALL_STATE(513)] = 9309,
  [SMALL_STATE(514)] = 9327,
  [SMALL_STATE(515)] = 9345,
  [SMALL_STATE(516)] = 9363,
  [SMALL_STATE(517)] = 9381,
  [SMALL_STATE(518)] = 9399,
  [SMALL_STATE(519)] = 9417,
  [SMALL_STATE(520)] = 9435,
  [SMALL_STATE(521)] = 9453,
  [SMALL_STATE(522)] = 9471,
  [SMALL_STATE(523)] = 9489,
  [SMALL_STATE(524)] = 9507,
  [SMALL_STATE(525)] = 9525,
  [SMALL_STATE(526)] = 9543,
  [SMALL_STATE(527)] = 9561,
  [SMALL_STATE(528)] = 9579,
  [SMALL_STATE(529)] = 9597,
  [SMALL_STATE(530)] = 9615,
  [SMALL_STATE(531)] = 9633,
  [SMALL_STATE(532)] = 9651,
  [SMALL_STATE(533)] = 9669,
  [SMALL_STATE(534)] = 9687,
  [SMALL_STATE(535)] = 9705,
  [SMALL_STATE(536)] = 9723,
  [SMALL_STATE(537)] = 9741,
  [SMALL_STATE(538)] = 9759,
  [SMALL_STATE(539)] = 9777,
  [SMALL_STATE(540)] = 9795,
  [SMALL_STATE(541)] = 9813,
  [SMALL_STATE(542)] = 9831,
  [SMALL_STATE(543)] = 9849,
  [SMALL_STATE(544)] = 9867,
  [SMALL_STATE(545)] = 9885,
  [SMALL_STATE(546)] = 9903,
  [SMALL_STATE(547)] = 9921,
  [SMALL_STATE(548)] = 9939,
  [SMALL_STATE(549)] = 9957,
  [SMALL_STATE(550)] = 9975,
  [SMALL_STATE(551)] = 9993,
  [SMALL_STATE(552)] = 10011,
  [SMALL_STATE(553)] = 10029,
  [SMALL_STATE(554)] = 10047,
  [SMALL_STATE(555)] = 10065,
  [SMALL_STATE(556)] = 10083,
  [SMALL_STATE(557)] = 10101,
  [SMALL_STATE(558)] = 10117,
  [SMALL_STATE(559)] = 10133,
  [SMALL_STATE(560)] = 10140,
  [SMALL_STATE(561)] = 10147,
  [SMALL_STATE(562)] = 10154,
  [SMALL_STATE(563)] = 10161,
  [SMALL_STATE(564)] = 10168,
  [SMALL_STATE(565)] = 10175,
  [SMALL_STATE(566)] = 10182,
  [SMALL_STATE(567)] = 10189,
  [SMALL_STATE(568)] = 10196,
  [SMALL_STATE(569)] = 10203,
  [SMALL_STATE(570)] = 10210,
  [SMALL_STATE(571)] = 10217,
  [SMALL_STATE(572)] = 10224,
  [SMALL_STATE(573)] = 10231,
  [SMALL_STATE(574)] = 10238,
  [SMALL_STATE(575)] = 10245,
  [SMALL_STATE(576)] = 10252,
  [SMALL_STATE(577)] = 10259,
  [SMALL_STATE(578)] = 10266,
  [SMALL_STATE(579)] = 10273,
  [SMALL_STATE(580)] = 10280,
  [SMALL_STATE(581)] = 10287,
  [SMALL_STATE(582)] = 10294,
  [SMALL_STATE(583)] = 10301,
  [SMALL_STATE(584)] = 10308,
  [SMALL_STATE(585)] = 10315,
  [SMALL_STATE(586)] = 10322,
  [SMALL_STATE(587)] = 10329,
  [SMALL_STATE(588)] = 10336,
  [SMALL_STATE(589)] = 10343,
  [SMALL_STATE(590)] = 10350,
  [SMALL_STATE(591)] = 10357,
  [SMALL_STATE(592)] = 10364,
  [SMALL_STATE(593)] = 10371,
  [SMALL_STATE(594)] = 10378,
  [SMALL_STATE(595)] = 10385,
  [SMALL_STATE(596)] = 10392,
  [SMALL_STATE(597)] = 10399,
  [SMALL_STATE(598)] = 10406,
  [SMALL_STATE(599)] = 10413,
  [SMALL_STATE(600)] = 10420,
  [SMALL_STATE(601)] = 10427,
  [SMALL_STATE(602)] = 10434,
  [SMALL_STATE(603)] = 10441,
  [SMALL_STATE(604)] = 10448,
  [SMALL_STATE(605)] = 10455,
  [SMALL_STATE(606)] = 10462,
  [SMALL_STATE(607)] = 10469,
  [SMALL_STATE(608)] = 10476,
  [SMALL_STATE(609)] = 10483,
  [SMALL_STATE(610)] = 10490,
  [SMALL_STATE(611)] = 10497,
  [SMALL_STATE(612)] = 10504,
  [SMALL_STATE(613)] = 10511,
  [SMALL_STATE(614)] = 10518,
  [SMALL_STATE(615)] = 10525,
  [SMALL_STATE(616)] = 10532,
  [SMALL_STATE(617)] = 10539,
  [SMALL_STATE(618)] = 10546,
  [SMALL_STATE(619)] = 10553,
  [SMALL_STATE(620)] = 10560,
  [SMALL_STATE(621)] = 10567,
  [SMALL_STATE(622)] = 10574,
  [SMALL_STATE(623)] = 10581,
  [SMALL_STATE(624)] = 10588,
  [SMALL_STATE(625)] = 10595,
  [SMALL_STATE(626)] = 10602,
  [SMALL_STATE(627)] = 10609,
  [SMALL_STATE(628)] = 10616,
  [SMALL_STATE(629)] = 10623,
  [SMALL_STATE(630)] = 10630,
  [SMALL_STATE(631)] = 10637,
  [SMALL_STATE(632)] = 10644,
  [SMALL_STATE(633)] = 10651,
  [SMALL_STATE(634)] = 10658,
  [SMALL_STATE(635)] = 10665,
  [SMALL_STATE(636)] = 10672,
  [SMALL_STATE(637)] = 10679,
  [SMALL_STATE(638)] = 10686,
  [SMALL_STATE(639)] = 10693,
  [SMALL_STATE(640)] = 10700,
  [SMALL_STATE(641)] = 10707,
  [SMALL_STATE(642)] = 10714,
  [SMALL_STATE(643)] = 10721,
  [SMALL_STATE(644)] = 10728,
  [SMALL_STATE(645)] = 10735,
  [SMALL_STATE(646)] = 10742,
  [SMALL_STATE(647)] = 10749,
  [SMALL_STATE(648)] = 10756,
  [SMALL_STATE(649)] = 10763,
  [SMALL_STATE(650)] = 10770,
  [SMALL_STATE(651)] = 10777,
  [SMALL_STATE(652)] = 10784,
  [SMALL_STATE(653)] = 10791,
  [SMALL_STATE(654)] = 10798,
  [SMALL_STATE(655)] = 10805,
  [SMALL_STATE(656)] = 10812,
  [SMALL_STATE(657)] = 10819,
  [SMALL_STATE(658)] = 10826,
  [SMALL_STATE(659)] = 10833,
  [SMALL_STATE(660)] = 10840,
  [SMALL_STATE(661)] = 10847,
  [SMALL_STATE(662)] = 10854,
  [SMALL_STATE(663)] = 10861,
  [SMALL_STATE(664)] = 10868,
  [SMALL_STATE(665)] = 10875,
  [SMALL_STATE(666)] = 10882,
  [SMALL_STATE(667)] = 10889,
  [SMALL_STATE(668)] = 10896,
  [SMALL_STATE(669)] = 10903,
  [SMALL_STATE(670)] = 10910,
  [SMALL_STATE(671)] = 10917,
  [SMALL_STATE(672)] = 10924,
  [SMALL_STATE(673)] = 10931,
  [SMALL_STATE(674)] = 10938,
  [SMALL_STATE(675)] = 10945,
  [SMALL_STATE(676)] = 10952,
  [SMALL_STATE(677)] = 10959,
  [SMALL_STATE(678)] = 10966,
  [SMALL_STATE(679)] = 10973,
  [SMALL_STATE(680)] = 10980,
  [SMALL_STATE(681)] = 10987,
  [SMALL_STATE(682)] = 10994,
  [SMALL_STATE(683)] = 11001,
  [SMALL_STATE(684)] = 11008,
  [SMALL_STATE(685)] = 11015,
  [SMALL_STATE(686)] = 11022,
  [SMALL_STATE(687)] = 11029,
  [SMALL_STATE(688)] = 11036,
  [SMALL_STATE(689)] = 11043,
  [SMALL_STATE(690)] = 11050,
  [SMALL_STATE(691)] = 11057,
  [SMALL_STATE(692)] = 11064,
  [SMALL_STATE(693)] = 11071,
  [SMALL_STATE(694)] = 11078,
  [SMALL_STATE(695)] = 11085,
  [SMALL_STATE(696)] = 11092,
  [SMALL_STATE(697)] = 11099,
  [SMALL_STATE(698)] = 11106,
  [SMALL_STATE(699)] = 11113,
  [SMALL_STATE(700)] = 11120,
  [SMALL_STATE(701)] = 11127,
  [SMALL_STATE(702)] = 11134,
  [SMALL_STATE(703)] = 11141,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 0),
  [7] = {.entry = {.count = 1, .reusable = false}}, SHIFT(396),
  [9] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3),
  [11] = {.entry = {.count = 1, .reusable = true}}, SHIFT(72),
  [13] = {.entry = {.count = 1, .reusable = true}}, SHIFT(76),
  [15] = {.entry = {.count = 1, .reusable = true}}, SHIFT(77),
  [17] = {.entry = {.count = 1, .reusable = true}}, SHIFT(49),
  [19] = {.entry = {.count = 1, .reusable = true}}, SHIFT(44),
  [21] = {.entry = {.count = 1, .reusable = true}}, SHIFT(182),
  [23] = {.entry = {.count = 1, .reusable = true}}, SHIFT(216),
  [25] = {.entry = {.count = 1, .reusable = true}}, SHIFT(217),
  [27] = {.entry = {.count = 1, .reusable = true}}, SHIFT(218),
  [29] = {.entry = {.count = 1, .reusable = true}}, SHIFT(221),
  [31] = {.entry = {.count = 1, .reusable = true}}, SHIFT(392),
  [33] = {.entry = {.count = 1, .reusable = false}}, SHIFT(393),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(395),
  [37] = {.entry = {.count = 1, .reusable = false}}, SHIFT(392),
  [39] = {.entry = {.count = 1, .reusable = true}}, SHIFT(396),
  [41] = {.entry = {.count = 1, .reusable = true}}, SHIFT(420),
  [43] = {.entry = {.count = 1, .reusable = true}}, SHIFT(389),
  [45] = {.entry = {.count = 1, .reusable = false}}, SHIFT(319),
  [47] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2),
  [49] = {.entry = {.count = 1, .reusable = true}}, SHIFT(309),
  [51] = {.entry = {.count = 1, .reusable = true}}, SHIFT(69),
  [53] = {.entry = {.count = 1, .reusable = true}}, SHIFT(70),
  [55] = {.entry = {.count = 1, .reusable = true}}, SHIFT(71),
  [57] = {.entry = {.count = 1, .reusable = true}}, SHIFT(39),
  [59] = {.entry = {.count = 1, .reusable = true}}, SHIFT(62),
  [61] = {.entry = {.count = 1, .reusable = false}}, SHIFT(233),
  [63] = {.entry = {.count = 1, .reusable = false}}, SHIFT(188),
  [65] = {.entry = {.count = 1, .reusable = false}}, SHIFT(191),
  [67] = {.entry = {.count = 1, .reusable = false}}, SHIFT(171),
  [69] = {.entry = {.count = 1, .reusable = false}}, SHIFT(170),
  [71] = {.entry = {.count = 1, .reusable = false}}, SHIFT(168),
  [73] = {.entry = {.count = 1, .reusable = false}}, SHIFT(167),
  [75] = {.entry = {.count = 1, .reusable = false}}, SHIFT(151),
  [77] = {.entry = {.count = 1, .reusable = false}}, SHIFT(219),
  [79] = {.entry = {.count = 1, .reusable = false}}, SHIFT(58),
  [81] = {.entry = {.count = 1, .reusable = false}}, SHIFT(234),
  [83] = {.entry = {.count = 1, .reusable = false}}, SHIFT(484),
  [85] = {.entry = {.count = 1, .reusable = false}}, SHIFT(54),
  [87] = {.entry = {.count = 1, .reusable = true}}, SHIFT(194),
  [89] = {.entry = {.count = 1, .reusable = true}}, SHIFT(195),
  [91] = {.entry = {.count = 1, .reusable = true}}, SHIFT(181),
  [93] = {.entry = {.count = 1, .reusable = true}}, SHIFT(197),
  [95] = {.entry = {.count = 1, .reusable = true}}, SHIFT(198),
  [97] = {.entry = {.count = 1, .reusable = false}}, SHIFT(494),
  [99] = {.entry = {.count = 1, .reusable = true}}, SHIFT(322),
  [101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(321),
  [103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(320),
  [105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(322),
  [107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(319),
  [109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(328),
  [111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(323),
  [113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(417),
  [115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(187),
  [117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(186),
  [119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(185),
  [121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(164),
  [123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(172),
  [125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(152),
  [127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(180),
  [129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(174),
  [131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(183),
  [133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(35),
  [135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(212),
  [137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(483),
  [139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(38),
  [141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(495),
  [143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(534),
  [145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(204),
  [147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(222),
  [149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(202),
  [151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(179),
  [153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(178),
  [155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(177),
  [157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(176),
  [159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(158),
  [161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(184),
  [163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(64),
  [165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(203),
  [167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(482),
  [169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(59),
  [171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(491),
  [173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(278),
  [175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(215),
  [177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(228),
  [179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(224),
  [181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(163),
  [183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(162),
  [185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(161),
  [187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(159),
  [189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(175),
  [191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(223),
  [193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13),
  [195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(214),
  [197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(480),
  [199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(34),
  [201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(492),
  [203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(612),
  [205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(196),
  [207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(241),
  [209] = {.entry = {.count = 1, .reusable = false}}, SHIFT(240),
  [211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(153),
  [213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(229),
  [215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(22),
  [217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(227),
  [219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(481),
  [221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(23),
  [223] = {.entry = {.count = 1, .reusable = false}}, SHIFT(493),
  [225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(165),
  [227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(160),
  [229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(155),
  [231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(154),
  [233] = {.entry = {.count = 1, .reusable = false}}, SHIFT(290),
  [235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5),
  [237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(429),
  [239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(130),
  [241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(67),
  [243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(139),
  [245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(31),
  [247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(32),
  [249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(124),
  [251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(192),
  [253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(193),
  [255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(199),
  [257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(200),
  [259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(232),
  [261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(285),
  [263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(284),
  [265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(283),
  [267] = {.entry = {.count = 1, .reusable = false}}, SHIFT(285),
  [269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(290),
  [271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(287),
  [273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(286),
  [275] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 23), SHIFT_REPEAT(290),
  [278] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 23), SHIFT_REPEAT(5),
  [281] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 23),
  [283] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 23), SHIFT_REPEAT(130),
  [286] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 23), SHIFT_REPEAT(67),
  [289] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 23), SHIFT_REPEAT(139),
  [292] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 23), SHIFT_REPEAT(31),
  [295] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 23), SHIFT_REPEAT(32),
  [298] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 23),
  [300] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 23), SHIFT_REPEAT(192),
  [303] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 23), SHIFT_REPEAT(193),
  [306] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 23), SHIFT_REPEAT(199),
  [309] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 23), SHIFT_REPEAT(200),
  [312] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 23), SHIFT_REPEAT(232),
  [315] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 23), SHIFT_REPEAT(285),
  [318] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 23), SHIFT_REPEAT(284),
  [321] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 23), SHIFT_REPEAT(283),
  [324] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 23), SHIFT_REPEAT(285),
  [327] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 23), SHIFT_REPEAT(290),
  [330] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 23), SHIFT_REPEAT(287),
  [333] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 23), SHIFT_REPEAT(286),
  [336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(397),
  [338] = {.entry = {.count = 1, .reusable = false}}, SHIFT(109),
  [340] = {.entry = {.count = 1, .reusable = false}}, SHIFT(111),
  [342] = {.entry = {.count = 1, .reusable = false}}, SHIFT(119),
  [344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(375),
  [346] = {.entry = {.count = 1, .reusable = false}}, SHIFT(148),
  [348] = {.entry = {.count = 1, .reusable = false}}, SHIFT(149),
  [350] = {.entry = {.count = 1, .reusable = false}}, SHIFT(150),
  [352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(428),
  [354] = {.entry = {.count = 1, .reusable = false}}, SHIFT(127),
  [356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(262),
  [358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(245),
  [360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(345),
  [362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(357),
  [364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(332),
  [366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(340),
  [368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(359),
  [370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(629),
  [372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(642),
  [374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(671),
  [376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(672),
  [378] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 23), SHIFT_REPEAT(319),
  [381] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 23), SHIFT_REPEAT(2),
  [384] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 23), SHIFT_REPEAT(69),
  [387] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 23), SHIFT_REPEAT(70),
  [390] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 23), SHIFT_REPEAT(71),
  [393] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 23), SHIFT_REPEAT(39),
  [396] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 23), SHIFT_REPEAT(62),
  [399] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 23), SHIFT_REPEAT(194),
  [402] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 23), SHIFT_REPEAT(195),
  [405] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 23), SHIFT_REPEAT(181),
  [408] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 23), SHIFT_REPEAT(197),
  [411] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 23), SHIFT_REPEAT(198),
  [414] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 23), SHIFT_REPEAT(322),
  [417] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 23), SHIFT_REPEAT(321),
  [420] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 23), SHIFT_REPEAT(320),
  [423] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 23), SHIFT_REPEAT(322),
  [426] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 23), SHIFT_REPEAT(319),
  [429] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 23), SHIFT_REPEAT(328),
  [432] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 23), SHIFT_REPEAT(323),
  [435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(677),
  [437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(678),
  [439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(686),
  [441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(694),
  [443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(695),
  [445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(702),
  [447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(274),
  [449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(273),
  [451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(388),
  [453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(261),
  [455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(477),
  [457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(256),
  [459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(255),
  [461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(459),
  [463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(313),
  [465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(344),
  [467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(264),
  [469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(253),
  [471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(288),
  [473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(456),
  [475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(403),
  [477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(530),
  [479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(529),
  [481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(399),
  [483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(454),
  [485] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_struct_repeat1, 2, .production_id = 10), SHIFT_REPEAT(319),
  [488] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_struct_repeat1, 2, .production_id = 10), SHIFT_REPEAT(2),
  [491] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_struct_repeat1, 2, .production_id = 10), SHIFT_REPEAT(69),
  [494] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_struct_repeat1, 2, .production_id = 10), SHIFT_REPEAT(70),
  [497] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_struct_repeat1, 2, .production_id = 10), SHIFT_REPEAT(71),
  [500] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_struct_repeat1, 2, .production_id = 10), SHIFT_REPEAT(39),
  [503] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_struct_repeat1, 2, .production_id = 10),
  [505] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_struct_repeat1, 2, .production_id = 10), SHIFT_REPEAT(62),
  [508] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_struct_repeat1, 2, .production_id = 10), SHIFT_REPEAT(194),
  [511] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_struct_repeat1, 2, .production_id = 10), SHIFT_REPEAT(195),
  [514] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_struct_repeat1, 2, .production_id = 10), SHIFT_REPEAT(181),
  [517] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_struct_repeat1, 2, .production_id = 10), SHIFT_REPEAT(197),
  [520] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_struct_repeat1, 2, .production_id = 10), SHIFT_REPEAT(198),
  [523] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_struct_repeat1, 2, .production_id = 10), SHIFT_REPEAT(322),
  [526] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_struct_repeat1, 2, .production_id = 10), SHIFT_REPEAT(321),
  [529] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_struct_repeat1, 2, .production_id = 10), SHIFT_REPEAT(320),
  [532] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_struct_repeat1, 2, .production_id = 10), SHIFT_REPEAT(322),
  [535] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_struct_repeat1, 2, .production_id = 10), SHIFT_REPEAT(319),
  [538] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_struct_repeat1, 2, .production_id = 10), SHIFT_REPEAT(328),
  [541] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_struct_repeat1, 2, .production_id = 10), SHIFT_REPEAT(323),
  [544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(449),
  [546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(421),
  [548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(448),
  [550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(324),
  [552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(528),
  [554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(500),
  [556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(501),
  [558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(303),
  [560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(521),
  [562] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_tuple_repeat1, 2, .production_id = 7), SHIFT_REPEAT(319),
  [565] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_repeat1, 2, .production_id = 7), SHIFT_REPEAT(2),
  [568] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_tuple_repeat1, 2, .production_id = 7),
  [570] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_repeat1, 2, .production_id = 7), SHIFT_REPEAT(69),
  [573] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_repeat1, 2, .production_id = 7), SHIFT_REPEAT(70),
  [576] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_repeat1, 2, .production_id = 7), SHIFT_REPEAT(71),
  [579] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_repeat1, 2, .production_id = 7), SHIFT_REPEAT(39),
  [582] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_repeat1, 2, .production_id = 7), SHIFT_REPEAT(62),
  [585] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_repeat1, 2, .production_id = 7), SHIFT_REPEAT(194),
  [588] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_repeat1, 2, .production_id = 7), SHIFT_REPEAT(195),
  [591] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_repeat1, 2, .production_id = 7), SHIFT_REPEAT(181),
  [594] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_repeat1, 2, .production_id = 7), SHIFT_REPEAT(197),
  [597] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_repeat1, 2, .production_id = 7), SHIFT_REPEAT(198),
  [600] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_repeat1, 2, .production_id = 7), SHIFT_REPEAT(322),
  [603] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_tuple_repeat1, 2, .production_id = 7), SHIFT_REPEAT(321),
  [606] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_tuple_repeat1, 2, .production_id = 7), SHIFT_REPEAT(320),
  [609] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_tuple_repeat1, 2, .production_id = 7), SHIFT_REPEAT(322),
  [612] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_repeat1, 2, .production_id = 7), SHIFT_REPEAT(319),
  [615] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_repeat1, 2, .production_id = 7), SHIFT_REPEAT(328),
  [618] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_repeat1, 2, .production_id = 7), SHIFT_REPEAT(323),
  [621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(509),
  [623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(314),
  [625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(514),
  [627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(522),
  [629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(515),
  [631] = {.entry = {.count = 1, .reusable = false}}, SHIFT(606),
  [633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6),
  [635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(90),
  [637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(92),
  [639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(94),
  [641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20),
  [643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21),
  [645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(235),
  [647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(446),
  [649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(603),
  [651] = {.entry = {.count = 1, .reusable = false}}, SHIFT(604),
  [653] = {.entry = {.count = 1, .reusable = false}}, SHIFT(605),
  [655] = {.entry = {.count = 1, .reusable = false}}, SHIFT(603),
  [657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(445),
  [659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(602),
  [661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(276),
  [663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(310),
  [665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(311),
  [667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(312),
  [669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(430),
  [671] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2),
  [673] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(396),
  [676] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(3),
  [679] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(72),
  [682] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(76),
  [685] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(77),
  [688] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(49),
  [691] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(44),
  [694] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(182),
  [697] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(216),
  [700] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(217),
  [703] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(218),
  [706] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(221),
  [709] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(392),
  [712] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(393),
  [715] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(395),
  [718] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(392),
  [721] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(396),
  [724] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(420),
  [727] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(389),
  [730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(431),
  [732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(432),
  [734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(338),
  [736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(341),
  [738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(342),
  [740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(343),
  [742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(355),
  [744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(329),
  [746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(613),
  [748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(620),
  [750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(621),
  [752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(673),
  [754] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_body, 1, .production_id = 5),
  [756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(433),
  [758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(674),
  [760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(675),
  [762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(676),
  [764] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 1),
  [766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(685),
  [768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(383),
  [770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(402),
  [772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(374),
  [774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(503),
  [776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(384),
  [778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(510),
  [780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(517),
  [782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(496),
  [784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(519),
  [786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(520),
  [788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(385),
  [790] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_while_repeat1, 2, .production_id = 13), SHIFT_REPEAT(319),
  [793] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_while_repeat1, 2, .production_id = 13), SHIFT_REPEAT(2),
  [796] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_while_repeat1, 2, .production_id = 13),
  [798] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_while_repeat1, 2, .production_id = 13), SHIFT_REPEAT(69),
  [801] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_while_repeat1, 2, .production_id = 13), SHIFT_REPEAT(70),
  [804] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_while_repeat1, 2, .production_id = 13), SHIFT_REPEAT(71),
  [807] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_while_repeat1, 2, .production_id = 13), SHIFT_REPEAT(39),
  [810] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_while_repeat1, 2, .production_id = 13), SHIFT_REPEAT(62),
  [813] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_while_repeat1, 2, .production_id = 13), SHIFT_REPEAT(194),
  [816] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_while_repeat1, 2, .production_id = 13), SHIFT_REPEAT(195),
  [819] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_while_repeat1, 2, .production_id = 13), SHIFT_REPEAT(181),
  [822] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_while_repeat1, 2, .production_id = 13), SHIFT_REPEAT(197),
  [825] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_while_repeat1, 2, .production_id = 13), SHIFT_REPEAT(198),
  [828] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_while_repeat1, 2, .production_id = 13), SHIFT_REPEAT(322),
  [831] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_while_repeat1, 2, .production_id = 13), SHIFT_REPEAT(321),
  [834] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_while_repeat1, 2, .production_id = 13), SHIFT_REPEAT(320),
  [837] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_while_repeat1, 2, .production_id = 13), SHIFT_REPEAT(322),
  [840] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_while_repeat1, 2, .production_id = 13), SHIFT_REPEAT(319),
  [843] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_while_repeat1, 2, .production_id = 13), SHIFT_REPEAT(328),
  [846] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_while_repeat1, 2, .production_id = 13), SHIFT_REPEAT(323),
  [849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(257),
  [851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(407),
  [853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(258),
  [855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(406),
  [857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(259),
  [859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(260),
  [861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(427),
  [863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(414),
  [865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(404),
  [867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(277),
  [869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(451),
  [871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(531),
  [873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(692),
  [875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(405),
  [877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(532),
  [879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(533),
  [881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(452),
  [883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(275),
  [885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(410),
  [887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(453),
  [889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(266),
  [891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(401),
  [893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(457),
  [895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(379),
  [897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(246),
  [899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(380),
  [901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(381),
  [903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(382),
  [905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7),
  [907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(336),
  [909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(239),
  [911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(238),
  [913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(237),
  [915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(236),
  [917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(606),
  [919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(683),
  [921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(471),
  [923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(670),
  [925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(669),
  [927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(667),
  [929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(504),
  [931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(408),
  [933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(523),
  [935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(298),
  [937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(666),
  [939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(297),
  [941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(296),
  [943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(295),
  [945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(468),
  [947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(664),
  [949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(327),
  [951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(335),
  [953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(334),
  [955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(267),
  [957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(333),
  [959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(326),
  [961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(469),
  [963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(691),
  [965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(476),
  [967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(263),
  [969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(553),
  [971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(554),
  [973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(555),
  [975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(556),
  [977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(472),
  [979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(464),
  [981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(424),
  [983] = {.entry = {.count = 1, .reusable = false}}, SHIFT(546),
  [985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4),
  [987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(137),
  [989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(136),
  [991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(133),
  [993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(46),
  [995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(47),
  [997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(207),
  [999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(208),
  [1001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(209),
  [1003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(230),
  [1005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(201),
  [1007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(542),
  [1009] = {.entry = {.count = 1, .reusable = false}}, SHIFT(541),
  [1011] = {.entry = {.count = 1, .reusable = false}}, SHIFT(540),
  [1013] = {.entry = {.count = 1, .reusable = false}}, SHIFT(542),
  [1015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(546),
  [1017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(545),
  [1019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(544),
  [1021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(440),
  [1023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(394),
  [1025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(473),
  [1027] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_def_repeat1, 2, .production_id = 19),
  [1029] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_def_repeat1, 2, .production_id = 19), SHIFT_REPEAT(557),
  [1032] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_def_repeat1, 2, .production_id = 19),
  [1034] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_def_repeat1, 2, .production_id = 19), SHIFT_REPEAT(194),
  [1037] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_def_repeat1, 2, .production_id = 19), SHIFT_REPEAT(195),
  [1040] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_def_repeat1, 2, .production_id = 19), SHIFT_REPEAT(181),
  [1043] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_def_repeat1, 2, .production_id = 19), SHIFT_REPEAT(197),
  [1046] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_def_repeat1, 2, .production_id = 19), SHIFT_REPEAT(479),
  [1049] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_def_repeat1, 2, .production_id = 19), SHIFT_REPEAT(328),
  [1052] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_short_quote, 2),
  [1054] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_short_quote, 2),
  [1056] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__specials, 1),
  [1058] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__specials, 1),
  [1060] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_fn, 4, .production_id = 16),
  [1062] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fn, 4, .production_id = 16),
  [1064] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while, 4, .production_id = 14),
  [1066] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while, 4, .production_id = 14),
  [1068] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_parameters_repeat1, 1, .production_id = 15),
  [1070] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 1, .production_id = 15),
  [1072] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do, 4, .production_id = 12),
  [1074] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do, 4, .production_id = 12),
  [1076] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break, 4),
  [1078] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break, 4),
  [1080] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if, 6, .production_id = 27),
  [1082] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if, 6, .production_id = 27),
  [1084] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_var, 6, .production_id = 26),
  [1086] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_var, 6, .production_id = 26),
  [1088] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_def, 6, .production_id = 26),
  [1090] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_def, 6, .production_id = 26),
  [1092] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extra_defs, 5, .production_id = 25),
  [1094] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extra_defs, 5, .production_id = 25),
  [1096] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_peg_set, 4),
  [1098] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_peg_set, 4),
  [1100] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_table, 3, .production_id = 9),
  [1102] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_table, 3, .production_id = 9),
  [1104] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct, 3, .production_id = 9),
  [1106] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct, 3, .production_id = 9),
  [1108] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sqr_array, 3, .production_id = 6),
  [1110] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sqr_array, 3, .production_id = 6),
  [1112] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array, 3, .production_id = 6),
  [1114] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array, 3, .production_id = 6),
  [1116] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sqr_tuple, 3, .production_id = 6),
  [1118] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sqr_tuple, 3, .production_id = 6),
  [1120] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple, 3, .production_id = 6),
  [1122] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple, 3, .production_id = 6),
  [1124] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_upscope, 3),
  [1126] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_upscope, 3),
  [1128] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do, 3),
  [1130] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do, 3),
  [1132] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break, 3),
  [1134] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break, 3),
  [1136] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_fn, 5, .production_id = 25),
  [1138] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fn, 5, .production_id = 25),
  [1140] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_fn, 5, .production_id = 24),
  [1142] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fn, 5, .production_id = 24),
  [1144] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while, 5, .production_id = 21),
  [1146] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while, 5, .production_id = 21),
  [1148] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if, 5, .production_id = 20),
  [1150] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if, 5, .production_id = 20),
  [1152] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_short_fn, 2, .production_id = 3),
  [1154] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_short_fn, 2, .production_id = 3),
  [1156] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_var, 5, .production_id = 18),
  [1158] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_var, 5, .production_id = 18),
  [1160] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_def, 5, .production_id = 18),
  [1162] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_def, 5, .production_id = 18),
  [1164] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_set, 5, .production_id = 17),
  [1166] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_set, 5, .production_id = 17),
  [1168] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_fn, 6, .production_id = 29),
  [1170] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fn, 6, .production_id = 29),
  [1172] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_table, 2),
  [1174] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_table, 2),
  [1176] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct, 2),
  [1178] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct, 2),
  [1180] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sqr_array, 2),
  [1182] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sqr_array, 2),
  [1184] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array, 2),
  [1186] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array, 2),
  [1188] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sqr_tuple, 2),
  [1190] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sqr_tuple, 2),
  [1192] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple, 2),
  [1194] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple, 2),
  [1196] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__shorthand, 1),
  [1198] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__shorthand, 1),
  [1200] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__special_forms, 1),
  [1202] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__special_forms, 1),
  [1204] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expr, 1),
  [1206] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expr, 1),
  [1208] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extra_defs, 6, .production_id = 29),
  [1210] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extra_defs, 6, .production_id = 29),
  [1212] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_bool_literal, 1),
  [1214] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bool_literal, 1),
  [1216] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_number_literal, 1),
  [1218] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_number_literal, 1),
  [1220] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__literals, 1),
  [1222] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__literals, 1),
  [1224] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_long_buffer_literal, 1),
  [1226] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_long_buffer_literal, 1),
  [1228] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_long_str_literal, 1),
  [1230] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_long_str_literal, 1),
  [1232] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extra_defs, 6, .production_id = 30),
  [1234] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extra_defs, 6, .production_id = 30),
  [1236] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extra_defs, 7, .production_id = 32),
  [1238] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extra_defs, 7, .production_id = 32),
  [1240] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__identifier, 1),
  [1242] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__identifier, 1),
  [1244] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_upscope, 4, .production_id = 12),
  [1246] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_upscope, 4, .production_id = 12),
  [1248] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_short_splice, 2),
  [1250] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_short_splice, 2),
  [1252] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_short_quasiquote, 2),
  [1254] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_short_quasiquote, 2),
  [1256] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_short_unquote, 2),
  [1258] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_short_unquote, 2),
  [1260] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_quote, 3),
  [1262] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_quote, 3),
  [1264] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_splice, 3),
  [1266] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_splice, 3),
  [1268] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_quasiquote, 3),
  [1270] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_quasiquote, 3),
  [1272] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unquote, 3),
  [1274] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unquote, 3),
  [1276] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_quote, 4),
  [1278] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_quote, 4),
  [1280] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_splice, 4),
  [1282] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_splice, 4),
  [1284] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_quasiquote, 4),
  [1286] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_quasiquote, 4),
  [1288] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unquote, 4),
  [1290] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unquote, 4),
  [1292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8),
  [1294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12),
  [1296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(524),
  [1298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(426),
  [1300] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_tuple_repeat1, 1, .production_id = 1),
  [1302] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_tuple_repeat1, 1, .production_id = 1),
  [1304] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameters, 4, .production_id = 22),
  [1306] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters, 4, .production_id = 22),
  [1308] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_parameters, 3, .production_id = 22),
  [1310] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_parameters, 3, .production_id = 22),
  [1312] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_parameters, 4, .production_id = 28),
  [1314] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_parameters, 4, .production_id = 28),
  [1316] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_parameters, 4, .production_id = 22),
  [1318] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_parameters, 4, .production_id = 22),
  [1320] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameters, 4, .production_id = 28),
  [1322] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters, 4, .production_id = 28),
  [1324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(254),
  [1326] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameters, 3, .production_id = 22),
  [1328] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters, 3, .production_id = 22),
  [1330] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_parameters, 5, .production_id = 31),
  [1332] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_parameters, 5, .production_id = 31),
  [1334] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameters, 5, .production_id = 31),
  [1336] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters, 5, .production_id = 31),
  [1338] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_parameters, 3),
  [1340] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_parameters, 3),
  [1342] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_metadata, 1),
  [1344] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_metadata, 1),
  [1346] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameters, 1),
  [1348] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameters, 1),
  [1350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(679),
  [1352] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameters, 3),
  [1354] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters, 3),
  [1356] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameters, 2),
  [1358] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters, 2),
  [1360] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_parameters, 2),
  [1362] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_parameters, 2),
  [1364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(513),
  [1366] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__struct_tables_commom, 2, .production_id = 8),
  [1368] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__struct_tables_commom, 2, .production_id = 8),
  [1370] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_struct_repeat1, 1, .production_id = 2),
  [1372] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_struct_repeat1, 1, .production_id = 2),
  [1374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(447),
  [1376] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__name, 1),
  [1378] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__name, 1),
  [1380] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_while_repeat1, 1, .production_id = 4),
  [1382] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_while_repeat1, 1, .production_id = 4),
  [1384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(346),
  [1386] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_def_repeat1, 1, .production_id = 11),
  [1388] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_def_repeat1, 1, .production_id = 11),
  [1390] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_def_repeat1, 2, .production_id = 19), SHIFT_REPEAT(558),
  [1393] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_def_repeat1, 2, .production_id = 19), SHIFT_REPEAT(207),
  [1396] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_def_repeat1, 2, .production_id = 19), SHIFT_REPEAT(208),
  [1399] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_def_repeat1, 2, .production_id = 19), SHIFT_REPEAT(209),
  [1402] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_def_repeat1, 2, .production_id = 19), SHIFT_REPEAT(230),
  [1405] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_def_repeat1, 2, .production_id = 19), SHIFT_REPEAT(524),
  [1408] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_def_repeat1, 2, .production_id = 19), SHIFT_REPEAT(545),
  [1411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(558),
  [1413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(171),
  [1415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(170),
  [1417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(168),
  [1419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(167),
  [1421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(179),
  [1423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(178),
  [1425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(177),
  [1427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(176),
  [1429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(693),
  [1431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(697),
  [1433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(698),
  [1435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(699),
  [1437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(700),
  [1439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(701),
  [1441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(425),
  [1443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(703),
  [1445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(387),
  [1447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(386),
  [1449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(552),
  [1451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(551),
  [1453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(550),
  [1455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(549),
  [1457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(249),
  [1459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(248),
  [1461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(291),
  [1463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(271),
  [1465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(270),
  [1467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(269),
  [1469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(680),
  [1471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(690),
  [1473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(265),
  [1475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(378),
  [1477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(689),
  [1479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(252),
  [1481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(251),
  [1483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(250),
  [1485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(272),
  [1487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(282),
  [1489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(377),
  [1491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(289),
  [1493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(688),
  [1495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(376),
  [1497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(687),
  [1499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(684),
  [1501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(601),
  [1503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(682),
  [1505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(681),
  [1507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(398),
  [1509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(559),
  [1511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(409),
  [1513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(299),
  [1515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(300),
  [1517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(301),
  [1519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(302),
  [1521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(512),
  [1523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(511),
  [1525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(508),
  [1527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(507),
  [1529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(506),
  [1531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(505),
  [1533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(358),
  [1535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(415),
  [1537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(502),
  [1539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(360),
  [1541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(499),
  [1543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(498),
  [1545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(527),
  [1547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(525),
  [1549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(526),
  [1551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(418),
  [1553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(539),
  [1555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(361),
  [1557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(356),
  [1559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(348),
  [1561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(347),
  [1563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(331),
  [1565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(304),
  [1567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(307),
  [1569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(306),
  [1571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(400),
  [1573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(330),
  [1575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(354),
  [1577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(434),
  [1579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(353),
  [1581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(352),
  [1583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(435),
  [1585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(351),
  [1587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(350),
  [1589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(436),
  [1591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(349),
  [1593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(437),
  [1595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(438),
  [1597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(439),
  [1599] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_janet_external_scanner_create(void);
void tree_sitter_janet_external_scanner_destroy(void *);
bool tree_sitter_janet_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_janet_external_scanner_serialize(void *, char *);
void tree_sitter_janet_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_janet(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_symbol,
    .external_scanner = {
      &ts_external_scanner_states[0][0],
      ts_external_scanner_symbol_map,
      tree_sitter_janet_external_scanner_create,
      tree_sitter_janet_external_scanner_destroy,
      tree_sitter_janet_external_scanner_scan,
      tree_sitter_janet_external_scanner_serialize,
      tree_sitter_janet_external_scanner_deserialize,
    },
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
